; -----------------------------------------------------------------------------
; #############################################################################
; -----------------------------------------------------------------------------
; Name:               NAMEDERERWEITERUNG
; -----------------------------------------------------------------------------
; Prefix:             NDE!_
; Version:            0.1
; Date:               2007-01-16
; Author:             Wolfgang Reszel
; Copyright:          2008 Heise Zeitschriften Verlag GmbH & Co. KG
; -----------------------------------------------------------------------------

; -----------------------------------------------------------------------------
; === Initialisation ==========================================================
; -----------------------------------------------------------------------------

; Initialisierungsroutine, welche beim Start von ac'tivAid aufgerufen wird.
init_NAMEDERERWEITERUNG:

   ; Folgende drei Variablen sind wichtig, damit die Erweiterung von ac'tivAid erkannt wird.
   ; Die Variablennamen drfen nicht verndert werden und drfen keine Kommentare dahinter gesetzt werden.

   ; * Das verwendete eindeutige Prfix ohne Unterstrich
   Prefix = NDE!
   ; * Der Name der Erweiterung ohne Leerzeichen und Sonderzeichen
   %Prefix%_ScriptName    = NAMEDERERWEITERUNG
   ; * Die Version der Erweiterung
   %Prefix%_ScriptVersion = 0.1
   ; Der Autor der Erweiterung
   %Prefix%_Author        = Wolfgang Reszel
   ; Erweiterungen, welche fr diese Erweiterung installiert sein mssen (kommasepariert, ohne Leerzeichen)
   RequireExtensions      =
   ; Wenn 1, dann gibt's im 'Pfeil'-Men einen Eintrag, dass Einstellungen hinzugeladen werden knnen
   AddSettings_NAMEDERERWEITERUNG =
   ; Wenn eine eigene Konfigurations-Datei statt ac'tivAid.ini verwendet wird, muss hier der relative Pfad angegeben werden
   ConfigFile_NAMEDERERWEITERUNG = ; %SettingsDir%\datei.ini

   ; Durch setzen der folgenden drei Variablen, kmmert sich ac'tivAid automatisch um ein Tastaturkrzel
   ; fr die Erweiterung und fgt auch automatisch ein Tastaturkrzel-Schaltflche zum Konfigurationsdialog hinzu
   CustomHotkey_NAMEDERERWEITERUNG =            ; automatisches benutzerdefinierbares Tastaturkrzel? (1 = ja)
   Hotkey_NAMEDERERWEITERUNG       =            ; Standard-Hotkey
   HotkeyPrefix_NAMEDERERWEITERUNG =            ; Prfix, welches vor immer vor dem Tastaturkrzel gesetzt wird
                                                ; in diesem Fall sorgt es dafr, dass das Tastaturkrzel durchgeschleift wird.

   HideSettings = 0                             ; Wenn 1, dann bekommt die Erweiterung keinen Eintrag im Konfigurationsdialog
   EnableTray_NAMEDERERWEITERUNG   =            ; Soll eine Erweiterung nicht im Tray-Men aufgefhrt werden, muss der Wert 0 betragen

   DisableIfCompiled_NAMEDERERWEITERUNG =       ; Wenn 1, lsst sich die Erweiterung in kompilierter Form nicht de-/aktivieren

   ; CreateGuiID("NAMEDERERWEITERUNG")  ; nchste freie GUI-ID in %GuiID_NAMEDERERWEITERUNG% ablegen und Close/Escape-Label
                                        ; registrieren (z.B. NAMEDERERWEITERUNGGuiClose statt 5GuiClose)
                                        ; Zugriff auf die GUI-ID vor dem Aufbau der Gui ber: GuiDefault("NAMEDERERWEITERUNG")

   IconFile_On_NAMEDERERWEITERUNG  = 
   IconPos_On_NAMEDERERWEITERUNG   = 
   IconFile_Off_NAMEDERERWEITERUNG = 
   IconPos_Off_NAMEDERERWEITERUNG  = 

   ; Sprachabhngige Variablen
   If Lng = 07  ; = Deutsch (0407, 0807, 0c07 ...)
   {
      ; Name des Meneintrags im Tray-Men
      MenuName                      = %NDE!_ScriptName% - Kurzbeschreibung
      ; Beschreibung fr den Erweiterungsmanager und den Konfigurationsdialog
      Description                   = Kurze Beschreibung, was die Erweiterung so kann
      ; Es gilt zu beachten, dass die Erweiterung selber spter nicht auf MenuName und Description zugreifen kann,
      ; das sie spter die Werte der zuletzt geladenen Erweiterung enthalten. Die Variablen werden von ac'tivAid aber
      ; automatisch in ExtensionMenuName[%NDE!_ScriptName%] und ExtensionDescription[%NDE!_ScriptName%] gespeichert

      ; hier folgen nun alle weiteren sprachspezifischen Textvariablen
      ; es empfiehlt sich folgende Form:
      ; lng_NDE!_VariablenName        = Text

      ; Fr GUI-Elemente sind auch automatische Tooltips mglich
      ; tooltip_NAMEDESGUIELEMENTS   = Text
   }
   else        ; = Alternativ-Sprache (wenn nicht Deutsch und keine language.ini vorhanden)
   {
      MenuName                      = %NDE!_ScriptName% - Kurzbeschreibung
      Description                   = Kurze Beschreibung, was die Erweiterung so kann

      ; ....
   }

   ; Hier folgt nun z.B. das Einlesen der Konfigurationswerte aus der INI-Datei

   ; zustzliches Hotkey aus der INI-Datei einlesen
   ; Syntax: HotkeyRead ( Name des Tastaturkrzels, INI-Datei, INI-Sektion, INI-Variable, Subroutine des Tastaturkrzels, Standard-Krzel)
   ; func_HotkeyRead( "NDE!_HOTKEYNAME", ConfigFile , NDE!_ScriptName, "INI-Variable", "NDE!_sub_UNTERROUTINE", "DEFAULTWERT" )

   ; Die zustzlichen Unterordner aus der INI-Datei auslesen
   ; IniRead, NDE!_VARIABLE, %ConfigFile%, %NDE!_ScriptName%, INI-Variable, DEFAULTWERT
Return

; Die folgende Routine enthlt alle Befehle, welche dazu ntig sind den Konfigurationsdialog zu ergnzen
; Das erste GUI-Element sollte immer mit "XS+10 Y+5" positioniert werden, wobei der Y-Wert ggf.
; auch angepasster werden kann.
SettingsGui_NAMEDERERWEITERUNG:
   ; Schaltflche fr Abfrage eines Tastaturkrzels hinzufgen
   ; func_HotkeyAddGuiControl( lng_NDE!_TEXT, "NDE!_HOTKEYNAME", "xs+10 y+10 w160" )
   ; Eigene Schaltflchen sollten in den Optionen auch sub_CheckIfSettingsChanged
   ; aufrufen, damit ac'tivAid erkennt, dass nderungen vorgenommen wurden.
   ; z.B.: Gui, Add, Edit, xs+10 y+5 gsub_CheckIfSettingsChanged vNDE!_var, %lng_NDE!_text%
Return

; wird aufgerufen, wenn im Konfigurationsdialog OK oder bernehmen angeklickt wird
SaveSettings_NAMEDERERWEITERUNG:
   ; Syntax: HotkeyWrite ( Name des Tastaturkrzels, INI-Datei, Sektion, INI-Variable [, Subroutine des Tastaturkrzels] )
   ; func_HotkeyWrite( "NDE!_HOTKEYNAME", ConfigFile , NDE!_ScriptName, "INI-Variable" )
   ; IniWrite, %NDE!_VARIABLE%, %ConfigFile%, INI-Sektion, INI-Variable

   ; Wenn es ntig ist, dass ac'tivAid nach dem Speichern der Einstellungen neu geladen werden muss, kann man Reload auf 1 setzen
   ; Reload = 1
Return

; Wird aufgerufen, wenn Einstellungen ber das 'Pfeil'-Men hinzugefgt werden, ist nur notwendig wenn AddSettings_NAMEDERERWEITERUNG = 1
AddSettings_NAMEDERERWEITERUNG:
Return

; wird beim Abbrechen des Konfigurationsdialogs aufgerufen
CancelSettings_NAMEDERERWEITERUNG:
Return

; wird beim Aktivieren der Erweiterung aufgerufen
DoEnable_NAMEDERERWEITERUNG:
   ; func_HotkeyEnable("NDE!_HOTKEYNAME")
Return

; wird beim Deaktivieren der Erweiterung und auch vor dem Speichern der Einstellungen aufgerufen
DoDisable_NAMEDERERWEITERUNG:
   ; func_HotkeyDisable("NDE!_HOTKEYNAME")
Return

; wird aufgerufen, wenn der Anwender die Erweiterung auf die Standard-Einstellungen zurcksetzt
DefaultSettings_NAMEDERERWEITERUNG:
Return

; wird aufgerufen, wenn ac'tivAid beendet oder neu geladen wird.
OnExitAndReload_NAMEDERERWEITERUNG:
Return

; -----------------------------------------------------------------------------
; === Hotkeys =================================================================
; -----------------------------------------------------------------------------

; Unterroutine fr das automatische Tastaturkrzel
; sub_Hotkey_NAMEDERERWEITERUNG:
;    Gosub, NDE!_main_NAMEDERERWEITERUNG
; Return

; -----------------------------------------------------------------------------
; === Subroutines =============================================================
; -----------------------------------------------------------------------------

; NDE!_sub_UNTERROUTINE
; Return
