; -----------------------------------------------------------------------------
; #############################################################################
; -----------------------------------------------------------------------------
; Name:               ac'tivAid
; -----------------------------------------------------------------------------
; Version:            1.3.1
; Date:               2008-06-06 08:24
; Author:             Wolfgang Reszel
; Copyright:          2008 Heise Zeitschriften Verlag GmbH & Co. KG
; AutoHotkey Version: 1.0.47.06
; -----------------------------------------------------------------------------

; -----------------------------------------------------------------------------
; === Global Settings =========================================================
; -----------------------------------------------------------------------------

#singleinstance force
InitTime = %A_TickCount%
A_Priority = A
Process, Priority,, %A_Priority%
#HotkeyInterval 500
SetTitlematchMode, 2
SetBatchLines, 500
SetControlDelay, 0
SetWinDelay, 0
SetKeyDelay,0
#NoTrayIcon
#ClipboardTimeout 4000
A_SendMode = Input
SendMode, %A_SendMode%
#InstallMousehook
#NoEnv
#MaxMem 512
Hotkey, $LButton, Off

#Include *i syntaxcheck.tmp

DetectHiddenWindows, On
WinGet, activAidRunning, List, %A_Scriptfullpath% - AutoHotkey v%A_Ahkversion%
If activAidRunning > 1
   ExitApp
DetectHiddenWindows, Off

Process, Exist
activAidPID := ErrorLevel
RunWorkingDir := A_WorkingDir

; -----------------------------------------------------------------------------
; === Initialisation ==========================================================
; -----------------------------------------------------------------------------

Menu, Tray, NoStandard
Menu, Tray, DeleteAll

ScriptName         = activAid
ScriptNameFull     = ac'tivAid
ScriptVersion      = 1.3.1
neededAHKversion   = 1.0.47.06

ScriptTitle        = %ScriptNameFull% v%ScriptVersion%
_ScriptName        = %ScriptName%

A_Args = "%1%" "%2%" "%3%" "%4%" "%5%" "%6%" "%7%" "%8%" "%9%"
A_YY := func_StrRight(A_YYYY,2)

SplitPath, A_ScriptDir, activAidFolderName,,,, Drive

EnvGet, A_LocalAppData, LOCALAPPDATA
IfExist, %A_LocalAppData%\VirtualStore\Program Files\%activAidFolderName%\_temp.tmp
   FileDelete, %A_LocalAppData%\VirtualStore\Program Files\%activAidFolderName%\_temp.tmp
IfExist, %A_LocalAppData%\VirtualStore\Program Files (x86)\%activAidFolderName%\_temp.tmp
   FileDelete, %A_LocalAppData%\VirtualStore\Program Files (x86)\%activAidFolderName%\_temp.tmp

IfNotExist, %A_Temp%
   FileCreateDir, %A_Temp%

FileAppend, write, %A_ScriptDir%\_temp.tmp
MainDirNotWriteable = %ErrorLevel%

If (FileExist( A_LocalAppData "\VirtualStore\Program Files\" activAidFolderName "\_temp.tmp" ) OR FileExist( A_LocalAppData "\VirtualStore\Program Files (x86)\" activAidFolderName "\_temp.tmp" ))
   MainDirNotWriteable = 2

FileDelete, %A_ScriptDir%\_temp.tmp

If A_IsCompiled = 1
   RegRead, A_RealOSVersion, HKEY_CURRENT_USER, Software\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\Layers, %A_ScriptFullPath%
Else
   RegRead, A_RealOSVersion, HKEY_CURRENT_USER, Software\Microsoft\Windows NT\CurrentVersion\AppCompatFlags\Layers, %A_AhkPath%
If (A_RealOSVersion <> "" AND ErrorLevel = 0)
   A_RealOSVersion = WIN_VISTA
Else
   A_RealOSVersion = %A_OSVersion%

ThisProcess := DllCall("GetCurrentProcess")
if !DllCall("IsWow64Process", "uint", ThisProcess, "int*", IsWow64Process)
    IsWow64Process := false
A_OSWordSize := IsWow64Process ? "64" : "32"

SplitPath, A_AhkPath,,A_AutoHotkeyPath

SplitPath, A_AutoHotkeyPath,,,,, A_AutoHotkeyDrive
DriveGet, A_AutoHotkeyDriveType, Type, %A_AutoHotkeyDrive%

If ( InStr(A_AutoHotkeyPath, A_ScriptDir) )
{
   AHKonUSB = 1
   If A_AutoHotkeyDriveType <> Removable
      AHKonlyPortable = 1
}

If AHKonUSB = 1
   APPDATA = %A_ScriptDir%\ComputerSettings\%A_Computername%
Else
   APPDATA = %A_AppData%

If APPDATA =
   RegRead, APPDATA, HKEY_CURRENT_USER,Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders,AppData

If (GetKeyState("Ctrl") = 1 AND GetKeyState(".") = 1)
   ExitApp
If AHKonUSB = 1
{
   activAidData = %APPDATA%
   activAidGlobalData = %A_ScriptDir%
}
Else
{
   activAidData = %APPDATA%\ac'tivAid
   If (MainDirNotWriteable > 0)
      activAidGlobalData = %A_AppDataCommon%\ac'tivAid
   Else
      activAidGlobalData = %A_ScriptDir%
   If (A_RealOSVersion = "WIN_VISTA" AND A_WorkingDir <> activAidGlobalData AND A_WorkingDir = A_ScriptDir )
   {
      IfNotExist, %activAidGlobalData%
         FileCreateDir, %activAidGlobalData%
      Debug("RELOAD",A_LineNumber,A_LineFile,A_ThisFunc A_ThisLabel)
      If A_IsCompiled = 1
         Run, %A_ScriptFullPath% %A_Args%, %activAidGlobalData%, UseErrorLevel ; Reload
      Else
         Run, %A_AhkPath% /r "%A_ScriptFullPath%" %A_Args%, %activAidGlobalData%, UseErrorLevel ; Reload
      ExitApp
   }
;   If (A_RealOSVersion = "WIN_VISTA" AND A_WorkingDir = activAidGlobalData )
;      activAidData = %activAidGlobalData%
}

A_Args =
Loop, %0%
{
   IfInString, %A_Index%, LastWorkingDir:
   {
      StringReplace, LastWorkingDir, %A_Index%, LastWorkingDir:
      continue
   }
   IfInString, %A_Index%, %A_Space%
      A_Args := A_Args " """ %A_Index% """"
   Else
      A_Args := A_Args " " %A_Index%
}
If LastWorkingDir =
{
   NoLastWorkingDirParam = 1
   If (A_WorkingDir <> A_ScriptDir OR MainDirNotWriteable = 0)
      LastWorkingDir = %A_WorkingDir%
   Else If (FileExist(A_Appdatacommon "\ac'tivAid\" ConfigFile) AND AHKonUSB <> 1)
      LastWorkingDir = %A_Appdatacommon%\ac'tivAid
   Else
      LastWorkingDir = %A_WorkingDir%
}
A_Args = %A_Args% "LastWorkingDir:%LastWorkingDir%"

If 1 = LeaveAdmin
   LeaveAdmin = 1

; #1011
If (InStr(A_Args, "update ") AND LastWorkingDir <> A_WorkingDir)
{
   LeaveAdmin = 1
}

SettingsDir = Settings
ConfigFile = %SettingsDir%\%ScriptNameFull%.ini

If A_IsAdmin = 1
{
   DetectHiddenWindows, On
   If A_IsCompiled = 1
      SendMessage, 0x1ccc, 1, 1,,%A_ScriptDir%\extensions\RunWithAdminRights.exe
   Else
      SendMessage, 0x1ccc, 1, 1,,%A_ScriptDir%\extensions\RunWithAdminRights.ahk - AutoHotkey v%A_Ahkversion%
   If ErrorLevel = 1
      tempAdminMode = 1
   DetectHiddenWindows, Off

   IfInString, A_Args, tempAdminMode
      tempAdminMode = 1
}

IniRead, _Devel, %ConfigFile%, %ScriptName%, Devel, 0
IniRead, _Debug, %ConfigFile%, %ScriptName%, Debug, 0
IniRead, _DebugLevel, %ConfigFile%, %ScriptName%, DebugLevel, 0
IniRead, _DebugToFile, %ConfigFile%, %ScriptName%, DebugToFile, %A_Space%

RegisterAdditionalSetting( "", "MessageBoxTips", 0 )
RegisterAdditionalSetting( "", "NoSoundBeepInSearch", 0 )
RegisterAdditionalSetting( "", "SilentUpdate", 0 )
RegisterAdditionalSetting( "", "AlternativeTrayMenu", 0 )
RegisterAdditionalSetting( "", "SingleClickTrayAction", 0 )
RegisterAdditionalSetting( "", "useTrayMenuIcons", 0, "ReloadOnChange:true" )
RegisterAdditionalSetting( "", "ShowIconsInOptionsListBox", 0, "" )

If A_IsCompiled <> 1
{
   RegisterAdditionalSetting("","")
   RegisterAdditionalSetting( "", "Debug", 0 )
   RegisterAdditionalSetting( "", "Devel", 0 )
}

IfExist, %A_ScriptDir%\Dbgview.exe
{
   _Debug = 1
   _DebugLevel = All
   IfWinNotExist, DebugView
   {
      Run, %A_ScriptDir%\DbgView.exe ,, Min UseErrorLevel
      If ErrorLevel <> ERROR
         WinWait, DebugView
   }
}

Debug("INIT", A_LineNumber, A_LineFile, "-----------------------------------------------------------------")
Debug("INIT", A_LineNumber, A_LineFile, "Initializing " ScriptTitle " - " A_ScriptFullPath)

If MainDirNotWriteable > 0
   DisabledIfNotAdmin = Disabled

IniRead, CustomWorkingDir, %A_ScriptDir%\Settings\ac'tivAid.ini, activAid, CustomWorkingDir, %A_Space%
IniRead, MultiUser, %activAidGlobalData%\%ConfigFile%, %ScriptName%, MultiUser, %A_Space%
Debug("VAR", A_LineNumber, A_LineFile, "MainDirNotWriteable,A_WorkingDir,A_ScriptDir,MultiUser")

If MultiUser > 0
   CustomWorkingDir = %A_WorkingDir%

If (CustomWorkingDir <> "" AND NoLastWorkingDirParam = 1)
{
   CustomWorkingDir := func_Deref(CustomWorkingDir)
   If (A_WorkingDir <> CustomWorkingDir AND FileExist(CustomWorkingDir))
   {
      LastWorkingDir = %CustomWorkingDir%
      NewWorkingDir = %CustomWorkingDir%
      A_Args = %A_Args% "LastWorkingDir:%NewWorkingDir%"
      Gosub, Reload
   }
}

If ((MultiUser = 1 AND A_WorkingDir = A_ScriptDir) OR (A_WorkingDir = A_ScriptDir AND MainDirNotWriteable > 0) OR (MultiUser = 1 AND A_WorkingDir = A_ScriptDir))
{
   MultiUser=2
   Gosub, sub_MultiUser
}


main_IsAdmin = %A_IsAdmin%

Debug("VAR", A_LineNumber, A_LineFile, "A_IsAdmin,A_UserName,MainDirNotWriteable")

IfNotExist, %activAidGlobalData%
   FileCreateDir, %activAidGlobalData%

If activAidGlobalData <> %A_ScriptDir%
{
   tmpRights := CMDret_RunReturn( "CACLS """ activAidGlobalData """")
   StringReplace, tmpRights, tmpRights, (CI),,All
   StringReplace, tmpRights, tmpRights, (OI),,All
   StringReplace, tmpRights, tmpRights, (IO),,All
   cmpString := "\" Ansi2Oem(LookupAccountSid("S-1-5-32-545")) ":C"
   IfNotInstring, tmpRights, %cmpString%
      func_SetFileAccessRights( activAidGlobalData, "S-1-5-32-545", "C" )
   tmpRights =
}

IfNotExist, %activAidGlobalData%\%SettingsDir%
   FileCreateDir, %activAidGlobalData%\%SettingsDir%

A_Quote = "

If (A_WorkingDir = activAidData)
   UsingUserDir = 1
Else
   UsingUserDir = 0

RegRead, SystemDPI, HKEY_CURRENT_USER,Control Panel\Desktop\WindowMetrics,AppliedDPI
If SystemDPI =
   SystemDPI = 96

FontSize := 96/SystemDPI * 8
FontSize5 := 96/SystemDPI * 5
FontSize6 := 96/SystemDPI * 6
FontSize7 := 96/SystemDPI * 7
FontSize9 := 96/SystemDPI * 9
FontSize12 := 96/SystemDPI * 12
FontSize14 := 96/SystemDPI * 14
FontSize20 := 96/SystemDPI * 20
FontSize25 := 96/SystemDPI * 25
If SystemDPI = 120
   FontSize = 7

UnpackSplashStyle := "b1 FS" FontSize9 " W400 CWeeeeee Y" A_ScreenHeight/2+20

If (FileExist("update.cmd") AND FileExist("ac'tivAid-updater.exe"))
{
   Debug("RELOAD",A_LineNumber,A_LineFile,"Launching ac'tivAid-updater.exe")
   Run, ac'tivAid-updater.exe
   Sleep, 100
   ExitApp
}

If ( A_WorkingDir <> A_ScriptDir OR MainDirNotWriteable = 0 )
{
   IfNotExist, %SettingsDir%
      FileCreateDir, %SettingsDir%
   IfNotExist, extensions
      FileCreateDir, Extensions
   IfNotExist, Extensions\Media
      FileCreateDir, Extensions\Media
   IfNotExist, Library
      FileCreateDir, Library
   IfNotExist, Library\Tools
      FileCreateDir, Library\Tools
}

IfExist, extensions\_main.ahk
{
   FileCopy, extensions\_main.ahk, settings\extensions_main.ini
   FileDelete, extensions\_main.ahk
   Reload = 1
}
IfExist, extensions\_header.ahk
{
   FileCopy, extensions\_header.ahk, settings\extensions_header.ini
   FileDelete, extensions\_header.ahk
   Reload = 1
}

If Reload = 1
   Gosub, Reload

RegRead, RecentPath, HKEY_CURRENT_USER,Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders, Recent

; -----------------------------------------------------------------------------
; Hier wird libCurl initalisiert.
; -----------------------------------------------------------------------------
/*
#include Library\libcurl.ahk
if lc_load()
{
   Sleep, 100
   setTimer, lc_tim_Progress, 10
   setTimer, lc_tim_Messages, 50
   setTimer, lc_thread_perform, 1000      ;Transferqueue starten
}
*/
; -----------------------------------------------------------------------------
; Hier werden alle verwendeten Funktionen eingetragen. Mit diesem Array
; wird automatisch das Tray-Men erzeugt.
; -----------------------------------------------------------------------------

; eigene Funktionen/Erweiterungen laden (includes)
IfExist, settings\extensions_header.ini
   Debug("INIT", A_LineNumber, A_LineFile, "#including extensions_header.ini ..." )
#Include *i settings\extensions_header.ini

; -----------------------------------------------------------------------------

IniRead, activAid_LastDateTime, %ConfigFile%, %ScriptName%, activAid_DateTime
FileGetTime, activAid_CurrDateTime, %A_ScriptFullPath%, C
If (A_IsCompiled = 1 AND activAid_CurrDateTime <> activAid_LastDateTime)
   activAid_HasChanged = 1

IfExist, exe-distribution.ahk
   Debug("INIT", A_LineNumber, A_LineFile, "#including exe-distribution.ahk ..." )
#Include *i exe-distribution.ahk

If A_IsCompiled = 1
{
   IfNotExist, Library\ac'tivAid.ico
   {
      func_UnpackSplash("Library\ac'tivAid.ico")
      FileInstall, Library\ac'tivAid.ico, Library\ac'tivAid.ico
   }

   If ExeDistribution <> 1
   {
      IfNotExist, settings\ac'tivAid.ini
      {
         func_UnpackSplash("settings\ac'tivAid.ini")
         FileInstall, settings\ac'tivAid.ini, settings\ac'tivAid.ini
      }
      IfNotExist, Library\ac'tivAid_on.ico
      {
         func_UnpackSplash("Library\ac'tivAid_on.ico")
         FileInstall, Library\ac'tivAid_on.ico, Library\ac'tivAid_on.ico
      }
      IfNotExist, Library\ac'tivAid_off.ico
      {
         func_UnpackSplash("Library\ac'tivAid_off.ico")
         FileInstall, Library\ac'tivAid_off.ico, Library\ac'tivAid_off.ico
      }
      IfNotExist, ac'tivAid LiesMich.txt
      {
         func_UnpackSplash("ac'tivAid LiesMich.txt")
         FileInstall, ac'tivAid LiesMich.txt, ac'tivAid LiesMich.txt
      }
      IfNotExist, ac'tivAid ReadMe.txt
      {
         func_UnpackSplash("ac'tivAid ReadMe.txt")
         FileInstall, ac'tivAid ReadMe.txt, ac'tivAid ReadMe.txt
      }
      IfNotExist, ac'tivAid ChangeLog.txt
      {
         func_UnpackSplash("ac'tivAid ChangeLog.txt")
         FileInstall, ac'tivAid ChangeLog.txt, ac'tivAid ChangeLog.txt
      }
   }
   IfNotExist, extensions\RunWithAdminRights.exe
   {
      func_UnpackSplash("extensions\RunWithAdminRights.exe")
      FileInstall, extensions\RunWithAdminRights.exe, extensions\RunWithAdminRights.exe
   }
}

Suspend, On

ScriptIcon# = 1
ScriptOnIcon# = 1
ScriptOffIcon# = 1

IniRead, ReloadOnWakeUp, %ConfigFile%, %ScriptName%, ReloadOnWakeUp, 0
IniRead, DisableAutoUpdateOnSlowNetwork, %ConfigFile%, %ScriptName%, DisableAutoUpdateOnSlowNetwork, 1
IniRead, NoTrayIcon, %ConfigFile%, %ScriptName%, NoTrayIcon, 0
If (FileExist( activAidGlobalData "\Library\ac'tivAid.ico" ) AND !FileExist( A_ScriptDir "\Library\ac'tivAid.ico" ) )
{
   IniRead, ScriptIcon, %ConfigFile%, %ScriptName%, Icon, %activAidGlobalData%\Library\ac'tivAid.ico
   IniRead, ScriptOnIcon, %ConfigFile%, %ScriptName%, TrayIcon_On, %activAidGlobalData%\Library\ac'tivAid_on.ico
   IniRead, ScriptOffIcon, %ConfigFile%, %ScriptName%, TrayIcon_Off, %activAidGlobalData%\Library\ac'tivAid_off.ico
}
Else
{
   IniRead, ScriptIcon, %ConfigFile%, %ScriptName%, Icon, %A_ScriptDir%\Library\ac'tivAid.ico
   IniRead, ScriptOnIcon, %ConfigFile%, %ScriptName%, TrayIcon_On, %A_ScriptDir%\Library\ac'tivAid_on.ico
   IniRead, ScriptOffIcon, %ConfigFile%, %ScriptName%, TrayIcon_Off, %A_ScriptDir%\Library\ac'tivAid_off.ico
}
If (!InStr(ScriptIcon,"`:\") AND !InStr(ScriptIcon,"\\"))
   ScriptIcon = %A_WorkingDir%\%ScriptIcon%
If (!InStr(ScriptOnIcon,"`:\") AND !InStr(ScriptOnIcon,"\\"))
   ScriptOnIcon = %A_WorkingDir%\%ScriptOnIcon%
If (!InStr(ScriptOffIcon,"`:\") AND !InStr(ScriptOffIcon,"\\"))
   ScriptOffIcon = %A_WorkingDir%\%ScriptOffIcon%

; Falls das Skript als EXE-Datei vorliegt, verwendet es sich selber fr die Icons
; das setzt voraus, dass die AutoHotkeySC.bin im Compilerverzeichnis modifiziert wurde
SplashIcon = %ScriptIcon%
If A_Iscompiled = 1
{
   ScriptIcon = %A_ScriptDir%\Library\ac'tivAid.ico
   ScriptOnIcon = %A_ScriptDir%\Library\ac'tivAid_on.ico
   ScriptOffIcon = %A_ScriptDir%\Library\ac'tivAid_off.ico
   IfNotExist, %ScriptIcon%
   {
      ScriptIcon = %A_ScriptFullPath%
      ScriptIcon# = 1
      SplashIcon =
   }
   IfNotExist, %ScriptOnIcon%
   {
      ScriptOnIcon = %A_ScriptFullPath%
      ScriptOnIcon# = 1
   }
   IfNotExist, %ScriptOffIcon%
   {
      ScriptOffIcon = %A_ScriptFullPath%
      ScriptOffIcon# = 1
   }
   If ExeDistribution = 1
      ScriptTitle := ScriptTitle
   Else
      ScriptTitle := ScriptTitle " (exe)"
}
Else
{
   IfNotExist, %ScriptIcon%
   {
      ScriptIcon = %A_AhkPath%
      ScriptIcon# = 1
      SplashIcon =
   }
   IfNotExist, %ScriptOnIcon%
   {
      ScriptOnIcon = %A_AhkPath%
      ScriptOnIcon# = 6
   }
   IfNotExist, %ScriptOffIcon%
   {
      ScriptOffIcon = %A_AhkPath%
      ScriptOffIcon# = 7
   }
}

If (main_IsAdmin <> 1 AND A_WorkingDir = A_ScriptDir AND MainDirNotWriteable = 1)
{
   FileCreateDir, %activAidData%\settings
   If A_Iscompiled = 1
      FileCreateShortcut, %A_ScriptFullPath%, %activAidData%\%ScriptNameFull%.lnk,%activAidData%,,,
   Else
   {
      IfExist, %A_ScriptDir%\Library\ac'tivAid.ico
         FileCreateShortcut,%A_AHKPath% /r "%A_ScriptFullPath%", %activAidData%\%ScriptNameFull%.lnk,%activAidData%,,,%ScriptIcon%
      Else
         FileCreateShortcut,%A_AHKPath% /r "%A_ScriptFullPath%", %activAidData%\%ScriptNameFull%.lnk,%activAidData%,,,
   }
   FileCopyDir, %A_ScriptDir%\settings\*.ini, %activAidData%\settings
   FileCopyDir, %A_ScriptDir%\settings\*.txt, %activAidData%\settings
   Debug("RELOAD",A_LineNumber,A_LineFile,A_ThisFunc A_ThisLabel)
   Run, %activAidData%\%ScriptNameFull%.lnk ; Reload
   ExitApp
}


IniRead, ListBox_selected, %ConfigFile%, %ScriptName%, GUIselected
IniRead, LastExitReason, %ConfigFile%, %ScriptName%, LastExitReason, %A_Space%

; Wenn ac'tivAid mit dem Parameter 'kill' aufgerufen wird, wird es direkt beendet.
; Wird fr das Auto-Update der EXE-Datei bentigt
IfInString, A_Args, kill
   ExitApp

; Zeigt den Starbildschirm an, oder auch nicht.
If (!InStr( A_Args, "nosplash" ) OR LastExitReason <> "")
{
   If SplashIcon <>
   {
      SplashImage, 2:%SplashIcon%,b2 FS%FontSize5% C c00 ZY2 ZX2 w36, %A_Space%,,, Terminal
      SetTimer, tim_Loading, 50
   }
}

If ListBox_selected = ERROR
   ListBox_selected =

; sprachabhngige Variablen, Systemsprache wird ermittelt
IniRead, Lng, %ConfigFile%, %ScriptName%, Language
If (Lng = "ERROR" OR Lng = "")
   StringRight, Lng, A_Language, 2 ; Sprache ermitteln, wenn nicht in INI festgelegt

lng_ID = 0x%A_Language%

IniRead, Betatester, %ConfigFile%, %ScriptName%, Betatester, 0
If (A_IsCompiled = 1 AND ExeDistribution <> 1)
   Betatester = 0
BetatesterLast = %Betatester%

If ExeDistribution = 1
{
   UpdateArchive = update_activaid_exe.exe
   ScriptTitle := ScriptTitle "e"
   ScriptVersion := ScriptVersion "e"
   StringReplace, ScriptTitle, ScriptTitle, %A_Space%betae, e beta
   StringReplace, ScriptVersion, ScriptVersion, %A_Space%betae, e beta
   StringReplace, ScriptTitle, ScriptTitle, %A_Space%alphae, e alpha
   StringReplace, ScriptVersion, ScriptVersion, %A_Space%alphae, e alpha
}
Else
   UpdateArchive = update_activaid.exe

If AHKonUSB = 1
   ScriptTitle = Portable %ScriptTitle%

If Lng = 07  ; = Deutsch (0407, 0807, 0c07 ...)
{
   lng_ID                          = 0x0407
   lng_Info                        = %ScriptTitle% konfigurieren ...
   lng_dontrunAhkMain              = Bitte starten Sie ac'tivAid ber die Datei "ac'tivAid.ahk" und nicht "ac'tivAid_main.ahk"!
   lng_downloadingActivAid         = Die aktuelle Version von ac'tivAid wird heruntergeladen ...
   lng_ProblemSolver               = Problembehebung
   lng_ProbSolvHidden              = Alle von %ScriptNameFull% verschobenen und minimierten Fenster wurden wiederhergestellt!
   lng_ProbSolvResult              = Folgende Probleme wurden behoben:
   lng_ProbSolvWhy                 = Beim Starten von %ScriptNameFull% wurden nicht wiederhergestellte Fenster gefunden.
   lng_ProbSolvNoRes               = Es wurden keine zu behebende Probleme gefunden.`nVersuchen sie evtl. %ScriptNameFull% zu deaktivieren, neu zu laden oder Erweiterungen zu deinstallieren.
   lng_update                      = Auf Aktualisierung prfen
   lng_NoUpdate                    = Automatische Aktualisierung einer mit PackAndGo erzeugten Exe-Version nicht mglich.`nBitte starten Sie die Skript-Version und erzeugen Sie nach der`nAktualisierung mittels PackAndGo eine neue Exe-Version.
   lng_AutoCheckUpdtBeta           = Automatisch bei jedem Start von ac'tivAid prfen
   lng_AutoCheckUpdt               = Jede Woche automatisch prfen
   lng_DisableAutoUpdateOnSlowNetwork= Bei langsamer Verbindung automatisch deaktivieren
   lng_AskUpdate                   = Soll eine automatische Aktualisierung durchgefhrt werden?`nSie mssen dazu online sein und den Internet Explorer installiert haben.`n`nDie aktuelle Version finden Sie auch unter: www.heise.de/software/download/24593
   lng_NeedNoUpdate                = %ScriptTitle% ist bereits auf dem aktuellen Stand!
   lng_NeedUpdate                  = Es ist eine neue Version von %ScriptNameFull% verfgbar.`nSoll sie heruntergeladen und automatisch aktualisiert werden?`nEs werden dabei keine Einstellungen in den INI-Dateien gendert!`n`nMomentane Version: %ScriptVersion%`nAktuelle Version:
   lng_UpdateError                 = Die aktuelle Version konnte nicht ermittelt werden, prfen Sie ggf. ihre Internetverbindung.`nDamit die Aktualisierung funktioniert, muss der Internet Explorer installiert sein.`nBeachten Sie auch die Hinweise zu Proxy-Servern in Kapitel 3.2 der Hilfe.
   lng_UpdateFinished              = %ScriptNameFull% wurde aktualisiert und wird nun neu geladen.
   lng_UpdateSuccess               = Die Aktualisierung auf %ScriptTitle% war erfolgreich.
   lng_UpdateNewExtension          = In der Aktualisierung sind folgende neue Erweiterungen enthalten:
   lng_UpdateFailed                = Aktualisierung fehlgeschlagen. Prfen Sie Ihre Internetverbindung und versuchen es noch einmal.`n`nDie aktuelle Version finden Sie auch unter: www.heise.de/software/download/24593
   lng_SlowNetwork                 = Die Internetverbindung ist sehr langsam oder falsch konfiguriert.`nSoll die automatische Aktualisierung nun deaktiviert werden, damit ac'tivAid beim Starten nicht mehr ausgebremst wird?`n"Nein" deaktiviert die Prfung auf langsame Verbindungen.
   lng_autostart                   = %ScriptNameFull% beim Anmelden bzw. Systemstart laden
   lng_ShowFocusToolTip            = Hinweise (ToolTips) zu aktiven Eingabefeldern
   lng_reload                      = %ScriptNameFull% &neu laden
   lng_More                        = Mehr
   lng_deactivate                  = %ScriptNameFull% &deaktivieren
   lng_deactivateM                 = %lng_deactivate%
   lng_TempSuspend                 = Tastaturkrzel kurzfristig deaktivieren
   lng_SuspendToolTip              = Tastaturkrzel von ac'tivAid inaktiv
   lng_TrayClick                   = Aktion bei Doppelklick auf das Tray-Symbol
   lng_TrayMClick                  = Aktion bei Mittelklick auf das Tray-Symbol
   lng_TrayRClick                  = Aktion bei Rechtsklick auf das Tray-Symbol
   lng_TrayClickOptions            = Konfiguration aufrufen|ac'tivAid de-/aktivieren|ac'tivAid neu laden|Tastaturkrzel-bersicht|Kontextmen aller Funktionen|Zuletzt ausgefhrter AutoHotkey-Code|AutoHotkey-Variablen|AutoHotkeys Hotkey-Belegung|AutoHotkeys Hotkey-Verlauf|WindowSpy aufrufen|ac'tivAid Men
   lng_SingleClickTrayAction       = Tray-Icon-Aktion mit einem Einfachklick ausfhren
   lng_useTrayMenuIcons            = Im ac'tivAid-Men Icons anzeigen.
   lng_ShowIconsInOptionsListBox   = In der Liste der Erweiterungen Icons anzeigen
   lng_Extension                   = Erweiterung
   lng_Extensions                  = Erweiterungen
   lng_IgnoreApps                  = Deaktivieren
   lng_ExtOff                      = Alle Erweiterungen verstecken
   lng_ExtOn                       = Alle Erweiterungen wieder anzeigen
   lng_ExtDeinst                   = Alle Erweiterungen verstecken und Einstellungs-Datei umbenennen
   lng_ExtDeinstAsk                = Sollen wirklich alle Erweiterungen versteckt und die Einstellungs-Datei in 'ac'tivAid_ProblemSolver.ini' umbenannt werden?
   lng_SwitchExtErr                = Kein Zugriff auf das extensions-Verzeichnis mit den Erweiterungen, evtl. sind noch Skript-Dateien in einem Texteditor geffnet!
   lng_ShowInTrayMenu              = Erweiterung im Tray-Men anzeigen
   lng_GetKey                      = Bitte eine Tastenkombination drcken`n(ESC = Abbruch, Entf = Lschen)
   lng_GetSingleKey                = Bitte eine Taste drcken`n(ESC = Abbruch, Entf = Lschen)
   lng_GetInputDevice              = Bitte eine Maustaste oder einen Joystick-Knopf drcken`n`nCursor hoch = Mausrad hoch, Cursor runter = Mausrad runter`nESC = Abbruch, Entf = Lschen
   lng_GetKeySuspendStatus0        = `n`nTastaturabfrage: ac'tivAid-Krzel und RemapKeys bercksichtigen`n(Umschalten mit beiden Strg-Tasten)
   lng_GetKeySuspendStatus1        = `n`nTastaturabfrage: komplette Tastatur`n(Umschalten mit beiden Strg-Tasten)
   lng_AddApps                     = Bitte das gewnschte Fenster auswhlen und Enter drcken (ESC = Abbruch):
   lng__Debug                      = AutoHotkey-Men ins Tray-Men einbeziehen (Window Spy, etc.)
   lng_MessageBoxTips              = Hinweisfenster statt Sprechblasenhinweise (BalloonTips)
   lng_NoBalloonTips               = Sprechblasenhinweise deaktivieren
   lng_MainGUI                     = Konfigurationsdialog
   lng_DuplicateHotkey             = ### wird schon von folgender Erweiterung verwendet:
   lng_DuplicateWinHotkey          = ##1 ist eine Standard-Tastaturkrzel von ##2.`nDerzeit hat es die Funktion:
   lng_OverwriteWinHotkey          = Soll das eingegebene Tastaturkrzel verwendet und somit das Tastaturkrzel`nvon Windows berschrieben werden?
   lng_DuplicateHotkeys            = Folgende Tastaturkrzel sind doppelt belegt. Nur dem erste Krzel wurde eine Funktion zugewiesen. Per Doppelklick kann man direkt zur entsprechenden Erweiterung springen.
   lng_DuplicateTitle              = Konflikt bei der Tastaturkrzel-Zuweisung
   lng_DuplicateCol1               = Erweiterung
   lng_DuplicateCol2               = Tastaturkrzel
   lng_DuplicateCol3               = Funktion
   lng_DuplicateTempHotkey         = ### wurde gerade zugewiesen,`njedoch noch nicht gespeichert
   lng_OverwriteDupHotkey          = Soll das eingegebene Tastaturkrzel verwendet und somit das Tastaturkrzel`naus der oben aufgefhrten Erweiterung entfernt werden?
   lng_Chapter                     = Kapitel:
   lng__Devel                      = Entwicklermodus (ac'tivAid wird automatisch neu geladen, wenn eine Skript-Datei gespeichert wurde)
   lng_WritingSettings             = Einstellungen werden gespeichert
   lng_requires                    = bentigt
   lng_requiresAddMsg              = Diese Erweiterung funktioniert nur,`nwenn folgende Erweiterungen installiert sind:`n
   lng_requiresRemMsg              = Diese Erweiterung kann nicht deinstalliert werden,`nda sie von folgenden Erweiterungen bentigt wird:`n
   lng_getClassMsg                 = Bitte den Mauszeiger ber das gewnschte Fensterelement oder`ndie Titelleiste (= komplettes Fenster) bewegen und Enter drcken.`n(ESC = Abbruch)
   lng_getWindowClassMsg           = Bitte den Mauszeiger ber das gewnschte`nFenster bewegen und Enter drcken.`n(ESC = Abbruch)
   lng_Loading                     = %ScriptNameFull% wird neu geladen ...
   lng_Apply                       = &bernehmen
   lng_installed                   = installierte
   lng_available                   = verfgbare (deinstallierte)
   lng_exit                        = &Beenden
   lng_Left                        = linke
   lng_Right                       = rechte
   lng_Middle                      = mittlere
   lng_MouseButton                 = Maustaste
   lng_Key                         = Taste
   lng_KbRelease                   = loslassen
   lng_KbAppsKey                   = Kontextmentaste
   lng_KbWin                       = Windows
   lng_KbAlt                       = Alt
   lng_KbShift                     = Umschalt
   lng_KbShiftShort                = Umsch
   lng_KbCtrl                      = Strg
   lng_KbCapsLock                  = Feststelltaste
   lng_KbNumpad                    = Ziffernblock
   lng_KbNumpadShort               = Num
   lng_KbScrollLock                = Rollen
   lng_KbPgUp                      = Bild hoch
   lng_KbPgDn                      = Bild runter
   lng_KbEnd                       = Ende
   lng_KbDot                       = Komma
   lng_KbDel                       = Entf
   lng_KbHome                      = Pos1
   lng_KbIns                       = Einfg
   lng_KbClear                     = Lschen
   lng_KbPrintScreen               = Druck
   lng_KbCtrlBreak                 = Pause/Untbr
   lng_KbBackspace                 = Lschen
   lng_KbSpace                     = Leertaste
   lng_KbEnter                     = Enter
   lng_KbTab                       = Tab
   lng_KbPause                     = Pause/Untbr
   lng_KbCurUp                     = Cursor hoch
   lng_KbCurDown                   = Cursor runter
   lng_KbCurLeft                   = Cursor links
   lng_KbCurRight                  = Cursor rechts
   lng_KbHelp                      = Hilfe
   lng_KbSleep                     = Standby
   lng_KbBrowser_Back              = Browser Zurck
   lng_KbBrowser_Forward           = Browser Vorwrts
   lng_KbBrowser_Refresh           = Browser Aktualisieren
   lng_KbBrowser_Stop              = Browser Abbrechen
   lng_KbBrowser_Search            = Browser Suchen
   lng_KbBrowser_Favorites         = Browser Favoriten
   lng_KbBrowser_Home              = Browser Startseite
   lng_KbVolume_Mute               = Lautstrke Stumm
   lng_KbVolume_Down               = Lautstrke Leiser
   lng_KbVolume_Up                 = Lautstrke Lauter
   lng_KbMedia_Next                = Media Vor
   lng_KbMedia_Prev                = Media Zurck
   lng_KbMedia_Stop                = Media Stop
   lng_KbMedia_Play_Pause          = Media Play/Pause
   lng_KbLaunch_Mail               = Start Mail
   lng_KbLaunch_Media              = Start Media
   lng_KbLaunch_App1               = Start Anwendung1
   lng_KbLaunch_App2               = Start Anwendung2
   lng_KbWheelUp                   = Mausrad hoch
   lng_KbWheelDown                 = Mausrad runter
   lng_KbLButton                   = linke Maustaste
   lng_KbRButton                   = rechte Maustaste
   lng_KbMButton                   = mittlere Maustaste
   lng_Readme                      = Hilfe
   lng_FAQ                         = Bitte beachten Sie auch die hufig gestellten Fragen auf www.heise.de/software/download/24593
   lng_Changelog                   = nderungen
   lng_ViewChangelog               = Was ist neu?
   lng_Browse                      = &Durchsuchen ...
   lng_CustomWorkingDir            = Arbeitsverzeichnis
   lng_activated                   = aktiviert
   lng_activate                    = aktivieren
   lng_deactivated                 = deaktiviert
   lng_OK                          = &OK
   lng_cancel                      = A&bbrechen
   lng_Close                       = &Schlieen
   lng_Hotkey                      = Tastaturkrzel
   lng_Hotkeys                     = Tastaturkrzel
   lng_Command                     = Befehl
   lng_SettingsMenu                = 8
   lng_DefaultSettings             = ### auf Standard-Einstellungen zurcksetzen
   lng_ExportSettings              = ###-Einstellungen exportieren
   lng_ImportSettings              = ###-Einstellungen importieren
   lng_AddSettings                 = ###-Einstellungen hinzufgen
   lng_ResetWindows                = Alle Fenster von ### zurcksetzen
   lng_AskResetWindows             = Sollen wirklich alle Fenster von ### zurckgesetzt werden?
   lng_ExportAsk                   = Sollen die Einstellungen der derzeit sichtbaren Erweiterung exportiert werden?`nnderungen, die hier noch nicht mit OK oder bernehmen besttigt wurden, werden nicht exportiert.
   lng_ImportAsk                   = Beim Importieren werden alle Einstellungen der sichtbaren Erweiterung berschrieben.`nSollen die Einstellungen wirklich importiert werden?
   lng_ImportAsk2                  = Beim Importieren werden alle Einstellungen der sichtbaren Erweiterung berschrieben.`nnderungen die hier und in anderen Erweiterungen noch nicht mit OK oder bernehmen besttigt wurden, werden nicht bernommen.`nSollen die Einstellungen wirklich importiert werden?
   lng_AddAsk                      = Sollen die Einstellungen wirklich hinzugefgt werden?`nEs werden nur nicht vorhandene Eintrge hinzugefgt.
   lng_ImportImpossible            = Diese Einstellungs-Datei passt nicht zu der Erweiterung!
   lng_SaveAllSettings             = Alle Einstellungs-Dateien in einem Ordner sichern
   lng_LoadAllSettings             = Einstellungs-Dateien aus einem Ordner laden
   lng_SaveAllAsk                  = Sicherungsordner auswhlen, wo die gesamten Einstellungen gesichert werden. Nicht besttigte nderungen (OK/bernehmen) werden nicht gesichert.
   lng_LoadAllAsk                  = Ordner mit den gesicherten Einstellungsdateien auswhlen. ALLE AKTUELLEN EINSTELLUNGEN WERDEN BERSCHRIEBEN!
   lng_DefaultMsg                  = Sollen die Einstellungen und Krzel dieser Erweiterung auf die Standard-Werte zurckgesetzt werden?`nAchtung: In anderen Erweiterungen gehen nicht mit OK oder bernehmen besttigte Einstellungen verloren.
   lng_SettingsNotApplied          = ac'tivAid muss neu geladen werden, nicht besttigte`nnderungen (OK/bernehmen) werden nicht gesichert.`n`nMchten Sie fortfahren?
   lng_PleaseApplySettings         = Bitte besttigen Sie zuvor alle vorgenommenen Einstellungen mit OK oder bernehmen!
   lng_ExtensionManagerHelp        = Installierte Erweiterungen mssen unter Umstnden noch im Konfigurationsfenster oder im Kontextmen des Tray-Symbols aktiviert werden.`n`nAlle bei 'Verfgbare Erweiterungen' aufgelisteten Erweiterungen werden nicht mit ac'tivAid geladen und mssen zur Verwendung hier installiert werden.
   lng_DuplicateExtensions         = Folgende Erweiterungen haben den gleichen Namen. Eine der Dateien muss angepasst oder gelscht werden
   lng_Settings                    = %ScriptName%
   lng_IsInList                    = Das ausgewhlte Verzeichnis befindet sich schon in der Liste!
   lng_HasSubfolder                = Vom ausgewhlte Verzeichnis befinden sich schon Unterverzeichnisse in der Liste!`nDiese mssen vorher entfernt werden.
   lng_IsSubfolder                 = Das ausgewhlte Verzeichnis ist ein Unterverzeichnis von:
   lng_EnableDisable               = Erweiterung aktivieren/deaktivieren
   lng_ShowHotkeyList              = Tastaturkrzel-bersicht einblenden
   lng_HotkeyListAOT               = Tastaturkrzel-bersicht immer im Vordergrund halten
   lng_CreatingHotkeyList          = Tastaturkrzel-bersicht wird aufgebaut ...
   lng_ShowMainContextMenu         = Kontextmen mit allen Funktionen
   lng_SilentUpdate                = Keine Sicherheitsabfrage bei der Aktualisierungs-Prfung
   lng_NoSoundBeepInSearch         = Kein PC-Speaker-Signalton bei der Suchfunktion (Hilfe, QuickNote ...) verwenden
   lng_NoTrayIcon                  = Programm-Symbol (Tray-Icon) in der Taskleiste verstecken`nAchtung: Der Konfigurationsdialog ist dann nur noch ber das oben aufgefhrte Tastaturkrzel zu erreichen.
   lng_Betatester                  = Auch Beta-Versionen beziehen, welche allerdings unerwartetes Verhalten aufweisen knnten.
   lng_ManualUpdate                = manuell aktualisieren
   lng_ManualUpdateText            = Falls automatische Updates z.B. durch einen Proxy-Server verhindert werden, mssen Sie die aktuelle Version manuell herunterladen und installieren. Die aktuelle Version finden Sie unter folgender Adresse:
   lng_OpenURLAndExit              = Webseite ffnen und ac'tivAid beenden
   lng_SelectLanguage              = Sprache whlen / select language
   lng_RunAsAdmin                  = ac'tivAid mit Administrator-Rechten starten
   lng_NeedAdminRights             = ac'tivAid bentigt Administrator-Rechte
   lng_NeedUserPass                = Bitte das Passwort des aktuellen Benutzers eingeben
   lng_LeaveAdmin                  = Administrator-Modus verlassen
   lng_LeaveAdminCantReload        = ac'tivAid wird nach dem Verlassen des Administrator-Modus nicht automatisch neu geladen.`nSie mssen ac'tivAid manuell neu starten.
   lng_UserMode00                  = Einzelbenutzer-Modus aktivieren
   lng_UserMode10                  = Einzelbenutzer-Modus, Admin
   lng_UserMode01                  = Mehrbenutzer-Modus aktivieren
   lng_UserMode11                  = Mehrbenutzer-Modus, Admin
   lng_UserMode001                 = USB/Portable Standard-Modus aktivieren
   lng_UserMode101                 = USB/Portable Standard-Modus, Admin
   lng_UserMode011                 = USB/Portable Mehr-Computer-Modus aktivieren
   lng_UserMode111                 = USB/Portable Mehr-Computer-Modus, Admin
   lng_CheckYourFolderOptions      = In den Ordneroptionen muss eingestellt werden, dass im`nFenstertitel oder in der (sichtbaren!) Adressleiste der`nvollstndige Pfad angezeigt wird. Da der Fenstertitel im`nExplorer eine Lngenbeschrnkung hat, empfiehlt sich`ngenerell die Adressleiste.
   lng_ChangeDirFailed             = Fr den Verzeichniswechsel muss ein Explorerfenster mit Adressleiste oder ein Dateidialog aktiv sein.
   lng_FolderDoesNotExist          = Das Verzeichnis existiert nicht:
   lng_AdminAttention              := "  Achtung: ac'tivAid luft mit Administrator-Rechten.`n  Falls Sie in Windows nicht mit Administrator-Rechten arbeiten,`n  sollten Sie den Administrator-Modus so bald wie mglich verlassen.`n  Nutzen Sie dazu den entsprechenden Menpunkt im ac'tivAid-Men!"
   lng_AdminAttentionAsk           = Mchten Sie ac'tivAid direkt neu laden und den`n  Admin-Modus verlassen?
   lng_DisableToggleLayout         = Das System-Tastaturkrzel fr den Eingabegebietsschemawechsel (meist Alt+Shift) ist aktiv.`nIm Zusammenhang mit ac'tivAid (bzw. AutoHotkey) kann es dabei zu einem unvorhergesehenen Tastaturlayout-Wechsel kommen.`nEs handelt sich hierbei um ein altbekanntes Problem, auf welches nur einmal hingewiesen wird.`n`nSoll ac'tivAid das Systemkrzel fr Sie deaktivieren? (Registry wird verndert)
   lng_AskUninstall                = Soll ac'tivAid samt allen Einstellungen der Benutzer deinstalliert werden?`n`nFolgende Verzeichnisse werden entfernt:`n
   lng_UninstallFinished           = ac'tivAid wurde deinstalliert!`nDateien, die nicht gelscht werden konnten, werden nach einem Neustart entfernt.
   lng_CreateUninstaller           = ac'tivAid wird zum ersten mal ausgefhrt.`n`nSoll ein Programmgruppe eingerichtet und ac'tivAid unter Systemsteuerung/Software eingetragen werden,`ndamit es spter einfach deinstalliert werden kann?`n`nDies erfordert Zugriff auf die Registry.
   lng_by                          = von
   lng_Help                        = Hilfe
   lng_ContextHelp                 = Hilfe zu ###
   lng_activAidHomepage            = Offizielle Webseite von ac'tivAid aufrufen
   lng_Bugtracker                  = Support-Webseite aufrufen (Bugtracker)
   lng_Contact                     = E-Mail-Kontakt (Stephan Ehrmann, se@ctmagazin.de)
   lng_OpenSettingsDir             = Verzeichnis 'settings' ffnen
   lng_CopySettingsToSingle        = Alle Einstellungen in den Einzelbenutzer-Modus exportieren
   lng_CopySettingsToSingleAsk     = Durch das Exportieren der Einstellungen zum Einzelbenutzer-Modus`nwerden dort alle Einstellungen berschrieben.`nSollen die Einstellungen exportiert werden?
   lng_CopyUSBSettingsToSingle     = Alle Einstellungen in den USB/Portable Standard-Modus exportieren
   lng_CopyUSBSettingsToSingleAsk  = Durch das Exportieren der Einstellungen zum USB/Portable Standard-Modus`nwerden dort alle Einstellungen berschrieben.`nSollen die Einstellungen exportiert werden?
   lng_CopySettingsToUser          = Alle Einstellungen aus dem Einzelbenutzer-Modus importieren
   lng_CopySettingsToUserAsk       = Durch das Importieren der Einstellungen vom Einzelbenutzer-Modus`nwerden alle derzeitigen Einstellungen dieses Benutzers berschrieben.`nSollen die Einstellungen importiert werden?
   lng_CopySettingsFromUser        = Alle Einstellungen des Benutzers %A_Username% importieren
   lng_CopySettingsFromUserAsk     = Durch das Importieren der Einstellungen des Benutzers %A_Username%`nin den Einzelbenutzer-Modus werden alle derzeitigen Einstellungen berschrieben.`nSollen die Einstellungen importiert werden?
   lng_CopyUSBSettingsToUser       = Alle Einstellungen aus dem USB/Portable Standard-Modus importieren
   lng_CopyUSBSettingsToUserAsk    = Durch das Importieren der Einstellungen vom USB/Portable Standard-Modus`nwerden alle vorhandenen Einstellungen fr diesen Computer berschrieben.`nSollen die Einstellungen importiert werden?
   lng_CopyUSBSettingsFromUser     = Alle Einstellungen aus ComputerSettings/%A_Computername% importieren
   lng_CopyUSBSettingsFromUserAsk  = Durch das Importieren der Einstellungen von ComputerSettings/%A_Computername%`nin den USB/Portable Standard-Modus werden alle vorhandenen Einstellungen berschrieben.`nSollen die Einstellungen importiert werden?
   lng_AlternativeTrayMenu         = Eintrge im Tray-Men rufen die Konfiguration der entsprechenden Erweiterung auf
   lng_AddUninstaller              = Deinstallations-Eintrag und ac'tivAid-Programmgruppe anlegen
   lng_RemoveUninstaller           = Deinstallations-Eintrag und ac'tivAid-Programmgruppe entfernen
   lng_AddUninstallerFailure       = Deinstallations-Eintrag und ac'tivAid-Programmgruppe konnten nicht angelegt werden.`nStarten Sie ac'tivAid ggf. im Administrator-Modus.
   lng_RemoveUninstallerFailure    = Deinstallations-Eintrag und ac'tivAid-Programmgruppe konnten nicht entfernt werden.`nStarten Sie ac'tivAid ggf. im Administrator-Modus.
   lng_AddUninstallerSuccess       = Deinstallations-Eintrag und ac'tivAid-Programmgruppe wurden angelegt.
   lng_RemoveUninstallerSuccess    = Deinstallations-Eintrag und ac'tivAid-Programmgruppe wurden entfernt.
   lng_None                        = (keine)
   lng_DisableOthers               = Alle anderen Erweiterungen deaktivieren
   lng_EnableAll                   = Alle Erweiterungen aktivieren
   lng_RemoveFromGUI               = ### aus dem Konfigurationsfenster entfernen
   lng_RemovedExtensions           = Entfernte Erweiterungen wiederherstellen...
   lng_Search                      = Suchbegriff
   lng_PortableExe                 = Vermutlich wollten Sie Portable ac'tivAid starten, haben aber versehentlich "ac'tivAid.ahk" gestartet. Um in den portablen Modus zu gelangen, mssen Sie "Portable_ac'tivAid.exe" ausfhren! Diese Meldung wird durch Umbenennen dieser Datei unterdrckt.
   lng_WrongAHKVersion             = AutoHotkey %neededAHKversion% oder hher wird bentigt.`nBitte installieren Sie die aktuelle Version von AutoHotkey.`n`nBei einer automatischen Aktualisierung von ac'tivAid`nwird AutoHotkey ebenfalls aktualisiert.
   lng_BackupOnUpdate              = Vor der Aktualisierung ein Backup vom ac'tivAid-Verzeichnis anlegen
   lng_Show                        = Zeigen ...
   lng_On                          = An
   lng_Off                         = Aus
   lng_AnotherActivAidActive       = Es luft bereits eine anderer ac'tivAid-Prozess.`nMehrere gleichzeitig laufende Prozesse fhren zu unvorhersehbarem Verhalten.`nMchten Sie wirklich einen weiteren ac'tivAid-Prozess starten?
   lng_NewSettingsDirForVista      = Unter Windows Vista darf ein Programm nicht mehr in das eigene Verzeichnis schreiben.`nDie Einstellungen fr den Einzelbenutzer-Modus werden nun von:`n%A_ScriptDir%\settings`nnach:`n%A_AppDataCommon%\ac'itvAid\settings`nkopiert.
   lng_NoExtensionsInstalled       = <-+------------------------------------------------------------------------+`n  | Es wurden noch keine Erweiterungen in ac'tivAid installiert. Ohne      |`n  | Erweiterungen bietet ac'tivAid keine ntzlichen Funktionen. Sie knnen |`n  | links in der Kategorieliste die Kategorie 'Erweiterungen' auswhlen    |`n  | und dort Erweiterungen installieren.                                   |`n  +------------------------------------------------------------------------+`n`n`n

   lng_Second                      = Sekunde
   lng_Seconds                     = Sekunden
   lng_Minute                      = Minute
   lng_Minutes                     = Minuten
   lng_Hour                        = Stunde
   lng_Hours                       = Stunden
   lng_Day                         = Tag
   lng_Days                        = Tage
   lng_Month                       = Monat
   lng_Months                      = Monate
   lng_Year                        = Jahr
   lng_Years                       = Jahre

   lng_Statistics                  = Statistik und Informationen
   lng_StatFirstLaunch             = Erster Programmstart
   lng_StatLastLaunched            = Letzter Programmstart
   lng_StatLaunchCount             = Programmstarts ingesamt
   lng_StatReloadCount             = Neu geladen insgesamt
   lng_StatUpdateCount             = Aktualisierungen insgesamt
   lng_StatExitCount               = Regulr beendet
   lng_StatTotalTime               = Laufzeit insgesamt
   lng_StatSessionTime             = Laufzeit aktuelle Sitzung
   lng_StatLongestSession          = Lngste Sitzung
   lng_StatVersion                 = ac'tivAid-Version
   lng_StatAHKVersion              = AutoHotkey-Version
   lng_StatOS                      = Betriebssystem
   lng_StatUser                    = Benutzername
   lng_StatComputer                = Computername
   lng_StatIP                      = IP-Adresse
   lng_StatCompiled                = , kompiliert
   lng_StatMode                    = Modus
   lng_StatSettingsDir             = Ordner mit Einstellungsdateien
   lng_StatWriteLocked             = (schreibgeschtzt oder keine Schreibrechte)
   lng_StatExtendRButton           = Erweitert rechte Maustaste
   lng_StatExtendMButton           = Erweitert mittlere Maustaste
   lng_StatLoadingTime             = Ladezeit (Dauer)
   lng_StatMainGuiBuildTime        = Aufbau Konfigurationsfenster
   lng_StatNumOfExtensions         = Installierte Erweiterungen
   lng_Network                     = Netzwerk
   lng_AdditionalSettings          = Weitere Optionen
   lng_CleanINI                    = Einstellungsdatei aufrumen
   lng_CleanINIAsk                 = Die Einstellungsdatei wird gelscht und neu angelegt.`nac'tivAid speichert dabei alle Einstellungen der installierten`nErweiterungen in die frische Einstellungs-Datei und wird danach neu geladen.`nEinstellungen nicht installierter Erweiterungen gehen dabei verloren.

   lng_ExtensionConflict           = Es konnten nicht alle installierten Erweiterungen geladen werden.`nac'tivAid wird nun automatisch neu geladen, um das Problem zu beheben.
   lng_ExtensionConflictDuplicates = Eine oder mehrere Erweiterungen sind doppelt installiert. `nac'tivAid wird nun automatisch neu geladen, um das Problem zu beheben.
   lng_StatisticsToClipboard       = In die Zwischenablage kopieren (inkl. weiterer Infos)
   lng_ReloadFailed                = ac'tivAid konnte nicht neu geladen werden.`nVermutlich ist ein Fehler aufgetreten oder ac'tivAid ist beschftigt.

   lng_winHK_ShowExplorer          = Neues Explorerfenster
   lng_winHK_ShowStartMenu         = Startmen einblenden
   lng_winHK_ShowContextMenu       = Kontextmen einblenden
   lng_winHK_ShowRunDialog         = Ausfhren-Dialog einblenden
   lng_winHK_MinimizeAllWindows    = Alle Fenster minimieren
   lng_winHK_RestoreAllWindows     = Alle Fenster wiederherstellen
   lng_winHK_ToggleDesktop         = Desktop anzeigen
   lng_winHK_SetFocusToSysTray     = Fokus auf Systray legen
   lng_winHK_LockWorkstation       = Arbeitstation sperren
   lng_winHK_ShowExplorerFindDialog= Neues Explorer-Suchfenster
   lng_winHK_OpenUtilityManager    = Hilfsprogramm-Manager aufrufen
   lng_winHK_OpenWindowsHelp       = Windows-Hilfe aufrufen
   lng_winHK_OpenSystemProperties  = Systemeigenschaften aufrufen
   lng_winHK_CycleTaskbarButtons   = Fokus auf Taskleisten-Schaltflche
   lng_winHK_TaskSwitcher          = Taskwechsler
   lng_winHK_TopWindowToBottom     = Oberstes Fenster nach hinten legen
   lng_winHK_BottomWindowToTop     = Hinterstes Fenster noch vorne holen
   lng_winHK_CloseWindow           = Fenster schlieen
   lng_winHK_ShowTaskmanager       = Task-Manager aufrufen
   lng_winHK_ScreenShotToClipboard = Bildschirmfoto in die Zwischenablage
   lng_winHK_WindowShotToClipboard = Foto vom aktiven Fenster in die Zwischenablage
   lng_winHK_CopyToClipboard       = In die Zwischanblage kopieren
   lng_winHK_CutToClipboard        = In die Zwischanblage ausschneiden
   lng_winHK_PasteFromClipboard    = Aus der Zwischanblage einfgen
   lng_winHK_NewFile               = Neue Datei
   lng_winHK_SaveFile              = Datei speichern
   lng_winHK_OpenFile              = Datei ffnen
   lng_winHK_PrintFile             = Datei drucken
   lng_winHK_Undo                  = Rckgngig
   lng_winHK_SelectAll             = Alles markieren
   lng_winHK_Find                  = Suchen
   lng_winHK_CloseTabOrChildWindow = Tab oder Kind-Fenster schlieen
   lng_winHK_OpenHelp              = Hilfe aufrufen
   lng_winHK_SetFocusToMenuBar     = Fokus auf Menleiste
   lng_winHK_ShowSystemMenu        = Systemmen einblenden
   lng_winHK_DefocusOrClose        = Fokus entfernen oder Fenster schlieen/abbrechen
   lng_winHK_InsertTabOrCycleControls= Tabulator einfgen oder Eingabefeld wechseln
   lng_winHK_CycleTabsOrChildWindows= Tab oder Kind-Fenster wechseln
   lng_winHK_Enter                 = Return
   lng_winHK_Space                 = Leertaste
   lng_winHK_MoveCursor            = Cursor bewegen
   lng_winHK_MoveCursorAndSelect   = Cursor bewegen und Markierung erweitern
   lng_winHK_Backspace             = Lschen
   lng_winHK_Delete                = Entfernen
   lng_winHK_DeleteFileOrSelection = Datei oder Auswahl lschen
   lng_VarDump                     = Interne Variablen anzeigen

   tooltip_Hotkey_                 = Anklicken, um ein Tastaturkrzel zuzuweisen.`nMit Shift oder Alt anklicken, um eine Maustaste`noder einen Joystickknopf zuzuweisen.
   tooltip_8                       = 'Pfeil'-Men mit weiteren Funktionen
   tooltip_AutoUpdate              = Die automatische Prfung erfolgt beim Skriptstart und zeigt ggf. eine Sicherheitsabfrage an.
   tooltip_Betatester              = Beta-Versionen erscheinen in unregelmigen Abstnden und teilweise mehrmals tglich.`nHufig sind in Beta-Versionen schon neue Funktionen enthalten,`nwelche aber womglich noch instabil laufen.
   tooltip_Autostart               = Aus = Entfernt die Verknpfung aus dem Autostart-Ordner`nAn = Es wird eine Verknpfung zu ac'tivAid im Autostart-Ordner angelegt bzw. entfernt.`nGrau/Grn = Es wird zustzlich der Parameter 'nosplash' mit angegeben, womit der Startbildchirm nicht angezeigt wird.
   tooltip_AlternativeTrayMenu     = Die Eintrge im Tray-Men de-/aktivieren nicht mehr eine Erweiterung,`nsondern es wird direkt ein vereinfachter Konfigurationsdialog aufgerufen,`nwelche schneller aufgebaut wird als der komplette Konfigurationsdialog.`nBei jeder Erweiterung besteht die Mglichkeit zu entscheiden, ob sie im Tray-Men aufgefhrt wird.
   tooltip_Devel                   = Der Entwicklermodus berwacht alle Skriptdateien innerhalb des ac'tivAid-Verzeichnisses`nund ldt ac'tivAid automatisch neu, falls ein Skript verndert wurde.`nDamit ist gewhrleistet, dass nderungen an Erweiterungen sofort getestet werden knnen.`nDiese Option erhht die Festplatten-Auslastung und kann zu Leistungseinbuen fhren.

   tooltip_]]                      = Alle verfgbaren Erweiterungen installieren
   tooltip_[[                      = Alle installierten Erweiterungen deinstallieren
   tooltip_]                       = Ausgewhlte Erweiterung installieren
   tooltip_[                       = Ausgewhlte Erweiterung deinstallieren

   tooltip_searchTermReadme        = Suchbegriff, welcher direkt bei der Eingabe gesucht wird.`nF3: weiter suchen  -  Shift+F3: rckwrts suchen
   tooltip_searchTermChangeLog     = %tooltip_searchTermReadme%
   tooltip_searchTermContextHelp   = %tooltip_searchTermReadme%
   tooltip_searchTermHotkeyList    = %tooltip_searchTermReadme%
   tooltip_searchButtonReadme      = %tooltip_searchTermReadme%
   tooltip_searchButtonChangeLog   = %tooltip_searchTermReadme%
   tooltip_searchButtonContextHelp = %tooltip_searchTermReadme%
   tooltip_searchButtonHotkeyList  = %tooltip_searchTermReadme%

   AdminGroup                      = Administratoren

   ReadMeFile                      = %A_ScriptDir%\ac'tivAid LiesMich.txt
   ChangeLogFile                   = %A_ScriptDir%\ac'tivAid nderungen.txt
}
else        ; = other languages (english)
{
   lng_ID                        = 0x0400
   lng_Info                      = configure %ScriptTitle% ...
   lng_dontrunAhkMain            = Please start ac'tivAid with "ac'tivAid.ahk" and not "ac'tivAid_main.ahk"!
   lng_downloadingActivAid       = Downloading the newest version of ac'tivAid ...
   lng_ProblemSolver             = resolve keyboard and mouse-problems
   lng_ProbSolvHidden            = All by %ScriptNameFull%' hidden windows have been restored!
   lng_ProbSolvResult            = The following problems have been solved:
   lng_ProbSolvWhy               = %ScriptNameFull% has found some hidden windows.
   lng_ProbSolvNoRes             = No problems found.`nTry to deactivate or reload %ScriptNameFull% or uninstall all extensions.
   lng_update                    = check for online-updates
   lng_NoUpdate                  = Automatic updates are not possible with an self created exe-Version (PackAndGo).`nPlease start the script-version and recreate the exe with PackAndGo after updating the script-version.
   lng_AutoCheckUpdtBeta         = Automatically check every script-launch
   lng_AutoCheckUpdt             = Automatically check every week
   lng_DisableAutoUpdateOnSlowNetwork = Disable on slow network connection
   lng_AskUpdate                 = Should the script check for an update?`nYou have to be online and Internet Explorer has to be installed.`n`nA new version could also be found at: http://www.heise.de/ct/activaid
   lng_NeedNoUpdate              = %ScriptTitle% needs no update!
   lng_NeedUpdate                = There's a new version of %ScriptNameFull% available.`nShould %ScriptNameFull% be downloaded and automatically updated?`nThe INI-files won't be changed!`n`ncurrent version: %ScriptVersion%`ncurrent version:
   lng_UpdateError               = Could not get the current version, please check your internet connection.`nInternet Explorer must be installed for this function to work.`nRemember that ac'tivAid uses also the Proxy settings from Internet Explorer.
   lng_UpdateFinished            = %ScriptNameFull% has been updated, it will be reloaded now.
   lng_UpdateSuccess             = Update successful: %ScriptTitle%
   lng_UpdateNewExtension        = The update has installed the following new extensions:
   lng_UpdateFailed              = The downloaded file is not correct, please try it again later.
   lng_SlowNetwork               = Your internet connection is very slow.`nShould the automatic update be disabled to avoid slow starting of ac'tivAid?`nChoosing "No" will disable checking for slow connection.
   lng_autostart                 = Load %ScriptNameFull% at login or system-start
   lng_ShowFocusToolTip          = Show tooltips for focused fields
   lng_reload                    = &Reload %ScriptNameFull%
   lng_More                      = More
   lng_deactivate                = &Deactivate %ScriptNameFull%
   lng_deactivateM               = %lng_deactivate%
   lng_TempSuspend               = Temporary disable hotkeys
   lng_SuspendToolTip            = ac'tivAid's hotkeys temporary disabled
   lng_TrayClick                 = Action for double-click on tray icon
   lng_TrayMClick                = Action for middle-click on tray icon
   lng_TrayRClick                = Action for right-click on tray icon
   lng_TrayClickOptions          = Show configuration|de-/activate ac'tivAid|reload ac'tivAid|overview of all hotkeys|context menu with all functions|ListLines|ListVars|ListHotkeys|KeyHistory|WindowSpy|ac'tivAid-Menu
   lng_SingleClickTrayAction     = Use single click for tray icon actions
   lng_useTrayMenuIcons          = Show icons in ac'tivAid's tray menu
   lng_ShowIconsInOptionsListBox = Show icons in the extension list
   lng_Extension                 = Extension
   lng_Extensions                = Extensions
   lng_IgnoreApps                = Deactivate
   lng_ExtOff                    = Hide all extensions
   lng_ExtOn                     = Show all extensions
   lng_ExtDeinst                 = Hide all extensions and rename the settings-file
   lng_ExtDeinstAsk              = Do you really want to hide all extensions and rename the settings-file to 'ac'tivAid_ProblemSolver.ini'?
   lng_SwitchExtErr              = No access to the extensions-folder, maybe you have files open!
   lng_ShowInTrayMenu            = Visible in tray-menu
   lng_GetKey                    = Please press a hotkey`n(ESC = cancel, Del = delete)
   lng_GetSingleKey              = Please press a key`n(ESC = cancel, Del = delete)
   lng_GetInputDevice            = Please press a mouse or joystick button`n`nCursor up = Wheel up, Cursor down = Wheel down`nESC = cancel, Del = delete
   lng_GetKeySuspendStatus0      = `n`nKeyboard mode: respect ac'tivAid hotkeys and RemapKeys`n(Switch with both Ctrl keys)
   lng_GetKeySuspendStatus1      = `n`nKeyboard mode: native keyboard`n(Switch with both Ctrl keys)
   lng_AddApps                   = Please activate a window and press Enter`n(ESC = cancel):
   lng__Debug                    = Include AutoHotkey-menu in tray-menu (for debugging)
   lng_MessageBoxTips            = Message boxes instead of balloon tips
   lng_SilentUpdate              = No confirmation message when checking for updates
   lng_NoSoundBeepInSearch       = Disable pc speaker beep for the search funciton (Help, QuickNote ...)
   lng_NoBalloonTips             = No BalloonTips
   lng_MainGUI                   = Settings-window
   lng_DuplicateHotkey           = ### is already in use by:
   lng_DuplicateWinHotkey        = ##1 is a standard hotkey of ##2.`nActually it is assigned to:
   lng_OverwriteWinHotkey        = Do you want to use this hotkey and overwrite its standard assignment?
   lng_DuplicateHotkeys          = The following hotkeys are use by more than one extension. Only the first one will be used. Double click opens the affected extension.
   lng_DuplicateTitle            = Conflict in hotkeys
   lng_DuplicateCol1             = Extension
   lng_DuplicateCol2             = Hotkey
   lng_DuplicateCol3             = Function
   lng_DuplicateTempHotkey       = ### is an already assigned but not confirmed hotkey
   lng_OverwriteDupHotkey        = Do you want to assign the entered hotkey and`ndelete the hotkey form the extension shown above?
   lng_Chapter                   = Chapter:
   lng__Devel                    = Development-mode (ac'tivAid reloads automatically, if a script-file has been updated)
   lng_WritingSettings           = Saving settings ...
   lng_requires                  = requires
   lng_requiresAddMsg            = This extension requires the following extension to be installed:`n
   lng_requiresRemMsg            = This extension can't be uninstalled because it's required by the following extensions:`n
   lng_getClassMsg               = Please position the mouse-cursor over a windows-control`nor title bar (= whole window) and press Enter. (ESC = cancel)
   lng_getWindowClassMsg         = Please position the mouse-cursor over`na window and press Enter. (ESC = cancel)
   lng_Loading                   = reloading %ScriptNameFull% ...
   lng_Apply                     = &Apply
   lng_installed                 = installed
   lng_available                 = available
   lng_exit                      = &Exit
   lng_Left                      = left
   lng_Right                     = right
   lng_Middle                    = middle
   lng_MouseButton               = Mousebutton
   lng_Key                       = key
   lng_KbRelease                 = release
   lng_KbAppsKey                 = AppsKey
   lng_KbWin                     = Windows
   lng_KbAlt                     = Alt
   lng_KbShift                   = Shift
   lng_KbShiftShort              = Sh
   lng_KbCtrl                    = Ctrl
   lng_KbCapsLock                = CapsLock
   lng_KbNumpad                  = Numpad
   lng_KbNumpadShort             = Num
   lng_KbScrollLock              = ScrollLock
   lng_KbPgUp                    = Page up
   lng_KbPgDn                    = Page down
   lng_KbEnd                     = End
   lng_KbDot                     = Dot
   lng_KbDel                     = Del
   lng_KbHome                    = Home
   lng_KbIns                     = Ins
   lng_KbClear                   = Clear
   lng_KbPrintScreen             = Print
   lng_KbCtrlBreak               = Break
   lng_KbBackspace               = Backspace
   lng_KbSpace                   = Space
   lng_KbEnter                   = Enter
   lng_KbTab                     = Tab
   lng_KbPause                   = Pause
   lng_KbCurUp                   = Cursor up
   lng_KbCurDown                 = Cursor down
   lng_KbCurLeft                 = Cursor left
   lng_KbCurRight                = Cursor right
   lng_KbHelp                    = Help
   lng_KbSleep                   = Standby
   lng_KbBrowser_Back            = Browser Back
   lng_KbBrowser_Forward         = Browser Forward
   lng_KbBrowser_Refresh         = Browser Refresh
   lng_KbBrowser_Stop            = Browser Cancel
   lng_KbBrowser_Search          = Browser Search
   lng_KbBrowser_Favorites       = Browser Favorites
   lng_KbBrowser_Home            = Browser Home
   lng_KbVolume_Mute             = Volume mute
   lng_KbVolume_Down             = Volume down
   lng_KbVolume_Up               = Volume up
   lng_KbMedia_Next              = Media Next
   lng_KbMedia_Prev              = Media Previous
   lng_KbMedia_Stop              = Media Stop
   lng_KbMedia_Play_Pause        = Media Play/Pause
   lng_KbLaunch_Mail             = Start Mail
   lng_KbLaunch_Media            = Start Media
   lng_KbLaunch_App1             = Start App1
   lng_KbLaunch_App2             = Start App2
   lng_KbWheelUp                 = Wheel up
   lng_KbWheelDown               = Wheel down
   lng_KbLButton                 = Left mouse button
   lng_KbRButton                 = Right mouse button
   lng_KbMButton                 = Middle mouse button
   lng_Readme                    = Help
   lng_FAQ                       = Also take a look at the FAQ on www.heise.de (German)
   lng_Changelog                 = Changes
   lng_ViewChangelog             = What's new?
   lng_Browse                    = &Browse ...
   lng_CustomWorkingDir          = Working directory
   lng_activated                 = active
   lng_activate                  = activate
   lng_deactivated               = inactive
   lng_cancel                    = Cancel
   lng_Close                     = Close
   lng_OK                        = OK
   lng_Hotkey                    = Hotkey
   lng_Hotkeys                   = Hotkeys
   lng_Command                   = Command
   lng_SettingsMenu              = 8
   lng_DefaultSettings           = Reset ### to default settings
   lng_ExportSettings            = Import ### settings
   lng_ImportSettings            = Export ### settings
   lng_AddSettings               = add ### settings
   lng_ResetWindows              = Reset all windows from ###
   lng_AskResetWindows           = Do you really want to reset all windows from ###?
   lng_ExportAsk                 = Do you really want to export the settings of the shown extension?`nUnconfirmed changes (with OK) won't be exported.
   lng_ImportAsk                 = Importing will overwrite all settings of the shown extension`nDo you really want to import?
   lng_ImportAsk2                = Importing will overwrite all settings of the shown extension`nUnconfirmed changes (with OK) won't be exported.`nDo you really want to import?
   lng_AddAsk                    = Do you really want to add the settings?`nOnly non-existent settings will be added.
   lng_ImportImpossible          = Wrong settings-file, it does no match to the extension!
   lng_SaveAllSettings           = save all settings-files to a folder
   lng_LoadAllSettings           = load all settings-file from a folder
   lng_SaveAllAsk                = Select the folder wher to save all settings-files.`nUnconfirmed changes (with OK or Apply) won't be exported.
   lng_LoadAllAsk                = Select the folder with saved settings. THIS WILL OVERWRITE ALL OF YOU CURRENT SETTINGS.
   lng_DefaultMsg                = Should the settings of the shown extension really be set to default?`nAttention: unconfirmed changes (with OK) get lost.
   lng_SettingsNotApplied        = ac'tivAid must be reloaded, unconfirmed`nchangeds (with OK or Apply) won't be saved.`n`nDo you want to continue?
   lng_PleaseApplySettings       = Please save all settings with OK or Apply!
   lng_ExtensionManagerHelp      = Installed extensions possibly have to be activated in the settings-window or the tray-menu`n`nAll 'available extensions' won't be loaded with ac'tivAid and have to be installed here if you want to use them.
   lng_DuplicateExtensions       = These extensions have the same extension name and one file should be modified or deleted
   lng_Settings                  = %ScriptName%
   lng_IsInList                  = The selected folder already exist in the list!
   lng_HasSubfolder              = There are sub-folders from the selected folder in the list!`nYou have to remove them first.
   lng_IsSubfolder               = The selected folder or is a sub-folder of:
   lng_EnableDisable             = Enable/disable extension
   lng_ShowHotkeyList            = Show overview of all hotkeys
   lng_HotkeyListAOT             = Show hotkey list always on top
   lng_CreatingHotkeyList        = Creating hotkey list ...
   lng_ShowMainContextMenu       = Context menu with all functions
   lng_NoTrayIcon                = No tray-icon (Attention: with this option the settings are only accessible via the hotkey)
   lng_Betatester                = Also load beta-versions, which could contain expected bugs
   lng_ManualUpdate              = Manual update
   lng_ManualUpdateText          = If the automatic update fails (blocked by a proxy), you have to download and install the latest version manually. The latest version can be downloaded at:
   lng_OpenURLAndExit            = Open website and quit ac'tivAid
   lng_SelectLanguage            = Select language / Sprache whlen
   lng_RunAsAdmin                = Start ac'tivAid with administrator rights
   lng_NeedAdminRights           = ac'tivAid needs administrator rights
   lng_NeedUserPass              = Please enter the password of the current user
   lng_LeaveAdmin                = Leave administrator mode
   lng_LeaveAdminCantReload      = ac'tivAid won't reload when leaving the admin-mode.`nYou have to run ac'tivAid manually.
   lng_UserMode00                = Activate single user-mode
   lng_UserMode10                = Single user-mode, Admin
   lng_UserMode01                = Activate multi user-mode
   lng_UserMode11                = Multi user-mode, Admin
   lng_UserMode001               = Activate USB/portable standard-mode
   lng_UserMode101               = USB/portable standard-mode, Admin
   lng_UserMode011               = activate USB/portable multi-computer-mode
   lng_UserMode111               = USB/portable multi-computer-mode, Admin
   lng_CheckYourFolderOptions    = Please configure windows explorer to show the`nfull path either in the window-title or the address-bar.
   lng_ChangeDirFailed           = Changing a directory does only work if an explorer-window with address-bar or a file-dialog is active.
   lng_FolderDoesNotExist        = The directory does not exist:
   lng_AdminAttention            := "  Attention: ac'tivAid is running with administrator rights`n  Please leave the admin mode as soon as possible (ac'tivAid menu)!"
   lng_AdminAttentionAsk         = Would you like to immediatly reload ac'tivAid and`n  leave the admin mode?"
   lng_DisableToggleLayout       = The system hotkey for changing the keyboard layout (Alt+Shift) is active.`nIn combination with ac'tivAid (respectively AutoHotkey) this could result in unexpected layout switches.`nIt is a well known problem and you'll never see this message again.`n`nShall ac'tivAid deacativate the system hotkey? (Registry will be change)
   lng_AskUninstall              = Do you really want to uninstall ac'tivAid and the user-settings?`n`nThe following directories will be removed:`n
   lng_UninstallFinished         = ac'tivAid has been successfully uninstalled!`nFiles that couldn't be deleted will be deleted at the next system-start.
   lng_CreateUninstaller         = ac'tivAid has been started the first time.`n`nShould a program group be created and ac'tivAid be added to Control Panel/Software`nso it can be easily uninstalled?`n`nThis will modify the Registry.
   lng_by                        = by
   lng_Help                      = Help
   lng_ContextHelp               = Help about ###
   lng_activAidHomepage          = visit the official ac'tivAid-website
   lng_Bugtracker                = visit support-website (bugtracker)
   lng_Contact                   = email-contact (Stephan Ehrmann, se@ctmagazin.de)
   lng_OpenSettingsDir           = open 'settings'-folder
   lng_CopySettingsToSingle      = Export all settings to the single user-mode
   lng_CopySettingsToSingleAsk   = All settings will be overwritten when you export`nthe settings to the single user-mode!`nDo you really want to export the settings?
   lng_CopyUSBSettingsToSingle    = Export all settings to the USB/Portable standard-mode
   lng_CopyUSBSettingsToSingleAsk = All settings will be overwritten when you export`nthe settings to the USB/Portable standard-mode!`nDo you really want to export the settings?
   lng_CopySettingsToUser        = Import all settings from the single user-mode
   lng_CopySettingsToUserAsk     = All settings of the current user will be overwritten`nwhen you import the settings from the single user-mode!`nDo you really want to import the settings?
   lng_CopyUSBSettingsToUser     = Import all settings from the USB/Portable standard-mode
   lng_CopyUSBSettingsToUserAsk  = All settings for the current computer will be overwritten`nwhen you import the settings from the USB/Portable standard-mode!`nDo you really want to import the settings?
   lng_CopySettingsFromUser      = Import all settings from %A_Username%
   lng_CopySettingsFromUserAsk   = All settings will be overwritten when you`nimport the settings from %A_Username%!`nDo you really want to import the settings?
   lng_CopyUSBSettingsFromUser   = Import all settings from ComputerSettings\%A_Computername%
   lng_CopyUSBSettingsFromUserAsk= All settings of the current computer will be overwritten`nwhen you import the settings from ComputerSettings\%A_Computername%!`nDo you really want to import the settings?
   lng_AlternativeTrayMenu       = The menue items of the tray-menu will show the settings-window of the corresponding extension
   lng_AddUninstaller            = Create uninstall-entry and program group
   lng_RemoveUninstaller         = Remove uninstall-entry and program group
   lng_None                      = (none)
   lng_DisableOthers             = Disable all other extensions
   lng_EnableAll                 = Enable all extensins
   lng_RemoveFromGUI             = Remove ### from configuration
   lng_RemovedExtensions         = restore removed extensions...
   lng_Search                    = Search term
   lng_PortableExe               = You probably want to start Portable ac'tivAid, but you accidentally launched "ac'tivAid.ahk". To enable the protable mode you have to launch "Portable_ac'tivAid.exe"! To avoid this message, you have to delete or rename that file.
   lng_WrongAHKVersion           = AutoHotkey %neededAHKversion% or higher is need to run ac'tivAid.`nPlease installe the latest Version of AutoHotkey.`n`nIf you use ac'tivAid's automatic update, AutoHotkey will also be updated.
   lng_BackupOnUpdate            = Create a backup of the ac'tivAid folder before updating
   lng_Show                      = Show ...
   lng_On                        = On
   lng_Off                       = Off
   lng_AnotherActivAidActive     = There are other ac'tivAid processs running.`nConcurrent processes will cause unpredictable problems.`nDo you really want to start another ac'tivAid process?
   lng_NewSettingsDirForVista    = Windows Vista does not allow programs to write to their own folder.`nBecause of this settings will for the single user-mode will be copied from:`n%A_ScriptDir%\settings`nto:`n%A_AppDataCommon%\ac'itvAid\settings

   lng_StatisticsToClipboard     = Copy to clipboard (incl. additional infos)
   lng_ReloadFailed              = Can't reload ac'tivAid.`nMaybe an error occured or ac'tivAid was too busy.
   lng_NoExtensionsInstalled     = <-+------------------------------------------------------------------------+`n  | There are no extensions installed yet. Without installed extensions    |`n  | ac'tivAid won't be very userful. Please select the category            |`n  | 'extensions' in the left category list to install extensions.          |`n  +------------------------------------------------------------------------+`n`n`n

   lng_Second                    = second
   lng_Seconds                   = seconds
   lng_Minute                    = minute
   lng_Minutes                   = minutes
   lng_Hour                      = hour
   lng_Hours                     = hours
   lng_Day                       = day
   lng_Days                      = days
   lng_Month                     = month
   lng_Months                    = months
   lng_Year                      = year
   lng_Years                     = years

   lng_Statistics                = Statistic and informations
   lng_StatFirstLaunch           = First time launch
   lng_StatLastLaunched          = Last time launched
   lng_StatLaunchCount           = Number of starts
   lng_StatReloadCount           = Number of reloads
   lng_StatUpdateCount           = Number of updates
   lng_StatExitCount             = Number of regular exits
   lng_StatTotalTime             = Total running time
   lng_StatSessionTime           = Running time of this session
   lng_StatLongestSession        = Longest session
   lng_StatVersion               = ac'tivAid version
   lng_StatAHKVersion            = AutoHotkey version
   lng_StatOS                    = Operating system
   lng_StatUser                  = User name
   lng_StatComputer              = Computer name
   lng_StatIP                    = IP addresse
   lng_StatCompiled              = , compiled
   lng_StatMode                  = Mode
   lng_StatSettingsDir           = Settings-Directory
   lng_StatWriteLocked           = (locked or no rights)
   lng_StatExtendRButton         = Extends richt mouse button
   lng_StatExtendMButton         = Extends middle mouse button
   lng_StatLoadingTime           = Loading time (duration)
   lng_Network                   = Network
   lng_AdditionalSettings        = Additional settings
   lng_CleanINI                  = Clean up settings file
   lng_CleanINIAsk               = The settings file will be deleted and recreated.`nac'tivAid saves all settings of the installed extensions`ninto the fresh settings file and will reload.`nYou'll lose all settings from uninstalled extensions.

   lng_VarDump                   = Show internal variables


   lng_ExtensionConflict         = Failed to load all installed extensions.`nac'tivAid will reload now to solve this problem.
   lng_ExtensionConflictDuplicates = Duplicate extensions found.`nac'tivAid will reload now to solve this problem.

   tooltip_Hotkey_               = Click to assign a hotkey.`nClick with Shift or Alt to assign mouse or joystick hotkeys.
   tooltip_Autostart             = Off = removes the shortcut from the autostart-folder`nOn = creates a shortcut to ac'tivAid in the autostart-folder`nGrey/Green = additionally adds the parameter 'nosplash' to hide the startup-screen
   tooltip_searchTermReadme      = F3 - search next`nShift+F3 - search previous
   tooltip_searchTermChangeLog   = %tooltip_searchTermReadme%
   tooltip_searchTermContextHelp = %tooltip_searchTermReadme%
   tooltip_searchTermHotkeyList  = %tooltip_searchTermReadme%
   tooltip_searchButtonReadme      = %tooltip_searchTermReadme%
   tooltip_searchButtonChangeLog   = %tooltip_searchTermReadme%
   tooltip_searchButtonContextHelp = %tooltip_searchTermReadme%
   tooltip_searchButtonHotkeyList  = %tooltip_searchTermReadme%

   AdminGroup                    = Administrators

   ReadMeFile                    = %A_ScriptDir%\ac'tivAid Readme.txt
   ChangeLogFile                 = %A_ScriptDir%\ac'tivAid Changelog.txt
}

lng_KbSC105                   = [Messenger/Files]
lng_KbSC107                   = [Redo]
lng_KbSC108                   = [Undo]
lng_KbSC10a                   = [Paste]
lng_KbSC10b                   = [Scroll Up]
lng_KbSC111                   = [Scroll Up fast]
lng_KbSC112                   = [Scroll Up faster]
lng_KbSC113                   = [Word]
lng_KbSC114                   = [Excel]
lng_KbSC115                   = [Calendar]
lng_KbSC116                   = [Log Off]
lng_KbSC117                   = [Cut]
lng_KbSC118                   = [Copy]
lng_KbSC11f                   = [Scroll Up fastest]
lng_KbSC121                   = [Calculator]
lng_KbSC123                   = [Spell]
lng_KbSC13b                   = [Help]
lng_KbSC13c                   = [My Music/Office]
lng_KbSC13d                   = [Task Pane]
lng_KbSC13e                   = [New]
lng_KbSC13f                   = [Open]
lng_KbSC140                   = [Close]
lng_KbSC141                   = [Reply]
lng_KbSC142                   = [Fwd]
lng_KbSC143                   = [Send]
lng_KbSC157                   = [Save]
lng_KbSC158                   = [Print]
lng_KbSC15e                   = [Power]
lng_KbSC15f                   = [Sleep]
lng_KbSC164                   = [My Pictures]
lng_KbSC16b                   = [My Computer]
lng_KbSC18b                   = [Scroll Down]
lng_KbSC191                   = [Scroll Down fast]
lng_KbSC192                   = [Scroll Down faster]
lng_KbSC19f                   = [Scroll Down fastest]

;IfInString, ScriptVersion, beta
;   ChangeLogFile                 = %A_ScriptDir%\ac'tivAid nderungen.txt

IfNotExist, %ReadMeFile%
   ReadMeFile                    = %A_ScriptDir%\ac'tivAid LiesMich.txt
IfNotExist, %ChangeLogFile%
   ReadMeFile                    = %A_ScriptDir%\ac'tivAid nderungen.txt

Debug("VAR", A_LineNumber, A_LineFile, "ReadMeFile,Lng")

If A_ScriptName = ac'tivAid_main.ahk
{
   MsgBox,16,%ScriptTitle%,%lng_dontrunAhkMain%
   ExitApp
}

If A_AHKversion < %neededAHKversion%
{
   SetTimer, tim_Loading, Off
   SplashImage, Off
   SplashImage, 2:Off
   MsgBox, 16, %ScriptTitle%, %lng_WrongAHKVersion%
   IfExist, DEV\Install\AHKinstall.exe
      Run, DEV\Install\AHKinstall.exe
   ExitApp
}

Gosub, CustomLanguage

; Benutzerdefinierte Variablen einfgen
IfExist, settings\custom-variables.ini
   Debug("INIT", A_LineNumber, A_LineFile, "#including custom-variables.ini ..." )
#Include *i settings\custom-variables.ini

If AHKonlyPortable = 1
{
   If A_AutoHotkeyDriveType = Network
      ScriptTitle = %ScriptTitle% (%lng_Network%)
   StringReplace, lng_UserMode001, lng_UserMode001, USB/,%USBreplace% ,A
   StringReplace, lng_UserMode101, lng_UserMode101, USB/,%USBreplace% ,A
   StringReplace, lng_UserMode011, lng_UserMode011, USB/,%USBreplace% ,A
   StringReplace, lng_UserMode111, lng_UserMode111, USB/,%USBreplace% ,A
   StringReplace, lng_CopyUSBSettingsToUser, lng_CopyUSBSettingsToUser, USB/,%USBreplace% ,A
   StringReplace, lng_CopyUSBSettingsToUserAsk, lng_CopyUSBSettingsToUserAsk, USB/,%USBreplace% ,A
   StringReplace, lng_CopyUSBSettingsFromUser, lng_CopyUSBSettingsFromUser, USB/,%USBreplace% ,A
   StringReplace, lng_CopyUSBSettingsFromUserAsk, lng_CopyUSBSettingsFromUserAsk, USB/,%USBreplace% ,A
   StringReplace, lng_CopyUSBSettingsToSingle, lng_CopyUSBSettingsToSingle, USB/,%USBreplace% ,A
   StringReplace, lng_CopyUSBSettingsToSingleAsk, lng_CopyUSBSettingsToSingleAsk, USB/,%USBreplace% ,A
}
Else If AHKonUSB = 1
   ScriptTitle = %ScriptTitle% (USB)

InputEscapeKeys =
( LTrim Join
   {PrintScreen}{ScrollLock}{Pause}{PgUp}{PgDn}{Home}{End}{Ins}{Del}{BackSpace}
   {F1}{F2}{F3}{F4}{F5}{F6}{F7}{F8}{F9}{F10}{F11}{F12}{F13}{F14}{F15}{F16}{F17}{F18}{F19}{F20}{F21}{F22}{F23}{F24}{F25}{F26}{F27}{F28}{F29}{F30}
   {Space}{Left}{Right}{Up}{Down}{NumLock}{NumPad1}{NumPad2}{NumPad3}{NumPad4}{NumPad5}{NumPad6}{NumPad7}{NumPad8}{NumPad9}{NumPad0}{NumPadAdd}{NumPadSub}{NumPadMult}{NumPadDiv}{NumPadDot}{NumPadEnter}{NumPadDot}
   {a}{b}{c}{d}{e}{f}{g}{h}{i}{j}{k}{l}{m}{n}{o}{p}{q}{r}{s}{t}{u}{v}{w}{x}{y}{z}{}{}{}{}{1}{2}{3}{4}{5}{6}{7}{8}{9}{0}{@}{!}{"}{}{$}{`%}{&}{/}{(}{)}{=}{+}{#}{-}{.}{,}{*}{'}{_}{:}{;}{<}{>}{^}{}{}{``}{[}{]}{\}{?}{|}{~}{{}{}}
   {AppsKey}{Esc}{Tab}{Enter}{CtrlBreak}{Help}{Sleep}
   {Browser_Back}{Browser_Forward}{Browser_Refresh}{Browser_Stop}{Browser_Search}{Browser_Favorites}{Browser_Home}
   {Volume_Mute}{Volume_Down}{Volume_Up}{Media_Next}{Media_Prev}{Media_Stop}{Media_Play_Pause}{Launch_Mail}{Launch_Media}{Launch_App1}{Launch_App2}
   {NumpadDel}{NumpadIns}{NumpadClear}{NumpadUp}{NumpadDown}{NumpadLeft}{NumpadRight}{NumpadHome}{NumpadEnd}{NumpadPgUp}{NumpadPgDn}
   {SC101}{SC102}{SC103}{SC104}{SC105}{SC106}{SC107}{SC108}{SC10a}{SC10b}{SC10c}{SC10d}{SC10e}{SC10f}
   {SC111}{SC112}{SC113}{SC114}{SC115}{SC116}{SC117}{SC118}{SC11a}{SC11b}{SC11f}
   {SC121}{SC123}{SC125}{SC126}{SC127}{SC128}{SC129}{SC12a}{SC12b}{SC12c}{SC12d}{SC12f}
   {SC131}{SC133}{SC134}{SC139}{SC13a}{SC13b}{SC13c}{SC13d}{SC13e}{SC13f}{SC140}
   {SC141}{SC142}{SC143}{SC144}{SC14a}{SC14c}{SC14e}
   {SC155}{SC156}{SC157}{SC158}{SC159}{SC15a}{SC15e}{SC160}
   {SC161}{SC162}{SC163}{SC164}{SC16b}{SC16e}{SC16f}{SC170}
   {SC171}{SC172}{SC173}{SC174}{SC175}{SC176}{SC177}{SC178}{SC179}{SC17a}{SC17b}{SC17c}{SC17d}{SC17e}{SC17f}
)
InputFromDevices =
( LTrim Join
   {Joy1}{Joy2}{Joy3}{Joy4}{Joy5}{Joy6}{Joy7}{Joy8}{Joy9}{Joy10}{Joy11}{Joy12}{Joy13}{Joy14}{Joy15}{Joy16}{Joy17}{Joy18}{Joy19}{Joy20}{Joy21}{Joy22}{Joy23}{Joy24}{Joy25}{Joy26}{Joy27}{Joy28}{Joy29}{Joy30}{Joy31}{Joy32}
   {2Joy1}{2Joy2}{2Joy3}{2Joy4}{2Joy5}{2Joy6}{2Joy7}{2Joy8}{2Joy9}{2Joy10}{2Joy11}{2Joy12}{2Joy13}{2Joy14}{2Joy15}{2Joy16}{2Joy17}{2Joy18}{2Joy19}{2Joy20}{2Joy21}{2Joy22}{2Joy23}{2Joy24}{2Joy25}{2Joy26}{2Joy27}{2Joy28}{2Joy29}{2Joy30}{2Joy31}{2Joy32}
   {LButton}{MButton}{RButton}{WheelUp}{WheelDown}{XButton1}{XButton2}{XButton3}{XButton4}
)

InputEscapeKeysAndDevices = %InputEscapeKeys%%InputFromDevices%

A_SpaceLine := "                                                                                                                                                                                                                                         "

lng_UpdateSuccess := lng_UpdateSuccess A_SpaceLine
StringLeft, lng_UpdateSuccess, lng_UpdateSuccess, 75

FileDelete, reload.cmd

Gosub, sub_GetAllEnv

If PATHEXT =
   PATHEXT = .COM;.EXE;.BAT;.CMD

IfInString, A_Args, uninstall
   Gosub, DoUninstall

OnExit, sub_OnExit

; Ntzlichen Subroutinen als Aktion registrieren
registerAction("sub_VarDumpGUI", lng_VarDump)
registerAction("sub_Statistics")
registerAction("sub_OpenSettingsDir")
registerAction("sub_ShowDuplicates", lng_DuplicateTitle)

If ScriptIcon <>
{
   ScriptIconFromDll := DllCall("LoadImage", uint, 0
      , str, ScriptIcon  ; Icon filename (this file may contain multiple icons).
      , uint, 1  ; Type of image: IMAGE_ICON
      , int, 32, int, 32  ; Desired width & height of image (helps LoadImage decide which icon is best).
      , uint, 0x10)  ; Flags: LR_LOADFROMFILE
}

ChangeDirClasses = #32770,ExploreWClass,CabinetWClass,Afx:400000:0,FileZilla Main Window,bosa_sdm,TTOTAL_CMD,SC12MainFrame,SC11MainFrame,SC10MainFrame,WinRarWindow,bosa_sdm_Mso96,ATL:ExplorerFrame,bosa_sdm_Microsoft Office Word 11.0,bosa_sdm_XL9,dopus.lister,ConsoleWindowClass,powershell.exe,TTntFormUltraExplorer.UnicodeClass
ExplorerAndDialogs = ExploreWClass,CabinetWClass,Progman,WorkerW,bosa_sdm,bosa_sdm_XL9,bosa_sdm_Mso96,bosa_sdm_Microsoft Office Word 11.0

; Prfen ob NiftyWindows aktiv ist
DetectHiddenWindows, On
IfWinExist,NiftyWindows,,.zip
   niftyWindows = on
Else
   IfWinExist,,NiftyWindows.ahk,.zip,NiftyWindows.ini
      niftyWindows = on
DetectHiddenWindows, Off

Gosub, tim_WM_DISPLAYCHANGE

; Prfen ob die Sprechblasen (BalloonTips) deaktiviert sind
RegRead, EnableBalloonTips, HKEY_CURRENT_USER, Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced, EnableBalloonTips

SpecialFolder1 = 208D2C60-3AEA-1069-A2D7-08002B30309D ; Netzwerkumgebung
SpecialFolder2 = 20D04FE0-3AEA-1069-A2D8-08002B30309D ; Arbeitsplatz
SpecialFolder3 = 21EC2O2O-3AEA-1O69-A2DD-08002b30309d ; Systemsteuerun / Control Panel
SpecialFolder4 = 2227A280-3AEA-1069-A2DE-08002B30309D ; Drucker
SpecialFolder5 = 2227A280-3AEA-1069-A2DE-08002B30309D ; Printers and Faxes
SpecialFolder6 = 645FF040-5081-101B-9F08-00AA002F954E ; Papierkorb
SpecialFolder7 = 7007ACC7-3202-11D1-AAD2-00805FC1270E ; Netzwerkverbindungen/Network Connections
SpecialFolder8 = 7BD29E00-76C1-11CF-9DD0-00A0C9034933 ; Temporary Internet Files
SpecialFolder9 = A4D92740-67CD-11CF-96F2-00AA00A11DD9 ; DF-Netzwerk
SpecialFolder10= BDEADF00-C265-11d0-BCED-00A0C90AB50F ; Web Folders
SpecialFolder11= D20EA4E1-3957-11d2-A40B-0C5020524152 ; Fonts
SpecialFolder12= D20EA4E1-3957-11d2-A40B-0C5020524153 ; Verwaltung/Administrative Tools
SpecialFolder13= D6277990-4C6A-11CF-8D87-00AA0060F5BF ; Geplante Tasks/Scheduled Tasks
SpecialFolder14= E211B736-43FD-11D1-9EFB-0000F8757FCD ; Scanners and Cameras
SpecialFolder15= FF393560-C2A7-11CF-BFF4-444553540000 ; Verlauf
SpecialFolder16= 21EC2020-3AEA-1069-A2DD-08002B30309D ; Systemsteuerung
SpecialFolderRun1 = ::{208D2C60-3AEA-1069-A2D7-08002B30309D} ; Netzwerkumgebung
SpecialFolderRun2 = ::{20D04FE0-3AEA-1069-A2D8-08002B30309D} ; Arbeitsplatz
SpecialFolderRun3 = ::{20D04FE0-3AEA-1069-A2D8-08002B30309D}\::{21EC2020-3AEA-1069-A2DD-08002B30309D} ; Systemsteuerung
SpecialFolderRun4 = ::{2227A280-3AEA-1069-A2DE-08002B30309D} ; Drucker
SpecialFolderRun5 = ::{20D04FE0-3AEA-1069-A2D8-08002B30309D}\::{21EC2020-3AEA-1069-A2DD-08002B30309D}\::{2227A280-3AEA-1069-A2DE-08002B30309D} ; Printers and Faxes
SpecialFolderRun6 = ::{645FF040-5081-101B-9F08-00AA002F954E} ; Papierkorb
SpecialFolderRun7 = ::{20D04FE0-3AEA-1069-A2D8-08002B30309D}\::{21EC2020-3AEA-1069-A2DD-08002B30309D}\::{7007ACC7-3202-11D1-AAD2-00805FC1270E} ; Netzwerkverbindungen/Network Connections
SpecialFolderRun8 = ::{7BD29E00-76C1-11CF-9DD0-00A0C9034933} ; Temporary Internet Files doppelpunkt
SpecialFolderRun9 = ::{A4D92740-67CD-11CF-96F2-00AA00A11DD9} ; DF-Netzwerk
SpecialFolderRun10= ::{20D04FE0-3AEA-1069-A2D8-08002B30309D}\::{BDEADF00-C265-11D0-BCED-00A0C90AB50F} ; Web Folders
SpecialFolderRun11= ::{20D04FE0-3AEA-1069-A2D8-08002B30309D}\::{21EC2020-3AEA-1069-A2DD-08002B30309D}\::{D20EA4E1-3957-11d2-A40B-0C5020524152} ; Fonts
SpecialFolderRun12= ::{20D04FE0-3AEA-1069-A2D8-08002B30309D}\::{21EC2020-3AEA-1069-A2DD-08002B30309D}\::{D20EA4E1-3957-11d2-A40B-0C5020524153} ; Verwaltung/Administrative Tools
SpecialFolderRun13= ::{20D04FE0-3AEA-1069-A2D8-08002B30309D}\::{21EC2020-3AEA-1069-A2DD-08002B30309D}\::{D6277990-4C6A-11CF-8D87-00AA0060F5BF} ; Geplante Tasks/Scheduled Tasks
SpecialFolderRun14= ::{20D04FE0-3AEA-1069-A2D8-08002B30309D}\::{21EC2020-3AEA-1069-A2DD-08002B30309D}\::{E211B736-43FD-11D1-9EFB-0000F8757FCD} ; Scanners and Cameras
SpecialFolderRun15= ::{FF393560-C2A7-11CF-BFF4-444553540000} ; Verlauf

IniRead, ShowFocusToolTips, %ConfigFile%, %ScriptName%, ShowFocusToolTips, 1
IniRead, BackupOnUpdate, %ConfigFile%, %ScriptName%, BackupOnUpdate, 1
IniRead, TrayClickOption, %ConfigFile%, %ScriptName%, TrayClickOption, 1
IniRead, TrayMClickOption, %ConfigFile%, %ScriptName%, TrayMClickOption, 5
IniRead, TrayRClickOption, %ConfigFile%, %ScriptName%, TrayRClickOption, 11
TrayClickOptionLast = %TrayClickOption%
IniRead, ExtensionsInExtDir, %ConfigFile%, %ScriptName%, AvailableExtensions
IniRead, ShowHotkeyListX, %ConfigFile%, %ScriptName%, ShowHotkeyListX, %A_Space%
IniRead, ShowHotkeyListY, %ConfigFile%, %ScriptName%, ShowHotkeyListY, %A_Space%
IniRead, ShowHotkeyListH, %ConfigFile%, %ScriptName%, ShowHotkeyListH, 330
IniRead, ShowHotkeyListW, %ConfigFile%, %ScriptName%, ShowHotkeyListW, 580
ShowHotkeyListW := ShowHotkeyListW - BorderHeight*2
ShowHotkeyListH := ShowHotkeyListH - BorderHeight*2 - CaptionHeight
IniRead, FileBrowser, %ConfigFile%, %ScriptName%, FileBrowser, Explorer
IniRead, FileBrowserWithTree, %ConfigFile%, %ScriptName%, FileBrowserWithTree, Explorer /e`,
IniRead, FileBrowserSelect, %ConfigFile%, %ScriptName%, FileBrowserSelect, Explorer /select`,
IniRead, FullScreenApps, %ConfigFile%, %ScriptName%, FullScreenApps, %A_Space%
IniRead, NetworkTimeout, %ConfigFile%, %ScriptName%, NetworkTimeout, 15
IniRead, WinModifierFirst, %ConfigFile%, %ScriptName%, WinModifierFirst, 0
IniRead, AllowMultipleInstances, %ConfigFile%, %ScriptName%, AllowMultipleInstances, 0

If ShowHotkeyListH < 100
   ShowHotkeyListH = 330
If ShowHotkeyListW < 150
   ShowHotkeyListW = 580

; Werte fr Statistik initialisiern
IniRead, MaintainStats, %ConfigFile%, %ScriptName%, MaintainStats, 1
If MaintainStats = 1
{
   statTimeLaunched = %A_Now%
   IniRead, statFirstLaunch, %ConfigFile%, Statistics, FirstLaunch, %A_Now%
   If (statFirstLaunch = "" OR statFirstLaunch = 0 OR statFirstLaunch = "ERROR")
      statFirstLaunch = %A_Now%
   IniRead, statLastLaunched, %ConfigFile%, Statistics, LastLaunched
   If (statLastLaunched = 0 OR statLastLaunched = "ERROR" OR statLastLaunched = "")
      statLastLaunched = %A_Now%
   If LastExitReason <> Reload
      IniWrite, %A_Now%, %ConfigFile%, Statistics, LastLaunched
   IniRead, statLaunchCount, %ConfigFile%, Statistics, LaunchCount
   If (statLaunchCount = "" OR statLaunchCount ="ERROR")
      statLaunchCount = 0
   statLaunchCount++
   IniRead, statReloadCount, %ConfigFile%, Statistics, ReloadCount
   If (statReloadCount = "" OR statReloadCount = "ERROR")
      statReloadCount = 0
   IniRead, statUpdateCount, %ConfigFile%, Statistics, UpdateCount
   If (statUpdateCount = "" OR statUpdateCount = "ERROR")
      statUpdateCount = 0
   IniRead, statExitCount, %ConfigFile%, Statistics, ExitCount
   If (statExitCount = "" OR statExitCount = "ERROR")
      statExitCount = 0
   IniRead, statTotalTime, %ConfigFile%, Statistics, TotalTime
   If (statTotalTime = "" OR statTotalTime = "ERROR")
      statTotalTime = 0
   IniRead, statLongestSession, %ConfigFile%, Statistics, LongestSession
   If (statLongestSession = "" OR statLongestSession = "ERROR")
      statLongestSession = 0
}

IniRead, LastScriptversion, %ConfigFile%, %ScriptName%, LastScriptVersion, 0
IniRead, activAid_LastFolder, %ConfigFile%, %ScriptName%, LastFolder, 0
IniRead, HotkeyListAOT, %ConfigFile%, %ScriptName%, HotkeyListAOT, 1

If A_IsCompiled = 1
{
   IniWrite, %_Debug%, %ConfigFile%, %ScriptName%, Debug
   _Devel = 0
}

func_HotkeyRead( "ProblemSolver" , ConfigFile, ScriptName, "Hotkey_ProblemSolver", "sub_ProblemSolver", "#+#" )
func_HotkeyRead( "MainGUI" , ConfigFile, ScriptName, "Hotkey_MainGUI", "sub_MainGUI", "#a" )
func_HotkeyRead( "DisableEnable" , ConfigFile, ScriptName, "Hotkey_DisableEnable", "sub_MenuSuspend", "#+ESCAPE" )
tempsuspend = 0
func_HotkeyRead( "TempSuspend" , ConfigFile, ScriptName, "Hotkey_TemporarySuspend", "sub_TempSuspend", "", "$" )
func_HotkeyRead( "ShowHotkeyList" , ConfigFile, ScriptName, "Hotkey_ShowHotkeyList", "sub_ShowHotkeyList", "^#F1")
func_HotkeyRead( "ShowMainContextMenu" , ConfigFile, ScriptName, "Hotkey_ShowMainContextMenu", "sub_ShowMainContextMenu", "#<")
func_HotkeyRead( "ReloadActivAid" , ConfigFile, ScriptName, "Hotkey_ReloadActivAid", "sub_MenuReload", "#!a" )
func_HotkeyEnable("MainGUI")
func_HotkeyEnable("DisableEnable")
func_HotkeyEnable("TempSuspend")
func_HotkeyEnable("ProblemSolver")
func_HotkeyEnable("ShowHotkeyList")
func_HotkeyEnable("ShowMainContextMenu")
func_HotkeyEnable("ReloadActivAid")

; Skript-berwachung, damit es bei nderung neu geladen wird
If ( _Devel <> 0 AND A_IsCompiled <> 1 AND MainDirNotWriteable = 0)
   SetTimer, tim_UPDATEDSCRIPT, 1000

; Gelegentlich auf NiftyWindows prfen
SetTimer, tim_CheckForNifty, 2000

SetTimer, tim_WM_DISPLAYCHANGE, 2000

; Mauspfeil-Konstanten
IDC_APPSTARTING := 32650
IDC_HAND := 32649
IDC_ARROW := 32512
IDC_CROSS := 32515
IDC_IBEAM := 32513
IDC_ICON := 32641
IDC_NO := 32648
IDC_SIZE := 32640
IDC_SIZEALL := 32646
IDC_SIZENESW := 32643
IDC_SIZENS := 32645
IDC_SIZENWSE := 32642
IDC_SIZEWE := 32644
IDC_UPARROW := 32516
IDC_WAIT := 32514
IDC_HELP := 32651

; -----------------------------------------------------------------------------
; Tray-Men und Icon erstellen
; -----------------------------------------------------------------------------
Menu, Tray, Tip, %ScriptTitle%
Menu, Tray, NoStandard

;Pre-Vista Iconmen ermglichen
#include %A_ScriptDir%\Library\MI.ahk
if _useTrayMenuIcons = 1
{
   WS_EX_APPWINDOW = 0x40000
   WS_EX_TOOLWINDOW = 0x80

   GW_OWNER = 4

   hTM := MI_GetMenuHandle("Tray")
   if (A_OSVersion != "WIN_VISTA")
   {
      OnMessage(0x404, "sub_trayClick")
      MI_SetMenuStyle(hTM, 0x04000000)

   }
}
ReadIcon(lng_Help, A_WinDir "\system32\shell32.dll", 24)
ReadIcon(lng_Extensions, A_WinDir "\system32\shell32.dll", 91)
ReadIcon(lng_Changelog, A_WinDir "\system32\shell32.dll", 214)
ReadIcon(lng_Hotkeys, A_WinDir "\system32\shell32.dll", 212)
ReadIcon("activAid", ScriptOnIcon, 0)
ReadIcon("Info", ScriptOnIcon, 0)
ReadIcon("ShowHotkeyList", A_WinDir "\system32\shell32.dll", 172)
ReadIcon("ShowMainContextMenu", ScriptOnIcon, 0)
ReadIcon("MainContextMenuListLines", ScriptOnIcon, 0)
ReadIcon("MainContextMenuListVars", ScriptOnIcon, 0)
ReadIcon("MainContextMenuListHotkeys", ScriptOnIcon, 0)
ReadIcon("MainContextMenuKeyHistory", ScriptOnIcon, 0)
ReadIcon("MainContextMenuWindowSpy", ScriptOnIcon, 0)
ReadIcon("MainContextMenuMainContext", ScriptOnIcon, 0)
ReadIcon("Update", A_WinDir "\system32\shell32.dll", 89)
ReadIcon("ProblemSolver", A_WinDir "\system32\shell32.dll", 24)
ReadIcon("HideAllExtensions", A_WinDir "\system32\shell32.dll", 218)
ReadIcon("reload", A_WinDir "\system32\shell32.dll", 147)
ReadIcon("deactivate", A_WinDir "\system32\shell32.dll", 110)
ReadIcon("Ahk", A_AhkPath, 1)
ReadIcon("Exit", A_WinDir "\system32\shell32.dll", 28)

Menu, Tray, Add, % lng_Info "`t" func_HotkeyDecompose( Hotkey_MainGUI, 1 ) , sub_MainGUI
Menu, Tray, Add, % lng_ShowHotkeyList "`t" func_HotkeyDecompose( Hotkey_ShowHotkeyList, 1 ) , sub_ShowHotkeyList
Menu, Tray, ToggleEnable, % lng_Info "`t" func_HotkeyDecompose( Hotkey_MainGUI, 1 )

if _useTrayMenuIcons = 1
{
   MI_SetMenuItemIcon(hTM, 1, TrayIcon[Info], TrayIconPos[Info], 16)
   MI_SetMenuItemIcon(hTM, 2, TrayIcon[ShowHotkeyList], TrayIconPos[ShowHotkeyList], 16)
}

If TrayClickOption = 5
{
   Menu, Tray, Add, % lng_ShowMainContextMenu "`t" func_HotkeyDecompose( Hotkey_ShowMainContextMenu, 1 ), sub_ShowMainContextMenu
   if _useTrayMenuIcons = 1
      MI_SetMenuItemIcon(hTM, 3, TrayIcon[ShowMainContextMenu], TrayIconPos[ShowMainContextMenu], 16)
   mi_trayNum = 4
}
else
   mi_trayNum = 3

Loop
{
   actFunct := Extension[%A_Index%]
   If actFunct =
      Break

   If (IsLabel( "TrayClick_" actFunct ))
   {
      RegisterHook("TrayClick",actFunct)
      Gosub, TrayClick_lng_%actFunct%
      lng_TrayClickOptions := lng_TrayClickOptions "|" lng_TrayClick_%actFunct%
   }
}

Loop, Parse, lng_TrayClickOptions, |
{
   If A_Index = %TrayClickOption%
      TrayClickOptionText = %A_LoopField%

   If A_Index = %TrayMClickOption%
      TrayMClickOptionText = %A_LoopField%

   If A_Index = %TrayRClickOption%
      TrayRClickOptionText = %A_LoopField%
}

If TrayClickOption = 6
{
   Menu, Tray, Add, % TrayClickOptionText, sub_MainContextMenuListLines
   if _useTrayMenuIcons = 1
      MI_SetMenuItemIcon(hTM, mi_trayNum, TrayIcon[MainContextMenuListLines], TrayIconPos[MainContextMenuListLines], 16)
   mi_trayNum += 1
}
If TrayClickOption = 7
{
   Menu, Tray, Add, % TrayClickOptionText, sub_MainContextMenuListVars
   if _useTrayMenuIcons = 1
      MI_SetMenuItemIcon(hTM, mi_trayNum, TrayIcon[MainContextMenuListVars], TrayIconPos[MainContextMenuListVars], 16)
   mi_trayNum += 1
}
If TrayClickOption = 8
{
   Menu, Tray, Add, % TrayClickOptionText, sub_MainContextMenuListHotkeys
   if _useTrayMenuIcons = 1
      MI_SetMenuItemIcon(hTM, mi_trayNum, TrayIcon[MainContextMenuListHotkeys], TrayIconPos[MainContextMenuListHotkeys], 16)
   mi_trayNum += 1
}
If TrayClickOption = 9
{
   Menu, Tray, Add, % TrayClickOptionText, sub_MainContextMenuKeyHistory
   if _useTrayMenuIcons = 1
      MI_SetMenuItemIcon(hTM, mi_trayNum, TrayIcon[MainContextMenuKeyHistory], TrayIconPos[MainContextMenuKeyHistory], 16)
   mi_trayNum += 1
}
If TrayClickOption = 10
{
   Menu, Tray, Add, % TrayClickOptionText, sub_MainContextMenuWindowSpy
   if _useTrayMenuIcons = 1
      MI_SetMenuItemIcon(hTM, mi_trayNum, TrayIcon[MainContextMenuWindowSpy], TrayIconPos[MainContextMenuWindowSpy], 16)
   mi_trayNum += 1
}
If TrayClickOption = 11
{
   Menu, Tray, Add, % TrayClickOptionText, sub_MainContextMenuMainContext
   if _useTrayMenuIcons = 1
      MI_SetMenuItemIcon(hTM, mi_trayNum, TrayIcon[MainContextMenuMainContext], TrayIconPos[MainContextMenuMainContext], 16)
   mi_trayNum += 1
}

Loop, Parse, hook_TrayClick, |
{
   If A_LoopField =
      continue
   If (TrayClickOptionText = lng_TrayClick_%A_LoopField%)
   {
      Menu, Tray, Add, % TrayClickOptionText, TrayClick_%A_LoopField%
      if (_useTrayMenuIcons = 1 && IconFile_On_%A_LoopField%!="" && FileExist(IconFile_On_%A_LoopField%))
      {
         ReadIcon(%A_LoopField%, IconFile_On_%A_LoopField%, IconPos_On_%A_LoopField%)
         MI_SetMenuItemIcon(hTM, mi_trayNum, TrayIcon[%A_LoopField%], TrayIconPos[%A_LoopField%], 16)
      }
      mi_trayNum += 1
   }
}

Menu, Tray, Add, %lng_update%, sub_getUpdates
Menu, Tray, Add
Menu, Tray, Add, % lng_ProblemSolver "`t" func_HotkeyDecompose( Hotkey_ProblemSolver, 1 ) , sub_ProblemSolver

if _useTrayMenuIcons = 1
{
   MI_SetMenuItemIcon(hTM, mi_trayNum, TrayIcon[Update], TrayIconPos[Update], 16)
   MI_SetMenuItemIcon(hTM, mi_trayNum+2, TrayIcon[ProblemSolver], TrayIconPos[ProblemSolver], 16)
   mi_trayNum := mi_trayNum + 3
}

If (A_IsCompiled <> 1 AND Extension[1] <> "")
{
   IfExist, extensions
   {
      Menu, Tray, Add, %lng_ExtDeinst%, sub_HideAllExtensions
      if _useTrayMenuIcons = 1
      {
         MI_SetMenuItemIcon(hTM, mi_trayNum, TrayIcon[HideAllExtensions], TrayIconPos[HideAllExtensions], 16)
         mi_trayNum := mi_trayNum + 1
      }
   }
}

Menu, Tray, Add, %lng_reload%, sub_MenuReload
Menu, Tray, Add, %lng_exit% , sub_MenuExit
Menu, Tray, Add
mi_trayNum := mi_trayNum + 2
If (TrayClickOption >= 6 AND TrayClickOption <= 11)
   TrayMenu = 9
Else
   TrayMenu = 8

TrayMenuFirstExtension := TrayMenu - 1


; GuiIDs vordefinieren

CreateGuiID("activAid") ; 1
CreateGuiID("HelpWindow") ; 2
CreateGuiID("HotkeyList") ; 4
CreateGuiID("ManualUpdate") ; 5
CreateGuiID("GetPasswords") ; 5
CreateGuiID("Statistics") ; 12
CreateGuiID("Duplicates")
CreateGuiID("VarDump")

Gosub, sub_DefaultWindowsHotkeyList

; Updates durchfhren
If (LastScriptVersion <> ScriptVersion OR activAid_LastDateTime <> activAid_CurrDateTime OR activAid_LastFolder <> A_ScriptDir)
{
   Gosub, Update_activAid
   Loop
   {
      actFunct := Extension[%A_Index%]
      If actFunct =
         Break

      If (IsLabel( "update_" actFunct ))
      {
         Debug("INIT", A_LineNumber, A_LineFile, "DoUpdate_" Function "...")
         Gosub, update_%actFunct%
      }
   }
   #Include *i %A_ScriptDir%\Library\update-scripts.ahk

   IniWrite, %Scriptversion%, %ConfigFile%, %ScriptName%, LastScriptVersion
   IniWrite, %activAid_CurrDateTime%, %ConfigFile%, %ScriptName%, activAid_DateTime
   IniWrite, %A_ScriptDir%, %ConfigFile%, %ScriptName%, LastFolder

   Debug("RELOAD",A_LineNumber,A_LineFile,"do Updates")
   LeaveAdmin =
   Gosub, Reload
}

If AllowMultipleInstances = 0
{
   Critical, On
   DetectHiddenWindows, On
   OnMessage(0x1ccc,"GetExternalActivAidProcessID")
   WinGet, activAidProcesses, List, ahk_class AutoHotkey
   Loop, %activAidProcesses%
   {
      SendMessage, 0x1ccc, 1,,, % "ahk_id " activAidProcesses%A_Index%
      If (ErrorLevel <> activAidPID AND ErrorLevel > 1)
      {
         SetTimer, tim_Loading, Off
         SplashImage, Off
         SplashImage, 2:Off
         MsgBox, 52, %ScriptTitle%, %lng_AnotherActivAidActive%
         IfMsgBox, No
            ExitApp
         Break
      }
   }
   If (!InStr( A_Args, "nosplash" ) OR LastExitReason <> "")
   {
      SplashImage, 2:%SplashIcon%,b2 FS%FontSize5% C c00 ZY2 ZX2 w36, %A_Space%,,, Terminal
      SetTimer, tim_Loading, 50
   }
   DetectHiddenWindows, Off
   Critical, Off
}

; Menpunkt fr jede eingebundenen Funktionen erstellen
Loop
{
   actFunct := Extension[%A_Index%]
   actEnable = Enable_%actFunct%
   actHideGui = HideInGui_%actFunct%
   actEnableTray = EnableTray_%actFunct%

   If actFunct =
      Break

   If ExtensionLoadingTime[%actFunct%] <>
   {
      ExtensionConflictDuplicates++
      ExtensionConflict++
   }

   ExtensionLoadingTime[%actFunct%] = %A_TickCount%

   IniRead, %actEnable%, %ConfigFile%, %ScriptName%, %actEnable%, 1
   If %actEnable% =
      %actEnable% = 1

   IniRead, %actHideGui%, %ConfigFile%, %ScriptName%, %actHideGui%, 0

   HideSettings = 0

   If IsLabel( "init_" actFunct )
   {
      Debug("EXTENSION", A_LineNumber, A_LineFile, "Initializing extension: " actFunct)
      Gosub, init_%actFunct%
   }
   Else
   {
      HideSettings = 1
      Enable_%actFunct% = 0
      EnableTray_%actFunct% = 0
      ExtensionConflict++
   }

   If HideSettings = 1
      EnableTray_%actFunct% = 0

   If (DisableIfCompiled_%actFunct% = 1 AND A_IsCompiled = 1)
      EnableTray_%actFunct% = 0

   If %actEnableTray% <> 0
   {
      IniRead, %actEnableTray%, %ConfigFile%, %ScriptName%, %actEnableTray%, 1
      If %actEnableTray% =
            %actEnableTray% = 1
   }

;   If HideInGui_%actFunct% = 1
;      %actEnableTray% = 0

   EnableTrayAll := EnableTrayAll %actEnableTray%

   EnableTray_%actFunct%_tmp := %actEnableTray%

   ExtensionCleanMenuName[%A_Index%] = %MenuName%

   If CustomHotkey_%actFunct% = 1
   {
      func_HotkeyRead( actFunct, ConfigFile, actFunct, "Hotkey_" actFunct, "sub_Hotkey_" actFunct, Hotkey_%actFunct%, HotkeyPrefix_%actFunct%, HotkeyClasses_%actFunct% )
      MenuName := MenuName "`t" func_HotkeyDecompose( Hotkey_%actFunct%, 1 )
   }

   If (CustomHotkey_%actFunct% <> 1 AND CustomHotkey_%actFunct% <> "")
   {
      CustomHotkeyVar := "Hotkey_" CustomHotkey_%actFunct%
      MenuName := MenuName "`t" func_HotkeyDecompose( %CustomHotkeyVar%, 1 )
   }

   ExtensionIndex[%actFunct%] = %A_Index%
   ExtensionPrefix[%A_Index%] = %Prefix%
   ExtensionPrefix[%actFunct%] = %Prefix%
   ExtensionMenuName[%A_Index%] = %MenuName%
   ExtensionMenuName[%actFunct%] = %MenuName%
   ExtensionHideSettings[%A_Index%] = %HideSettings%
   If HideInGui_%actFunct% = 1
      ExtensionHideSettings[%A_Index%] = 1
   Extension[%actFunct%] = 1
   ExtensionDescription[%actFunct%] = %Description%
   ExtensionVersion[%actFunct%] := %Prefix%_ScriptVersion

   If ExeDistribution = 1
      ExtensionsInExtDir = %ExtensionsInExtDir%%actFunct%|

   If IsLabel( "init_" actFunct )
   {
      ReadIcon(actFunct, IconFile_On_%actFunct%, IconPos_On_%actFunct%, IconFile_Off_%actFunct%, IconPos_Off_%actFunct%)
      If %actEnable% = 1
      {
         If CustomHotkey_%actFunct% = 1
            func_HotkeyEnable( actFunct )
         Gosub, DoEnable_%actFunct%
      }
      Else
      {
         If CustomHotkey_%actFunct% = 1
            func_HotkeyDisable( actFunct )
      }
      If HideInGui_%actFunct% = 1
      {
         HiddenInGui++
         Menu, RemovedExtensions, Add, %actFunct%, sub_RestoreExtToGUI
      }
      Gosub, sub_MenuCreate
      SubMenu =
   }
   NumFunctions = %A_Index%
   ExtensionLoadingTime[%actFunct%] := A_TickCount-ExtensionLoadingTime[%actFunct%]
}

If HiddenInGui =
{
   Menu, RemovedExtensions, Add, %lng_none%, sub_RestoreExtToGUI
   Menu, RemovedExtensions, Disable, %lng_none%
}

Gosub, DoEnable_MButton
Gosub, DoEnable_RButton

Menu, Tray, Delete, %lng_reload%
Menu, Tray, Delete, %lng_exit%

; Unterer Teil des Mens mit 'deaktivieren' und 'beenden'.
If TrayExtensions <>
   Menu, Tray, Add
Else
   mi_trayNum--

Menu, Tray, Add, % lng_reload "`t" func_HotkeyDecompose( Hotkey_ReloadActivAid, 1 ), sub_MenuReload
Menu, Tray, Add, % lng_deactivate "`t" func_HotkeyDecompose( Hotkey_DisableEnable, 1 ), sub_MenuSuspend

if _useTrayMenuIcons = 1
{
   ;mi_trayNum := mi_trayNum + 2
   MI_SetMenuItemIcon(hTM, mi_trayNum, TrayIcon[reload], TrayIconPos[reload], 16)
   MI_SetMenuItemIcon(hTM, mi_trayNum+1, TrayIcon[deactivate], TrayIconPos[deactivate], 16)
   mi_trayNum := mi_trayNum + 2
}

If _Debug = 1
{
   Menu, Tray, Add
   Menu, AHKMenu, Standard

   if _useTrayMenuIcons = 1
   {
      h_ahkTM := MI_GetMenuHandle("AHKMenu")
      MI_SetMenuStyle(h_ahkTM, 0x4000000)
      SplitPath, A_AhkPath,, SpyPath
      SpyPath = %SpyPath%\AU3_Spy.exe
      MI_SetMenuItemIcon(h_ahkTM, 1, A_AhkPath, 1, 16) ; open
      MI_SetMenuItemIcon(h_ahkTM, 2, A_WinDir "\hh.exe", 1, 16) ; help
      ;-
      MI_SetMenuItemIcon(h_ahkTM, 4, SpyPath,   1, 16) ; spy
      MI_SetMenuItemIcon(h_ahkTM, 5, TrayIcon[reload], TrayIconPos[reload], 16)
      MI_SetMenuItemIcon(h_ahkTM, 6, A_AhkPath, 2, 16) ; edit
      ;-
      MI_SetMenuItemIcon(h_ahkTM, 8, A_AhkPath, 3, 16) ; suspend
      MI_SetMenuItemIcon(h_ahkTM, 9, A_AhkPath, 4, 16) ; pause
      MI_SetMenuItemIcon(h_ahkTM, 10, TrayIcon[Exit], TrayIconPos[Exit], 16) ; exit
   }
   Menu, Tray, Add, AutoHotkey, :AHKMenu

   if _useTrayMenuIcons = 1
   {
      MI_SetMenuItemIcon(hTM, mi_trayNum+1, TrayIcon[Ahk], TrayIconPos[Ahk], 16)
      mi_trayNum := mi_trayNum + 2
   }

}
Menu, Tray, Add
Menu, Tray, Add, %lng_exit% , sub_MenuExit

if _useTrayMenuIcons = 1
{
   MI_SetMenuItemIcon(hTM, mi_trayNum+1, TrayIcon[Exit], TrayIconPos[Exit], 16)
   mi_trayNum := mi_trayNum + 1
}

; -----------------------------------------------------------------------------

If TrayClickOption = 1
   Menu, Tray, Default, % lng_Info "`t" func_HotkeyDecompose( Hotkey_MainGUI, 1 )
If TrayClickOption = 2
   Menu, Tray, Default, % lng_deactivate "`t" func_HotkeyDecompose( Hotkey_DisableEnable, 1 )
If TrayClickOption = 3
   Menu, Tray, Default, % lng_reload "`t" func_HotkeyDecompose( Hotkey_ReloadActivAid, 1 )
If TrayClickOption = 4
   Menu, Tray, Default, % lng_ShowHotkeyList "`t" func_HotkeyDecompose( Hotkey_ShowHotkeyList, 1 )
If TrayClickOption = 5
   Menu, Tray, Default, % lng_ShowMainContextMenu "`t" func_HotkeyDecompose( Hotkey_ShowMainContextMenu, 1 )
If (TrayClickOption >= 6 )
   Menu, Tray, Default, %TrayClickOptionText%

AutoTrim, Off

If tempAdminMode = 1
   lng_UpdateSuccess = %lng_UpdateSuccess%`n`n%lng_AdminAttention%

; Readme-Datei einlesen
gosub, sub_GetReadme

; Changelog-Datei einlesen
gosub, sub_GetChangeLog

AutoTrim, On

; Problembehebung erforderlich?
; Prfe ob versteckte Fenster nicht wiederhergestellt wurden
IniRead, TempDeskWindowsToMaximize, %ConfigFile%, TemporaryDesktop, WindowsToMaximize
If TempDeskWindowsToMaximize = ERROR
   TempDeskWindowsToMaximize =
IniRead, HiddenWindows, %ConfigFile%, HiddenWindows, WindowList
If HiddenWindows = ERROR
   HiddenWindows =
If HiddenWindows <>
   HiddenWindows = %HiddenWindows%|
StringReplace, HiddenWindows, HiddenWindows, ||,, a

IniRead, TempDeskWindows, %ConfigFile%, TemporaryDesktop, Windows
If TempDeskWindows = ERROR
   TempDeskWindows =

Loop, Parse, TempDeskWindows, |
{
   If A_LoopField =
      continue
   IniRead, TempDeskWindowX[%A_LoopField%], %ConfigFile%, TemporaryDesktop, WindowPosX%A_LoopField%
   IniRead, TempDeskWindowY[%A_LoopField%], %ConfigFile%, TemporaryDesktop, WindowPosY%A_LoopField%
   IniRead, TempDeskWindowMax[%A_LoopField%], %ConfigFile%, TemporaryDesktop, WindowMax%A_LoopField%
}

If HiddenWindows = ERROR
   HiddenWindows =

If ( HiddenWindows <> "" OR TempDeskWindows <> "" )
{
   ProbSolvStartMessage = %lng_ProbSolvWhy%`n`n
   Gosub, sub_ProblemSolver
}
If ShowGUI =
   IniRead, ShowGUI, %ConfigFile%, %ScriptName%, ShowGUI, 0

; Skript aktualisiert?
WorkingDir = %A_WorkingDir%
SetWorkingDir, %A_ScriptDir%

IfExist, versions.ini
{
   IniRead, tmp_avail, %ConfigFile%, activAid, AvailableExtensions
   If tmp_avail = ERROR
   {
      FileDelete, versions.ini
   }
   Else
   {
      IniRead, newScriptVersion, versions.ini, activAid, version
      IniRead, newScriptExtension, versions.ini, activAid, Extensions
      FileMove, versions.ini, update.exe, 1
      IniWrite, %newScriptExtension%, %ConfigFile%, activAid, newext
      IniWrite, %newScriptVersion%, %ConfigFile%, activAid, newver
   }
}

IfExist, ac'tivAid-updater.exe
{
   FileDelete, ac'tivAid-updater.exe
   If A_IsCompiled = 1
   {
      IniRead, CreateUninstaller, %ConfigFile%, %ScriptName%, CreateUninstaller
      If CreateUninstaller = 1
         IniWrite, 2, %ConfigFile%, %ScriptName%, CreateUninstaller
      tempAdminMode = 1
   }
}

If (FileExist("update.exe") OR FileExist("update.zip"))
{
   FileSetAttrib,-A,%A_ScriptFullPath%
   FileSetAttrib,-R,update.exe
   FileSetAttrib,-R,update.zip
   FileSetAttrib,-R,update.cmd
   FileDelete, update.zip
   FileDelete, update.exe
   FileDelete, AutoHotkeyInstall.exe
   FileDelete, update_autohotkey.exe
   FileDelete, update.cmd
   IniRead, newext, %ConfigFile%, activAid, newext, %A_Space%
   IniRead, updScriptVersion, %ConfigFile%, activAid, newver
   newext = %newext%
   updScriptExtension =
   updScriptExtension_line := "  "
   Loop, Parse, newext, `,
   {
      IfNotInstring, ExtensionsInExtDir, %A_LoopField%`,
      {
         updScriptExtension_line := updScriptExtension_line A_LoopField "`, "
         If ( StrLen( updScriptExtension_line ) > 77)
         {
            updScriptExtension := updScriptExtension "`n  "
            updScriptExtension_line := "  " A_LoopField "`, "
         }
         updScriptExtension := updScriptExtension A_LoopField "`, "
      }
   }
   If ExtensionsInExtDir = ERROR
      updScriptExtension =
   StringTrimRight, updScriptExtension, updScriptExtension, 2
   IniDelete, %ConfigFile%, activAid, newver
   IniDelete, %ConfigFile%, activAid, newext
   ListBox_selected = 2
   ShowGui = 1

   Loop
   {
      IniRead, FileToDelete, %ConfigFile%, DeleteAfterUpdate, DeleteFile%A_Index%
      If FileToDelete = ERROR
         break
      StringReplace, FileToDelete, FileToDelete, /, \, A
      StringReplace, FileToDelete, FileToDelete, %A_WorkingDir%\,
      StringReplace, FileToDelete, FileToDelete, %A_ScriptDir%\,
      If (func_StrLeft(FileToDelete,1) = "\" OR InStr(FileToDelete, "\\") OR InStr(FileToDelete, ":\"))
         continue
      FileDelete, %FileToDelete%
      IfExist, %A_ScriptDir%\%FileToDelete%
         FileDelete, %A_ScriptDir%\%FileToDelete%
   }
}

SetWorkingDir, %WorkingDir%
SplitPath, A_WorkingDir,,BackupDir
BackupDir = %BackupDir%\ac'tivAid_backup

; Wchentliches Update
IniRead, UpdateImmediatly, %ConfigFile%, %ScriptName%, CheckForUpdates, 0
IfInString, A_Args, SimulateUpdate
   SimulateUpdate = 1
IniDelete, %ConfigFile%, %ScriptName%, CheckForUpdates
IniRead, AutoUpdate, %ConfigFile%, %ScriptName%, AutoUpdate
IniRead, DelayedUpdateCheck, %ConfigFile%, %ScriptName%, DelayedUpdateCheck, %A_Space%
IniRead, LastUpdate, %ConfigFile%, %ScriptName%, LastUpdate
UpdateDiff := (A_YYYY A_YDay) - LastUpdate

; Update-URLs
IniRead, UpdateURLbeta, %ConfigFile%, %ScriptName%, UpdateURL

If (UpdateURLbeta = "ERROR" OR UpdateURLbeta = "")
   UpdateURLbeta = http://activaid.rumborak.de/ahk-versions.ini

UpdateURLrelease = http://www.heise.de/ct/activaid/versions.ini

If ((UpdateURL = "ERROR" OR UpdateURL = "") AND Betatester = 1)
   UpdateURL = %UpdateURLbeta%

If (UpdateURL = "ERROR" OR UpdateURL = "") ; OR ExeDistribution = 1)
   UpdateURL = %UpdateURLrelease%
Else
   LastUpdate = ERROR

;If LeaveAdmin = 1
;{
;   StringReplace, A_Args, A_Args, LeaveAdmin
;   Gosub, sub_LeaveAdmin
;}

If ( ( (AutoUpdate = "1" AND (LastUpdate = "" OR LastUpdate = "ERROR" OR UpdateDiff >6 )) AND func_CheckIfOnline() = 1 ) OR (UpdateImmediatly = 1 AND main_IsAdmin = 1) )
{
   If DelayedUpdateCheck =
      Gosub, sub_AutoUpdate
   If AutoUpdate = 1
      SetTimer, tim_AutoUpdate, 86400000  ; 24*60*60*1000 = Alle 24 Std. prfen
   If DelayedUpdateCheck+0 > 0
      SetTimer, tim_AutoUpdate, % -(DelayedUpdateCheck*1000)
   If DelayedUpdateCheck = On
      SetTimer, tim_AutoUpdate, -30000 ; 30 Sekunden
}

; Sprachen ermitteln
IfExist, settings\language.ini
{
   FileReadLine, iniLanguage, settings\language.ini, 1
   StringTrimLeft, iniLanguage, iniLanguage, 31
}

Languages = [ automatisch ermitteln / autodetect ]|Deutsch (German)|English|language-files

LanguageNum = 4
Loop, %A_ScriptDir%\settings\languages\language_*.ini,0,1
{
   FileReadLine, tempLanguage, %A_LoopFileFullPath%, 1
   IfNotInString, tempLanguage, `; Language-file for ac'tivAid:
      continue
   LanguageNum++
   StringTrimLeft, tempLanguage, tempLanguage, 31
   Languages = %Languages%|%tempLanguage%
   LanguagesFile[%LanguageNum%] = %A_LoopFileFullPath%
   If tempLanguage = %iniLanguage%
      actLanguage = %LanguageNum%
}
IfNotExist, settings\language.ini
{
   If Lng = 07
      actLanguage = 2
   Else
      actLanguage = 3
}
Else If actLanguage =
{
   LanguageNum++
   actLanguage := LanguageNum
   Languages = %Languages%|%iniLanguage%
   LanguagesFile[%actLanguage%] = settings\language.ini
}
If LanguageNum < 5
   StringReplace, Languages, Languages, |language-files,,

MinusString = 
If A_OSversion = WIN_NT4
{
   StringReplace, Languages, Languages, , --, All
   MinusString = --
}

SetTimer, tim_Loading, Off
SplashImage, 2:Off

If _SingleClickTrayAction = 1
   Menu, Tray, Click, 1
Else
   Menu, Tray, Click, 2

If NoTrayIcon <> 1
{
   Menu, Tray, Icon, %ScriptOnIcon%, %ScriptOnIcon#%, 1
   Menu, Tray, Icon
   Gui, 1:Destroy
   mainGuiID =
}

Gui, 1:+LastFound
activAidID := WinExist()

ToolTip
Suspend, Off

Loop
{
   If Extension[%A_Index%] =
      break
   Function := Extension[%A_Index%]
   If ( IsLabel("OnResume_" Function) )
   {
      Debug("STATUS", A_LineNumber, A_LineFile, "OnResume_" Function "...")
      Gosub, OnResume_%Function%
   }
}

Menu, Tray, ToggleEnable, % lng_Info "`t" func_HotkeyDecompose( Hotkey_MainGUI, 1 )

func_AutoVSplitMenu("Tray")

Debug("INIT", A_LineNumber, A_LineFile, "Init finisehd: " A_TickCount - InitTime " ms")

LoadingFinished = 1
LoadingTime := A_TickCount-InitTime


Gosub, sub_RestoreKeyStates
SplashImage, Off
SplashImage, 2:Off

func_AddMessage(0x100,"sub_ExtendEdit1Controls")
func_AddMessage(0x218,"sub_OnWakeUp") ; WM_POWERBROADCAST

If (ShowGUI > 0 OR ExtensionConflict <> "")
{
   If ExtensionConflict <>
      ListBox_selected = 6
   IniDelete, %ConfigFile%, %ScriptName%, ShowGUI
   SetTimer, tim_LaunchGUI, -20
}

IniRead, ShowVarDump, %ConfigFile%, %ScriptName%, ShowVarDump, %A_Space%
IniDelete, %ConfigFile%, %ScriptName%, ShowVarDump
If ShowVarDump = 1
   SetTimer, sub_VarDumpGUI, -20

SetTimer, CreateUninstallFile, -20

SetTimer, sub_ShowDuplicates, -2000
If (AHKonUSB <> 1 AND LastExitReason <> "Reload")
   IfExist, Portable_ac'tivAid.exe
      BalloonTip(ScriptTitle, lng_PortableExe,"Info",0,0,20)

IfExist, %A_ScriptDir%\installer.exe
{
   IniRead, CreateUninstaller, %ConfigFile%, %ScriptName%, CreateUninstaller
   If CreateUninstaller = 1
      IniWrite, 2, %ConfigFile%, %ScriptName%, CreateUninstaller
   FileDelete, %A_ScriptDir%\installer.exe
   tempAdminMode = 1
}

DllCall("kernel32.dll\SetProcessShutdownParameters", UInt, 0x4FF, UInt, 0)

SetTimer, sub_AfterLoadingProcesses, -5000

; Benutzerdefinierte Funktionen einfgen
IfExist, settings\includescript.ahk
   Debug("INIT", A_LineNumber, A_LineFile, "#including includescript.ahk ..." )
#Include *i settings\includescript.ahk
Return

/*
; LibCurl Timer
lc_tim_Messages:
   lc_checkForMessages()
return

lc_thread_perform:
   lc_performLoop()
   lc_finishAll()
return

downFini:
   text := lc_history_url[%lc_historySize%] "`nhas finished downloading!`nAverage Speed: " lc_history_speed[%lc_historySize%] "bytes/s`nTotal Time: " lc_history_time[%lc_historySize%] "sec"
   TrayTip, libCurl Test, %text%, 4, 1
return

lc_tim_Progress:
   ;Progress, %Percent%, %KBNow% of %KBTotal% KB (%Percent% `%)

   TooltipText =
   firstFound = 1
   Loop, %lc_hCurlMaxTransfers%
   {
      if lc_easyHandles%A_Index% !=
      {
         If firstFound != 1
            TooltipText = %TooltipText%`n`n
         else
            firstFound = 0

         TooltipText := TooltipText "Download No. " A_Index ": " lc_url[%A_Index%] "`n" lc_KBNow[%A_Index%] " of " lc_KBTotal[%A_Index%] " KB (" lc_Percent[%A_Index%] "`%)"

         lc_hPosTmp := 0
         lc_hPosTmp := lc_history_pos[%A_Index%]
         if lc_hPosTmp > 0
            TooltipText := TooltipText "`nAverage Speed: " lc_history_speed[%lc_hPosTmp%] "bytes/s`nTotal Time: " lc_history_time[%lc_hPosTmp%] "sec"
      }
   }

   ToolTip, %TooltipText%
return
*/
sub_trayClick(wParam, lParam)
{
    global ; hTM, M_IsPaused, TrayRClickOption, TrayMClickOption, hook_TrayClick, TrayRClickOptionText, TrayMClickOptionText

    if (lParam = 0x202) ; WM_LBUTTONUP
    {

      IfWinActive, Expose
         msgbox, doh
       ;  gosub, rex_Window_Activate
      return 0
    }

    if (lParam = 0x205) ; WM_RBUTTONUP
    {
      If TrayRClickOption = 1
         gosub, sub_MainGUI
      If TrayRClickOption = 2
         gosub, sub_MenuSuspend
      If TrayRClickOption = 3
         gosub, sub_MenuReload
      If TrayRClickOption = 4
         gosub, sub_ShowHotkeyList
      If TrayRClickOption = 5
         gosub, sub_ShowMainContextMenu
      If TrayRClickOption = 6
         gosub, sub_MainContextMenuListLines
      If TrayRClickOption = 7
         gosub, sub_MainContextMenuListVars
      If TrayRClickOption = 8
         gosub, sub_MainContextMenuListHotkeys
      If TrayRClickOption = 9
         gosub, sub_MainContextMenuKeyHistory
      If TrayRClickOption = 10
         gosub, sub_MainContextMenuWindowSpy
      If TrayRClickOption = 11
         gosub, sub_MainContextMenuMainContext

      return 0
    }

    if (lParam = 0x208) ; WM_MBUTTONUP
    {
      If TrayMClickOption = 1
         gosub, sub_MainGUI
      If TrayMClickOption = 2
         gosub, sub_MenuSuspend
      If TrayMClickOption = 3
         gosub, sub_MenuReload
      If TrayMClickOption = 4
         gosub, sub_ShowHotkeyList
      If TrayMClickOption = 5
         gosub, sub_ShowMainContextMenu
      If TrayMClickOption = 6
         gosub, sub_MainContextMenuListLines
      If TrayMClickOption = 7
         gosub, sub_MainContextMenuListVars
      If TrayMClickOption = 8
         gosub, sub_MainContextMenuListHotkeys
      If TrayMClickOption = 9
         gosub, sub_MainContextMenuKeyHistory
      If TrayMClickOption = 10
         gosub, sub_MainContextMenuWindowSpy
      If TrayMClickOption = 11
         gosub, sub_MainContextMenuMainContext

      Loop, Parse, hook_TrayClick, |
      {
         If A_LoopField =
            continue

         If (TrayMClickOptionText = lng_TrayClick_%A_LoopField%)
            gosub, TrayClick_%A_LoopField%
      }

      return 0
    }
}

sub_DefaultWindowsHotkeyList:
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<#e ShowExplorer>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^Escape ShowStartMenu>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<+F10 ShowContextMenu>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<AppsKey ShowContextMenu>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<#r ShowRunDialog>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<#m MinimizeAllWindows>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<#+m RestoreAllWindows>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<#d ToggleDesktop>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<#b SetFocusToSysTray>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<#l LockWorkstation>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<#f ShowExplorerFindDialog>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<F3 Find>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<#u OpenUtilityManager>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<#F1 OpenWindowsHelp>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<#Pause OpenSystemProperties>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<#Tab CycleTaskbarButtons>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<#+Tab CycleTaskbarButtons>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<!Tab TaskSwitcher>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<!+Tab TaskSwitcher>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<!Escape TopWindowToBottom>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<!+Escape BottomWindowToTop>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<!F4 CloseWindow>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^!Delete ShowTaskmanager>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^!NumpadDel ShowTaskmanager>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^+Escape ShowTaskmanager>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<PrintScreen ScreenShotToClipboard>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<!PrintScreen WindowShotToClipboard>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^c CopyToClipboard>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^x CutToClipboard>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^p PasteFromClipboard>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^n NewFile>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^s SaveFile>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^o OpenFile>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^p PrintFile>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^z Undo>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^a SelectAll>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^f Find>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^F4 CloseTabOrChildWindow>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<F1 OpenHelp>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<F10 SetFocusToMenuBar>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<!Space ShowSystemMenu>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<Escape DefocusOrClose>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<Tab InsertTabOrCycleControls>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<+Tab InsertTabOrCycleControls>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^Tab CycleTabsOrChildWindows>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^+Tab CycleTabsOrChildWindows>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<Enter Enter>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<Space Space>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^Left MoveCursor>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^Right MoveCursor>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^Up MoveCursor>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^Down MoveCursor>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<+Left MoveCursorAndSelect>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<+Right MoveCursorAndSelect>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<+Up MoveCursorAndSelect>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<+Down MoveCursorAndSelect>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^+Left MoveCursorAndSelect>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^+Right MoveCursorAndSelect>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^+Up MoveCursorAndSelect>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^+Down MoveCursorAndSelect>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<End MoveCursor>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<Home MoveCursor>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^End MoveCursor>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^Home MoveCursor>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<+End MoveCursorAndSelect>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<+Home MoveCursorAndSelect>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^+End MoveCursorAndSelect>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^+Home MoveCursorAndSelect>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<Backspace Backspace>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<Delete Delete>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^Backspace Backspace>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<^Delete Delete>
   Hotkey_WindowsHotkeys = %Hotkey_WindowsHotkeys%<+Delete DeleteFileOrSelection>
Return

sub_AdminAttentionDialog:
   Gui %GuiID_activAid%:+OwnDialogs
   IfInString, Changelog, %lng_UpdateSuccess%
   {
      MsgBox, 52, %ScriptTitle%, %lng_AdminAttention%`n`n  %lng_AdminAttentionAsk%
      LeaveAdmin = 1
      IfMsgBox, Yes
         Gosub, Reload
   }
   Else
      MsgBox, 48, %ScriptTitle%, %lng_AdminAttention%
Return

sub_AfterLoadingProcesses:
   If tempAdminMode = 1
   {
      Gosub, sub_AdminAttentionDialog
   }

   IniRead, DisableToggleLayoutQuestion, %ConfigFile%, %ScriptName%, DisableToggleLayoutQuestion, 0
   RegRead, KeyBoardLayoutReg1, HKEY_CURRENT_USER, Keyboard Layout\Toggle, Hotkey
   RegRead, KeyBoardLayoutReg2, HKEY_CURRENT_USER, Keyboard Layout\Toggle, Language Hotkey
   RegRead, KeyBoardLayoutReg3, HKEY_CURRENT_USER, Keyboard Layout\Toggle, Layout Hotkey
   If (KeyBoardLayoutReg1 KeyBoardLayoutReg2 KeyBoardLayoutReg3 <> "333" AND DisableToggleLayoutQuestion = 0)
   {
      MsgBox, 52, %ScriptTitle%, %lng_DisableToggleLayout%
      IfMsgBox, Yes
      {
         RegWrite, REG_SZ, HKEY_CURRENT_USER, Keyboard Layout\Toggle, Hotkey, 3
         RegWrite, REG_SZ, HKEY_CURRENT_USER, Keyboard Layout\Toggle, Language Hotkey, 3
         RegWrite, REG_SZ, HKEY_CURRENT_USER, Keyboard Layout\Toggle, Layout Hotkey, 3
         DllCall("SystemParametersInfo", "Uint", 91, "Uint", 0, "str", 0, "Uint", 0)
      }
      IniWrite, 1, %ConfigFile%, %ScriptName%, DisableToggleLayoutQuestion
   }

   Loop
   {
      If Extension[%A_Index%] =
         break
      Function := Extension[%A_Index%]
      If ( IsLabel("AfterLoadingProcess_" Function) )
         Gosub, AfterLoadingProcess_%Function%
   }
Return

tim_LaunchGUI:
   If tim_LaunchGUI = 1
      Return
   tim_LaunchGUI = 1
   Gosub, sub_MainGUI
   If ShowGUI = 2
      Gosub, sub_CallFAQ
Return

GetExternalActivAidProcessID(wParam, lParam, msg, hwnd)
{
   global
   If (wParam = 1) ; Check if RunWithAdminRights.ahk is running
      Return %activAidPID%
   Return 0
}

; -----------------------------------------------------------------------------
; === Subroutines =============================================================
; -----------------------------------------------------------------------------

sub_ShowDuplicates:
   Critical
   If (Hotkey_AllDuplicates = "" OR Hotkey_AllDuplicates = "`n")
   {
      Gosub, DuplicatesGuiClose
      Return
   }

   Gui, %GuiID_Duplicates%:+LastFoundExist
   IfWinExist
      Gosub, DuplicatesGuiClose

   IniRead, ShowDuplicatesGuiX, %ConfigFile%, %ScriptName%, ShowDuplicatesGuiX
   IniRead, ShowDuplicatesGuiY, %ConfigFile%, %ScriptName%, ShowDuplicatesGuiY

   If ShowDuplicatesGuiX = ERROR
      ShowDuplicatesGuiX =
   Else
   {
      If (ShowDuplicatesGuiX < MonitorAreaLeft)
         ShowDuplicatesGuiX := MonitorAreaLeft
      If (ShowDuplicatesGuiX+420+BorderHeight*2 > MonitorAreaRight)
         ShowDuplicatesGuiX := MonitorAreaRight-(420+BorderHeight*2)
      ShowDuplicatesGuiX = x%ShowDuplicatesGuiX%
   }
   If ShowDuplicatesGuiY = ERROR
      ShowDuplicatesGuiY =
   Else
   {
      If (ShowDuplicatesGuiY < MonitorAreaTop)
         ShowDuplicatesGuiY := MonitorAreaTop
      If (ShowDuplicatesGuiY+480+MenuBarHeight+BorderHeight*2+CaptionHeight > MonitorAreaBottom)
         ShowDuplicatesGuiY := MonitorAreaBottom-(480+MenuBarHeight+BorderHeight*2+CaptionHeight)
      ShowDuplicatesGuiY = y%ShowDuplicatesGuiY%
   }

   ShowDuplicatesID := GuiDefault("Duplicates","+ToolWindow +LastFoundExist +AlwaysOnTop")
   Gui, Add, Text, w400, %lng_DuplicateHotkeys%
   Gui, Add, ListView, h300 w400 gsub_DuplicatesSelect vDuplicatesList -wrap +VScroll +HScroll, %lng_DuplicateCol1%|%lng_DuplicateCol2%|%lng_DuplicateCol3%
   GuiControl, -Redraw, DuplicatesList
   DuplicatesVisible = 0
   Duplicate = 0
   LastLoopField2 =

   Loop, Parse, Hotkey_AllDuplicates, `n
   {
      If A_LoopField =
         continue
      StringSplit, LoopField, A_LoopField, %A_Tab%
      If (LoopField2 <> LastLoopField2 AND LoopField2 <> "*" LastLoopField2 AND "*" LoopField2 <> LastLoopField2)
      {
         Duplicate++
         DuplicatesVisible%Duplicate% = 0
      }

      If (Enable_%LoopField1% = 1 OR LoopField1 = "activAid")
      {
         DuplicatesVisible++
         DuplicatesVisible%Duplicate%++
         If DuplicatesVisible%Duplicate% = 1
         {
            Duplicate--
            If DuplicatesVisible%Duplicate% = 1
            {
               DuplicatesVisible--
               LV_Delete(DuplicatesVisible)
            }
            Duplicate++
         }
         LV_Add("", LoopField1, LoopField2, LoopField3)
         LastLoopField2 := LoopField2
      }
   }
   If DuplicatesVisible%Duplicate% = 1
   {
      LV_Delete(DuplicatesVisible)
      DuplicatesVisible--
   }
   LV_ModifyCol()
   GuiControl, +Redraw, DuplicatesList
   If DuplicatesVisible = 0
      Gui, Destroy
   Else
      Gui, Show, %ShowDuplicatesGuiX% %ShowDuplicatesGuiY%, %ScriptNameFull% - %lng_DuplicateTitle%
Return

DuplicatesGuiEscape:
DuplicatesGuiClose:
   Gui, %GuiID_Duplicates%:+LastFoundExist
   IfWinNotExist
      Return

   If ShowDuplicatesGuiX <> Reset
   {
      WinGetPos, ShowDuplicatesGuiX, ShowDuplicatesGuiY, , , ahk_id %ShowDuplicatesID%
      IniWrite, %ShowDuplicatesGuiX%, %ConfigFile%, %ScriptName%, ShowDuplicatesGuiX
      IniWrite, %ShowDuplicatesGuiY%, %ConfigFile%, %ScriptName%, ShowDuplicatesGuiY
   }
   Gui, %GuiID_Duplicates%:Destroy
Return

sub_DuplicatesSelect:
   GuiDefault("Duplicates")
   Gui, ListView, DuplicatesList
   LV_GetText(goToDuplicateExtension, A_EventInfo, 1)
   If goToDuplicateExtension = activAid
      goToDuplicateExtension := lng_Hotkeys
   Gosub, sub_MainGUI
   GuiDefault("activAid")
   Gui, ListView, OptionsListBox
   LV_Modify( GuiTabs[%goToDuplicateExtension%], "Select Focus")
   Gosub, sub_OptionsListBox
Return

sub_VarDumpGUI:
   Critical
   Gui, %GuiID_VarDump%:+LastFoundExist
   IfWinExist
      Gosub, VarDumpGuiClose

   DefaultDumpVar1 = A_OSVersion
   DefaultDumpVar2 = A_RealOSVersion
   DefaultDumpVar3 = A_OSType
   DefaultDumpVar4 = A_OSWordSize
   DefaultDumpVar5 = A_ThisHotkey
   DefaultDumpVar6 = RegionFormatID

   IniRead, NumOfDumpVars, %ConfigFile%, %ScriptName%, NumOfDumpVars, 6
   If NumOfDumpVars < 1
      NumOfDumpVars = 6

   IniRead, VarDumpGuiX, %ConfigFile%, %ScriptName%, VarDumpGuiX
   IniRead, VarDumpGuiY, %ConfigFile%, %ScriptName%, VarDumpGuiY

   Loop, %NumOfDumpVars%
      IniRead, VarDumpVar%A_Index%, %ConfigFile%, %ScriptName%, VarDumpVar%A_Index%,% DefaultDumpVar%A_Index%

   If VarDumpGuiX = ERROR
      VarDumpGuiX =
   Else
   {
      If (VarDumpGuiX < MonitorAreaLeft)
         VarDumpGuiX := MonitorAreaLeft
      If (VarDumpGuiX+334+BorderHeight*2 > MonitorAreaRight)
         VarDumpGuiX := MonitorAreaRight-(334+BorderHeight*2)
      VarDumpGuiX = x%VarDumpGuiX%
   }
   If VarDumpGuiY = ERROR
      VarDumpGuiY =
   Else
   {
      If (VarDumpGuiY < MonitorAreaTop)
         VarDumpGuiY := MonitorAreaTop
      If (VarDumpGuiY+5+NumOfDumpVars*21+MenuBarHeight+BorderHeight*2+CaptionHeight > MonitorAreaBottom)
         VarDumpGuiY := MonitorAreaBottom-(5+NumOfDumpVars*21+MenuBarHeight+BorderHeight*2+CaptionHeight)
      VarDumpGuiY = y%VarDumpGuiY%
   }

   VarDumpGuiWinID:= GuiDefault("VarDump","+ToolWindow +LastFoundExist +AlwaysOnTop")
   Loop, %NumOfDumpVars%
   {
      Gui, Add, Edit, w100 R1 x10 y+5 g tim_VarDumpRefresh vVarDumpVar%A_Index%, % VarDumpVar%A_Index%
      Gui, Add, Text, x+5, =
      Gui, Add, Edit, w400 x+5 ReadOnly vVarDumpVar%A_Index%Value,
   }

   Gui, Show, %VarDumpGuiX% %VarDumpGuiY%, %ScriptNameFull% - %lng_VarDump%
   SetTimer, tim_VarDumpRefresh, 100
Return

VarDumpGuiOK:
VarDumpGuiEscape:
VarDumpGuiClose:
   Gui, %GuiID_VarDump%:+LastFoundExist
   IfWinNotExist
      Return

   SetTimer, tim_VarDumpRefresh, Off
   If VarDumpGuiX <> Reset
   {
      WinGetPos, VarDumpGuiX, VarDumpGuiY, , , ahk_id %VarDumpGuiWinID%
      IniWrite, %VarDumpGuiX%, %ConfigFile%, %ScriptName%, VarDumpGuiX
      IniWrite, %VarDumpGuiY%, %ConfigFile%, %ScriptName%, VarDumpGuiY
   }
   Gui, %GuiID_VarDump%:Submit
   Loop, %NumOfDumpVars%
      IniWrite, % VarDumpVar%A_Index%, %ConfigFile%, %ScriptName%, VarDumpVar%A_Index%
   Gui, %GuiID_VarDump%:Destroy
Return

tim_VarDumpRefresh:
   SetWinDelay, -1
   Loop, %NumOfDumpVars%
   {
      GuiControlGet, VarDumpFocus, %GuiID_VarDump%:FocusV
      If VarDumpFocus = VarDumpVar%A_Index%Value
         continue
      GuiControlGet, VarDumpVar, %GuiID_VarDump%:, VarDumpVar%A_Index%
      VarDumpVar := func_StrClean(VarDumpVar)
      If VarDumpVar =
         VarDumpVar = A_EmptyVar
      VarDumpVar := %VarDumpVar%
      GuiControl,%GuiID_VarDump%: ,VarDumpVar%A_Index%Value, %VarDumpVar%
   }
Return



CreateUninstallFile:
   If AHKonUSB = 1
      Return

   IniRead, CreateUninstaller, %ConfigFile%, %ScriptName%, CreateUninstaller
   RegRead, InstallLocation, HKEY_LOCAL_MACHINE, SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ac'tivAid, InstallLocation
   If (InstallLocation <> A_ScriptDir AND CreateUninstaller = "ERROR" AND ErrorLevel = 0)
      CreateUninstaller = 1
   If ( ErrorLevel = 1 AND CreateUninstaller = 1 )
      CreateUninstaller = 0

   RegDelete, HKEY_LOCAL_MACHINE, SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce, %ScriptName%

   If (CreateUninstaller = "ERROR" OR CreateUninstaller = "")
   {
      SetTimer, tim_Loading, Off
      SplashImage, 2:Off
      MsgBox, 36, %ScriptTitle%, %lng_CreateUninstaller%
      IfMsgBox, Yes
      {
         CreateUninstaller = 2
         Gosub, sub_MenuAutostart
         CreateUninstaller = 1
         SetTimer, tim_LaunchGUI, 50
      }
      IfMsgBox, No
         CreateUninstaller = 0
   }
   If CreateUninstaller = 2
   {
      Gosub, sub_MenuAutostart
      CreateUninstaller = 1
   }
   IniWrite, %CreateUninstaller%, %ConfigFile%, %ScriptName%, CreateUninstaller
   If CreateUninstaller = 1
   {
      RegWrite, REG_SZ, HKEY_LOCAL_MACHINE,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ac'tivAid, DisplayName, %ScriptTitle%
      RegWrite, REG_SZ, HKEY_LOCAL_MACHINE,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ac'tivAid, InstallLocation, %A_ScriptDir%
      RegWrite, REG_SZ, HKEY_LOCAL_MACHINE,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ac'tivAid, DisplayVersion, %ScriptVersion%
      RegWrite, REG_SZ, HKEY_LOCAL_MACHINE,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ac'tivAid, HelpLink, http://activaid.rumborak.de
      RegWrite, REG_SZ, HKEY_LOCAL_MACHINE,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ac'tivAid, URLUpdateInfo, http://www.heise.de/ct/activaid/
      RegWrite, REG_SZ, HKEY_LOCAL_MACHINE,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ac'tivAid, URLInfoAbout, http://www.heise.de/ct
      RegWrite, REG_SZ, HKEY_LOCAL_MACHINE,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ac'tivAid, Publisher, Heise Zeitschriften Verlag GmbH & Co. KG
      RegWrite, REG_SZ, HKEY_LOCAL_MACHINE,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ac'tivAid, Author, Wolfgang Reszel
      RegWrite, REG_SZ, HKEY_LOCAL_MACHINE,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ac'tivAid, Contact, Stephan Ehrmann, Wolfgang Reszel
      If A_IsCompiled = 1
         RegWrite, REG_SZ, HKEY_LOCAL_MACHINE,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ac'tivAid, UninstallString, %A_ScriptFullPath% uninstall
      Else
         RegWrite, REG_SZ, HKEY_LOCAL_MACHINE,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ac'tivAid, UninstallString, %A_AHKPath% "%A_ScriptFullPath%" uninstall
      RegWrite, REG_DWORD, HKEY_LOCAL_MACHINE,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ac'tivAid, NoModify, 1
      RegWrite, REG_DWORD, HKEY_LOCAL_MACHINE,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ac'tivAid, NoRepair, 1
      RegWrite, REG_DWORD, HKEY_LOCAL_MACHINE,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ac'tivAid, EstimatedSize, 800
      RegWrite, REG_SZ, HKEY_LOCAL_MACHINE,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ac'tivAid, Size, 123
      RegWrite, REG_SZ, HKEY_LOCAL_MACHINE,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ac'tivAid, Readme, %ReadMeFile%
      If ErrorLevel
         Error++
   }
Return

DoUninstall:
   RegRead, InstallLocation, HKEY_LOCAL_MACHINE, SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ac'tivAid, InstallLocation
   If ErrorLevel = 1
      Return

   RunWithAdminRightsPara = uninstall

   If main_IsAdmin <> 1
      Gosub, sub_RunAsAdmin

   SplitPath,UserProfile,,CrawlDir
   SplitPath,A_AppData,AppDataName
   RegRead, StartMenuName, HKEY_CURRENT_USER,Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders,Start Menu
   RegRead, AutoStartName, HKEY_CURRENT_USER,Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders,Startup
   RegRead, RegDesktop, HKEY_CURRENT_USER,Software\Microsoft\Windows\CurrentVersion\Explorer\User Shell Folders,Desktop
   StringReplace, RegDesktop, RegDesktop, `%USERPROFILE`%\
   SplitPath, StartMenuName, StartMenuName
   SplitPath, AutoStartName, AutoStartName

   UninstallPaths = %InstallLocation%

   Loop, %CrawlDir%\ac'tivAid.lnk,0,1
   {
      IfInString, A_LoopFileFullPath, \%AppDataName%
      {
         SplitPath, A_LoopFileFullPath, , LoopFilePath
         UninstallPaths = %UninstallPaths%`n%LoopFilePath%
      }
      IfInString, A_LoopFileFullPath, \%StartMenuName%\
      {
         IfInString, A_LoopFileFullPath, \%AutoStartName%
         {
            UninstallPaths = %UninstallPaths%`n%A_LoopFileFullPath%
         }
         IfInString, A_LoopFileFullPath, \ac'tivAid\
         {
            SplitPath, A_LoopFileFullPath,Prg,ProgramGroup
            UninstallPaths = %UninstallPaths%`n%ProgramGroup%
         }
      }
      IfInString, A_LoopFileFullPath, \%RegDesktop%\
         UninstallPaths = %UninstallPaths%`n%A_LoopFileFullPath%
   }

   SetTimer, tim_Loading, Off
   SplashImage, 2:Off
   MsgBox, 36, %ScriptTitle%, %lng_AskUninstall%%UninstallPaths%
   IfMsgBox, Yes
   {
      Loop, %CrawlDir%\ac'tivAid.lnk,0,1
      {
         IfInString, A_LoopFileFullPath, \%AppDataName%
         {
            SplitPath, A_LoopFileFullPath, , LoopFilePath
            Loop, %LoopFilePath%\*.*, 0, 1
            {
               FileDelete, %A_LoopFilefullpath%
            }
            Loop, %LoopFilePath%\*.*, 2, 1
            {
               FileRemoveDir, %A_LoopFilefullpath%, 1
            }
         }
         IfInString, A_LoopFileFullPath, \%StartMenuName%\
         {
            IfInString, A_LoopFileFullPath, \%AutoStartName%
            {
               FileDelete, %A_LoopFileFullPath%
            }
            IfInString, A_LoopFileFullPath, \ac'tivAid\
            {
               SplitPath, A_LoopFileFullPath,Prg,ProgramGroup
               FileRemoveDir, %ProgramGroup%, 1
            }
         }
         IfInString, A_LoopFileFullPath, \%RegDesktop%\
            FileDelete, %A_LoopFileFullPath%
      }
      RegDelete, HKEY_LOCAL_MACHINE,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ac'tivAid
      RegWrite, REG_SZ, HKEY_LOCAL_MACHINE, SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce, %ScriptName%, %ComSpec% /c del "%InstallLocation%\ac'tivAid.*" && rd /q "%InstallLocation%"
      FileDelete, %InstallLocation%\ac'tivAid*.*
      FileDelete, %InstallLocation%\Lizenz.txt
      FileDelete, %InstallLocation%\Library\tools\*.*
      Loop, %InstallLocation%\settings\*.*, 0, 1
      {
         FileDelete, %A_LoopFilefullpath%
      }
      Loop, %InstallLocation%\extensions\*.*, 0, 1
      {
         FileDelete, %A_LoopFilefullpath%
      }
      Loop, %InstallLocation%\library\*.*, 0, 1
      {
         FileDelete, %A_LoopFilefullpath%
      }
      FileRemoveDir, %A_Programs%\ac'tivAid, 1
      FileRemoveDir, %A_AppDataCommon%\ac'tivAid, 1
      FileRemoveDir, %InstallLocation%\settings, 1
      FileRemoveDir, %InstallLocation%\development, 1
      FileRemoveDir, %InstallLocation%\extensions, 1
      FileRemoveDir, %InstallLocation%, 0

      FileAppend, del "%InstallLocation%\ac'tivAid*.*"`r`n, %A_Temp%\uninst_aAd.cmd
      FileAppend, rd /q "%InstallLocation%"`r`n, %A_Temp%\uninst_aAd.cmd
      FileAppend, del "%A_Temp%\uninst_aAd.cmd"`r`n, %A_Temp%\uninst_aAd.cmd
      If A_IsCompiled = 1
         SendMessage, 0x1ccc, 33, 33,,%A_ScriptDir%\extensions\RunWithAdminRights.exe
      Else
         SendMessage, 0x1ccc, 33, 33,,%A_ScriptDir%\extensions\RunWithAdminRights.ahk - AutoHotkey v%A_Ahkversion%
      MsgBox, 32, %ScriptTitle%, %lng_UninstallFinished%
      Run, %A_Temp%\uninst_aAd.cmd,,Hide
   }
   ExitApp
Return

CustomLanguage:
   ; Sprachdatei laden (lng-Variablen werden berschrieben)
   IfExist, settings\language.ini
      Debug("INIT", A_LineNumber, A_LineFile, "#including custom language-file ..." )
   #Include *i settings\language.ini
   Description := %Prefix%_Description
   MenuName := %Prefix%_MenuName
Return

; eigene Funktionen laden (include)
#Include *i settings\extensions_main.ini

Update_activAid:
   ; nderungen an der Verzeichnisstruktur durchfhren
   If ( A_RealOSVersion = "WIN_VISTA" AND AHKonUSB <> 1 )
   {
      IniRead, tmp_AvailableExtensions, %activAidData%\settings\ac'tivAid.ini, activAid, AvailableExtensions
      IniRead, tmp_AvailableExtensions2, settings\ac'tivAid.ini, activAid, AvailableExtensions
      If (tmp_AvailableExtensions = "ERROR" AND tmp_AvailableExtensions2 <> "ERROR")
      {
         SetTimer, tim_Loading, Off
         SplashImage, 2:Off
         MsgBox, 32, %ScriptTitle%, %lng_NewSettingsDirForVista%
         FileCopyDir, %A_ScriptDir%\settings, %activAidData%\settings, 1
         IfNotExist, %A_ScriptDir%\settings\ac'tivAid.ini
            FileRemoveDir, %A_ScriptDir%\settings
      }
   }
   If (FileExist( A_ScriptDir "\Settings\ac'tivAid.ico" ) AND !FileExist( A_ScriptDir "\Library\ac'tivAid.ico") )
   {
      If ScriptIcon = %A_ScriptDir%\settings\ac'tivAid.ico
      {
         IniDelete, %ConfigFile%, %ScriptName%, Icon
         IniDelete, %ConfigFile%, %ScriptName%, TrayIcon_On
         IniDelete, %ConfigFile%, %ScriptName%, TrayIcon_Off
      }
      FileMove, %A_ScriptDir%\Settings\*.ico, %A_ScriptDir%\Library, 1
   }
   Else IfNotExist, %ScriptIcon%
   {
      IniDelete, %ConfigFile%, %ScriptName%, Icon
      IniDelete, %ConfigFile%, %ScriptName%, TrayIcon_On
      IniDelete, %ConfigFile%, %ScriptName%, TrayIcon_Off
   }
   If activAidData <> %A_ScriptDir%
   {
      FileRead, tmp_Main, %activAidData%\settings\extensions_main.ini
      IfInString, tmp_Main, #Include *i extensions\
      {
         StringReplace, tmp_Main, tmp_Main, #Include *i extensions\ , #Include *i %A_ScriptDir%\extensions\, All
         FileDelete, %activAidData%\settings\extensions_main.ini
         FileAppend, %tmp_Main%, %activAidData%\settings\extensions_main.ini
      }
   }
   IfExist, WebResearch
   {
      FileCreateDir, WebSearch
      FileMove, WebResearch\*.*, WebSearch\, 1
      FileRemoveDir, WebResearch, 1
      IfExist, WebSearch\URLs.cfg
      {
         MsgBox, 36, %ScriptTitle%, %lng_wr_UpdateCFG%
         IfMsgBox,yes
         {
            FileMove, WebSearch\URLs.cfg, WebSearch\URLs.bak
         }
      }
   }
   IfExist, WebSearch
   {
      FileMoveDir, WebSearch, settings\WebSearch
      FileRemoveDir, WebSearch, 1
      IfExist, settings\WebSearch\URLs.cfg
      {
         MsgBox, 36, %ScriptTitle%, %lng_wr_UpdateCFG%
         IfMsgBox,yes
         {
            FileMove, settings\WebSearch\URLs.cfg, settings\WebSearch\URLs.bak
         }
      }
   }
   IfExist, Portable ac'tivAid.exe
      IfNotExist, Portable_ac'tivAid.exe
         FileMove, Portable ac'tivAid.exe, Portable_ac'tivAid.exe
      Else
         FileDelete, Portable ac'tivAid.exe
   If AHKonUSB =
      FileDelete, Portable_ac'tivAid.exe

   IfExist, ac'tivAid.ini
      FileMove, ac'tivAid.ini, settings\ac'tivAid.ini, 1
   IfExist, includes
      FileRemoveDir, includes, 1
   IfExist, extensions\Hotstrings.ahk
      FileMove, extensions\Hotstrings.ahk, settings\Hotstrings.ini
   FileDelete, extensions\Hotstrings.ahk
   IfExist, extensions\Hotstrings.ini
      FileMove, extensions\Hotstrings.ini, settings\Hotstrings.ini
   FileDelete, extensions\Hotstrings.ini
   FileDelete, extensions\unelevated.ahk
   FileDelete, extensions\ac'tivAid_MinimizeToTrayHelper.ahk

   FileDelete, extensions\Media\ac'tivAid_ReadingRuler.wav

   IfExist, extensions\_main.ahk
   {
      FileMove, extensions\_main.ahk, settings\extensions_main.ini
      FileDelete, extensions\_main.ahk
   }
   IfExist, extensions\_header.ahk
   {
      FileMove, extensions\_header.ahk, settings\extensions_header.ini
      FileDelete, extensions\_header.ahk
   }

   FileMoveDir, UserSettings, ComputerSettings, R

   FileDelete, ac'tivAid_ct.ico
   FileDelete, ac'tivAid.ico
   FileDelete, ac'tivAid_off.ico
   FileDelete, ac'tivAid_on.ico
   FileDelete, settings/ac'tivAid_icons.dll
   FileDelete, %A_ScriptDir%\extensions\Vol.gif
   FileDelete, %A_ScriptDir%\extensions\Vol2.gif
   FileDelete, %A_ScriptDir%\extensions\Vol.wav
   FileDelete, %A_ScriptDir%\extensions\mute.gif
   FileDelete, %A_ScriptDir%\extensions\Eject.gif

   FileDelete, %A_ScriptDir%\extensions\simwin.ahk
   FileDelete, %A_ScriptDir%\extensions\ac'tivAid_Winamp.ahk
   FileDelete, %A_ScriptDir%\extensions\ac'tivAid_Winamp_Vol.gif
   FileDelete, %A_ScriptDir%\extensions\ac'tivAid_Winamp_Vol2.gif
   FileDelete, %A_ScriptDir%\extensions\ac'tivAid_Winamp_Vol.wav
   FileDelete, betatester.ini

   FileDelete, %A_ScriptDir%\extensions\ac'tivAid_KeyState.dll

   FileDelete, %A_ScriptDir%\development\unzip.exe

   FileDelete, settings\unzip.exe

   FileDelete, %A_ScriptDir%\extensions\*.wav
   FileDelete, %A_ScriptDir%\extensions\*.gif
   FileDelete, %A_ScriptDir%\extensions\*.icl

   IfExist, backup\ac'tivAid_main.exe
   {
      FileDelete, ac'tivAid.exe
      FileMove, backup\ac'tivAid_main.exe, backup\ac'tivAid.exe
   }

   FileMove, language.ini, settings\language.ini
   FileDelete, language.ini

   func_ReplaceExtension( "WindowShrinker", "ExplorerShrinker" )

   IfNotInString, ScriptVersion, alpha
      IniDelete, %ConfigFile%, %ScriptNameClean%, UpdateURL

   IniRead, Hotkey_TempSuspend, %ConfigFile%, activAid, Hotkey_TempSuspend
   If (Hotkey_TempSuspend <> "ERROR" AND Hotkey_TempSuspend <> "Numlock")
      IniWrite, %Hotkey_TempSuspend%, %ConfigFile%, activAid, Hotkey_TemporarySuspend

   IniDelete, %ConfigFile%, activAid, Hotkey_TempSuspend

   IniRead, statFirstLaunch, %ConfigFile%, Statistics, FirstLaunch_%A_Computername%, 0
   IniRead, statLastLaunched, %ConfigFile%, Statistics, LastLaunched_%A_Computername%, 0
   IniRead, statLaunchCount, %ConfigFile%, Statistics, LaunchCount_%A_Computername%, 0
   IniRead, statReloadCount, %ConfigFile%, Statistics, ReloadCount_%A_Computername%, 0
   IniRead, statUpdateCount, %ConfigFile%, Statistics, UpdateCount_%A_Computername%, 0
   IniRead, statExitCount, %ConfigFile%, Statistics, ExitCount_%A_Computername%, 0
   IniRead, statTotalTime, %ConfigFile%, Statistics, TotalTime_%A_Computername%, 0
   IniRead, statLongestSession, %ConfigFile%, Statistics, LongestSession_%A_Computername%, 0
   If statFirstLaunch <> ERROR
   {
      IniWrite, %statFirstLaunch%, %ConfigFile%, Statistics, FirstLaunch
      IniWrite, %statLastLaunched%, %ConfigFile%, Statistics, LastLaunched
      IniWrite, %statLaunchCount%, %ConfigFile%, Statistics, LaunchCount
      IniWrite, %statReloadCount%, %ConfigFile%, Statistics, ReloadCount
      IniWrite, %statUpdateCount%, %ConfigFile%, Statistics, UpdateCount
      IniWrite, %statExitCount%, %ConfigFile%, Statistics, ExitCount
      IniWrite, %statTotalTime%, %ConfigFile%, Statistics, TotalTime
      IniWrite, %statLongestSession%, %ConfigFile%, Statistics, LongestSession
      IniDelete, %ConfigFile%, Statistics, FirstLaunch_%A_Computername%
      IniDelete, %ConfigFile%, Statistics, LastLaunched_%A_Computername%
      IniDelete, %ConfigFile%, Statistics, LaunchCount_%A_Computername%
      IniDelete, %ConfigFile%, Statistics, ReloadCount_%A_Computername%
      IniDelete, %ConfigFile%, Statistics, UpdateCount_%A_Computername%
      IniDelete, %ConfigFile%, Statistics, ExitCount_%A_Computername%
      IniDelete, %ConfigFile%, Statistics, TotalTime_%A_Computername%
      IniDelete, %ConfigFile%, Statistics, LongestSession_%A_Computername%
   }

   FileRead, ExtHeader, settings\extensions_header.ini

   FileMove, %A_ScriptDir%\deveject.exe, %A_ScriptDir%\Library\Tools\, 1
   FileMove, %A_ScriptDir%\RemoveDrive.exe, %A_ScriptDir%\Library\Tools\, 1

   IfInString, ExtHeader, Extension[1]
      Return

   FileDelete, settings\_temp.tmp

   Loop, Read, settings\extensions_header.ini, settings\_temp.tmp
   {
      IfNotInString A_LoopReadLine, Extension[3]
      {
         FileAppend, %A_LoopReadLine%`n
      }
      Else
         FileAppend, Extension[1] = ComfortDrag`nExtension[2] = MouseClip`n%A_LoopReadLine%`n
   }
   FileMove, settings\_temp.tmp, settings\extensions_header.ini, 1
   FileDelete, settings\_temp.tmp


   FileRead, ExtMain, settings\extensions_main.ini

   IfInString, ExtMain, %A_ScriptDir%
      UsingUserDir = 1
   If (UsingUserDir <> 1 OR AHKonUSB = 1)
   {
      FileAppend, % "#Include *i extensions\ac'tivAid_ComfortDrag.ahk `; ComfortDrag`n", settings\extensions_main.ini
      FileAppend, % "#Include *i extensions\ac'tivAid_MouseClip.ahk `; MouseClip`n", settings\extensions_main.ini
   }
   Else
   {
      FileAppend, % "#Include *i " A_ScriptDir "\extensions\ac'tivAid_ComfortDrag.ahk `; ComfortDrag`n", settings\extensions_main.ini
      FileAppend, % "#Include *i " A_ScriptDir "\extensions\ac'tivAid_MouseClip.ahk `; MouseClip`n", settings\extensions_main.ini
   }
Return

sub_GetReadme:
   ReadIndex = 1
   ReadmeGotoLine[1] = 1
   FileRead, Readme, %ReadMeFile%

   If tempAdminMode = 1
      Readme := "`n" lng_AdminAttention "`n`n" Readme

   If _Devel <> -1
      StringReplace, Readme, Readme, : ###), : %A_AHKversion%)

   ReadmeDropDown =
   ReadmeGotoLine =
   ReadmeEditIndex = 0
   Loop, Parse, Readme, `n, `r
   {
      ReadmeEditIndex := ReadmeEditIndex + StrLen( A_LoopField ) +2
      IfNotInstring, A_LoopField, % ". "
      {
         PrevReadmeEditIndex = %ReadmeEditIndex%
         continue
      }
      If (func_StrLeft(A_LoopField,1) <> " ")
         continue

      StringSplit, ReadLineSplit, A_LoopField, %A_Space%
      StringReplace, ReadLineTest1, ReadLineSplit2, ., , A
      ReadLineTest2 = %ReadLineTest1%
      ReadLineTest2++
      ReadLineTest2--
      If ((ReadLineTest1 = ReadLineTest2) AND ReadLineTest1 <> "")
      {
         ReadmeIndent = 0
         Loop, Parse, ReadLineSplit2
         {
            If A_LoopField = .
               ReadmeIndent++
         }
         ReadmeSpaces := "             "
         StringLeft, ReadmeSpaces, ReadmeSpaces, % ReadmeIndent * 3
         StringTrimLeft, ReadmeSpaces, ReadmeSpaces, 3
         StringTrimLeft, ReadLine, A_LoopField, 1
         ReadIndex++
         ReadmeDropDown = %ReadmeDropDown%|%ReadmeSpaces%%ReadLine%
         ReadmeGotoLine[%ReadIndex%] = %PrevReadmeEditIndex% ; %A_Index%
         ReadmeChapter[%ReadIndex%] = %A_LoopField%
      }
      PrevReadmeEditIndex = %ReadmeEditIndex%

      ReadLineSplit2 =
   }
   ;FileSetAttrib,-A, %ReadMeFile%
   IfNotExist, settings\extensions_main.ini
      ReadMe = %lng_NoExtensionsInstalled%%ReadMe%
Return

sub_GetChangeLog:
   FileRead,ChangeLog, %ChangeLogFile%
   ;FileSetAttrib,-A, %A_ScriptDir%\%ScriptNameFull% Changelog.txt
Return

tim_Loading:
   LoadingProgress++
   LoadingSymbols =  ۲ 
   Loop, 8
   {
      StringMid, LoadingSymbol%A_Index%, LoadingSymbols, LoadingProgress+A_Index-1, 1
   }
   SplashImage, 2: , , %LoadingSymbol8%%LoadingSymbol7%%LoadingSymbol6%%LoadingSymbol5%%LoadingSymbol4%%LoadingSymbol3%%LoadingSymbol2%%LoadingSymbol1%
   If LoadingProgress > 10
      LoadingProgress = 0
Return

; Menpunkt fr Funktion erstellen und Haken setzen
sub_MenuCreate:
   If EnableTray_%actFunct% <> 1
      Return
   TrayExtensions++

   If SubMenu <>
   {
      Menu, Tray, add, %MenuName%, :%SubMenu%

      TrayMenu[%TrayMenu%] = %actFunct%
      TrayMenu[%actFunct%] = %TrayMenu%
      TrayMenuName[%TrayMenu%] = %MenuName%
      TrayMenuName[%SubMenu%] = %MenuName%
      TrayMenu++
      mi_trayNum++
      EnableMenu := %actFunct%_EnableMenu
      if Enable_%actFunct% = 1
      {
         If CustomHotkey_%actFunct% = 1
            func_HotkeyEnable( actFunct )

         If _useTrayMenuIcons = 1
            ReadIcon(actFunct, IconFile_On_%actFunct%, IconPos_On_%actFunct%)

         If (_useTrayMenuIcons = 1 && TrayIcon[%actFunct%]!="" && FileExist(TrayIcon[%actFunct%]))
            MI_SetMenuItemIcon(hTM, mi_trayNum, TrayIcon[%actFunct%], TrayIconPos[%actFunct%], 16)
         Else
            Menu, Tray, Check, %MenuName%

         Menu, %SubMenu%, Check, %EnableMenu%
      }
      Else
      {
         If CustomHotkey_%actFunct% = 1
         {
            func_HotkeyDisable( actFunct )
         }

         If _useTrayMenuIcons = 1
            ReadIcon(actFunct,IconFile_On_%actFunct%, IconPos_On_%actFunct%, IconFile_Off_%actFunct%, IconPos_Off_%actFunct%)

         If (_useTrayMenuIcons = 1 && TrayIconOff[%actFunct%]!="" && FileExist(TrayIconOff[%actFunct%]))
            MI_SetMenuItemIcon(hTM, mi_trayNum, TrayIconOff[%actFunct%], TrayIconOffPos[%actFunct%], 16)
         Else
            Menu, Tray, Uncheck, %MenuName%
         Menu, %SubMenu%, UnCheck, %EnableMenu%
      }
   }
   Else
   {
      Menu, Tray, add, %MenuName%, sub_MenuCall

      TrayMenu[%TrayMenu%] = %actFunct%
      TrayMenu[%actFunct%] = %TrayMenu%
      TrayMenuName[%TrayMenu%] = %MenuName%
      TrayMenu++
      mi_trayNum++
      If Enable_%actFunct% = 1
      {
         If CustomHotkey_%actFunct% = 1
            func_HotkeyEnable( actFunct )

         If _useTrayMenuIcons = 1
            ReadIcon(actFunct, IconFile_On_%actFunct%, IconPos_On_%actFunct%)

         If (_useTrayMenuIcons = 1 && TrayIcon[%actFunct%]!="" && FileExist(TrayIcon[%actFunct%]))
            MI_SetMenuItemIcon(hTM, mi_trayNum, TrayIcon[%actFunct%], TrayIconPos[%actFunct%], 16)
         Else
            Menu, Tray, Check, %MenuName%
      }
      Else
      {
         If CustomHotkey_%actFunct% = 1
         {
            func_HotkeyDisable( actFunct )
         }

         If _useTrayMenuIcons = 1
            ReadIcon(actFunct,IconFile_On_%actFunct%, IconPos_On_%actFunct%, IconFile_Off_%actFunct%, IconPos_Off_%actFunct%)

         If (_useTrayMenuIcons = 1 && TrayIconOff[%actFunct%]!="" && FileExist(TrayIconOff[%actFunct%]))
            MI_SetMenuItemIcon(hTM, mi_trayNum, TrayIconOff[%actFunct%], TrayIconOffPos[%actFunct%], 16)
         Else
            Menu, Tray, Uncheck, %MenuName%
      }
   }

   SubMenu =
Return

GuiDefaultFont:
   Gui, Font
   Gui, Font, S%FontSize% ; , Modern MS Sans Serif
Return

; Wird von den Menpunkten aufgerufen.
sub_MenuCall:
   Thread, Priority, 1
   DoReload =
   Reload =

   If A_ThisMenu = Tray
   {
      RegExMatch(A_ThisMenuItem,"(.+) - ",MenuItem)
      MenuItem := MenuItem1
      If MenuItem =
         MenuItem := TrayMenu[%A_ThisMenuItemPos%]
   }
   Else
   {
      MenuID = 0
      StringSplit, MenuItem, A_ThisMenu, _
      MenuItem = %MenuItem1%
   }

   If _AlternativeTrayMenu = 1
   {
      If MainGuiVisible <>
         Gosub, activAidGuiClose
      SimpleMainGUI = %MenuItem%
      Gosub, sub_MainGUI
   }
      Else
   {
      ; Menupunkt de/aktivieren
      If Enable_%MenuItem% = 1
      {
         If _useTrayMenuIcons = 1
            ReadIcon(MenuItem,IconFile_On_%MenuItem%, IconPos_On_%MenuItem%, IconFile_Off_%MenuItem%, IconPos_Off_%MenuItem%)

         If (_useTrayMenuIcons = 1 && TrayIconOff[%MenuItem%]!="" && FileExist(TrayIconOff[%MenuItem%]))
         {
            htm_pos := TrayMenu[%MenuItem%]
            MI_SetMenuItemIcon(hTM, htm_pos, TrayIconOff[%MenuItem%], TrayIconOffPos[%MenuItem%], 16)
         }

         Menu, %A_ThisMenu%, UnCheck, %A_ThisMenuItem%

         If A_ThisMenu <> Tray
         {
            Menu, Tray, UnCheck, % TrayMenuName[%A_ThisMenu%]
         }

         Enable_%MenuItem% = 0

         If CustomHotkey_%MenuItem% = 1
            func_HotkeyDisable(MenuItem)

         Gosub, DoDisable_%MenuItem%
      }
      Else
      {
         If _useTrayMenuIcons = 1
            ReadIcon(MenuItem,IconFile_On_%MenuItem%, IconPos_On_%MenuItem%, IconFile_Off_%MenuItem%, IconPos_Off_%MenuItem%)

         If (_useTrayMenuIcons = 1 && TrayIcon[%MenuItem%]!="" && FileExist(TrayIcon[%MenuItem%]))
         {
            htm_pos := TrayMenu[%MenuItem%]
            MI_SetMenuItemIcon(hTM, htm_pos, TrayIcon[%MenuItem%], TrayIconPos[%MenuItem%], 16)
         }
         Else
            Menu, %A_ThisMenu%, Check, %A_ThisMenuItem%

         If A_ThisMenu <> Tray
            Menu, Tray, Check, % TrayMenuName[%A_ThisMenu%]

         Enable_%MenuItem% = 1

         If CustomHotkey_%MenuItem% = 1
            func_HotkeyEnable(MenuItem)

         Gosub, DoEnable_%MenuItem%
      }

      ; Einstellung speichern
      actEnable = Enable_%MenuItem%

      IniWrite, % %actEnable% , %ConfigFile%, %ScriptName%, %actEnable%

      Debug("RELOAD",A_LineNumber,A_LineFile,A_ThisFunc A_ThisLabel)
      If (Reload = 1 OR DoReload = 1)
         Gosub, Reload
   }
Return

; ProblemSolver versucht 'festhngende' Tasten und Maustasten zu lsen
sub_ProblemSolver:
   Gosub, sub_RestoreKeyStates  ; Korrigiert die Modifier-Tasten
   If (HiddenWindows <> "" OR TempDeskWindows <> "")
   {
      If IsLabel("cd_sub_RestoreTempDeskWindows")
         Gosub, cd_sub_RestoreTempDeskWindows%A_EmptyVar%
      If IsLabel("cd_sub_RestoreHiddenWindows")
         Gosub, cd_sub_RestoreHiddenWindows%A_EmptyVar%
      ProbSolvMessage = %ProbSolvMessage%%lng_ProbSolvHidden%
      ProbSolv=
      IniDelete,%ConfigFile%,TemporaryDesktop
      IniDelete,%ConfigFile%,HiddenWindows
   }
   If IsLabel("scr_sub_RefreshWindows")
      Gosub, scr_sub_RefreshWindows%A_EmptyVar%

   If IsLabel("OnExitAndReload_MinimizeToTray")
      Gosub, OnExitAndReload_MinimizeToTray%A_EmptyVar%

   If ProbSolvMessage =
      BalloonTip(ScriptTitle, ProbSolvStartMessage lng_ProbSolvNoRes,"Info",0,0,8)
   Else
      BalloonTip(ScriptTitle, ProbSolvStartMessage lng_ProbSolvResult "`n`n" ProbSolvMessage, "Info",0,0,8)
   ProbSolvStartMessage =
Return

sub_HideAllExtensions:
;   Critical
   MsgBox,36,%ScriptTitle%,%lng_ExtDeinstAsk%
   IfMsgBox, yes
   {
      FileMove, %ConfigFile%, %SettingsDir%\ac'tivAid_ProblemSolver.ini
      gosub, sub_ExtensionsOff
   }
Return

sub_MenuReload:
   Debug("RELOAD",A_LineNumber,A_LineFile,"Reload from menu")
   Gosub, Reload
return

Reload:
   Critical
   Suspend, On
   Process, Priority,, H
   If LeaveAdmin = 1
   {
      Gosub, sub_LeaveAdmin
   }
   Else
   {
      IfNotInString, A_Args, nosplash
      {
         If AutoStart = -1
            AutoStartNoSplash = nosplash
         Else
            AutoStartNoSplash =
      }
      Loop
      {
         Debug("RELOAD",A_LineNumber,A_LineFile,"Reload function")
         Sleep, 300

         If A_IsCompiled = 1
            Run, %A_ScriptFullPath% %A_Args%, , UseErrorLevel ; Reload
         Else
            If Reload = 2
               Run, %A_AhkPath% "%A_ScriptFullPath%" %A_Args% %AutoStartNoSplash%, %NewWorkingDir% , UseErrorLevel ; Reload
            Else
               Run, %A_AhkPath% /r "%A_ScriptFullPath%" %A_Args% %AutoStartNoSplash%, %NewWorkingDir% , UseErrorLevel ; Reload

         Reload =
         Sleep, 3000
         Suspend, Off
         MsgBox,21,%ScriptTitle%,%lng_ReloadFailed%
         Suspend, On
         Loop
         {
            IfWinExist, ac'tivAid.ahk, Error at line
               ControlClick,Button1, ac'tivAid.ahk, Error at line
            Else
               break
         }
         IfMsgBox, Cancel
            break
      }
   }
   Process, Priority,, %A_Priority%
   Suspend, Off
Return

sub_TempSuspend:
   Suspend, Toggle
   Debug("STATUS",A_LineNumber,A_LineFile,"Toggle Suspend")
   StringReplace, TempSuspendHK, A_ThisHotkey, $
   KeyWait, %TempSuspendHK%, T0.3
   If ErrorLevel = 1
   {
      SplashImage,,b1 cwFFFFc0 FS10, %lng_SuspendToolTip%
      susHold++
      KeyWait, %TempSuspendHK%
      susHold++
      SplashImage, Off
      Suspend, Off
   }
   Else If susHold =
   {
      SendEvent, % func_PrepareHotkeyForSend(A_ThisHotkey,"",1)
      Suspend, Off
      IfInString, A_ThisHotkey, numlock
         SendEvent, % func_PrepareHotkeyForSend(A_ThisHotkey,"",1)
   }
   Sleep,200
   susHold =
Return

; Alle Funktionen deaktivieren
sub_MenuSuspend:
   Suspend, Toggle
   Critical
   TemporaryMenuSuspend = 1
   Loop
   {
      If Extension[%A_Index%] =
         break
      Function := Extension[%A_Index%]
      If ( IsLabel("OnSuspend_" Function) )
      {
         Debug("STATUS", A_LineNumber, A_LineFile, "OnSuspend_" Function "...")
         Gosub, OnSuspend_%Function%
      }

      If A_IsSuspended = 1
      {
         If (IsLabel( "DoDisable_" Function))
         {
            Debug("EXTENSION", A_LineNumber, A_LineFile, "DoDisable_" Function "...")
            Gosub, DoDisable_%Function%
         }
      }
      Else If Enable_%Function% = 1
      {
         If (IsLabel( "DoEnable_" Function))
         {
            Debug("EXTENSION", A_LineNumber, A_LineFile, "DoEnable_" Function "...")
            Gosub, DoEnable_%Function%
         }
      }
   }
   TemporaryMenuSuspend = 0
   Gosub, sub_ChangeIcon
Return

sub_ChangeIcon:
   If LoadingFinished <> 1
      Return
   If A_IsSuspended <> 1
   {
      If (NoTrayIcon <> 1 AND CustomIcon <> 1)
         If A_IconFile <> %ScriptOnIcon%
            Menu, Tray, Icon, %ScriptOnIcon%, %ScriptOnIcon#%, 1
      Menu, Tray, UnCheck, % lng_deactivate "`t" func_HotkeyDecompose( Hotkey_DisableEnable, 1 )
      Loop, % TrayMenu - TrayMenuFirstExtension
      {
         Index := A_Index + TrayMenuFirstExtension
         If TrayMenuName[%Index%] =
            continue
         Menu, Tray, Enable, % TrayMenuName[%Index%]
      }
   }
   Else
   {
      If (NoTrayIcon <> 1 AND CustomIcon <> 1)
         If A_IconFile <> %ScriptOffIcon%
            Menu, Tray, Icon, %ScriptOffIcon%, %ScriptOffIcon#%, 1
      Menu, Tray, Check, % lng_deactivate "`t" func_HotkeyDecompose( Hotkey_DisableEnable, 1 )
      Loop, % TrayMenu - TrayMenuFirstExtension
      {
         Index := A_Index + TrayMenuFirstExtension
         If TrayMenuName[%Index%] =
            continue
         Menu, Tray, Disable, % TrayMenuName[%Index%]
      }
   }
Return

sub_temporarySuspend:
   If temporarySuspended = 1
   {
      If IsSuspended <> 1
      {
         Suspend, Off
         CallHook("OnResume")
         Debug("STATUS", A_LineNumber, A_LineFile, "Un-Suspended ac'tivAid" )
         If (NoTrayIcon <> 1 AND CustomIcon <> 1)
            Menu, Tray, Icon, %ScriptOnIcon%, %ScriptOnIcon#%, 1
      }
      temporarySuspended =
   }
   Else
   {
      IsSuspended = %A_IsSuspended%
      temporarySuspended = 1
      If IsSuspended <> 1
      {
         Suspend, On
         CallHook("OnSuspend")
         Debug("STATUS", A_LineNumber, A_LineFile, "Suspended ac'tivAid" )
         If (NoTrayIcon <> 1 AND CustomIcon <> 1)
            Menu, Tray, Icon, %ScriptOffIcon%, %ScriptOffIcon#%, 1
      }
   }
Return

activaidGuiContextMenu:
   If (GetKeyState("LButton") = 1 OR GuiContextMenu = "visible")
      Return
   Loop
   {
      If Extension[%A_Index%] =
         break
      Function := Extension[%A_Index%]
      If ( IsLabel("GuiContextMenu_" Function) )
      {
         GuiContextMenu = visible
         Gosub, GuiContextMenu_%Function%
         SetTimer, sub_GuiContextMenuUnVis, 20
         If GuiContextMenu = visible
         Return
      }
   }

   Prefix := ExtensionPrefix[%actFunct%]
   If %Prefix%_AdditionalSettings
   {
      GuiContextMenu = visible
      Gosub, sub_AdditionalSettingsMenu
      SetTimer, sub_GuiContextMenuUnVis, 20
   }
Return

sub_GuiContextMenuUnVis:
   SetTimer, sub_GuiContextMenuUnVis, Off
   GuiContextMenu =
Return

; Konfigurations-Dialog anzeigen
sub_MainGUI:
   Critical
   Thread NoTimers

   MainGuiBuildTime = %A_TickCount%

   Readme_Hotkeys =

   Hotkey_AllDuplicates_Backup = %Hotkey_AllDuplicates%

   If (MainGuiVisible <> "")
   {
      If DontShowMainGUI <>
      {
         Gosub, activAidGuiClose
         DontShowMainGUI =
         Gosub, sub_MainGUI
         Return
      }
      Else
      {
         DetectHiddenWindows, On
         IfWinExist, ahk_id %mainGuiID%
         {
            IfWinNotActive, ahk_id %mainGuiID%
               WinActivate, ahk_id %mainGuiID%
            Return
         }
      }
   }

   If mainGuiID <>
      Return

   mainGuiID := GuiDefault("activAid")

   Critical, Off

   IniRead, MainGuiX, %ConfigFile%, %ScriptName%, MainGuiX
   IniRead, MainGuiY, %ConfigFile%, %ScriptName%, MainGuiY

   If MainGuiX = ERROR
      MainGuiX =
   Else
   {
      If (MainGuiX < MonitorAreaLeft)
         MainGuiX := MonitorAreaLeft
      If (MainGuiX+706+BorderHeight*2 > MonitorAreaRight)
         MainGuiX := MonitorAreaRight-(706+BorderHeight*2)
      MainGuiX = x%MainGuiX%
   }
   If MainGuiY = ERROR
      MainGuiY =
   Else
   {
      If (MainGuiY < MonitorAreaTop)
         MainGuiY := MonitorAreaTop
      If (MainGuiY+450+MenuBarHeight+BorderHeight*2+CaptionHeight > MonitorAreaBottom)
         MainGuiY := MonitorAreaBottom-(450+MenuBarHeight+BorderHeight*2+CaptionHeight)
      MainGuiY = y%MainGuiY%
   }

   CallHook("MainGui","Init")

   Debug("GUI", A_LineNumber, A_LineFile, "Creating main GUI (" mainGuiID ")" )

   Hotkey_AllNewHotkeys = %Hotkey_AllHotkeys%

   If SimpleMainGUI =
   {
      If ( FileExist( ReadMeFile ) contains "A" )
         Gosub, sub_GetReadme
      If ( FileExist( ChangeLogFile ) contains "A" )
         Gosub, sub_GetChangeLog

      If (updScriptVersion <> "ERROR" AND updScriptVersion <> "")
      {
         If (updScriptExtension <> "ERROR" AND updScriptExtension <> "")
            Changelog = =============================================================================`n  %lng_UpdateSuccess%`n`n  %lng_UpdateNewExtension%`n  %updScriptExtension%`n=============================================================================`n`n%Changelog%
         Else
            Changelog = =============================================================================`n  %lng_UpdateSuccess%`n=============================================================================`n`n%Changelog%
      }

      CreateHotKeyList_tmp = %CreateHotKeyList%
      CreateHotkeyList = 1
   }

   If DontShowMainGUI =
      Menu, Tray, ToggleEnable, % lng_Info "`t" func_HotkeyDecompose( Hotkey_MainGUI, 1 )

   Reload = 0
   IniWrite, 1, %ConfigFile%, %ScriptName%, ShowGUI

   If LoadingFinished <> 1
      Debug("GUI", A_LineNumber, A_LineFile, "waiting for loading finished ..." )
   Loop
   {
      If LoadingFinished = 1
         break
      Sleep, 100
   }

   If DontShowMainGUI <> 1
      MainGuiVisible = 1

   IniRead, AutoUpdate, %ConfigFile%, %ScriptName%, AutoUpdate

   Loop
   {
      Function := Extension[%A_Index%]
      If Function =
         Break

      If ExtensionGuiDrawn[%Function%] =
         ExtensionGuiDrawn[%Function%] = 0

      Debug("VAR", A_LineNumber, A_LineFile, "Function" )

      Prefix := ExtensionPrefix[%A_Index%]

      If (SimpleMainGUI <> "" AND Function <> SimpleMainGUI)
         Continue

      If (ExtensionHideSettings[%A_Index%] <> 1 OR SimpleMainGUI = Function)
      {
         If %Prefix%_AdditionalSettings
            RestoreAdditionalTmpSettings( Prefix )
      }
   }

   Debug("GUI", A_LineNumber, A_LineFile, "Creating GUI-Menu" )
   Gosub, sub_SettingsMenu

   Menu, MenuBar, Add, &%ScriptName%, :SettingsMenu_activAid
   Menu, MenuBar, Add, &%lng_Extension%, :SettingsMenu_Extension
   Menu, MenuBar, Add, &%lng_Help%, :SettingsMenu_Help
   If _Devel = 1
   {
      Menu, MenuBar, Add, &Devel, :Devel_Menu
   }
   Gui, Menu, MenuBar

   Gosub, sub_BigIcon

   Gui, %GuiID_activAid%:+Disabled
   If DontShowMainGUI =
   {
      ; ImageList erstellen
      If _ShowIconsInOptionsListBox = 1
      {
         InstalledExtension_ImageList := IL_Create(NumFunctions)

         IL_Count := 0
         Loop, %NumFunctions%
         {
            actFunct := Extension[%A_Index%]
            IL_Count++
            ImageList[%actFunct%] := IL_Count
            If Enable_%actFunct% = 1
            {
               IfNotExist, % TrayIcon[%actFunct%]
               {
                  ImageList[%actFunct%] := 0
                  IL_Count--
                  continue
               }
               hIcon := ExtractIcon(TrayIcon[%actFunct%], TrayIconPos[%actFunct%], 16)
            }
            Else
            {
               IfNotExist, % TrayIconOff[%actFunct%]
               {
                  ImageList[%actFunct%] := 0
                  IL_Count--
                  continue
               }
               hIcon := ExtractIcon(TrayIconOff[%actFunct%], TrayIconOffPos[%actFunct%], 16)
            }

            DllCall("ImageList_ReplaceIcon", "uint", InstalledExtension_ImageList, "int", -1, "uint", hIcon)
            DllCall("DestroyIcon", "uint", hIcon)
         }
      }

      If _AlternativeTrayMenu <> 1
      {
         Loop, % TrayMenu - TrayMenuFirstExtension
         {
            Index := A_Index + TrayMenuFirstExtension
            If TrayMenuName[%Index%] =
               continue
            Menu, Tray, Disable, % TrayMenuName[%Index%]
         }
      }

      If SimpleMainGUI =
      {
         If (MainGuiX = "" OR MainGuiY = "")
            func_CenterCoordsOnActiveMonitor(MainGuiX,MainGuiY,726,450)
         Gui, Show, %MainGuiX% %MainGuiY% W726 H450, %ScriptTitle%
      }
      Else
      {
         If (MainGuiX = "" OR MainGuiY = "")
            func_CenterCoordsOnActiveMonitor(MainGuiX,MainGuiY,578,450)
         Gui, Show, %MainGuiX% %MainGuiY% W578 H450, %ScriptTitle%
      }
   }

   If SimpleMainGUI =
   {
      Debug("GUI", A_LineNumber, A_LineFile, "SimpleGUI setting copyright and status bar" )

      Gui, Add, Text, 0x1000 x0 y0 w726 h2
      Gui, Add, Picture, y12 x160 H32 W32 Icon%ScriptIcon#%, %ScriptIcon%
      Gui, Font, S%FontSize25% bold italic,Arial
      Gui, Font, S%FontSize25% bold italic,Verdana
      Gui, Add, Text, x+10 yp-2 BackgroundTrans, ac'tivAid%A_Space%
      Gosub, GuiDefaultFont
      Gui, Font, italic, Verdana
      Gui, Add, Text, x+30 yp+6 , v%ScriptVersion% von Wolfgang Reszel fr c't`n 2008 Heise Zeitschriften Verlag GmbH && Co. KG
      Gosub, GuiDefaultFont
      Gui, Add, Text, 0x1000 BackgroundTrans x153 y7 w569 h42
      UserMode := lng_UserMode%main_IsAdmin%%UsingUserDir%%AHKonUSB%
      StringReplace, UserMode, UserMode, %lng_activate%,,
      Gui, Add, StatusBar, vStatusBar gsub_OpenActivaidDir
      If AHKonUSB = 1
         SB_SetParts(480)
      Else
         SB_SetParts(540)
      SB_SetText( " " A_WorkingDir, 1)
      SB_SetText( " " UserMode, 2)
   }
   Else
   {
      Debug("GUI", A_LineNumber, A_LineFile, "setting copyright and status bar" )
      Gui, Add, Text, 0x1000 x0 y0 w726 h2
      Gui, Add, Picture, y12 x12 H32 W32 Icon%ScriptIcon#%, %ScriptIcon%
      Gui, Font, S%FontSize25% bold italic,Arial
      Gui, Font, S%FontSize25% bold italic,Verdana
      Gui, Add, Text, x+10 yp-2 BackgroundTrans, ac'tivAid%A_Space%
      Gosub, GuiDefaultFont
      Gui, Font, italic, Verdana
      Gui, Add, Text, x+30 yp+6 , v%ScriptVersion% von Wolfgang Reszel fr c't`n 2008 Heise Zeitschriften Verlag GmbH && Co. KG
      Gui, Add, Text, 0x1000 BackgroundTrans x5 y7 w569 h42
      Gosub, GuiDefaultFont
      UserMode := lng_UserMode%main_IsAdmin%%UsingUserDir%%AHKonUSB%
      StringReplace, UserMode, UserMode, %lng_activate%,,
      Gui, Add, StatusBar, vStatusBar gsub_OpenActivaidDir
      If AHKonUSB = 1
         SB_SetParts(352)
      Else
         SB_SetParts(412)
      SB_SetText( " " A_WorkingDir, 1)
      SB_SetText( " " UserMode, 2)
   }

   WinGetPos, GuiSplashX, GuiSplashY, GuiSplashW, GuiSplashH, ahk_id %MainGuiID%

   GuiSplashX := GuiSplashX+(GuiSplashW-400)/2-BorderHeight*2
   GuiSplashW := 400
   GuiSplashY := GuiSplashY+225

   Function = %ScriptNameFull%

   Gosub, sub_temporarySuspend
   If Extension[1] <>
      IfExist extensions
         Exts = 1

   GuiTabs[%lng_Readme%]=1
   GuiTabs[1]=%lng_Readme%
   GuiTabs[%lng_Changelog%]=2
   GuiTabs[2]=%lng_Changelog%
   GuiTabs[%lng_Settings%]=4
   GuiTabs[4]=%lng_Settings%
   GuiTabs[%lng_Hotkeys%]=5
   GuiTabs[5]=%lng_Hotkeys%

   If A_IsCompiled = 1
   {
      OptionsListBox = %lng_Readme%||%lng_Changelog%||%lng_Settings%|%lng_Hotkeys%|
      GuiTabs = 7
   }
   Else
   {
      OptionsListBox = %lng_Readme%||%lng_Changelog%||%lng_Settings%|%lng_Hotkeys%|%lng_Extensions%|
      GuiTabs[%lng_Extensions%]=6
      GuiTabs[6]=%lng_Extensions%
      GuiTabs = 8
   }

   If A_OSversion = WIN_NT4
      StringReplace, OptionsListBox, OptionsListBox, , --, All

   If SimpleMainGUI <>
   {
      Debug("GUI", A_LineNumber, A_LineFile, "SimpleGUI just create one tab" )

      GuiTabs = 1
      OptionsListBox = %SimpleMainGUI%
   }
   Else
   {
      Debug("GUI", A_LineNumber, A_LineFile, "creating tab-array" )
      Loop
      {
         Index := A_Index
         If Extension[%Index%] =
            break
         Function := Extension[%Index%]

         If (ExtensionHideSettings[%Index%] = 1 AND SimpleMainGUI <> Function)
            continue

         If (SimpleMainGUI <> "" AND Function <> SimpleMainGUI)
            continue

         OptionsListBox := OptionsListBox "|" Extension[%Index%]
         GuiTabs[%Function%] = %GuiTabs%
         GuiTabs[%GuiTabs%] = %Function%
         GuiTabs++
      }
   }

   If SimpleMainGUI =
   {
      Gui, Add, ListView, vOptionsListBox ReadOnly AltSubmit X3 Y7 h420 w144 gsub_OptionsListBoxClick -Multi -Hdr,Extensions
      LV_ModifyCol(1,"123")
      If _ShowIconsInOptionsListBox = 1
         LV_SetImageList(InstalledExtension_ImageList,1)

      Loop, Parse, OptionsListBox, |
      {
         If A_LoopField =
            continue

         If (ImageList[%A_LoopField%] = "" AND TrayIcon[%A_LoopField%] <> "" AND _ShowIconsInOptionsListBox = 1)
         {
            If A_RealOSVersion <> WIN_VISTA
               IL_Count++
            ImageList[%A_LoopField%] := IL_Count
            hIcon := ExtractIcon(TrayIcon[%A_LoopField%], TrayIconPos[%A_LoopField%], 16)
            DllCall("ImageList_ReplaceIcon", "uint", InstalledExtension_ImageList, "int", -1, "uint", hIcon)
            DllCall("DestroyIcon", "uint", hIcon)
            If A_RealOSVersion = WIN_VISTA
               IL_Count++
         }
         LV_Add("Icon" ImageList[%A_LoopField%], A_LoopField)
      }
      LV_Modify(ListBox_Selected, "Select Focus")

      Gui, Add, GroupBox, Section X153 Y88 H287 W570 Disabled Hidden

      Gui, Add, Tab2,vDlgTabs Y0 X-1000 gsub_OptionsListCtrlTab, %OptionsListBox%

      If (MainGuiX = "" OR MainGuiY = "")
         func_CenterCoordsOnActiveMonitor(MainGuiX,MainGuiY,726,450)

      If DontShowMainGUI =
         Gui, Show, W726 H450 %MainGuiX% %MainGuiY%, %ScriptTitle%

      Gui, %GuiID_activAid%:+Disabled

      Gui, Tab, % GuiTabs[%lng_Readme%]
      Gui, Add, Text, XS YS-23 gsub_DevCopyIndex, %lng_Chapter%
      Gui, Add, DropDownList, X+5 YP-4 W340 AltSubmit vReadmeChapter gsub_Chapter, %ReadmeDropDown%
      Gui, Add, Text, X+5 YP+4, %lng_Search%:
      Gui, Add, Edit, x+5 yp-4 w100 vsearchTermReadme gsub_ReadmeSearch
      Gui, Add, Button, -Wrap x+3 gsub_ReadmeSearch vsearchButtonReadme H21 W15, >
      Gui, Font, S%FontSize%, Courier New
      Gui, Font, S%FontSize%, Lucida Console
      Gui, Add, Edit, XS Y+5 Readonly 0x100 T100 H290 W570 -WantReturn vReadme gsub_CheckIfSettingsChanged, Readme
      Gosub, GuiDefaultFont
      Gui, Font, C00099 underline bold
      Gui, Add, Text, Y+5 gsub_CallFAQ center w570, %lng_FAQ%
      GuiControl, , Readme, %Readme%

      Gosub, GuiDefaultFont

      Gui, Tab, % GuiTabs[%lng_Changelog%]
      Gui, Add, Text, XS YS-23, %lng_Search%:
      Gui, Add, Edit, x+5 yp-4 w100 vsearchTermChangeLog gsub_ReadmeSearch
      Gui, Add, Button, -Wrap x+3 gsub_ReadmeSearch vsearchButtonChangelog H21 W15, >
      Gui, Font, S%FontSize%, Courier New
      Gui, Font, S%FontSize%, Lucida Console
      Gui, Add, Edit, XS Y+5 Readonly 0x100 T100 H290 W570 -WantReturn vChangelog gsub_CheckIfSettingsChanged, Changelog
      Gosub, GuiDefaultFont
      Gui, Font, C00099 underline bold
      Gui, Add, Text, Y+5 gsub_CallFAQ center w570, %lng_FAQ%
      GuiControl, , Changelog, %Changelog%

      Gosub, GuiDefaultFont

      Gui, Tab, % GuiTabs[%lng_Settings%]
      Gui, Add, GroupBox, X153 Y88 H287 W570 Disabled
      Gui, Add, Text, -Wrap XS+3 YS-17, %lng_SelectLanguage%:
      Gui, Add, DropDownList, -Wrap X+10 YP-3 w300 vselectedLanguage gsub_CheckIfSettingsChanged AltSubmit, %Languages%
      GuiControl, Choose, selectedLanguage, %actLanguage%

      IfExist %A_Startup%\%ScriptNameFull%.lnk
      {
         FileGetShortcut, %A_Startup%\%ScriptNameFull%.lnk,,,AutoStart
         IfInString, AutoStart, nosplash
            AutoStart = -1
         Else
            AutoStart = 1
      }
      Else
         AutoStart = 0

      If (AHKonUSB = "" OR AHKonlyPortable = 1)
         Gui, Add, CheckBox, XS+10 YS+11 vAutoStart gsub_CheckIfSettingsChanged -Wrap Check3 Checked%AutoStart%, %lng_Autostart%
      Else
         Gui, Add, CheckBox, XS+10 YS+11 Disabled vAutoStart -Wrap Checked%AutoStart%, %lng_Autostart%

      Gui, Add, CheckBox, XS+300 YP vShowFocusToolTips gsub_CheckIfSettingsChanged Checked%ShowFocusToolTips% -Wrap, %lng_ShowFocusToolTip%

      Gui, Add, GroupBox, XS+10 YS+29 W550 H103, Update
      Gui, Add, Button, -Wrap XS+19 YP+18 W150 gsub_getUpdates, %lng_Update%
      Gui, Add, Button, -Wrap %DisabledIfNotAdmin% X+10 W130 gsub_getManualUpdates, %lng_ManualUpdate%
      If Betatester = 1
         Gui, Add, CheckBox, R1 XS+20 Y+5 vAutoUpdate w250 gsub_CheckIfSettingsChanged -Wrap Checked%AutoUpdate%, %lng_AutoCheckUpdtBeta%
      Else
         Gui, Add, CheckBox, R1 XS+20 Y+5 vAutoUpdate w250 gsub_CheckIfSettingsChanged -Wrap Checked%AutoUpdate%, %lng_AutoCheckUpdt%
      Gui, Add, CheckBox, -Wrap x+10 vDisableAutoUpdateOnSlowNetwork Checked%DisableAutoUpdateOnSlowNetwork% gsub_CheckIfSettingsChanged, %lng_DisableAutoUpdateOnSlowNetwork%
      Gui, Add, CheckBox, -Wrap XS+20 Y+5 vBetatester gsub_BetaMode Checked%Betatester%, %lng_Betatester%
      Gui, Add, CheckBox, -Wrap XS+20 y+5 vBackupOnUpdate Checked%BackupOnUpdate% gsub_CheckIfSettingsChanged, %lng_BackupOnUpdate%
      IfExist, %BackupDir%
         Gui, Add, Button, -Wrap X+5 h18 yp-2 w70 gsub_ShowBackupDir, %lng_Show%

      Gui, Add, GroupBox, XS+10 YS+136 W550 H118, Tray
      Gui, Add, Text, XS+20 YP+18, %lng_TrayClick%:
      Gui, Add, DropDownList, xS+240 yp-3 w200 gsub_CheckIfSettingsChanged -Wrap AltSubmit vTrayClickOption, %lng_TrayClickOptions%
      GuiControl, Choose, TrayClickOption, %TrayClickOption%

      Gui, Add, Text, XS+20 Y+5, %lng_TrayRClick%:
      Gui, Add, DropDownList, xS+240 yp-3 w200 gsub_CheckIfSettingsChanged -Wrap AltSubmit vTrayRClickOption, %lng_TrayClickOptions%
      GuiControl, Choose, TrayRClickOption, %TrayRClickOption%

      Gui, Add, Text, XS+20 Y+5, %lng_TrayMClick%:
      Gui, Add, DropDownList, XS+240 yp-3 w200 gsub_CheckIfSettingsChanged -Wrap AltSubmit vTrayMClickOption, %lng_TrayClickOptions%
      GuiControl, Choose, TrayMClickOption, %TrayMClickOption%

      Gui, Add, CheckBox, XS+20 Y+5 w530 R2 vNoTrayIcon gsub_CheckIfSettingsChanged Checked%NoTrayIcon%, %lng_NoTrayIcon%

      CustomWorkingDirDisable =
      If MainDirNotWriteable <> 0
         CustomWorkingDirDisable = Disabled

      CustomWorkingDirTmp = %CustomWorkingDir%
      If CustomWorkingDirTmp =
         CustomWorkingDirTmp := A_WorkingDir
      CustomWorkingDirTmp := func_ReplaceWithCommonPathVariables(CustomWorkingDirTmp,"A_ScriptDir,")

      Gui, Add, Text, XS+10 Y+13 %CustomWorkingDirDisable%, %lng_CustomWorkingDir%:
      Gui, Add, Edit, X+5 YP-3 R1 W350 vCustomWorkingDirTmp gsub_CheckIfSettingsChanged %CustomWorkingDirDisable%, %CustomWorkingDirTmp%
      Gui, Add, Button, -Wrap X+5 YP-1 W100 %CustomWorkingDirDisable% gsub_CustomWorkingDirBrowse, %lng_Browse%

      If _AdditionalSettings
         Gui, Add, Button, -Wrap XS+445 YS+290 w124 h16 gsub_AdditionalSettingsMenu v_AdditionalSettingsMenu, %lng_AdditionalSettings% ...

      Gui, Add, Button, -Wrap XS+550 YS-25 h27 w18 vCH_activAid gsub_ContextHelp, ?

      Gui, Tab, % GuiTabs[%lng_Hotkeys%]
      Gui, Add, GroupBox, X153 Y88 H287 W570 Disabled
      Function = activAid

      func_HotkeyAddGuiControl( lng_MainGUI, "MainGUI", "xs+10 ys+20 W190")
      func_HotkeyAddGuiControl( lng_ProblemSolver, "ProblemSolver", "xs+10 y+4 W190")
      func_HotkeyAddGuiControl( lng_deactivate, "DisableEnable", "xs+10 y+4 W190")
      func_HotkeyAddGuiControl( lng_TempSuspend, "TempSuspend", "xs+10 y+4 W190")
      func_HotkeyAddGuiControl( lng_ShowHotkeyList, "ShowHotkeyList", "xs+10 y+4 W190")
      Gui, Add, CheckBox, xs+205 y+3 vHotkeyListAOT gsub_SettingsChangedForce -Wrap Checked%HotkeyListAOT%, %lng_HotkeyListAot%
      func_HotkeyAddGuiControl( lng_ShowMainContextMenu, "ShowMainContextMenu", "xs+10 y+10 W190")
      func_HotkeyAddGuiControl( lng_Reload, "ReloadActivAid", "xs+10 y+4 W190")

      Gui, Add, Button, -Wrap XS+550 YS-25 h27 w18 vCH_activAid2 gsub_ContextHelp, ?

      If A_IsCompiled <> 1
      {
         Gui, Tab, % GuiTabs[%lng_Extensions%]
         Gui, Add, GroupBox, X153 Y88 H287 W570 Disabled
         IfNotExist, settings\extensions_main_off.ini
         {
            Gui, Add, Button, -Wrap %DisabledIfNotAdmin% XS+10 YS-21 gsub_ExtensionsOff, %A_Space%%A_Space%%lng_ExtOff%%A_Space%%A_Space%
            Gosub, sub_ExtensionManager
         }
         Else IfExist, settings\extensions_main_off.ini
         {
            Gui, Add, Button, -Wrap %DisabledIfNotAdmin% XS+10 YS-21 gsub_ExtensionsOn, %A_Space%%A_Space%%lng_ExtOn%%A_Space%%A_Space%
         }
         Gui, Add, Picture, xs+536 ys-30 H32 W32 vExtensionGUIIcon_%Function% Icon91, %A_WinDir%\System32\shell32.dll
      }
   }
   Else
   {
      Function = %SimpleMainGUI%
      GuiTabs[1] = %SimpleMainGUI%
      GuiTabs[%SimpleMainGUI%] = 1

;      Gosub, sub_OptionsListBox

      Gui, Add, GroupBox, Section X5 Y88 H287 W570 Hidden

      Gui, Add, Tab2,vDlgTabs Y0 X-1000, %OptionsListBox%

      If (MainGuiX = "" OR MainGuiY = "")
         func_CenterCoordsOnActiveMonitor(MainGuiX,MainGuiY,578,450)

      If DontShowMainGUI =
         Gui, Show, W578 H450 %MainGuiX% %MainGuiY%, %ScriptTitle%
   }

   Debug("GUI", A_LineNumber, A_LineFile, "Creating Tabs ..." )

   CreateHotKeyList = %CreateHotKeyList_tmp%

   NumOfExtensions = 0
   ProcessedExtensions =
   Loop
   {
      Function := Extension[%A_Index%]
      If Function =
         Break

      If (InStr(ProcessedExtensions, "|" Function "|") )
         Continue

      ExtensionGuiTime[%Function%] = %A_TickCount%

      NumOfExtensions++

      Prefix := ExtensionPrefix[%A_Index%]

      If (SimpleMainGUI <> "" AND Function <> SimpleMainGUI)
         Continue

      If (CreateHotKeyList = 1 OR Function = SimpleMainGUI)
         Gosub, sub_CreateExtensionConfigGui
   }
   GuiDefault("actvAid")

   If CreateHotKeyList = 1
      HotkeyListCreated = 1

   Gui, Tab
   Gosub, GuiDefaultFont

   If SimpleMainGUI =
   {
      Gui, Add, Button, -Wrap X280 Y400 W80 vMainGuiOK gsub_SettingsOK, %lng_OK%
      Gui, Add, Button, -Wrap X+5 W80 vMainGuiCancel gactivAidGuiClose, %lng_cancel%
      Gui, Add, Button, -Wrap X+20 Disabled W80 vMainGuiApply gsub_SettingsOK, %lng_Apply%
   }
   Else
   {
      Gui, Add, Button, -Wrap X168 Y400 W80 vMainGuiOK gsub_SettingsOK, %lng_OK%
      Gui, Add, Button, -Wrap X+5 W80 vMainGuiCancel gactivAidGuiClose, %lng_cancel%
      Gui, Add, Button, -Wrap X+20 Disabled W80 vMainGuiApply gsub_SettingsOK, %lng_Apply%
   }

;   Critical, Off

   If DontShowMainGUI = 1
   {
      DontShowMainGUI =
      MainGuiVisible =
      IniDelete, %ConfigFile%, %ScriptName%, ShowGUI
      Gui, Destroy
      mainGuiID =
   }
   Else
   {
      Debug("GUI", A_LineNumber, A_LineFile, "Registering GUI-Messages" )
      func_AddMessage(0x100,"sub_searchInReadme")
      func_AddMessage(0x101,"GuiTooltipKey")
      func_AddMessage(0x200, "GuiTooltip")
      func_AddMessage(0x202, "GuiTooltipKey")
      func_AddMessage(0x6, "RemoveGuiTooltip")
      Debug("GUI", A_LineNumber, A_LineFile, "Finished registering GUI-Messages" )
      SetTimer, tim_GuiFinished, -20
   }

   MainGuiBuildTime := A_TickCount-MainGuiBuildTime
   Debug("GUI", A_LineNumber, A_LineFile, "Finished creating GUI (" MainGuiBuildTime "ms)" )

   Critical, Off

   Gosub, sub_OptionsListBox
   Gui, %GuiID_activAid%:-Disabled

   GuiControl, Focus, OptionsListBox
   Send, {Right}

   If (updScriptVersion <> "ERROR" AND updScriptVersion <> "" AND Listbox_selected = 2 AND DontShowMainGUI = "")
   {
      GuiControl, Focus, ChangeLog
      Send, ^{Home}{Down}+{Down}
      updScriptVersion =
   }

   Gosub, sub_temporarySuspend

   Gosub, sub_ShowDuplicates

   IniRead, CustomWorkingDirTmp, %A_ScriptDir%\Settings\ac'tivAid.ini, activAid, CustomWorkingDir, %A_Space%
   If CustomWorkingDirTmp =
   {
      func_SettingsChanged("activAid")
      OnlyChangedWorkingDir = 1
   }

   If (ExtensionConflict <> "" AND SimpleMainGUI = "")
   {
      InstalledExtensionsBefore =
      func_SettingsChanged("activAid")
      If ExtensionConflictDuplicates <> ""
         MsgBox, 48, %ScriptTitle%, %lng_ExtensionConflictDuplicates%
      Else
         MsgBox, 48, %ScriptTitle%, %lng_ExtensionConflict%
      NoBackup = 1
      Gosub, sub_SettingsOK
   }

   GuiControl, MoveDraw, OptionsListBox, x3 y7

   MainGuiBuildTime := ""
Return

sub_CustomWorkingDirBrowse:
   Gui +OwnDialogs
   FileSelectFolder, CustomWorkingDirTmp, *%CustomWorkingDirTmp% , 3
   If CustomWorkingDirTmp <>
      GuiControl,,CustomWorkingDirTmp,% func_ReplaceWithCommonPathVariables(CustomWorkingDirTmp,"A_ScriptDir,")
Return

sub_CreateAllExtensionConfigs:
   Loop
   {
      Function := Extension[%A_Index%]
      If Function =
         Break

      If (InStr(ProcessedExtensions, "|" Function "|") )
         Return

      Prefix := ExtensionPrefix[%A_Index%]

      If (SimpleMainGUI <> "" AND Function <> SimpleMainGUI)
         Return

      CreateHotKeyList = 1
      Gosub, sub_CreateExtensionConfigGui
      CreateHotKeyList =
   }
Return

sub_CreateExtensionConfigGui:
   Thread NoTimers
   If Function =
      Return

   GuiDefault("activAid")

   Debug("GUI", A_LineNumber, A_LineFile, "Creating Tab for: " Function )

   ExtensionIndex := ExtensionIndex[%Function%]

   Prefix := ExtensionPrefix[%ExtensionIndex%]

   If (SimpleMainGUI <> "" AND Function <> SimpleMainGUI)
      Return

   If ExtensionGuiDrawn[%Function%] = 1
      Return

   ExtensionGuiDrawn[%Function%] = 1

   Gui, %GuiID_activAid%:+Disabled

   BuildingGUI = %Prefix%_

   ProcessedExtensions = %ProcessedExtensions%|%Function%|

   If (ExtensionHideSettings[%ExtensionIndex%] <> 1 OR SimpleMainGUI=Function)
   {
      Gui, Tab, % GuiTabs[%Function%]

      If SimpleMainGUI =
         Gui, Add, GroupBox, X153 Y88 H287 W570 Disabled
      Else
         Gui, Add, GroupBox, X5 Y88 H287 W570 Disabled

      If (DisableIfCompiled_%Function% = 1 AND A_IsCompiled = 1)
         DisableIfCompiled = Disabled
      Else
         DisableIfCompiled =
      Enabled := Enable_%Function%
      EnableTray := EnableTray_%Function%
      Gui, Add, GroupBox, XS+0 YS-41 H43 W570
      IconIndent = 0
      If IconFile_On_%Function% <>
      {
         IconFile := TrayIcon[%Function%]
         IconPos := TrayIconPos[%Function%]
         IconIndent = 40
         Gui, Add, Picture, xp+512 yp+8 H32 W32 vExtensionGUIIcon_%Function% Icon%IconPos%, %IconFile%
      }
      Gui, Add, Button, -Wrap XS+550 YS-32 h31 w17 vCH_%Function% gsub_ContextHelp, ?
      If Enabled = 1
      {
         If OnlyForConfigDialog_%Function% <> 1
         {
            Gui, Add, Text, % "XS+" 30 " YP+2 W" 515-IconIndent " R2 vInfo_" Function, % Function " " ExtensionVersion[%Function%] " - " ExtensionDescription[%Function%]
            Gui, Add, Checkbox, % "XS+" 5 " YS-28 +E0x1 +0x8000 W20 H21 -Wrap vEnable_" Function " Checked" Enabled " gsub_ExtEnableDisable " DisableIfCompiled, %lng_activated%
         }
         Else
            Gui, Add, Text, % "XS+" 10 " YP+2 W" 515-IconIndent " R2 vInfo_" Function, % Function " " ExtensionVersion[%Function%] " - " ExtensionDescription[%Function%]
      }
      Else
      {
         If OnlyForConfigDialog_%Function% <> 1
         {
            Gui, Add, Text, % "XS+" 30 " YP+2 W" 515-IconIndent " R2 Disabled vInfo_" Function, % Function " " ExtensionVersion[%Function%] " - " ExtensionDescription[%Function%]
            Gui, Add, Checkbox, % "XS+" 5 " YS-28 +E0x1 +0x8000 W20 H21 -Wrap vEnable_" Function " Checked" Enabled " gsub_ExtEnableDisable " DisableIfCompiled, %lng_deactivated%
         }
         Else
            Gui, Add, Text, % "XS+" 10 " YP+2 W" 515-IconIndent " R2 Disabled vInfo_" Function, % Function " " ExtensionVersion[%Function%] " - " ExtensionDescription[%Function%]
      }
      tooltip_Enable_%Function% = %lng_EnableDisable%
      Gosub, GuiDefaultFont

      If OnlyForConfigDialog_%Function% <> 1
         Gui, Add, Checkbox, XS+10 YS+290 vEnableTray_%Function%_tmp gsub_CheckIfSettingsChanged_BackToList -Wrap Checked%EnableTray% %DisableIfCompiled%, %lng_ShowInTrayMenu%
      If %Prefix%_AdditionalSettings
         Gui, Add, Button, -Wrap XS+445 YS+290 w124 h16  gsub_AdditionalSettingsMenu v%Prefix%_AdditionalSettingsMenu, %lng_AdditionalSettings% ...

      Gui, Add, Picture, YS+1 h10

      If CustomHotkey_%Function% = 1
      {
         func_HotkeyAddGuiControl( lng_Hotkey, Function, "y+3 xs+10" )
      }
      If (IsLabel( "init_" Function ))
      {
         Gosub, SettingsGui_%Function%
      }
   }
   Else
   {
      RequireExtensions := FunctionRequireExt[%Function%]
      Loop, Parse, RequireExtensions, `,
      {
         If ((HideInGui_%A_LoopField% <> 1 AND RequireExtensions <> "") OR SimpleMainGUI = Function )
            If (IsLabel( "init_" Function ))
            {
               Gosub, SettingsGui_%Function%
            }
      }
   }

   Gosub, GuiDefaultFont
   ExtensionGuiTime[%Function%] := A_TickCount-ExtensionGuiTime[%Function%]
   Gui, -Disabled
   Sleep,0
   BuildingGUI =
Return

sub_ReadmeSearchBack:
   IfInString, A_GuiControl, ContextHelp
   {
      GuiControlGet, searchTermContextHelp, %GuiID_HelpWindow%:
      func_SearchInControl( searchTermContextHelp, "Edit2", "A", 1)
   }
   IfInString, A_GuiControl, HotkeyList
   {
      GuiControlGet, searchTermHotkeyList, %GuiID_HotkeyList%:
      func_SearchInControl( searchTermHotkeyList, "Edit2", "A", 1)
   }
   Else IfInString, A_GuiControl, Readme
   {
      GuiControlGet, searchTermReadme
      func_SearchInControl( searchTermReadme, "Edit2", "A", 1)
   }
   IfInString, A_GuiControl, ChangeLog
   {
      GuiControlGet, searchTermChangeLog
      func_SearchInControl( searchTermChangeLog, "Edit4", "A", 1)
   }
Return

sub_ReadmeSearch:
   IfInString, A_GuiControl, ContextHelp
   {
      GuiControlGet, searchTermContextHelp, %GuiID_HelpWindow%:
      func_SearchInControl( searchTermContextHelp, "Edit2", "A", 0)
   }
   IfInString, A_GuiControl, HotkeyList
   {
      GuiControlGet, searchTermHotkeyList, %GuiID_HotkeyList%:
      func_SearchInControl( searchTermHotkeyList, "Edit2", "A", 0)
   }
   Else IfInString, A_GuiControl, Readme
   {
      GuiControlGet, searchTermReadme
      func_SearchInControl( searchTermReadme, "Edit2", "A", 0)
   }
   IfInString, A_GuiControl, ChangeLog
   {
      GuiControlGet, searchTermChangeLog
      func_SearchInControl( searchTermChangeLog, "Edit4", "A", 0)
   }
Return

sub_SearchInReadme:
   searchKey = %#wParam%
   searchSendAdd =

   searchTermTargetHwnd =

   GuiDefault("activAid")

   IfInString, A_GuiControl, searchTerm
   {
      StringReplace, searchTermTarget, A_GuiControl, searchTerm,,
      GuiControlGet, searchTermTargetHwnd, Hwnd, %searchTermTarget%
   }

   SetFormat, integer, hex
   searchKeyHex := searchKey+0
   SetFormat, integer, d

   GetKeyState, searchCtrlStateTmp, Ctrl
   If searchCtrlStateTmp = D
   {
      searchKey := searchKey + 1000
      searchSendAdd = %searchSendAdd%^
   }
   GetKeyState, searchShiftState, Shift
   If searchShiftState = D
   {
      searchKey := searchKey + 2000
      searchSendAdd = %searchSendAdd%+
      searchKeyChr := searchKeyChr - 32
   }
   GetKeyState, searchAltState, Alt
   If searchAltState = D
   {
      searchKey := searchKey + 4000
      searchSendAdd = %searchSendAdd%!
   }

;   tooltip, %A_EventInfo% %A_GuiControl%: %searchKey% %searchTermTargetHwnd%:%searchTermTarget%,,,2

   If (searchKey = 114 OR searchKey = 13)
      Gosub, sub_ReadmeSearch

   If (searchKey = 2114 OR searchKey = 2013)
      Gosub, sub_ReadmeSearchBack

   If (searchKey = 40 AND searchTermTargetHwnd <> "")
   {
      SendMessage, 0x115, 1, , , ahk_id %searchTermTargetHwnd% ; WM_VSCROLL (down)
      #Return = 0
   }
   If (searchKey = 38 AND searchTermTargetHwnd <> "")
   {
      SendMessage, 0x115, 0, , , ahk_id %searchTermTargetHwnd% ; WM_VSCROLL (up)
      #Return = 0
   }
   If (searchKey = 34 AND searchTermTargetHwnd <> "")
   {
      SendMessage, 0x115, 3, , , ahk_id %searchTermTargetHwnd% ; WM_VSCROLL (PgDown)
      #Return = 0
   }
   If (searchKey = 33 AND searchTermTargetHwnd <> "")
   {
      SendMessage, 0x115, 2, , , ahk_id %searchTermTargetHwnd% ; WM_VSCROLL (PgUp)
      #Return = 0
   }
   If (searchkey = 1067 AND A_GuiControl= "HotkeyList")
   {
      Clipboard = %HotkeyList%
      #Return = 0
   }
   If searchKey not in 33,34,35,36,37,38,39,40,1017,1065,2016,3016,3017,1033,1034,1035,1036,1037,1038,1039,1040,2033,2034,2035,2036,2037,2038,2039,2040,3033,3034,3035,3036,3037,3038,3039,3040
      If #Return <> 0
         If A_GuiControl in ContextHelp,HotkeyList,Readme,ChangeLog
         {
            GuiControl, Focus, searchTerm%A_GuiControl%
            If searchKey > 2000
               searchKey := searchkey-2000
            Else If searchKey > 64
               searchKey := searchkey+32
            Send, % Chr(searchKey)
            #Return = 0
         }

   If A_GuiControl = Readme
      Gosub, sub_DetectChapter

Return

tim_GuiFinished:
   MainGuiVisible = 2
Return

sub_BigIcon:
   Gui, +LastFound
   SendMessage, 0x80, 1, ScriptIconFromDll  ; 0x80 is WM_SETICON; and 1 means ICON_BIG (vs. 0 for ICON_SMALL).
Return

sub_BetaMode:
   Gosub, sub_CheckIfSettingsChanged
   GuiControlGet, BetatesterTmp,,Betatester
   If BetatesterTmp = 1
      GuiControl,,AutoUpdate,%lng_AutoCheckUpdtBeta%
   Else
      GuiControl,,AutoUpdate,%lng_AutoCheckUpdt%
Return

GuiTooltip:
   func_ShowGuiToolTip(A_GuiControl)
Return

GuiTooltipKey:
;   Gosub, RemoveGuiTooltip
   If ShowFocusToolTips = 0
      Return

   MouseGetPos,ttThisControlX,ttThisControlY,ttThisWin, ttThisControl
   GuiControlGet, ttFocusControlV, FocusV
   GuiControlGet, ttFocusControl, Focus
   ControlGetPos, ttFocusX, ttFocusY, ttFocusW, ttFocusH, %ttFocusControl%, A

   If ttFocusControl =
      Return

   ttFocusControlV := func_StrTranslate(ttFocusControlV, "=-+ !&()'<>:,./\", "_______[]_[]_____")
   ttFocusControlV := func_StrClean(ttFocusControlV,"",0,"_")

   If (#wParam <> 0 AND #wParam <> 4 AND #wParam <> 8)
      If (func_StrLeft(ttFocusControlV,7)="Hotkey_" AND InStr(ttFocusControl,"Button"))
         ttFocusControlV = Hotkey_

   CoordMode, ToolTip, Relative

   If ( tooltip_%ttFocusControlV% = "")
   {
      Gosub, RemoveGuiTooltip
   }
   Else
   {
      SetTimer, tim_ShowGuiToolTip, Off
      thisTooltip := tooltip_%ttFocusControlV%
      tooltip, %thisTooltip%, % ttFocusX, % ttFocusY+ttFocusH, 9
      SetTimer, tim_ToolTipWatcher, 10
      SetTimer, tim_RemoveGuiToolTip, 20000
   }
   lastControl := ttFocusControl
   ttLastFocusControl := ttFocusControl
   ttLastControlX := ttThisControlX
   ttLastControlY := ttThisControlY
Return

RemoveGuiTooltip:
   SetTimer, tim_ShowGuiToolTip, Off
   SetTimer, tim_ToolTipWatcher, Off
   tooltip,,,,9
   lastControl =
   ttLastFocusControl =
   thisTooltip =
Return

func_ShowGuiToolTip(Control)
{
   global lastControl, thisTooltip, ttThisControl, ttLastControlX, ttLastControlY, ShowFocusToolTips, ttLastFocusControl

   MouseGetPos,ttThisControlX,ttThisControlY,ttThisWin, ttThisControl

   If (ttLastControlX = ttThisControlX AND ttLastControlY = ttThisControlY)
      Return

   control := func_StrTranslate(Control, "=-+ !&()'<>:,./\", "_______[]_[]_____")
   control := func_StrClean(Control,"",0,"_")

   CoordMode, ToolTip, Screen
   If (func_StrLeft(Control,7)="Hotkey_" AND InStr(ttThisControl,"Button"))
      Control = Hotkey_

   If (tooltip_%Control% = "" )
   {
      Gosub, RemoveGuiTooltip
   }
   Else If (Control And ttThisControl)
   {
      If thisTooltip <>
         ToolTip,,,,9
      thisTooltip := tooltip_%Control%

      If ttThisControl <> %lastControl%
      {
         SetTimer, tim_ShowGuiToolTip, -600
         SetTimer, tim_RemoveGuiToolTip, 20000
         SetTimer, tim_ToolTipWatcher, 600
      }
      Else ; If ( ttLastControlX <> ttThisControlX OR ttLastControlY <> ttThisControlY )
      {
         Gosub, tim_RemoveGuiToolTip
      }
   }
   ttLastControlX := ttThisControlX
   ttLastControlY := ttThisControlY
}

tim_ShowGuiToolTip:
   tooltip, %thisTooltip% ,,,9
   lastControl := ttThisControl
Return

tim_RemoveGuiToolTip:
   Gosub, RemoveGuiTooltip
Return

tim_ToolTipWatcher:
   WinGetTitle, ttTitle, A
   If (ttTitle = "" OR !WinActive("ahk_class AutoHotkeyGUI") )
      Gosub, tim_RemoveGuiToolTip
Return

sub_CheckIfSettingsChanged_BackToList:
   Gosub, sub_CheckIfSettingsChanged
   GuiControl, Focus, OptionsListBox
Return

sub_SettingsChangedForce:
   If activeTab := lng_Hotkeys
      activeTab = activAid
   func_SettingsChanged(activeTab)
   Gosub, sub_EnableDisable_ApplyButton
Return

sub_CheckIfSettingsChanged:
   If (A_GuiControl = "" OR StrLen(A_GuiControl) < 3 OR MainGuiVisible <> 2 OR SkipChecking = 1 OR A_GuiControl="OptionsListBox" OR (BuildingGUI <> "" AND BuildingGUI = func_StrLeft(A_GuiControl,StrLen(BuildingGUI))))
      return

   Control := func_StrTranslate(A_GuiControl, "-+ !&()'<>:,./\", "________________")

   If (activeTab = lng_Hotkeys)
      activeTab = activAid

   GuiControlGet, activeTab,,DlgTabs
   GuiControlGet, activeControlValue,,%A_GuiControl%
   StringReplace, ChangedSettings[%activeTab%], ChangedSettings[%activeTab%], %A_GuiControl%|,,A
   If Control <> %A_GuiControl%
   {
      If OnTab_%activeTab% =
         ChangedSettings[%activeTab%] := ChangedSettings[%activeTab%] A_GuiControl "|"
      Else
      {
         Loop, Parse, OnTab_%activeTab%, |
         {
            ChangedSettings[%A_LoopField%] := ChangedSettings[%A_LoopField%] A_GuiControl "|"
         }
         ChangedSettings[%activeTab%] := ChangedSettings[%activeTab%] A_GuiControl "|"
      }
      OnlyChangedWorkingDir =
   }
   Else If A_GuiControl <> %activeControlValue%
   {
      If OnTab_%activeTab% =
         ChangedSettings[%activeTab%] := ChangedSettings[%activeTab%] A_GuiControl "|"
      Else
      {
         Loop, Parse, OnTab_%activeTab%, |
         {
            ChangedSettings[%A_LoopField%] := ChangedSettings[%A_LoopField%] A_GuiControl "|"
         }
         ChangedSettings[%activeTab%] := ChangedSettings[%activeTab%] A_GuiControl "|"
      }
      OnlyChangedWorkingDir =
   }

   Gosub, sub_EnableDisable_ApplyButton
Return

func_SettingsChanged( Extension )
{
   Global
   If Extension = A_GuiControl
   {
      StringSplit, ExtensionPrefix, A_GuiControl, _
      Extension := %ExtensionPrefix1%_ScriptName
   }
   ChangedSettings[%Extension%] := ChangedSettings[%Extension%] Extension "|"
   Gosub, sub_EnableDisable_ApplyButton
   OnlyChangedWorkingDir =
}

sub_EnableDisable_ApplyButton:
   If OptionsListBoxClick = 1
      Return
   SettingsChanged = 0
   If ChangedSettings[activAid] <>
      SettingsChanged++
   Loop
   {
      tmpFunct := Extension[%A_Index%]
      If tmpFunct =
         break
      If ChangedSettings[%tmpFunct%] <>
      {
         SettingsChanged++
         Break
      }
   }

   If SettingsChanged > 0
   {
      GuiControl, %GuiID_activAid%:Enable, MainGuiApply
      Debug("GUI", A_LineNumber, A_LineFile, "Enabled Apply button" )
   }
   Else
   {
      GuiControl, %GuiID_activAid%:Disable, MainGuiApply
      Debug("GUI", A_LineNumber, A_LineFile, "Disabled Apply button" )
   }
Return

sub_Chapter:
;   tooltip, %A_GuiEvent% %A_EventInfo%
   Gui, %GuiID_activAid%:+LastFound
   GuiControlGet, ReadmeChapter
   SendMessage, 0x115, 6 , , Edit2 ; WM_VSCROLL (top)
   SendMessage, 0xB1, ReadmeGotoLine[%ReadmeChapter%], % ReadmeGotoLine[%ReadmeChapter%]+StrLen(ReadmeChapter[%ReadmeChapter%]), Edit2 ; EM_SETSEL
   SendMessage, 0xB7, , , Edit2 ; EM_SCROLLCARET
   SendMessage, 0xB6, , 24, Edit2 ; EM_LINESCROLL
Return

sub_DetectChapter:
   ReadmeChapter =
   ControlGet, searchCol, CurrentCol,,Edit2, A
   ControlGet, searchLine, CurrentLine,,Edit2, A
   searchCol--
   searchLine--
   SendMessage, 0xBB, searchLine, 0 , Edit2, A  ; EM_LINEINDEX
   searchEditIndex := Errorlevel + searchCol
   Loop
   {
      If ReadmeGotoLine[%A_Index%] =
         break
      ChapterIndex := A_Index + 1
      If (searchEditIndex >= ReadmeGotoLine[%A_Index%] AND searchEditIndex <= ReadmeGotoLine[%ChapterIndex%])
      {
         ReadmeChapter := A_Index
         break
      }
      ReadmeChapter := A_Index
      If searchEditIndex = 0
         break
   }
   GuiControl, Choose, ReadmeChapter, %ReadmeChapter%
Return

sub_DevCopyIndex:
   If (A_GuiControlEvent = "DoubleClick" AND _Debug = 1)
   {
      StringReplace, Clipboard, ReadmeDropDown, |, `r`n, A
   }
   tooltip, %A_GuiControlEvent%
Return


sub_ExtEnableDisable:
   GuiDefault("activAid")
   Gui, ListView, OptionsListBox
   StringReplace, Function, A_GuiControl, Enable_
   GuiControlGet, Enable_%Function%_tmp,,%A_GuiControl%
   If Enable_%Function%_tmp = 1
   {
      GuiControl,Enable, Info_%Function%

      If (ImageList[%Function%] <> "" AND _ShowIconsInOptionsListBox = 1)
      {
         hIcon := ExtractIcon(TrayIcon[%Function%], TrayIconPos[%Function%], 16)
         DllCall("ImageList_ReplaceIcon", "uint", InstalledExtension_ImageList, "int", ImageList[%Function%]-1, "uint", hIcon)
         DllCall("DestroyIcon", "uint", hIcon)
         LV_Modify(GuiTabs[%Function%],"Icon0")
         LV_Modify(GuiTabs[%Function%],"Icon" ImageList[%Function%])
      }
   }
   Else
   {
      GuiControl,Disable, Info_%Function%

      If (ImageList[%Function%] <> "" AND _ShowIconsInOptionsListBox = 1)
      {
         hIcon := ExtractIcon(TrayIconOff[%Function%], TrayIconOffPos[%Function%], 16)
         DllCall("ImageList_ReplaceIcon", "uint", InstalledExtension_ImageList, "int", ImageList[%Function%]-1, "uint", hIcon)
         DllCall("DestroyIcon", "uint", hIcon)
         LV_Modify(GuiTabs[%Function%],"Icon0")
         LV_Modify(GuiTabs[%Function%],"Icon" ImageList[%Function%])
      }
   }
   gosub, sub_CheckIfSettingsChanged
Return

sub_OptionsListCtrlTab:
   GuiDefault("activAid")
   GuiControl, +AltSubmit, DlgTabs
   GuiControlGet, DlgTab,,DlgTabs
   GuiControl, -AltSubmit, DlgTabs
   LV_Modify(DlgTab, "Select Focus")
   If GuiTabs[%DlgTab%] =
      Return
   Gosub, sub_OptionsListBox
Return

sub_OptionsListBoxClick:
   StringCaseSense, On
   GuiDefault("activAid")
   Gui, ListView, OptionsListBox
   OptionsListBoxClick =
;   If (A_GuiEvent = "K" OR (A_GuiEvent ="I" AND ErrorLevel = "f" AND GetKeyState("LButton","P")) OR A_GuiEvent = "Normal")
   If (A_EventInfo > 0 AND !(A_GuiEvent = "I" AND ErrorLevel = "f" AND !GetKeyState("LButton"))) ; OR (GetKeyState("LButton","P") AND A_EventInfo > 0) OR A_GuiEvent = "K")
   {
      OptionsListBoxClick = 1
      StringCaseSense, Off
      SetTimer, sub_OptionsListBox, -100, 1
   }
;   Else If ((A_GuiEvent ="D" AND !GetKeyState("LButton","P")) OR A_GuiEvent ="f" OR A_GuiEvent ="F")
   Else If (!GetKeyState("LButton") AND (A_EventInfo = 0 OR A_GuiEvent = "D" OR A_GuiEvent ="f" OR (A_GuiEvent="I" AND ErrorLevel="s")))
      LV_Modify(ListBox_Selected, "Select Focus")
   Else
      GuiControl, %GuiID_activAid%:Choose, DlgTabs, %ListBox_selected%

   If (A_GuiEvent = "K" AND A_EventInfo = 27 )
      SetTimer, activAidGuiEscape, -50

   OutputDebug, % A_GuiEvent ":" ErrorLevel ":LB" GetKeyState("LButton") ":" A_EventInfo
   Sleep,0
Return

sub_OptionsListBox:
   Thread,Priority,1
   GuiDefault("activAid")
   Gui, %GuiID_activAid%:+Disabled
   Gui, ListView, OptionsListBox
   If MainGuiVisible <>
   {
      ListBox_selected := LV_GetNext()
   }

   If SimpleMainGUI <>
      ListBox_selected = 1

   If GuiTabs[%ListBox_selected%] =
   {
      Gui, %GuiID_activAid%:-Disabled
      OptionsListBoxClick =
      Return
   }

   GuiControl, %GuiID_activAid%:Choose, DlgTabs, %ListBox_selected%

   Function := GuiTabs[%ListBox_selected%]
   ExtensionIndex := ExtensionIndex[%Function%]
   Prefix := ExtensionPrefix[%ExtensionIndex%]
   actFunct := Function

   If ExtensionGuiDrawn[%Function%] = 0
   {
      Gosub, sub_CreateExtensionConfigGui
   }

   GuiDefault("activAid")

   Gosub, sub_CreateAdditionalSettingsMenu

   SetTimer,tim_StoreSelection, -20

   If (ListBox_selected <> ListBox_selected_last OR OptionsListBoxClick = 1)
      GuiControl, %GuiID_activAid%:Focus, OptionsListBox

   ListBox_selected_last := ListBox_selected
   Sleep,0
   Gui, %GuiID_activAid%:-Disabled
Return

tim_StoreSelection:
   Debug("GUI", A_LineNumber, A_LineFile, "Updating GUI-Menu (" actFunct ")" )
   Gosub, sub_SettingsMenu
   IniWrite, %ListBox_selected%, %ConfigFile%, %ScriptName%, GUIselected
   BuildingGUI =
   OptionsListBoxClick =
Return

activAidGuiEscape:
activAidGuiClose:
   Critical
   Debug("GUI", A_LineNumber, A_LineFile, "Close/Escape GUI (" GetKey ", " InputMode ")" )

   GuiDefault("activAid")

   If (GetKey = "Escape" OR InputMode <> "")
   {
      GetKey =
      Return
   }

   If MainGUiVisible = 1
      Return

   MainGuiVisible =
   Hotkey_DupDuplicates =

   func_RemoveMessage(0x100,"sub_searchInReadme")

   Hotkey_AllNewHotkeys =
   IniWrite, %ListBox_selected%, %ConfigFile%, %ScriptName%, GUIselected

   If MainGuiX <> Reset
   {
      WinGet, MinMax, MinMax, ahk_id %MainGuiID%
      If MinMax <> -1
      {
         WinGetPos, MainGuiX, MainGuiY, MainGuiW, MainGuiH, ahk_id %MainGuiID%
         If (!func_CheckIfCoordsCentered(MainGuiX, MainGuiY, MainGuiW, MainGuiH))
         {
            IniWrite, %MainGuiX%, %ConfigFile%, %ScriptName%, MainGuiX
            IniWrite, %MainGuiY%, %ConfigFile%, %ScriptName%, MainGuiY
         }
      }
   }

   Gui, %GuiID_activAid%:Default

   Gui, Destroy
   mainGuiID =

   Loop
   {
      Function := Extension[%A_Index%]
      ExtensionGuiDrawn[%Function%] =
      If Function =
         Break

      If (SimpleMainGUI <> "" AND Function <> SimpleMainGUI)
         continue

      If (Enable_%Function% = 1 AND A_IsSuspended = 0)
      {
         Debug("EXTENSION", A_LineNumber, A_LineFile, "DoEnable_" Function "...")
         Gosub, DoEnable_%Function%
      }

      ChangedSettings[%Function%] =

      If IsLabel( "init_" Function )
      {
         Debug("GUI", A_LineNumber, A_LineFile, "CancelSettings_" Function )
         Gosub, CancelSettings_%Function%
      }
   }
   Menu, Tray, ToggleEnable, % lng_Info "`t" func_HotkeyDecompose( Hotkey_MainGUI, 1 )

   IniDelete, %ConfigFile%, %ScriptName%, ShowGUI

   Gosub, sub_ChangeIcon

   If A_IsSuspended = 1
      Gosub, sub_temporarySuspend

   SimpleMainGUI =

   Hotkey_AllDuplicates = %Hotkey_AllDuplicates_Backup%
   Gosub, DuplicatesGuiClose

   Loop, Parse, OptionsListBox, |
   {
      If A_LoopField =
         continue
      ImageList[%A_LoopField%] =
   }

   Loop, Parse, hook_UnsetVarOnGuiClose, |
      %A_LoopField% := ""
   hook_UnsetVarOnGuiClose := ""

   func_RemoveMessage(0x200, "GuiTooltip")
   func_RemoveMessage(0x101, "GuiTooltipKey")
   func_RemoveMessage(0x202, "GuiTooltipKey")
   func_RemoveMessage(0x6, "RemoveGuiTooltip")

   Sleep, 0
Return

sub_SettingsOK:
   Critical
   GuiDefault("activAid")

   Debug("GUI", A_LineNumber, A_LineFile, "Received OK or Apply button ..." )
   Gosub, sub_temporarySuspend
   Debug("GUI", A_LineNumber, A_LineFile, "Creating Backup of Config file ..." )
   If NoBackup =
      FileCopy, %ConfigFile%, %ConfigFile%.bak, 1

   func_RemoveMessage(0x100,"sub_searchInReadme")
   Debug("GUI", A_LineNumber, A_LineFile, "Message removed: 0x100,sub_searchInReadme" )

   DontReload = 1
   Loop
   {
      Function := Extension[%A_Index%]
      If Function =
         Break
      If ChangedSettings[%Function%] =
         continue
      Debug("EXTENSION", A_LineNumber, A_LineFile, "DoDisable_" Function "...")
      Gosub, DoDisable_%Function%
   }
   Debug("GUI", A_LineNumber, A_LineFile, "Reset Sound ..." )
   SoundPlay, Nonexistent.wav, wait
   DontReload = 0

   Hotkey_ProblemSolver_old2 = %Hotkey_ProblemSolver%
   Hotkey_MainGUI_old2 = %Hotkey_MainGUI%
   Hotkey_DisableEnable_old2 = %Hotkey_DisableEnable%
   Hotkey_TempSuspend_old2 = %Hotkey_TempSuspend%
   Hotkey_ShowHotkeyList_old2 = %Hotkey_ShowHotkeyList%
   Hotkey_ShowMainContextMenu_old2 = %Hotkey_ShowMainContextMenu%
   Hotkey_ReloadActivAid_old2 = %Hotkey_ReloadActivAid%

   Hotkey_ProblemSolver_old = %Hotkey_ProblemSolver%
   Hotkey_MainGUI_old = %Hotkey_MainGUI%
   Hotkey_DisableEnable_old = %Hotkey_DisableEnable%
   Hotkey_TempSuspend_old = %Hotkey_TempSuspend%
   Hotkey_ShowMainContextMenu_old = %Hotkey_ShowMainContextMenu%
   Hotkey_ReloadActivAid_old = %Hotkey_ReloadActivAid%

   _DebugLast = %_Debug%
   _DevelLast = %_Devel%

   If MainGuiX <> Reset
   {
      Debug("GUI", A_LineNumber, A_LineFile, "Reset Config window position" )
      WinGetPos, MainGuiX, MainGuiY, MainGuiW, , ahk_id %MainGuiID%
      IniWrite, %MainGuiX%, %ConfigFile%, %ScriptName%, MainGuiX
      IniWrite, %MainGuiY%, %ConfigFile%, %ScriptName%, MainGuiY

      GuiSplashX := MainGuiX+(MainGuiW-400)/2-BorderHeight*2
      GuiSplashY := MainGuiY+225
   }

   Debug("GUI", A_LineNumber, A_LineFile, "Submitting GUI fields to variables ..." )
   GuiDefault("activAid")
   Gui, Submit, NoHide

   IniWrite, %ListBox_selected%, %ConfigFile%, %ScriptName%, GUIselected

   Gui, %GuiID_activAid%:+Disabled

   Gosub, sub_EnableDisable_ApplyButton
   If SettingsChanged > 0
   {
      Readme_Hotkeys =
      HotkeyListCreated =
      Gui, %GuiID_HotkeyList%:+LastFoundExist
      IfWinExist
      {
         WinGetPos, ShowHotkeyListX , ShowHotkeyListY , ShowHotkeyListW, ShowHotkeyListH
         ShowHotkeyListW := ShowHotkeyListW - BorderHeight*2
         ShowHotkeyListH := ShowHotkeyListH - BorderHeight*2 - CaptionHeight
         Gui, %GuiID_HotkeyList%:Cancel
      }
   }

   ChangedSettings = 0

   If ChangedSettings[activAid] <>
   {
      Debug("SETTINGS", A_LineNumber, A_LineFile, "Writing Settings for: activAid ..." )

      SplashImage,,CWeeeeee b1 FS9 w%GuiSplashW% x%GuiSplashX% y%GuiSplashY%, %lng_WritingSettings%
      IniWrite, %TrayClickOption%, %ConfigFile%, %ScriptName%, TrayClickOption
      IniWrite, %TrayMClickOption%, %ConfigFile%, %ScriptName%, TrayMClickOption
      IniWrite, %TrayRClickOption%, %ConfigFile%, %ScriptName%, TrayRClickOption
      IniWrite, %_Debug%, %ConfigFile%, %ScriptName%, Debug
      IniWrite, %_Devel%, %ConfigFile%, %ScriptName%, Devel
      IniWrite, %AutoUpdate%, %ConfigFile%, %ScriptName%, AutoUpdate
      IniWrite, %DelayedUpdateCheck%, %ConfigFile%, %ScriptName%, DelayedUpdateCheck
      IniWrite, %NoTrayIcon%, %ConfigFile%, %ScriptName%, NoTrayIcon
      IniWrite, %Betatester%, %ConfigFile%, %ScriptName%, Betatester
      IniWrite, %BackupOnUpdate%, %ConfigFile%, %ScriptName%, BackupOnUpdate
      IniWrite, %DisableAutoUpdateOnSlowNetwork%, %ConfigFile%, %ScriptName%, DisableAutoUpdateOnSlowNetwork
      IniWrite, %ShowFocusToolTips%, %ConfigFile%, %ScriptName%, ShowFocusToolTips

      IniWrite, %_DebugLevel%, %ConfigFile%, %ScriptName%, DebugLevel
      IniWrite, %ReloadOnWakeUp%, %ConfigFile%, %ScriptName%, ReloadOnWakeUp
      IniWrite, %DisableAutoUpdateOnSlowNetwork%, %ConfigFile%, %ScriptName%, DisableAutoUpdateOnSlowNetwork
      IniWrite, %NoTrayIcon%, %ConfigFile%, %ScriptName%, NoTrayIcon
      If ScriptIcon <> %A_ScriptDir%\Library\ac'tivAid.ico
         IniWrite, %ScriptIcon%, %ConfigFile%, %ScriptName%, Icon
      If ScriptOnIcon <> %A_ScriptDir%\Library\ac'tivAid_on.ico
         IniWrite, %ScriptOnIcon%, %ConfigFile%, %ScriptName%, TrayIcon_On
      If ScriptOffIcon <> %A_ScriptDir%\Library\ac'tivAid_off.ico
         IniWrite, %ScriptOffIcon%, %ConfigFile%, %ScriptName%, TrayIcon_Off
      IniWrite, %AllowMultipleInstances%, %ConfigFile%, %ScriptName%, AllowMultipleInstances
      IniWrite, %NetworkTimeout%, %ConfigFile%, %ScriptName%, NetworkTimeout
      IniWrite, %WinModifierFirst%, %ConfigFile%, %ScriptName%, WinModifierFirst
      IniWrite, %FileBrowser%, %ConfigFile%, %ScriptName%, FileBrowser
      IniWrite, %FileBrowserWithTree%, %ConfigFile%, %ScriptName%, FileBrowserWithTree
      IniWrite, %FileBrowserSelect%, %ConfigFile%, %ScriptName%, FileBrowserSelect
      IniWrite, %FullScreenApps%, %ConfigFile%, %ScriptName%, FullScreenApps
      IniWrite, %MaintainStats%, %ConfigFile%, %ScriptName%, MaintainStats
      IniWrite, %LastScriptversion%, %ConfigFile%, %ScriptName%, LastScriptVersion
      IniWrite, %activAid_LastFolder%, %ConfigFile%, %ScriptName%, LastFolder
      IniWrite, %HotkeyListAOT%, %ConfigFile%, %ScriptName%, HotkeyListAOT
      IniWrite, %CreateUninstaller%, %ConfigFile%, %ScriptName%, CreateUninstaller
      CustomWorkingDir := func_ReplaceWithCommonPathVariables(CustomWorkingDirTmp,"A_ScriptDir,")
      If CustomWorkingDir =
         CustomWorkingDir = `%A_ScriptDir`%
      If (CustomWorkingDir <> "" AND MainDirNotWriteable = 0 AND FileExist(func_Deref(CustomWorkingDir)))
      {
         IniWrite, %CustomWorkingDir%, %A_ScriptDir%\Settings\ac'tivAid.ini, activAid, CustomWorkingDir
         CustomWorkingDir := func_Deref(CustomWorkingDir)
         If (CustomWorkingDir <> A_WorkingDir)
         {
            If CustomWorkingDir = %A_AppData%\ac'tivAid
            {
               IniWrite, 1, %activAidGlobalData%\%ConfigFile%, %ScriptName%, MultiUser
               IniWrite, 1, %A_ScriptDir%\Settings\ac'tivAid.ini, %ScriptName%, MultiUser
            }
            Else
            {
               IniDelete, %activAidGlobalData%\%ConfigFile%, %ScriptName%, MultiUser
               IniDelete, %A_ScriptDir%\Settings\ac'tivAid.ini, %ScriptName%, MultiUser
            }
            NewWorkingDir = %CustomWorkingDir%
            A_Args = %A_Args% "LastWorkingDir:%NewWorkingDir%"
            Reload =1
         }
      }
      CustomWorkingDir := func_Deref(CustomWorkingDir)

      If NumOfDumpVars
         IniWrite, %NumOfDumpVars%, %ConfigFile%, %ScriptName%, NumOfDumpVars

      If ((selectedLanguage <> 4 AND actLanguage <> selectedLanguage OR CleanINI = 1))
      {
         IniDelete, %ConfigFile%, %ScriptName%, Language
         If selectedLanguage < 4
            FileDelete, settings\language.ini
         If selectedLanguage = 2
            IniWrite, 07, %ConfigFile%, %ScriptName%, Language
         If selectedLanguage = 3
            IniWrite, 09, %ConfigFile%, %ScriptName%, Language
         If selectedLanguage > 4
            FileCopy, % LanguagesFile[%selectedLanguage%], settings\language.ini, 1

         Reload = 1
      }

      If (_Devel <> _DevelLast OR _Debug <> _DebugLast OR A_IconHidden <> NoTrayIcon OR Betatester <> BetatesterLast OR TrayClickOption <> TrayClickOptionLast)
         Reload = 1

      func_HotkeyWrite( "ProblemSolver", ConfigFile, ScriptName, "Hotkey_ProblemSolver" )
      If Hotkey_ProblemSolver_old2 <> %Hotkey_ProblemSolver_old%
         Menu, Tray, Rename, % lng_ProblemSolver "`t" func_HotkeyDecompose( Hotkey_ProblemSolver_old2, 1 ),  % lng_ProblemSolver "`t" func_HotkeyDecompose( Hotkey_ProblemSolver, 1 )
      func_HotkeyWrite( "MainGUI", ConfigFile, ScriptName, "Hotkey_MainGUI" )
      If Hotkey_MainGUI_old2 <> %Hotkey_MainGUI_old%
         Menu, Tray, Rename, % lng_Info "`t" func_HotkeyDecompose( Hotkey_MainGUI_old2, 1 ), % lng_Info "`t" func_HotkeyDecompose( Hotkey_MainGUI, 1 )
      func_HotkeyWrite( "DisableEnable", ConfigFile, ScriptName, "Hotkey_DisableEnable" )
      If Hotkey_DisableEnable_old2 <> %Hotkey_DisableEnable_old%
         Menu, Tray, Rename, % lng_deactivate "`t" func_HotkeyDecompose( Hotkey_DisableEnable_old2, 1 ), % lng_deactivate "`t" func_HotkeyDecompose( Hotkey_DisableEnable, 1 )
      func_HotkeyWrite( "TempSuspend", ConfigFile, ScriptName, "Hotkey_TemporarySuspend" )
      func_HotkeyWrite( "ShowHotkeyList", ConfigFile, ScriptName, "Hotkey_ShowHotkeyList" )
      If Hotkey_ShowHotkeyList_old2 <> %Hotkey_ShowHotkeyList_old%
         Menu, Tray, Rename, % lng_ShowHotkeyList "`t" func_HotkeyDecompose( Hotkey_ShowHotkeyList_old2, 1 ), % lng_ShowHotkeyList "`t" func_HotkeyDecompose( Hotkey_ShowHotkeyList, 1 )
      func_HotkeyWrite( "ShowMainContextMenu", ConfigFile, ScriptName, "Hotkey_ShowMainContextMenu" )
      If Hotkey_ShowMainContextMenu_old2 <> %Hotkey_ShowMainContextMenu_old%
         If TrayClickOption = 5
            Menu, Tray, Rename, % lng_ShowMainContextMenu "`t" func_HotkeyDecompose( Hotkey_ShowMainContextMenu_old2, 1 ), % lng_ShowHotkeyList "`t" func_HotkeyDecompose( Hotkey_ShowMainContextMenu, 1 )
      func_HotkeyWrite( "ReloadActivAid", ConfigFile, ScriptName, "Hotkey_ReloadActivAid" )
      If Hotkey_ReloadActivAid_old2 <> %Hotkey_ReloadActivAid_old%
         Menu, Tray, Rename, % lng_Reload "`t" func_HotkeyDecompose( Hotkey_ReloadActivAid_old2, 1 ), % lng_Reload "`t" func_HotkeyDecompose( Hotkey_ReloadActivAid, 1 )

      If _AdditionalSettings
         SaveAdditionalSettings( "" )

      ChangedSettings[activAid] =
      ChangedSettings++
   }
   Gosub, sub_MenuAutostart

   EnableTray =
   Loop
   {
      Function := Extension[%A_Index%]

      If Function =
         Break

      If (SimpleMainGUI <> "" AND Function <> SimpleMainGUI)
         continue

      EnableTray := EnableTray EnableTray_%Function%_tmp
   }

   If ( (EnableTray <> EnableTrayAll AND SimpleMainGUI = "") OR Duplicate <> "")
      Reload = 1

   Loop
   {
      Function := Extension[%A_Index%]
      If Function =
         Break

      Prefix := ExtensionPrefix[%A_Index%]

      If (IsLabel( "SavePosition_" Function ))
      {
         Debug("FILE", A_LineNumber, A_LineFile, "Save Positions for " Function "...")
         Gosub, SavePosition_%Function%
      }

      If (ChangedSettings[%Function%] = "" OR Function = "" OR (HideInGui_%Function% = 1 AND SimpleMainGUI <> Function))
         continue

      If (SimpleMainGUI <> "" AND Function <> SimpleMainGUI)
         continue

      Debug("SETTINGS", A_LineNumber, A_LineFile, "Writing Settings for: " Function " ..." )

      ChangedSettings[%Function%] =
      ChangedSettings++
      If ChangedSettings = 1
         SplashImage,,CWeeeeee b1 FS9 w%GuiSplashW% x%GuiSplashX% y%GuiSplashY%, %lng_WritingSettings%
      Else
         SplashImage,,, %lng_WritingSettings%: %Function%

      IniWrite, % Enable_%Function%, %ConfigFile%, %ScriptName%, Enable_%Function%
      IniWrite, % EnableTray_%Function%_tmp, %ConfigFile%, %ScriptName%, EnableTray_%Function%

      If CustomHotkey_%Function% = 1
      {
         func_HotkeyDisable(Function)
         func_HotkeyWrite( Function, ConfigFile, Function, "Hotkey_" Function )
      }

      If ExtensionMenuName[%A_Index%] =
         continue

      If (IsLabel( "SaveSettings_" Function ))
      {
         Debug("FILE", A_LineNumber, A_LineFile, "Save Settings for " Function "...")
         Gosub, SaveSettings_%Function%
      }
      GuiDefault("activAid")
      Gui, ListView, OptionsListBox

      If %Prefix%_AdditionalSettings
         SaveAdditionalSettings( Prefix )

      If Enable_%Function% = 1
      {
         If CustomHotkey_%Function% =1
            func_HotkeyEnable( Function )

         Debug("EXTENSION", A_LineNumber, A_LineFile, "DoEnable_" Function "...")
         Gosub, DoEnable_%Function%
         If ((EnableTray_%Function% = 1 OR (EnableTray_%Function% = 1 AND EnableTray = EnableTrayAll)) AND Reload <> 1)
         {
            If (ImageList[%Function%] <> "" AND A_GuiControl = "MainGUIapply" AND _ShowIconsInOptionsListBox = 1)
            {
               hIcon := ExtractIcon(TrayIcon[%Function%], TrayIconPos[%Function%], 16)
               DllCall("ImageList_ReplaceIcon", "uint", InstalledExtension_ImageList, "int", ImageList[%Function%]-1, "uint", hIcon)
               DllCall("DestroyIcon", "uint", hIcon)
               LV_Modify(GuiTabs[%Function%],"Icon0")
               LV_Modify(GuiTabs[%Function%],"Icon" ImageList[%Function%])
            }

            If _useTrayMenuIcons = 1
               ReadIcon(Function,IconFile_On_%Function%, IconPos_On_%Function%, IconFile_Off_%Function%, IconPos_Off_%Function%)

            If (_useTrayMenuIcons = 1 && TrayIcon[%Function%]!="" && FileExist(TrayIcon[%Function%]))
            {
               htm_pos := TrayMenu[%Function%]
               MI_SetMenuItemIcon(hTM, htm_pos, TrayIcon[%Function%], TrayIconPos[%Function%], 16)
            }
            Else
               Menu, Tray, Check, % ExtensionMenuName[%A_Index%]

         }
      }
      Else
      {
         If CustomHotkey_%Function% = 1
         {
            func_HotkeyDisable( Function )
         }
         If (IsLabel( "DoDisable_" Function ) )
            Gosub, DoDisable_%Function%
         If ((EnableTray_%Function% = 1 OR (EnableTray_%Function% = 1 AND EnableTray = EnableTrayAll)) AND Reload <> 1)
         {
            If (ImageList[%Function%] <> "" AND A_GuiControl = "MainGUIapply" AND _ShowIconsInOptionsListBox = 1)
            {
               hIcon := ExtractIcon(TrayIconOff[%Function%], TrayIconOffPos[%Function%], 16)
               DllCall("ImageList_ReplaceIcon", "uint", InstalledExtension_ImageList, "int", ImageList[%Function%]-1, "uint", hIcon)
               DllCall("DestroyIcon", "uint", hIcon)
               LV_Modify(GuiTabs[%Function%],"Icon0")
               LV_Modify(GuiTabs[%Function%],"Icon" ImageList[%Function%])
            }

            If _useTrayMenuIcons = 1
               ReadIcon(Function,IconFile_On_%Function%, IconPos_On_%Function%, IconFile_Off_%Function%, IconPos_Off_%Function%)

            If (_useTrayMenuIcons = 1 && TrayIconOff[%Function%]!="" && FileExist(TrayIconOff[%Function%]))
            {
               htm_pos := TrayMenu[%Function%]
               MI_SetMenuItemIcon(hTM, htm_pos, TrayIconOff[%Function%], TrayIconOffPos[%Function%], 16)
            }
            Menu, Tray, UnCheck, % ExtensionMenuName[%A_Index%]
         }
      }

      If CustomHotkey_%Function% = 1
      {
         MenuName := ExtensionCleanMenuName[%A_Index%] "`t" func_HotkeyDecompose( Hotkey_%Function%, 1 )
         If (ExtensionMenuName[%A_Index%] <> MenuName AND Reload <> 1 AND EnableTray_%Function% = 1)
         {
            Menu, Tray, Rename, % ExtensionMenuName[%A_Index%], %MenuName%
            ExtensionMenuName[%A_Index%] = %MenuName%
            Index := TrayMenu[%Function%]
            TrayMenuName[%Index%] = %MenuName%
         }
      }

      If (CustomHotkey_%Function% <> 1 AND CustomHotkey_%Function% <> "")
      {
         CustomHotkeyVar := "Hotkey_" CustomHotkey_%Function%
         MenuName := ExtensionCleanMenuName[%A_Index%] "`t" func_HotkeyDecompose( %CustomHotkeyVar%, 1 )
         If (ExtensionMenuName[%A_Index%] <> MenuName AND Reload <> 1 AND EnableTray_%Function% = 1)
         {
            Menu, Tray, Rename, % ExtensionMenuName[%A_Index%], %MenuName%
            ExtensionMenuName[%A_Index%] = %MenuName%
            Index := TrayMenu[%Function%]
            TrayMenuName[%Index%] = %MenuName%
         }
      }
   }

   Gui, %GuiID_activAid%:Default

   Gosub, sub_ExtInstall

   Gosub, DoEnable_MButton
   Gosub, DoEnable_RButton

   If ChangedSettings > 0
   {
      func_HotkeyEnable("MainGUI")
      func_HotkeyEnable("DisableEnable")
      func_HotkeyEnable("TempSuspend")
      func_HotkeyEnable("ProblemSolver")
      func_HotkeyEnable("ShowHotkeyList")
      func_HotkeyEnable("ShowMainContextMenu")
      func_HotkeyEnable("ReloadActivAid")

      GuiControl, Disable, MainGuiApply

      If A_GuiControl <> MainGuiApply
         IniDelete, %ConfigFile%, %ScriptName%, ShowGUI

      gosub, sub_BeautifyINI

      If Reload = 1
      {
         Debug("RELOAD",A_LineNumber,A_LineFile,A_ThisFunc A_ThisLabel)
         Gosub, Reload
      }
   }

   SplashImage, Off

   Gosub, sub_temporarySuspend
   Gosub, sub_ChangeIcon

   If A_GuiControl = MainGUIapply
   {
      Gui, -Disabled
      If _AlternativeTrayMenu <> 1
      {
         Loop, % TrayMenu - TrayMenuFirstExtension
         {
            Index := A_Index + TrayMenuFirstExtension
            If TrayMenuName[%Index%] =
               continue
            Menu, Tray, Disable, % TrayMenuName[%Index%]
         }
      }
      If MainGuiVisible = 2
         Gui, %GuiID_activAid%:Show
   }
   Else
   {
      MainGuiVisible =
      Menu, Tray, ToggleEnable, % lng_Info "`t" func_HotkeyDecompose( Hotkey_MainGUI, 1 )

      Loop, Parse, hook_UnsetVarOnGuiClose, |
         %A_LoopField% := ""
      hook_UnsetVarOnGuiClose := ""

      func_RemoveMessage(0x200, "GuiTooltip")
      func_RemoveMessage(0x101, "GuiTooltipKey")
      func_RemoveMessage(0x202, "GuiTooltipKey")
      func_RemoveMessage(0x6, "RemoveGuiTooltip")

      Loop, Parse, OptionsListBox, |
      {
         If A_LoopField =
            continue
         ImageList[%A_LoopField%] =
         ExtensionGuiDrawn[%A_LoopField%] =
      }
   }

   If A_GuiControl <> MainGUIapply
   {
      Gui, Destroy
      mainGuiID =
      Debug("GUI", A_LineNumber, A_LineFile, "Config windows closed." )
   }
   Else
      Debug("GUI", A_LineNumber, A_LineFile, "Window stays open because of 'Apply'" )

   If _SingleClickTrayAction = 1
      Menu, Tray, Click, 1
   Else
      Menu, Tray, Click, 2

   Readme_Hotkeys =
   HotkeyList =

   SimpleMainGUI =

   Hotkey_AllNewHotkeys = %Hotkey_AllHotkeys%

   Gosub, sub_ShowDuplicates
Return

sub_MenuExit:
   ExitApp
Return

ResetWindows_activAid:
   MainGuiX = RESET
   VarDumpGuiX = RESET
   ShowDuplicatesGuiX = RESET
   IniDelete, %ConfigFile%, %ScriptName%, MainGuiX
   IniDelete, %ConfigFile%, %ScriptName%, MainGuiY
   IniDelete, %ConfigFile%, %ScriptName%, VarDumpGuiX
   IniDelete, %ConfigFile%, %ScriptName%, VarDumpGuiY
   IniDelete, %ConfigFile%, %ScriptName%, ShowDuplicatesGuiX
   IniDelete, %ConfigFile%, %ScriptName%, ShowDuplicatesGuiY
Return

; INI-Datei verschnern
sub_BeautifyINI:
   func_BeautifyIniFile( ConfigFile )
Return

sub_CleanINI:
   MsgBox, 33, %lng_CleanINI%, %lng_CleanINIAsk%
   IfMsgBox, Cancel
      Return

   actLanguage =
   Loop
   {
      IniRead, FileToDelete%A_Index%, %ConfigFile%, DeleteAfterUpdate, DeleteFile%A_Index%
      If FileToDelete%A_Index% = ERROR
         break
   }
   FileMove, %ConfigFile%, %ConfigFile%.bak, 1
   func_SettingsChanged( "activAid" )
   IniWrite, %ExtensionsInExtDir%, %ConfigFile%, %ScriptName%, AvailableExtensions
   Loop
   {
      Function := Extension[%A_Index%]

      If Function =
         Break

      ExtensionIndex := ExtensionIndex[%Function%]
      Prefix := ExtensionPrefix[%ExtensionIndex%]

      If ExtensionGuiDrawn[%Function%] = 0
         Gosub, sub_CreateExtensionConfigGui

      IniRead, %Prefix%_LastUpdateNumber, %ConfigFile%.bak, %Function%, UpdateNumber
      If %Prefix%_LastUpdateNumber <> ERROR
         IniWrite, % %Prefix%_LastUpdateNumber, %ConfigFile%, %Function%, UpdateNumber
      func_SettingsChanged( Function )
   }
   Loop
   {
      If (FileToDelete%A_Index% = "ERROR" OR FileToDelete%A_Index% = "")
         break
      IniWrite, % FileToDelete%A_Index%, %ConfigFile%, DeleteAfterUpdate, DeleteFile%A_Index%
   }
   CleanINI = 1
   Gui, 1:Submit, NoHide
   Gosub, sub_SettingsOK
   CleanINI =
Return

sub_SettingsMenu:
   If AHKonUSB = 1
      AHKonUSBstr = USB

   If CreateUninstaller =
      Gosub, CreateUninstallFile

   If SettingsMenu <> 1
   {
      Menu, SettingsMenu_activAid, Add, %lng_SaveAllSettings%, sub_SaveAllSettings
      Menu, SettingsMenu_activAid, Add, %lng_LoadAllSettings%, sub_LoadAllSettings
      Menu, SettingsMenu_activAid, Add, %lng_RemoveUninstaller%, sub_AddRemoveUninstaller
      SettingsMenu_Uninstaller = %lng_RemoveUninstaller%

      Menu, SettingsMenu_activAid, Add
      Menu, SettingsMenu_activAid, Add, %lng_UserMode00%, sub_SingleOrMultiUser
      Menu, SettingsMenu_activAid, Add, %lng_OpenSettingsDir%, sub_OpenSettingsDir
      If (UsingUserDir = 1 AND MainDirNotWriteable <> 1 AND A_ScriptDir <> WorkingDir)
      {
         Menu, SettingsMenu_activAid, Add, % lng_Copy%AHKonUSBstr%SettingsToUser, sub_CopySettingsToUser
         Menu, SettingsMenu_activAid, Disable, % lng_Copy%AHKonUSBstr%SettingsToUser
         Menu, SettingsMenu_activAid, Add, % lng_Copy%AHKonUSBstr%SettingsToSingle, sub_CopySettingsToSingle
      }
      Else
      {
         Menu, SettingsMenu_activAid, Add, % lng_Copy%AHKonUSBstr%SettingsFromUser, sub_CopySettingsFromUser
         Menu, SettingsMenu_activAid, Disable, % lng_Copy%AHKonUSBstr%SettingsFromUser
      }

      Menu, SettingsMenu_activAid, Disable, %lng_UserMode00%
      SettingsMenu_UserMode = %lng_UserMode00%

      Menu, SettingsMenu_activAid, Add, %lng_CleanINI%, sub_CleanINI

      Menu, SettingsMenu_activAid, Add
      Menu, SettingsMenu_activAid, Add, %lng_RunAsAdmin%, sub_RunOrLeaveAdmin
      Menu, SettingsMenu_activAid, Disable, %lng_RunAsAdmin%
      SettingsMenu_Admin = %lng_RunAsAdmin%

      If _Debug = 1
      {
         Menu, SettingsMenu_activAid, Add
         Menu, AHKMenuBar, Standard
         Menu, SettingsMenu_activAid, Add, AutoHotkey, :AHKMenuBar
      }

      Menu, SettingsMenu_activAid, Add
      Menu, SettingsMenu_activAid, Add, %lng_Reload% , sub_MenuReload
      Menu, SettingsMenu_activAid, Add, %lng_exit% , sub_MenuExit

      Menu, AdditionalSettingsMenu, Add

      actFunct := " "
      Menu, SettingsMenu_Extension, Add, % #(lng_DefaultSettings,actFunct), sub_DefaultSettings
      Menu, SettingsMenu_Extension, Add, % #(lng_ResetWindows,actFunct), sub_ResetWindows
      If (!IsLabel("ResetWindows_" actFunct))
         Menu, SettingsMenu_Extension, Disable, % #(lng_ResetWindows,actFunct)
      Menu, SettingsMenu_Extension, Add
      Menu, SettingsMenu_Extension, Add, % #(lng_ExportSettings,actFunct), sub_ExportSettings
      Menu, SettingsMenu_Extension, Add, % #(lng_ImportSettings,actFunct), sub_ImportSettings
      Menu, SettingsMenu_Extension, Add
      Menu, SettingsMenu_Extension, Add, % #(lng_AddSettings,actFunct), sub_AddSettings
      Menu, SettingsMenu_Extension, Disable, % #(lng_AddSettings,actFunct)
      Menu, SettingsMenu_Extension, Add
      Menu, SettingsMenu_Extension, Add, %lng_EnableAll%, sub_EnableAll
      Menu, SettingsMenu_Extension, Add, %lng_DisableOthers%, sub_DisableOthers
      Menu, SettingsMenu_Extension, Add

      Menu, SettingsMenu_Extension, Add, % #(lng_RemoveFromGUI, actFunct), sub_RemoveExtFromGUI
      Menu, SettingsMenu_Extension, Add, %lng_RemovedExtensions%, :RemovedExtensions
      Menu, SettingsMenu_Extension, Add
      Menu, SettingsMenu_Extension, Add, %lng_AdditionalSettings%, :AdditionalSettingsMenu
      Menu, SettingsMenu_Extension, Disable, %lng_AdditionalSettings%

      Menu, AdditionalSettingsMenu, DeleteAll

      SettingsMenu_actFunct = %actFunct%

      Menu, SettingsMenu_Help, Add, % #(lng_ContextHelp,actFunct), sub_MenuContextHelp
      Menu, SettingsMenu_Help, Add,
      Menu, SettingsMenu_Help, Add, %lng_ShowHotkeyList%, sub_ShowHotkeyList
      Menu, SettingsMenu_Help, Add,
      Menu, SettingsMenu_Help, Add, FAQ (www.heise.de), sub_CallFAQ
      Menu, SettingsMenu_Help, Add, %lng_activAidHomepage%, sub_CallHomePage
      Menu, SettingsMenu_Help, Add, %lng_Bugtracker%, sub_CallBugtracker
      Menu, SettingsMenu_Help, Add, %lng_Contact%, sub_CallContact
      Menu, SettingsMenu_Help, Add,
      Menu, SettingsMenu_Help, Add, %lng_Statistics% ..., sub_Statistics
      Menu, SettingsMenu_Help, Add, %lng_VarDump% ..., sub_VarDumpGUI

      If _Devel = 1
      {
         Menu, Devel_Menu, Add, Simulate Update, sub_SimulateUpdate
      }
   }
   Else
   {
      If (UsingUserDir = 1 AND MainDirNotWriteable <> 1)
      {
         Menu, SettingsMenu_activAid, Enable, %SettingsMenu_UserMode%

         If AHKonUSB = 1
         {
            If SettingsMenu_UserMode <> %lng_UserMode001%
               Menu, SettingsMenu_activAid, Rename, %SettingsMenu_UserMode%, %lng_UserMode001%
            SettingsMenu_UserMode = %lng_UserMode001%
         }
         Else
         {
            If SettingsMenu_UserMode <> %lng_UserMode00%
               Menu, SettingsMenu_activAid, Rename, %SettingsMenu_UserMode%, %lng_UserMode00%
            SettingsMenu_UserMode = %lng_UserMode00%
         }
      }
      Else
      {
         If (MainDirNotWriteable <> 1)
            Menu, SettingsMenu_activAid, Enable, %SettingsMenu_UserMode%
         Else
            Menu, SettingsMenu_activAid, Disable, %SettingsMenu_UserMode%

         If AHKonUSB = 1
         {
            If SettingsMenu_UserMode <> %lng_UserMode011%
               Menu, SettingsMenu_activAid, Rename, %SettingsMenu_UserMode%, %lng_UserMode011%
            SettingsMenu_UserMode = %lng_UserMode011%
         }
         Else
         {
            If SettingsMenu_UserMode <> %lng_UserMode01%
               Menu, SettingsMenu_activAid, Rename, %SettingsMenu_UserMode%, %lng_UserMode01%
            SettingsMenu_UserMode = %lng_UserMode01%
         }
      }
      If (UsingUserDir = 1 AND MainDirNotWriteable <> 1 AND A_ScriptDir <> WorkingDir)
      {
         Menu, SettingsMenu_activAid, Enable, % lng_Copy%AHKonUSBstr%SettingsToUser
      }
      Else
      {
         If MainDirNotWriteable <> 1
            Menu, SettingsMenu_activAid, Enable, % lng_Copy%AHKonUSBstr%SettingsFromUser
         Else
            Menu, SettingsMenu_activAid, Disable, % lng_Copy%AHKonUSBstr%SettingsFromUser
      }

      If A_IsAdmin <> 1
      {
         Menu, SettingsMenu_activAid, Enable, %SettingsMenu_Admin%
         If SettingsMenu_Admin <> %lng_RunAsAdmin%
            Menu, SettingsMenu_activAid, Rename, %SettingsMenu_Admin%, %lng_RunAsAdmin%
         SettingsMenu_Admin = %lng_RunAsAdmin%
      }
      Else
      {
         If ( tempAdminMode > 0 )
            Menu, SettingsMenu_activAid, Enable, %SettingsMenu_Admin%
         Else
            Menu, SettingsMenu_activAid, Disable, %SettingsMenu_Admin%

         If SettingsMenu_Admin <> %lng_LeaveAdmin%
            Menu, SettingsMenu_activAid, Rename, %SettingsMenu_Admin%, %lng_LeaveAdmin%
         SettingsMenu_Admin = %lng_LeaveAdmin%
      }

      actFunct := GuiTabs[%ListBox_selected%]
      If ListBox_selected = 5
         actFunct := GuiTabs[4]

      If actFunct <> %SettingsMenu_actFunct%
      {
         Menu, SettingsMenu_Extension, Rename, % #(lng_DefaultSettings,SettingsMenu_actFunct), % #(lng_DefaultSettings,actFunct)
         Menu, SettingsMenu_Extension, Rename, % #(lng_ResetWindows,SettingsMenu_actFunct), % #(lng_ResetWindows,actFunct)
         Menu, SettingsMenu_Extension, Rename, % #(lng_ExportSettings,SettingsMenu_actFunct), % #(lng_ExportSettings,actFunct)
         Menu, SettingsMenu_Extension, Rename, % #(lng_ImportSettings,SettingsMenu_actFunct), % #(lng_ImportSettings,actFunct)
         Menu, SettingsMenu_Extension, Rename, % #(lng_AddSettings,SettingsMenu_actFunct), % #(lng_AddSettings,actFunct)
         Menu, SettingsMenu_Extension, Rename, % #(lng_RemoveFromGUI,SettingsMenu_actFunct), % #(lng_RemoveFromGUI,actFunct)
         Menu, SettingsMenu_Help, Rename, % #(lng_ContextHelp,SettingsMenu_actFunct), % #(lng_ContextHelp,actFunct)
      }
      If AddSettings_%actFunct% = 1
         Menu, SettingsMenu_Extension, Enable, % #(lng_AddSettings,actFunct)
      Else
         Menu, SettingsMenu_Extension, Disable, % #(lng_AddSettings,actFunct)

      If (IsLabel("ResetWindows_" actFunct))
         Menu, SettingsMenu_Extension, Enable, % #(lng_ResetWindows,actFunct)
      Else
         Menu, SettingsMenu_Extension, Disable, % #(lng_ResetWindows,actFunct)

      If (Enable_%actFunct% <> "" OR actFunct = "activAid" )
      {
         Menu, SettingsMenu_Extension, Enable, % #(lng_DefaultSettings,actFunct)
         Menu, SettingsMenu_Extension, Enable, % #(lng_ExportSettings,actFunct)
         Menu, SettingsMenu_Extension, Enable, % #(lng_ImportSettings,actFunct)
         Menu, SettingsMenu_Extension, Enable, % #(lng_RemoveFromGUI,actFunct)
         ;Menu, MenuBar, Enable, &%lng_Extension%
         Menu, SettingsMenu_Help, Enable, % #(lng_ContextHelp,actFunct)
      }
      Else
      {
         Menu, SettingsMenu_Extension, Disable, % #(lng_DefaultSettings,actFunct)
         Menu, SettingsMenu_Extension, Disable, % #(lng_ExportSettings,actFunct)
         Menu, SettingsMenu_Extension, Disable, % #(lng_ImportSettings,actFunct)
         Menu, SettingsMenu_Extension, Disable, % #(lng_AddSettings,actFunct)
         Menu, SettingsMenu_Extension, Disable, % #(lng_RemoveFromGUI,actFunct)
         ;Menu, MenuBar, Disable, &%lng_Extension%
         Menu, SettingsMenu_Help, Disable, % #(lng_ContextHelp,actFunct)
      }

      SettingsMenu_actFunct = %actFunct%
      If (CreateUninstaller = 1 AND Settingsmenu_Uninstaller <> lng_RemoveUninstaller)
      {
         Menu, SettingsMenu_activAid, Rename, %Settingsmenu_Uninstaller%, %lng_RemoveUninstaller%
         Settingsmenu_Uninstaller = %lng_RemoveUninstaller%
      }
      Else If (CreateUninstaller <> 1 AND Settingsmenu_Uninstaller <> lng_AddUninstaller)
      {
         Menu, SettingsMenu_activAid, Rename, %Settingsmenu_Uninstaller%, %lng_AddUninstaller%
         Settingsmenu_Uninstaller = %lng_AddUninstaller%
      }
      If AHKonUSB = 1
         Menu, SettingsMenu_activAid, Disable, %Settingsmenu_Uninstaller%

      tmpPrefix := ExtensionPrefix[%actFunct%]
      If %tmpPrefix%_AdditionalSettings
      {
         SeparateMenuName =
         Gosub, sub_CreateAdditionalSettingsMenu
         Menu, SettingsMenu_Extension, Add, %lng_AdditionalSettings%, :AdditionalSettingsMenu
      }
      Else
      {
         Menu, SettingsMenu_Extension, Disable, %lng_AdditionalSettings%
      }
      NumEnabledExtensions = 0
      ExtensionsCount = 0
      Loop
      {
         Function := Extension[%A_Index%]
         If Function =
            Break
         If OnlyForConfigDialog_%Function% <> 1
         {
            ExtensionsCount++
            GuiControlGet, EnableFunction,, Enable_%Function%
            If ( EnableFunction OR ( EnableFunction = "" AND Enable_%Function% = 1) )
               NumEnabledExtensions++
         }
      }
      If (NumEnabledExtensions = 1 AND Enable_%actFunct% = 1)
         Menu, SettingsMenu_Extension, Disable, %lng_DisableOthers%
      Else
         Menu, SettingsMenu_Extension, Enable, %lng_DisableOthers%
      If (NumEnabledExtensions = ExtensionsCount)
         Menu, SettingsMenu_Extension, Disable, %lng_EnableAll%
      Else
         Menu, SettingsMenu_Extension, Enable, %lng_EnableAll%
   }
   SettingsMenu = 1
Return

sub_DisableOthers:
   GuiDefault("activAid")
   Loop
   {
      Function := Extension[%A_Index%]
      If Function =
         Break
      If Function = %actFunct%
         continue

      ExtensionIndex := ExtensionIndex[%Function%]
      Prefix := ExtensionPrefix[%ExtensionIndex%]

      If ExtensionGuiDrawn[%Function%] = 0
      {
         Gosub, sub_CreateExtensionConfigGui
         GuiControl, %GuiID_activAid%:Choose, DlgTabs, % GuiTabs[%Function%]
         Gui, ListView, OptionsListBox
         ListBox_selected := LV_GetNext()
      }

      GuiControl, , Enable_%Function%, 0
      GuiControl, Enable , Info_%Function%

      If (ImageList[%Function%] <> "" AND _ShowIconsInOptionsListBox = 1)
      {
         hIcon := ExtractIcon(TrayIconOff[%Function%], TrayIconOffPos[%Function%], 16)
         DllCall("ImageList_ReplaceIcon", "uint", InstalledExtension_ImageList, "int", ImageList[%Function%]-1, "uint", hIcon)
         DllCall("DestroyIcon", "uint", hIcon)
         LV_Modify(GuiTabs[%Function%],"Icon0")
         LV_Modify(GuiTabs[%Function%],"Icon" ImageList[%Function%])
      }

      func_SettingsChanged(Function)
   }
   GuiControl, , Enable_%actFunct%, 1
   GuiControl, Enable , Info_%actFunct%
   Menu, SettingsMenu_Extension, Disable, %lng_DisableOthers%
   Menu, SettingsMenu_Extension, Enable, %lng_EnableAll%
Return

sub_EnableAll:
   GuiDefault("activAid")
   Loop
   {
      Function := Extension[%A_Index%]
      If Function =
         Break

      ExtensionIndex := ExtensionIndex[%Function%]
      Prefix := ExtensionPrefix[%ExtensionIndex%]

      If ExtensionGuiDrawn[%Function%] <> 1
      {
         Gosub, sub_CreateExtensionConfigGui
         GuiControl, %GuiID_activAid%:Choose, DlgTabs, % GuiTabs[%Function%]
         Gui, ListView, OptionsListBox
         ListBox_selected := LV_GetNext()
      }

      GuiControl, Enable , Info_%Function%
      GuiControl, , Enable_%Function%, 1

      If (ImageList[%Function%] <> "" AND _ShowIconsInOptionsListBox = 1)
      {
         hIcon := ExtractIcon(TrayIcon[%Function%], TrayIconPos[%Function%], 16)
         DllCall("ImageList_ReplaceIcon", "uint", InstalledExtension_ImageList, "int", ImageList[%Function%]-1, "uint", hIcon)
         DllCall("DestroyIcon", "uint", hIcon)
         LV_Modify(GuiTabs[%Function%],"Icon0")
         LV_Modify(GuiTabs[%Function%],"Icon" ImageList[%Function%])
      }

      func_SettingsChanged(Function)
   }
   Menu, SettingsMenu_Extension, Disable, %lng_EnableAll%
   Menu, SettingsMenu_Extension, Enable, %lng_DisableOthers%
Return

sub_RemoveExtFromGUI:
   If SettingsChanged > 0
      Msgbox, 52, %ScriptTitle%, %lng_SettingsNotApplied%
         IfMsgBox, No
            Return
   IniWrite, 1, %ConfigFile%, %ScriptName%, HideInGui_%actFunct%
   Debug("RELOAD",A_LineNumber,A_LineFile,A_ThisFunc A_ThisLabel)
   Gosub, Reload
Return

sub_RestoreExtToGUI:
   If SettingsChanged > 0
      Msgbox, 52, %ScriptTitle%, %lng_SettingsNotApplied%
         IfMsgBox, No
            Return
   IniWrite, 0, %ConfigFile%, %ScriptName%, HideInGui_%A_ThisMenuItem%
   Debug("RELOAD",A_LineNumber,A_LineFile,A_ThisFunc A_ThisLabel)
   Gosub, Reload
Return

sub_AddRemoveUninstaller:
   Error = 0
   Gui %GuiID_activAid%:+Disabled
   Gui %GuiID_activAid%:+OwnDialogs
   If CreateUninstaller = 1
   {
      FileRemoveDir, %A_Programs%\ac'tivAid, 1
      IfExist,  %A_Programs%\ac'tivAid
         Error++
      RegDelete, HKEY_LOCAL_MACHINE,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\ac'tivAid
      If ErrorLevel
         Error++
      If Error = 0
      {
         CreateUninstaller = 0
         IniWrite, %CreateUninstaller%, %ConfigFile%, %ScriptName%, CreateUninstaller
         MsgBox, 64, %ScriptTitle%, %lng_RemoveUninstallerSuccess%
      }
      Else
         MsgBox, 48, %ScriptTitle%, %lng_RemoveUninstallerFailure%
   }
   Else
   {
      CreateUninstaller = 2
      Gosub, CreateUninstallFile
      IfNotExist,  %A_Programs%\ac'tivAid
         Error++
      If Error = 0
      {
         CreateUninstaller = 1
         IniWrite, %CreateUninstaller%, %ConfigFile%, %ScriptName%, CreateUninstaller
         MsgBox, 64, %ScriptTitle%, %lng_AddUninstallerSuccess%
      }
      Else
         MsgBox, 48, %ScriptTitle%, %lng_AddUninstallerFailure%
   }
   Debug("GUI", A_LineNumber, A_LineFile, "Updating GUI-Menu" )
   Gosub, sub_SettingsMenu
   Gui, %GuiID_activAid%:-Disabled
Return

sub_SingleOrMultiUser:
   If (UsingUserDir = 1 AND MainDirNotWriteable <> 1)
      Gosub, sub_SingleUser
   Else If (MainDirNotWriteable <> 1)
      Gosub, sub_MultiUser
Return

sub_RunOrLeaveAdmin:
   If main_IsAdmin <> 1
      Gosub, sub_RunAsAdmin
   Else If ( tempAdminMode = 1 )
      Gosub, sub_LeaveAdmin
Return

sub_CallHomePage:
   Run, http://www.heise.de/ct/activaid
Return

sub_CallFAQ:
   Run, http://www.heise.de/software/download/special/activaid_forte/10_11
;   GuiControl, Choose, DlgTabs, 1
;   GuiControl, Choose, OptionsListBox, 1
;   Gui, %GuiID_activAid%:+LastFound
;   SendMessage, 0x115, 6 , , Edit2 ; WM_VSCROLL (top)
;   SendMessage, 0xB1, ReadmeGotoLine[%ReadIndex%], % ReadmeGotoLine[%ReadIndex%]+StrLen(ReadmeChapter[%ReadIndex%]), Edit2 ; EM_SETSEL
;   SendMessage, 0xB7, , , Edit2 ; EM_SCROLLCARET
;   SendMessage, 0xB6, , 24, Edit2 ; EM_LINESCROLL
Return

sub_CallBugtracker:
   Run, http://activaid.rumborak.de
Return

sub_CallContact:
   Run, mailto:"Stephan Ehrmann" <se@ctmagazin.de>
Return

sub_OpenSettingsDir:
   Run, .\settings
Return

sub_OpenActivaidDir:
   If A_GuiControlEvent = DoubleClick
   {
      If A_EventInfo = 1
         Run, .
   }
Return

sub_RunAsAdmin:
   Critical
   Suspend, On
   Debug("RELOAD",A_LineNumber,A_LineFile,A_ThisFunc A_ThisLabel)
   If A_IsCompiled = 1
      Run, %A_ScriptDir%\extensions\RunWithAdminRights.exe %RunWithAdminRightsPara% %A_Args%
   Else
      Run, %A_AhkPath% /f "%A_ScriptDir%\extensions\RunWithAdminRights.ahk" %RunWithAdminRightsPara% %A_Args%
   ExitApp
Return

sub_LeaveAdmin:
   Critical
   DetectHiddenWindows, On
   StringReplace, A_Args, A_Args, LeaveAdmin
   If A_IsCompiled = 1
      SendMessage, 0x1ccc, 99, 99,,%A_ScriptDir%\extensions\RunWithAdminRights.exe
   Else
      SendMessage, 0x1ccc, 99, 99,,%A_ScriptDir%\extensions\RunWithAdminRights.ahk - AutoHotkey v%A_Ahkversion%
   If ErrorLevel
      MsgBox, 64, %ScriptName%, %lng_LeaveAdminCantReload%
   ExitApp
Return

sub_MultiUser:
   Critical
   UsingUserDir = 1
   Gosub, sub_MenuAutostart
   IfNotExist, %activAidData%
      FileCreateDir, %activAidData%
   If MultiUser <> 2
   {
      IniWrite, %ListBox_selected%, %activAidData%\%ConfigFile%, %ScriptName%, GUIselected
      IniWrite, 1, %activAidData%\%ConfigFile%, %ScriptName%, ShowGUI
   }
   IniWrite, 1, %activAidGlobalData%\%ConfigFile%, %ScriptName%, MultiUser
   Debug("RELOAD",A_LineNumber,A_LineFile,A_ThisFunc A_ThisLabel)
   Debug("VAR",A_LineNumber,A_LineFile,"activAidData,UsingUserDir")
   NewWorkingDir = %activAidData%
   CustomWorkingDir = %activAidData%
   Gosub, Reload
;   If A_IsCompiled = 1
;      Run, %A_ScriptFullPath% %A_Args%, %activAidData%
;   Else
;      Run, %A_AhkPath% /r "%A_ScriptFullPath%" %A_Args%, %activAidData%
Return

sub_MainContextMenuMainContext:
   MI_ShowMenu(hTM)
Return

sub_SingleUser:
   Critical
   UsingUserDir = 0
   Gosub, sub_MenuAutostart
   IniDelete, %activAidGlobalData%\%ConfigFile%, %ScriptName%, MultiUser
   IniWrite, %ListBox_selected%, %activAidGlobalData%\%ConfigFile%, %ScriptName%, GUIselected
   IniWrite, 1, %activAidGlobalData%\%ConfigFile%, %ScriptName%, ShowGUI
   Debug("RELOAD",A_LineNumber,A_LineFile,A_ThisFunc A_ThisLabel)
   Debug("VAR",A_LineNumber,A_LineFile,"LastWorkingDir,UsingUserDir")
   NewWorkingDir = %LastWorkingDir%
   CustomWorkingDir = %LastWorkingDir%
   Gosub, Reload
;   If A_IsCompiled = 1
;      Run, %A_ScriptFullPath% %A_Args%, %LastWorkingDir%
;   Else
;      Run, %A_AhkPath% /r "%A_ScriptFullPath%" %A_Args% ,%LastWorkingDir%
;   ExitApp
Return

sub_ShowMainContextMenu:
   DontShowMainGUI = 1
   CreateHotKeyList = 1
   If HotkeyListCreated <> 1
   {
      GuiDefault("activAid")
      Loop
      {
         Function := Extension[%A_Index%]
         If Function =
            Break

         Prefix := ExtensionPrefix[%A_Index%]

         CreateHotKeyList = 1
         Gosub, sub_CreateExtensionConfigGui
         CreateHotKeyList =
      }
      HotkeyListCreated = 1
      SkipChecking =
      If MainGuiVisible =
      {
         Gui, %GuiID_activAid%:Destroy
         Hotkey_DupDuplicates =
         Hotkey_AllNewHotkeys =
         mainGuiID =
         Loop
         {
            Function := Extension[%A_Index%]
            ExtensionGuiDrawn[%Function%] =
            If Function =
               Break
            ChangedSettings[%Function%] =
         }
      }
   }
   DontShowMainGUI =
   func_AutoVSplitMenu("MainContextMenu")
   WinGet, WinIDbeforeContextMenu, ID, A
   Menu, MainContextMenu, Show
   Gosub, sub_RestoreKeyStates
Return

sub_MainContextMenuKeyHistory:
   Keyhistory
Return

sub_MainContextMenuListHotkeys:
   Listhotkeys
Return

sub_MainContextMenuListLines:
   Listlines
Return

sub_MainContextMenuListVars:
   ListVars
Return

sub_MainContextMenuWindowSpy:
   Run, %A_AutoHotkeyPath%\AU3_Spy.exe,,UseErrorLevel
   If ErrorLevel = ERROR
      func_GetErrorMessage( A_LastError, ScriptTitle, A_Quote A_AutoHotkeyPath "\AU3_Spy.exe" A_Quote "`n`n" )
Return

sub_ShowHotkeyList:
   Gui, %GuiID_HotkeyList%:+LastFoundExist
   IfWinActive
   {
      WinGetPos, ShowHotkeyListX , ShowHotkeyListY , ShowHotkeyListW, ShowHotkeyListH
      func_RemoveMessage(0x100,"sub_searchInReadme")
      Gui, %GuiID_HotkeyList%:Cancel
      Return
   }

   If HotkeyListAOT = 1
      HotkeyListID := GuiDefault("HotkeyList", "+LastFound +Resize +AlwaysOnTop +0xF2C0")
   Else
      HotkeyListID := GuiDefault("HotkeyList", "+LastFound +Resize +0xF2C0")

   If (Readme_Hotkeys = "" OR HotkeyListCreated <> 1)
   {
      DontShowMainGUI = 1
      CreateHotKeyList = 1
      Gui, Add, Text, , %lng_CreatingHotkeyList%
      Gui, Show, x%ShowHotkeyListX% y%ShowHotkeyListY% w%ShowHotkeyListW% h%ShowHotkeyListH% , %ScriptNameFull%-%lng_Hotkeys%
      If (Readme_Hotkeys <> "" AND HotkeyListCreated = "")
      {
         GuiDefault("activAid")
         Loop
         {
            Function := Extension[%A_Index%]
            If Function =
               Break

            Prefix := ExtensionPrefix[%A_Index%]

            CreateHotKeyList = 1
            Gosub, sub_CreateExtensionConfigGui
            CreateHotKeyList =
         }
         HotkeyListCreated = 1
      }
      Else
         Gosub, sub_MainGUI
      GuiDefault("HotkeyList")
      Control, Hide,, Static1, ahk_id %HotkeyListID%
      CreateHotKeyList =
      DontShowMainGUI =
   }

   If HotkeyListAOT = 1
      HotkeyListID := GuiDefault("HotkeyList", "+LastFound +Resize +AlwaysOnTop +0xF2C0")
   Else
      HotkeyListID := GuiDefault("HotkeyList", "+LastFound +Resize +0xF2C0")

   Gosub, sub_BigIcon
   If HotkeyList =
   {
      IfWinExist
         Gui, Destroy
      If (ShowHotkeyListX+ShowHotkeyListW < WorkAreaLeft + 40 OR ShowHotkeyListX > WorkAreaRight -40 OR InStr(ShowHotkeyListX,"x") )
         ShowHotkeyListX =
      If (ShowHotkeyListY+ShowHotkeyListH < WorkAreaTop + 40 OR ShowHotkeyListY > WorkAreaBottom -40 OR InStr(ShowHotkeyListY,"y") )
         ShowHotkeyListY =
      If ShowHotkeyListX <>
         ShowHotkeyListX = x%ShowHotkeyListX%
      If ShowHotkeyListY <>
         ShowHotkeyListY = y%ShowHotkeyListY%
      ShowHotkeyContentH := ShowHotkeyListH - 22
      ShowHotkeySearchW := ShowHotkeyListW - 100
      ShowHotkeyListW = w%ShowHotkeyListW%
      ShowHotkeyListH = h%ShowHotkeyListH%
      ShowHotkeyContentH = h%ShowHotkeyContentH%

      If HotkeyListAOT = 1
         GuiDefault("HotkeyList", "+LastFound +AlwaysOnTop +Resize +0xF2C0")
      Else
         GuiDefault("HotkeyList", "+LastFound +Resize +0xF2C0")
      StringTrimLeft, HotkeyList, Readme_Hotkeys, 4
      Gui, Color , FFFFFF, FFFFFF
      Gosub, GuiDefaultFont
      Gui, Add, Text, X0 y4 Right w75, %lng_Search%:
      Gui, Add, Edit, x80 y0 Left w%ShowHotkeySearchW% h22 vsearchTermHotkeyList gsub_ReadmeSearch
      Gui, Add, Button, -Wrap x+1 yp+1 gsub_ReadmeSearch vsearchButtonHotkeyList H20 W18, >
      Gui, Font, , Courier New
      Gui, Font, , Lucida Console
      Gui, Add, Edit, Y23 X0 0x100 Readonly -Wrap HScroll -WantReturn %ShowHotkeyContentH% %ShowHotkeyListW% vHotkeyList, %HotkeyList%
      Gosub, GuiDefaultFont
      Gui, Show, %ShowHotkeyListX% %ShowHotkeyListY% %ShowHotkeyListW% %ShowHotkeyListH% , %ScriptNameFull%-%lng_Hotkeys%
      ControlSend, Edit2, ^{Home}
   }
   func_AddMessage(0x100,"sub_searchInReadme")
   Gui, Show
   GuiControl, Focus, searchTermHotkeyList
   ControlSend,Edit1, ^a
   Send,{F3}

   HotkeyListMainGuiWasVisible =
Return

HotkeyListGuiEscape:
HotkeyListGuiClose:
   Critical
   GuiDefault("HotkeyList", "+LastFound")
   WinGetPos, ShowHotkeyListX , ShowHotkeyListY , ShowHotkeyListW, ShowHotkeyListH
   Gui, Cancel
   If MainGuiVisible =
      func_RemoveMessage(0x100,"sub_searchInReadme")
Return

HotkeyListGuiSize:
   GuiDefault("HotkeyList", "+LastFound")
   WinGetPos, ShowHotkeyListX , ShowHotkeyListY , ShowHotkeyListW, ShowHotkeyListH
   GuiControl, Move, searchTermHotkeyList, % "w" A_GuiWidth-100
   GuiControl, Move, searchButtonHotkeyList, % "x" A_GuiWidth-20
   GuiControl, Move, HotkeyList, % "w" A_GuiWidth " h" A_GuiHeight-22
Return

sub_CopySettingsToUser:
   MsgBox, 36, %ScriptTitle%, % lng_Copy%AHKonUSBstr%SettingsToUserAsk
   IfMsgBox, Yes
   {
      Gui, %GuiID_activAid%:+Disabled
      If A_ScriptDir <> %WorkingDir%
      {
         FileRemoveDir, settings_backup, 1
         FileMoveDir, settings,  settings_backup, 1
      }
      FileCreateDir, settings
      FileCopyDir, %A_ScriptDir%\settings, settings\, 1
      FileRead, tmp_Main, settings\extensions_main.ini
      IfNotInString, tmp_Main, %A_ScriptDir%\
      {
         StringReplace, tmp_Main, tmp_Main, #Include *i extensions\ , #Include *i %A_ScriptDir%\extensions\, All
         FileDelete, settings\extensions_main.ini
         FileAppend, %tmp_Main%, settings\extensions_main.ini
      }
      IniWrite, %ListBox_selected%, %ConfigFile%, %ScriptName%, GUIselected
      IniWrite, 1, %ConfigFile%, %ScriptName%, ShowGUI
      IniWrite, 1, %ConfigFile%, %ScriptName%, MultiUser
      Debug("RELOAD",A_LineNumber,A_LineFile,A_ThisFunc A_ThisLabel)
      Gosub, Reload
   }
Return

sub_CopySettingsToSingle:
   MsgBox, 36, %ScriptTitle%, % lng_Copy%AHKonUSBstr%SettingsToSingleAsk
   IfMsgBox, Yes
   {
      Gui, %GuiID_activAid%:+Disabled
      If A_ScriptDir <> %WorkingDir%
      {
         FileRemoveDir, %A_ScriptDir%\settings_backup, 1
         FileMoveDir, %A_ScriptDir%\settings,  %A_ScriptDir%\settings_backup, 1
      }
      FileCreateDir, %A_ScriptDir%\settings
      FileCopyDir, settings, %A_ScriptDir%\settings\, 1
      FileRead, tmp_Main, %A_ScriptDir%\settings\extensions_main.ini
      IfInString, tmp_Main, %A_ScriptDir%\
      {
         StringReplace, tmp_Main, tmp_Main, #Include *i %A_ScriptDir%\extensions\ , #Include *i extensions\, All
         FileDelete, %A_ScriptDir%\settings\extensions_main.ini
         FileAppend, %tmp_Main%, %A_ScriptDir%\settings\extensions_main.ini
      }
      IniWrite, 0, %activAidGlobalData%\%ConfigFile%, %ScriptName%, % "MultiUser" func_Hex(A_UserName)
      Gui, %GuiID_activAid%:-Disabled
   }
Return

sub_CopySettingsFromUser:
   MsgBox, 36, %ScriptTitle%, % lng_Copy%AHKonUSBstr%SettingsFromUserAsk
   IfMsgBox, Yes
   {
      Gui, %GuiID_activAid%:+Disabled
      If AHKonUSB = 1
      {
         If A_ScriptDir <> %A_ScriptDir%\ComputerSettings\%A_Computername%
         {
            FileRemoveDir, settings_backup, 1
            FileMoveDir, settings,  settings_backup, 1
         }
         FileCreateDir, %A_ScriptDir%\ComputerSettings\%A_Computername%\settings
         FileCopyDir, %A_ScriptDir%\ComputerSettings\%A_Computername%\settings, %A_ScriptDir%\settings\, 1
         FileRead, tmp_Main, %A_ScriptDir%\ComputerSettings\%A_Computername%\settings\extensions_main.ini
         IfInString, tmp_Main, %A_ScriptDir%\
         {
            StringReplace, tmp_Main, tmp_Main, #Include *i %A_ScriptDir%\extensions\ , #Include *i extensions\, All
            FileDelete, settings\extensions_main.ini
            FileAppend, %tmp_Main%, settings\extensions_main.ini
         }
         IniWrite, %ListBox_selected%, %ConfigFile%, %ScriptName%, GUIselected
         IniWrite, 1, %ConfigFile%, %ScriptName%, ShowGUI
         IniWrite, 0, %activAidGlobalData%\%ConfigFile%, %ScriptName%, % "MultiUser" func_Hex(A_UserName)
         Debug("RELOAD",A_LineNumber,A_LineFile,A_ThisFunc A_ThisLabel)
         Gosub, Reload
      }
      Else
      {
         If A_ScriptDir <> %A_AppData%\ac'tivAid\
         {
            FileRemoveDir, settings_backup, 1
            FileMoveDir, settings,  settings_backup, 1
         }
         FileCreateDir, %A_AppData%\ac'tivAid\settings
         FileCopyDir, %A_AppData%\ac'tivAid\settings, %A_ScriptDir%\settings\, 1
         FileRead, tmp_Main, %A_AppData%\ac'tivAid\settings\extensions_main.ini
         IfInString, tmp_Main, %A_ScriptDir%\
         {
            StringReplace, tmp_Main, tmp_Main, #Include *i %A_ScriptDir%\extensions\ , #Include *i extensions\, All
            FileDelete, settings\extensions_main.ini
            FileAppend, %tmp_Main%, settings\extensions_main.ini
         }
         IniWrite, %ListBox_selected%, %ConfigFile%, %ScriptName%, GUIselected
         IniWrite, 1, %ConfigFile%, %ScriptName%, ShowGUI
         IniWrite, 0, %activAidGlobalData%\%ConfigFile%, %ScriptName%, % "MultiUser" func_Hex(A_UserName)
         Debug("RELOAD",A_LineNumber,A_LineFile,A_ThisFunc A_ThisLabel)
         Gosub, Reload
      }
   }
Return

sub_DefaultSettings:
;   Critical
   Gui %GuiID_activAid%:+OwnDialogs
   MsgBox, 36, %actFunct%, %lng_DefaultMsg%
   IfMsgBox, Yes
   {
      If actFunct <> %ScriptName%
      {
         Gosub, DefaultSettings_%actFunct%
         IfExist, % ConfigFile_%actFunct%
            FileDelete, % ConfigFile_%actFunct%
      }
      IniDelete, %ConfigFile%, %actFunct%
      IniWrite, %ListBox_selected%, %ConfigFile%, %ScriptName%, GUIselected
      Debug("RELOAD",A_LineNumber,A_LineFile,A_ThisFunc A_ThisLabel)
      Gosub, Reload
   }
Return

sub_SaveAllSettings:
;   Critical
   Gui %GuiID_activAid%:+OwnDialogs
   IniRead, LastExportDir, %ConfigFile%, %ScriptName%, LastExportDir, %A_ScriptDir%

   FileSelectFolder, tempFile, *%LastExportDir%, 1, %lng_SaveAllAsk%

   If ErrorLevel <> 0
      Return

   IniWrite, %tempFile%, %ConfigFile%, %ScriptName%, LastExportDir

   tempFound = 0
   FileCopy, %ConfigFile%, %tempFile%\, 1
   Loop
   {
      Function := Extension[%A_Index%]
      If Function =
         Break
      If ConfigFile_%Function% <>
      {
         SplitPath, ConfigFile_%Function%, ConfigFileName
         FileRead, tempContent, % ConfigFile_%Function%
         FileDelete, %tempFile%\%ConfigFileName%
         IfNotInString, tempContent, `; [%Function%]`r`n
            FileAppend, `; [%Function%]`r`n, %tempFile%\%ConfigFileName%
         FileAppend, %tempContent%, %tempFile%\%ConfigFileName%
      }
;      If DataFile_%Function% <>
;      {
;         SplitPath, DataFile_%Function%, DataFileName
;         FileRead, tempContent, % DataFile_%Function%
;         FileDelete, %tempFile%\%DataFileName%
;         IfNotInString, tempContent, `; [%Function%]`r`n
;            FileAppend, `; [%Function%]`r`n, %tempFile%\%DataFileName%
;         FileAppend, %tempContent%, %tempFile%\%DataFileName%
;      }
   }
Return

sub_LoadAllSettings:
;   Critical
   Gui %GuiID_activAid%:+OwnDialogs
   IniRead, LastExportDir, %ConfigFile%, %ScriptName%, LastExportDir, %A_ScriptDir%

   FileSelectFolder, tempFile, *%LastExportDir%, 1, %lng_LoadAllAsk%

   If ErrorLevel <> 0
      Return

   IniWrite, %tempFile%, %ConfigFile%, %ScriptName%, LastExportDir

   FileRead, tempContent, %tempFile%\%ScriptNameFull%.ini
   IfNotInString, tempContent, [%ScriptName%]`r`n
   {
      Msgbox, 16, %ScriptNameFull%.ini, %lng_ImportImpossible%`n`n%ConfigFile%
      return
   }
   Loop
   {
      Function := Extension[%A_Index%]
      If Function =
         Break
      If ConfigFile_%Function% <>
      {
         SplitPath, ConfigFile_%Function%, ConfigFileName
         FileReadLine, tempContent, %tempFile%\%ConfigFileName%, 1
;         msgbox, %tempContent%
         IfNotInString, tempContent, `; [%Function%]
         {
            Msgbox, 16, %ConfigFileName%, % lng_ImportImpossible "`n`n" ConfigFile_%Function%
            return
         }
      }
;      If DataFile_%Function% <>
;      {
;         SplitPath, DataFile_%Function%, DataFileName
;         FileReadLine, tempContent, %tempFile%\%DataFileName%, 1
;         IfNotInString, tempContent, `; [%Function%]
;         {
;            Msgbox, 16, %DataFileName%, % lng_ImportImpossible "`n`n" DataFile_%Function%
;            return
;         }
;      }
   }

   FileCopy, %tempFile%\%ScriptNameFull%.ini, %SettingsDir%\, 1
   Loop
   {
      Function := Extension[%A_Index%]
      If Function =
         Break
      If ConfigFile_%Function% <>
      {
         SplitPath, ConfigFile_%Function%, ConfigFileName
         FileRead, tempContent, %tempFile%\%ConfigFileName%
         StringReplace, tempContent, tempContent, `; [%Function%]`r`n,
         FileDelete, % ConfigFile_%Function%
         FileAppend, %tempContent%, % ConfigFile_%Function%
      }
;      If DataFile_%Function% <>
;      {
;         SplitPath, DataFile_%Function%, DataFileName
;         FileRead, tempContent, %tempFile%\%DataFileName%
;         StringReplace, tempContent, tempContent, `; [%Function%]`r`n,
;         FileDelete, % DataFile_%Function%
;         FileAppend, %tempContent%, % DataFile_%Function%
;      }
   }
   IniWrite, %ListBox_selected%, %ConfigFile%, %ScriptName%, GUIselected
   Debug("RELOAD",A_LineNumber,A_LineFile,A_ThisFunc A_ThisLabel)
   Gosub, Reload
Return

sub_ResetWindows:
   MsgBox, 36, %ScriptTitle%, % #(lng_AskResetWindows,actFunct)
   IfMsgBox, Yes
   {
      Gosub, ResetWindows_%actFunct%
   }
Return

sub_ExportSettings:
   Gui %GuiID_activAid%:+OwnDialogs
   Msgbox, 36, %actFunct% ,%lng_ExportAsk%

   IfMsgBox, yes
   {
      Gui %GuiID_activAid%:+OwnDialogs

      FileSelectFile, tempFile, S 16, %actFunct%_exported.ini, %lng_ExportSettings%, *.ini

      If ErrorLevel <> 0
         Return

      tempFound = 0
      FileDelete, %tempFile%

      If ConfigFile_%actFunct% <>
      {
         FileAppend, `; [%actFunct%]`r`n, %tempFile%
         Loop, Read, % ConfigFile_%actFunct%, %tempFile%
         {
            FileAppend, %A_LoopReadLine%`r`n
         }
      }
      Else
      {
         Loop, Read, %ConfigFile%, %tempFile%
         {
            IfInString, A_LoopReadLine, [%actFunct%]
            {
               tempFound = 1
               FileAppend, %A_LoopReadLine%`r`n
               continue
            }

            If tempFound < 1
               continue

            If (func_StrLeft(A_LoopReadLine,1) = "[")
               break

            FileAppend, %A_LoopReadLine%`r`n
         }
      }
      Loop, Parse, AdditionalConfigFiles_%actFunct%, `,
      {
         If A_LoopField =
            Break
         IfExist, %A_LoopField%
         {
            FileRead, tempContent, %A_LoopField%
            FileAppend, % "`r`n`r`n" Chr(28) "### " A_LoopField "###`r`n" Chr(29) tempContent,%tempFile%
         }
      }
   }
Return

sub_ImportSettings:
   Critical
   Gui %GuiID_activAid%:+OwnDialogs

   FileSelectFile, tempFile, 1, %A_ScriptDir%, %lng_ImportSettings%, *.ini
   If ErrorLevel <> 0
      Return

   FileReadLine, tempContent, %tempFile%, 1
   IfNotInString, tempContent, [%actFunct%]
   {
      Msgbox, 16, %actFunct%, %lng_ImportImpossible%
      return
   }
   If AddSettings_%actFunct% = 1
      Msgbox, 36, %actFunct%, %lng_ImportAsk%
   Else
      Msgbox, 36, %actFunct%, %lng_ImportAsk2%

   IfMsgBox, yes
   {
      If ConfigFile_%actFunct% <>
      {
         If AddSettings_%actFunct% = 1
         {
            AddFreshSettings = 1
            AddFile = %tempFile%
            Gosub, AddSettings_%actFunct%
         }
         Else
         {
            FileCopy, %tempFile%, % ConfigFile_%actFunct%, 1
         }
      }
      Else
      {
         If AddSettings_%actFunct% = 1
         {
            AddFreshSettings = 1
            AddFile = %tempFile%
            Gosub, AddSettings_%actFunct%
         }
         FileRead, tempContent, %tempFile%
         IniDelete, %ConfigFile%, %actFunct%
         Loop, Parse, tempContent, % Chr(28)
         {
            If A_Index = 1
            {
               FileAppend, %A_LoopField%, %ConfigFile%
               Gosub, sub_BeautifyINI
            }
            Else
            {
               StringSplit, tempContent, A_LoopField, % Chr(29)
               StringTrimLeft, tempContent1, tempContent1, 4
               StringTrimRight, tempContent1, tempContent1, 5
               If tempContent1 =
                  break
               FileDelete, %tempContent1%
               FileAppend, %tempContent2%, %tempContent1%
            }
         }
      }
      If AddSettings_%actFunct% <> 1
      {
         IniWrite, %ListBox_selected%, %ConfigFile%, %ScriptName%, GUIselected
         Debug("RELOAD",A_LineNumber,A_LineFile,A_ThisFunc A_ThisLabel)
         Gosub, Reload
      }
      AddFreshSettings = 0
   }
Return

sub_AddSettings:
   Gui %GuiID_activAid%:+OwnDialogs

   FileSelectFile, AddFile, 1, %A_ScriptDir%, %lng_AddSettings%, *.ini
   If ErrorLevel <> 0
      Return

   FileReadLine, tempContent, %AddFile%, 1
   IfNotInString, tempContent, [%actFunct%]
   {
      Msgbox, 16, %actFunct%, %lng_ImportImpossible%
      return
   }
   Msgbox, 36, %actFunct%, %lng_AddAsk%

   IfMsgBox, yes
   {
      Gosub, AddSettings_%actFunct%
   }
Return


sub_ExtensionManager:
   AvailableExtensions =
   InstalledExtensions =
   ExtensionsInExtDir =
   AutoTrim, On
   ExtensionsToParse=
   Loop, %A_ScriptDir%\extensions\*.ahk, 0, 0
   {
      ExtensionsToParse=%ExtensionsToParse%%A_LoopFileFullPath%`n
   }
   Loop, %A_ScriptDir%\beta_extensions\*.ahk, 0, 0
   {
      ExtensionsToParse=%ExtensionsToParse%%A_LoopFileFullPath%`n
   }

   LoadedExtensions = |
   DuplicateExtensions =
   Loop, Parse, ExtensionsToParse, `n
   {
      LoopFileName = %A_LoopField%
      IfInString, LoopFileName, extensions\_
         continue
      If LoopFileName =
         continue

      EMExtName =
      EMReqExtName =
      Loop, Read, %LoopFileName%
      {
         IfInString, A_LoopReadLine, Prefix ; And
         IfNotInString, A_LoopReadLine, `%
         {
            StringSplit, ext_temp, A_LoopReadLine, =

            StringReplace, Prefix, ext_temp2, %A_Space%,, A
         }
         IfInString, A_LoopReadLine, `%Prefix`%_ScriptName
         {
            StringSplit, ext_temp, A_LoopReadLine, =

            StringReplace, EMExtName, ext_temp2, %A_Space%,, A

            If (InStr(LoadedExtensions, "|" EMExtName "|") AND !InStr)
            {
               SplitPath, LoopFileName, LoopFileName1
               SplitPath, ExtensionFile[%EMExtName%], LoopFileName2
               DuplicateExtensions := DuplicateExtensions LoopFileName1 ", " LoopFileName2 ", "
               Continue
            }

            LoadedExtensions = %LoadedExtensions%%EMExtName%|

            IfNotInString, LoopFileName, beta_extensions
               ExtensionsInExtDir = %ExtensionsInExtDir%%EMExtName%`,

            If Extension[%EMExtName%] <> 1
               AvailableExtensions = %AvailableExtensions%%EMExtName%|
            Else
               InstalledExtensions = %InstalledExtensions%%EMExtName%|

            ExtensionPrefix[%EMExtName%] = %Prefix%
         }
         IfInString, A_LoopReadLine, `%Prefix`%_ScriptVersion
         {
            StringSplit, ext_temp, A_LoopReadLine, =

            ExtensionVersion[%EMExtName%] = %ext_temp2%
         }
         IfInString, A_LoopReadLine, `%Prefix`%_Author
         {
            StringSplit, ext_temp, A_LoopReadLine, =

            %Prefix%_Author = %ext_temp2%
         }
         IfInString, A_LoopReadLine, IconFile_On_
         {
            StringSplit, ext_temp, A_LoopReadLine, =
            ext_temp2 = %ext_temp2%
            ext_temp2 := func_Deref(ext_temp2)
            IconFile_On_%EMExtName% = %ext_temp2%
            ReadIcon( EMExtName, ext_temp2, "")
         }
         IfInString, A_LoopReadLine, IconPos_On_
         {
            StringSplit, ext_temp, A_LoopReadLine, =
            ext_temp2 = %ext_temp2%
            ext_temp2 := func_Deref(ext_temp2)
            IconPos_On_%EMExtName% = %ext_temp2%
            ReadIcon( EMExtName, "", ext_temp2 )
         }
         IfInString, A_LoopReadLine, RequireExtensions
         {
            StringSplit, ext_temp, A_LoopReadLine, =

            StringReplace, EMReqExtName, ext_temp2, %A_Space%,, A

            FunctionRequireExt[%EMExtName%] = %EMReqExtName%

            Loop, Parse, EMReqExtName, `,
            {
               If FunctionRequiredFromExt[%A_LoopField%] =
                  FunctionRequiredFromExt[%A_LoopField%] = %EmExtName%
               Else
                  IfNotInstring, FunctionRequiredFromExt[%A_LoopField%], %EmExtName%
                     FunctionRequiredFromExt[%A_LoopField%] := FunctionRequiredFromExt[%A_LoopField%] "," EmExtName
            }
         }
         IfInString, A_LoopReadLine, FileInstall
         {
            IfNotInstring, A_LoopReadLine, .exe
               continue
            StringSplit, ext_temp, A_LoopReadLine, `,
            ExtensionExtraCompile[%EMExtName%] = %ext_temp2%
         }
         IfInString, A_LoopReadLine, SettingsGui_
            break

         Continue
      }
      If EMExtName =
         continue
      ExtensionFile[%EMExtName%] = %LoopFileName%
      StringReplace, ExtensionFile[%EMExtName%], ExtensionFile[%EMExtName%], %A_ScriptDir%\,

      EMfound = 0
      Loop, Read, %LoopFileName%
      {
         StringReplace,EMline,A_LoopReadLine,%A_Space%,,A

         IfInString, EMline, IfLng=%Lng%
            EMfound = 1

         IfNotInString, EMline, Description=
            Continue

         StringSplit, ext_temp, A_LoopReadLine, =

         StringReplace, ext_temp2, ext_temp2, ``n, `n, A

         If ((ExtensionDescription[%EMExtName%] = "" OR EMfound = 0) AND Enable_%EMExtName% = "")
         {
            ext_temp2 = %ext_temp2%
            ExtensionDescription[%EMExtName%] := func_Deref(ext_temp2)
         }

         If EMfound = 1
            break
      }
      EMFound = 0
      If Extension[%EMExtName%] =
      {
         Prefix := ExtensionPrefix[%EMExtName%]
         tmpHelp =
         Loop, Read, %LoopFileName%
         {
            If EMFound = 0
               IfNotInString, A_LoopReadLine, Help_%EMExtName%`:
                  Continue
               Else
                  EMFound = 1

            If EMFound < 4
            {
               EMFound++
               continue
            }
            If A_LoopReadLine = )
               break

            tmpHelp := tmpHelp "`r`n" A_LoopReadLine
         }
         %Prefix%_Help = %tmpHelp%
      }
   }
   Sort, InstalledExtensions, D|
   Sort, AvailableExtensions, D|

   IniWrite, %ExtensionsInExtDir%, %ConfigFile%, %ScriptName%, AvailableExtensions
   GuiControl, -Redraw, InstalledExtensionsBox
   GuiControl, -Redraw, AvailableExtensionsBox
   Gui, Add, Text, XS+240 YS+13, %lng_installed% %lng_Extensions%:
   Gui, Add, ListBox, -0x1000 Multi h200 w200 vInstalledExtensionsBox gsub_ExtISelect , %InstalledExtensions%
   Gui, Add, Text, XS+10 YS+13, %lng_available% %lng_Extensions%:
   Gui, Add, ListBox, -0x1000 Multi h200 w200 vAvailableExtensionsBox gsub_ExtASelect , %AvailableExtensions%
   Gui, Add, Button, -Wrap XS+10 Y+3 h47 gsub_EMContextHelp, ?
   Gui, Font, Underline
   Gui, Add, Text, X+5 YP+3 w500 -Wrap vEMAuthor ReadOnly,
   Gosub, GuiDefaultFont
   Gui, Add, Text, XP+0 Y+3 w500 R2 vEMDescription ReadOnly,
   Gui, Add, Picture, x+0 yp-10 H32 W32 vExtensionManagerGUIIcon
   Gui, Add, Button, -Wrap XS+213 YS+70 gsub_AllExtAdd, >>
   Gui, Add, Button, -Wrap XS+216 Y+5 gsub_ExtAdd, >
   Gui, Add, Button, -Wrap Y+5 gsub_ExtRem, <
   Gui, Add, Button, -Wrap XS+213 Y+5 gsub_AllExtRem, <<
   Gui, Font, S%FontSize7%, Arial
   Gui, Add, Text, YS+32 XS+450 W110 R16, %lng_ExtensionManagerHelp%
   Gosub, GuiDefaultFont
   InstalledExtensionsBefore = %InstalledExtensions%
   GuiControl, +Redraw, InstalledExtensionsBox
   GuiControl, +Redraw, AvailableExtensionsBox
   If DuplicateExtensions <>
   {
      Gui, Font, Caa0000 Normal
      StringTrimRight, DuplicateExtensions, DuplicateExtensions, 2
      Gui, Add, Text, YS+290 XS+10 w550, %lng_DuplicateExtensions%:
      Gui, Font, C660000 Normal
      Gui, Add, Text, Y+1 w550, %DuplicateExtensions%
      Gosub, GuiDefaultFont
   }
Return

sub_ExtISelect:
   GuiDefault("activAid")
   PostMessage, 0x185, 0, -1, ListBox2 ; LB_SETSEL, Selektion aufheben

   GuiControlGet, ExtI_selection, , InstalledExtensionsBox
   If ExtI_selection =
   {
      GuiControl,, EMAuthor,
      GuiControl,, EMDescription,
      Return
   }
   ExtI_selected =
   Loop, Parse, ExtI_selection, |
   {
      IfNotInString, ExtI_LastSelection, |%A_LoopField%|
         ExtI_selected = %A_LoopField%
   }

   If ExtI_selected =
   {
      IfInString, ExtI_Selection, |
      {
         Loop, Parse, ExtI_selection, |
            StringReplace, ExtI_LastSelection, ExtI_LastSelection, |%A_LoopField%|, |
         StringReplace, ExtI_selected, ExtI_LastSelection, |,,A
      }
      Else
         ExtI_selected = %ExtI_Selection%
      IfNotInString, ExtI_Selection, %ExtI_selected%
      {
         ExtI_selected := func_StrLeft(ExtI_Selection,InStr(ExtI_Selection,"|")-1)
      }
   }
   ExtI_LastSelection = |%ExtI_selection%|

   ExtAppend =
   If FunctionRequireExt[%ExtI_selected%] <>
      ExtAppend := " (" lng_requires " " FunctionRequireExt[%ExtI_selected%] ")"
   Prefix := ExtensionPrefix[%ExtI_selected%]
   GuiControl,, EMAuthor, % ExtI_selected " v" ExtensionVersion[%ExtI_selected%] " " lng_by " " %Prefix%_Author
   GuiControl,, EMDescription, % ExtensionDescription[%ExtI_selected%] ExtAppend
   Context = %ExtI_selected%

   EMExtIconPos := TrayIconPos[%ExtI_selected%]
   EMExtIcon := TrayIcon[%ExtI_selected%]
   GuiControl,, ExtensionManagerGUIIcon, *icon%EMExtIconPos% %EMExtIcon%

   If (A_GuiControlEvent = "DoubleClick" AND ExtNoDoubleClick <> 1)
      Gosub, sub_ExtRem
Return

sub_ExtASelect:
   GuiDefault("activAid")
   PostMessage, 0x185, 0, -1, ListBox1 ; LB_SETSEL, Selektion aufheben

   GuiControlGet, ExtA_selection, , AvailableExtensionsBox
   If ExtA_selection =
   {
      GuiControl,, EMAuthor,
      GuiControl,, EMDescription,
      Return
   }
   ExtA_selected =
   Loop, Parse, ExtA_selection, |
   {
      IfNotInString, ExtA_LastSelection, |%A_LoopField%|
         ExtA_selected = %A_LoopField%
   }
   If ExtA_selected =
   {
      IfInString, ExtA_Selection, |
      {
         Loop, Parse, ExtA_selection, |
            StringReplace, ExtA_LastSelection, ExtA_LastSelection, |%A_LoopField%|, |
         StringReplace, ExtA_selected, ExtA_LastSelection, |,,A
      }
      Else
         ExtA_selected = %ExtA_Selection%
      IfNotInString, ExtA_Selection, %ExtA_selected%
      {
         ExtA_selected := func_StrLeft(ExtA_Selection,InStr(ExtA_Selection,"|")-1)
      }
  }
   ExtA_LastSelection = |%ExtA_selection%|

   ExtAppend =
   If FunctionRequireExt[%ExtA_selected%] <>
      ExtAppend := " (" lng_requires " " FunctionRequireExt[%ExtA_selected%] ")"
   Prefix := ExtensionPrefix[%ExtA_selected%]
   GuiControl,, EMAuthor, % ExtA_selected " v" ExtensionVersion[%ExtA_selected%] " " lng_by " " %Prefix%_Author
   GuiControl,, EMDescription, % ExtensionDescription[%ExtA_selected%] ExtAppend
   Context = %ExtA_selected%

   EMExtIconPos := TrayIconPos[%ExtA_selected%]
   EMExtIcon := TrayIcon[%ExtA_selected%]
   GuiControl,, ExtensionManagerGUIIcon, *icon%EMExtIconPos% %EMExtIcon%

   If (A_GuiControlEvent = "DoubleClick" AND ExtNoDoubleClick <> 1)
      Gosub, sub_ExtAdd
Return

sub_ExtAdd:
   GuiControlGet, ExtA_selection, , AvailableExtensionsBox
   Loop, Parse, ExtA_selection, |
   {
      ExtA_selected = %A_LoopField%
      If ExtA_selected <>
         Gosub, sub_ExtAdd2
   }
   ExtNoDoubleClick = 1
   Gosub, sub_ExtASelect
   ExtNoDoubleClick = 0
Return

sub_ExtAdd2:
   GuiControlGet,AvailableExtensionsBoxHwnd, Hwnd, AvailableExtensionsBox
   GetScrollInfo(AvailableExtensionsBoxHwnd, 1, AvailableExtensionsBoxPos, AvailableExtensionsBoxPage, AvailableExtensionsBoxMin, AvailableExtensionsBoxMax, AvailableExtensionsBoxTrackPos)    ; Gets scroll bar position and things
   If FunctionRequireExt[%ExtA_selected%] <>
   {
      Loop, Parse, FunctionRequireExt[%ExtA_selected%], `,
      {
         If A_LoopField =
            break
         IfNotInstring, InstalledExtensions, %A_LoopField%
         {
            Gui %GuiID_activAid%:+OwnDialogs
            ext_temp := lng_requiresAddMsg "`n" FunctionRequireExt[%ExtA_selected%]
            msgbox, 16,%ScriptTitle%, %ext_temp%
            return
         }
      }
   }

   If InstalledExtensions =
      InstalledExtensions = %ExtA_selected%|
   Else
      InstalledExtensions = %ExtA_selected%|%InstalledExtensions%
   Sort, InstalledExtensions, D|
   StringReplace, InstalledExtensions, InstalledExtensions, ||, |, A
   StringReplace, InstalledExtensions, InstalledExtensions, %ExtA_selected%|, %ExtA_selected%||, A
   GuiControl,,InstalledExtensionsBox, |%InstalledExtensions%
   StringReplace, InstalledExtensions, InstalledExtensions, ||, |, A
   AvailableExtensions := RegExReplace(AvailableExtensions, ExtA_selected "\|([^|]*\||$)", "$1|")
   StringLeft, EMfirst, AvailableExtensions, 1
   If EMfirst = |
      StringTrimLeft, AvailableExtensions, AvailableExtensions, 1
   GuiControl,,AvailableExtensionsBox, |%AvailableExtensions%
   StringReplace, AvailableExtensions, AvailableExtensions, ||, |, A
   SetScrollPos(AvailableExtensionsBoxHwnd, 1, AvailableExtensionsBoxPos)    ; Sets scroll bar position and things

   ChangedSettings[activAid]= |
   Gosub, sub_EnableDisable_ApplyButton
Return

sub_AllExtAdd:
   InstalledExtensions = %InstalledExtensions%|%AvailableExtensions%
   AvailableExtensions =
   Sort, InstalledExtensions, D|
   StringLeft, EMfirst, InstalledExtensions, 1
   If EMfirst = |
      StringTrimLeft, InstalledExtensions, InstalledExtensions, 1
   GuiControl,,InstalledExtensionsBox, |%InstalledExtensions%
   GuiControl,,AvailableExtensionsBox, |%AvailableExtensions%
   ChangedSettings[activAid]= |
   Gosub, sub_EnableDisable_ApplyButton
   Gosub, sub_ExtASelect
Return

sub_ExtRem:
   GuiControlGet, ExtI_selection, , InstalledExtensionsBox
   Loop, Parse, ExtI_selection, |
   {
      ExtI_selected = %A_LoopField%
      If ExtI_selected <>
         Gosub, sub_ExtRem2
   }
   ExtNoDoubleClick = 1
   Gosub, sub_ExtISelect
   ExtNoDoubleClick = 0
Return

sub_ExtRem2:
   GuiControlGet,InstalledExtensionsBoxHwnd, Hwnd, InstalledExtensionsBox
   GetScrollInfo(InstalledExtensionsBoxHwnd, 1, InstalledExtensionsBoxPos, InstalledExtensionsBoxPage, InstalledExtensionsBoxMin, InstalledExtensionsBoxMax, InstalledExtensionsBoxTrackPos)    ; Gets scroll bar position and things
   If FunctionRequiredFromExt[%ExtI_selected%] <>
   {
      Loop, Parse, FunctionRequiredFromExt[%ExtI_selected%], `,
      {
         If A_LoopField =
            break
         IfInstring, InstalledExtensions, %A_LoopField%
         {
            Gui %GuiID_activAid%:+OwnDialogs
            ext_temp := lng_requiresRemMsg "`n" FunctionRequiredFromExt[%ExtI_selected%]
            msgbox, 16,%ScriptTitle%,%ext_temp%
            return
         }
      }
   }

   If AvailableExtensions =
      AvailableExtensions = %ExtI_selected%|
   Else
      AvailableExtensions = %ExtI_selected%|%AvailableExtensions%
   Sort, AvailableExtensions, D|
   StringReplace, AvailableExtensions, AvailableExtensions, ||, |, A
   StringReplace, AvailableExtensions, AvailableExtensions, %ExtI_selected%|, %ExtI_selected%||, A
   GuiControl,,AvailableExtensionsBox, |%AvailableExtensions%
   StringReplace, AvailableExtensions, AvailableExtensions, ||, |, A
   InstalledExtensions := RegExReplace(InstalledExtensions, ExtI_selected "\|([^|]*\||$)", "$1|")
   StringLeft, EMfirst, InstalledExtensions, 1
   If EMfirst = |
      StringTrimLeft, InstalledExtensions, InstalledExtensions, 1
   GuiControl,,InstalledExtensionsBox, |%InstalledExtensions%
   StringReplace, InstalledExtensions, InstalledExtensions, ||, |, A

   SetScrollPos(InstalledExtensionsBoxHwnd, 1, InstalledExtensionsBoxPos)    ; Sets scroll bar position and things

   ChangedSettings[activAid]= |
   Gosub, sub_EnableDisable_ApplyButton
Return

sub_AllExtRem:
   AvailableExtensions = %AvailableExtensions%|%InstalledExtensions%
   InstalledExtensions =
   Sort, AvailableExtensions, D|
   StringLeft, EMfirst, AvailableExtensions, 1
   If EMfirst = |
      StringTrimLeft, AvailableExtensions, AvailableExtensions, 1
   GuiControl,,InstalledExtensionsBox, |%InstalledExtensions%
   GuiControl,,AvailableExtensionsBox, |%AvailableExtensions%

   ChangedSettings[activAid]= |
   Gosub, sub_EnableDisable_ApplyButton
   Gosub, sub_ExtISelect
Return

sub_ExtInstall:
   StringReplace, InstalledExtensions, InstalledExtensions, ||, |, A
   StringSplit, InstalledExtensions, InstalledExtensions, |

   If InstalledExtensions = %InstalledExtensionsBefore%
      Return

   Debug("GUI", A_LineNumber, A_LineFile, "(Un)Installing extensions ..." )

   ChangedSettings++

   FileDelete, settings\_temp.tmp

   Loop, Parse, InstalledExtensionsBefore, |
   {
      IfInString, InstalledExtensions, %A_LoopField%|
         continue

      If (IsLabel( "UnInstallExt_" A_LoopField ))
         Gosub, UnInstallExt_%A_LoopField%
   }

   Loop, Parse, InstalledExtensions, |
   {
      IfNotInString, InstalledExtensionsBefore, %A_LoopField%|
         IniWrite, 1, %ConfigFile%, activAid, Enable_%A_LoopField%
   }

   Loop, Read, settings\extensions_header.ini, settings\_temp.tmp
   {
      IfNotInString A_LoopReadLine, CustomIncludes
      {
         FileAppend, %A_LoopReadLine%`n
         continue
      }
      break
   }
   FileAppend, CustomIncludes = 1`n, settings\_temp.tmp
   Loop
   {
      If InstalledExtensions%A_Index% =
         break
      ext_temp := A_Index
      FileAppend, % "Extension[" ext_temp "] = " InstalledExtensions%A_Index% "`n", settings\_temp.tmp
   }

   Debug("GUI", A_LineNumber, A_LineFile, "Writing new extensions_header.ini" )
   FileMove, settings\_temp.tmp, settings\extensions_header.ini, 1
   FileDelete, settings\_temp.tmp

   Loop, Read, settings\extensions_main.ini, settings\_temp.tmp
   {
      IfNotInString, A_LoopReadLine, #Include *i
      {
         FileAppend, %A_LoopReadLine%`n
         continue
      }
      break
   }
   Loop
   {
      If InstalledExtensions%A_Index% =
         break
      ExtensionName := InstalledExtensions%A_Index%
      ExtensionFile := ExtensionFile[%ExtensionName%]
;      If A_WorkingDir <> %A_ScriptDir%
;         FileAppend, % "#Include *i " A_ScriptDir "\" ExtensionFile " `;" ExtensionName "`n", settings\_temp.tmp
;      Else
;         FileAppend, % "#Include *i " ExtensionFile " `;" ExtensionName "`n", settings\_temp.tmp
      FileAppend, % "#Include *i %A_ScriptDir%\" ExtensionFile " `;" ExtensionName "`n", settings\_temp.tmp

   }
   Debug("GUI", A_LineNumber, A_LineFile, "Writing new extensions_main.ini" )

   FileDelete, settings\extensions_main.ini
   FileMove, settings\_temp.tmp, settings\extensions_main.ini, 1
   FileDelete, settings\_temp.tmp

   Reload = 1
Return

; Prfen, ob NiftyWindows luft und dieses Skript ggf. mit doppeltem Suspend *vor* Nifty setzen
tim_CheckForNifty:
   DetectHiddenWindows, On
   IfWinExist,NiftyWindows,,.zip
   {
      if niftyWindows <> on
      {
         Suspend, Toggle
         Suspend, Toggle
         niftyWindows = on
      }
   }
   Else IfWinExist,NiftyWindows.ahk,,.zip,NiftyWindows.ini
   {
      if niftyWindows <> on
      {
         Suspend, Toggle
         Suspend, Toggle
         niftyWindows = on
      }
   }
   Else
      NiftyWindows =

   DetectHiddenWindows, Off

   IfWinExist,,NiftyWindows is resumed now.
   {
      WinGetClass, NiftyClass, A
      If ( NiftyClass = "tooltips_class32" AND NiftyTip <> "on" )
      {
         Suspend, Toggle
         Suspend, Toggle
         niftyWindows = on
         NiftyTip = on
      }
   }
   Else
      NiftyTip =
Return

sub_ExtensionsOff:
;   Critical
   Gui %GuiID_activAid%:+OwnDialogs
   GetKeyState, AppsState, RAlt
   If AppsState = D
   {
      FileMove, settings\extensions_main.ini, settings\extensions_main_switch1.ini, 1
      FileMove, settings\extensions_header.ini, settings\extensions_header_switch1.ini, 1
      FileMove, settings\extensions_main_switch.ini, settings\extensions_main.ini, 1
      FileMove, settings\extensions_header_switch.ini, settings\extensions_header.ini, 1
      FileMove, settings\extensions_main_switch1.ini, settings\extensions_main_switch.ini, 1
      FileMove, settings\extensions_header_switch1.ini, settings\extensions_header_switch.ini, 1
   }
   Else
   {
      FileMove, settings\extensions_main.ini, settings\extensions_main_off.ini, 1
      FileMove, settings\extensions_header.ini, settings\extensions_header_off.ini, 1
   }
   If ErrorLevel = 0
   {
      Debug("RELOAD",A_LineNumber,A_LineFile,A_ThisFunc A_ThisLabel)
      Gosub, Reload
   }
   Else
      MsgBox, 16, %ScriptTitle%, %lng_SwitchExtErr%
return

sub_ExtensionsOn:
;   Critical
   Gui %GuiID_activAid%:+OwnDialogs
   FileMove, settings\extensions_main_off.ini, settings\extensions_main.ini, 1
   FileMove, settings\extensions_header_off.ini, settings\extensions_header.ini, 1
   If ErrorLevel = 0
   {
      Debug("RELOAD",A_LineNumber,A_LineFile,A_ThisFunc A_ThisLabel)
      Gosub, Reload
   }
   Else
      MsgBox, 16, %ScriptTitle%, %lng_SwitchExtErr%
return

; Unterroutine vom ProblemSolver, welche die Tasten prft und zurcksetzt
sub_RestoreKeyStates:
   ProbSolvMessage =

   Suspend, Toggle
   Suspend, Toggle

   GetKeyState,stateL,LButton
   GetKeyState,stateP,LButton, P
   if (stateL <> stateP)
   {
      Send,{LButton Up}
      ProbSolvMessage = %ProbSolvMessage%%lng_Left% %lng_MouseButton%-%lng_Key%`n
   }

   GetKeyState,stateL,RButton
   GetKeyState,stateP,RButton, P
   if (stateL <> stateP)
   {
      Send,{RButton Up}
      ProbSolvMessage = %ProbSolvMessage%%lng_Right% %lng_MouseButton%-%lng_Key%`n
   }

   GetKeyState,stateL,MButton
   GetKeyState,stateP,MButton, P
   if (stateL <> stateP)
   {
      Send,{MButton Up}
      ProbSolvMessage = %ProbSolvMessage%%lng_Middle% %lng_MouseButton%-%lng_Key%`n
   }

   If LoadingFinished = 1
   {
      GetKeyState,stateL,LWin
      GetKeyState,stateP,LWin, P
      if (stateL <> stateP)
      {
         Send,{LWin Up}
         ProbSolvMessage = %ProbSolvMessage%%lng_Left% %lng_KbWin%-%lng_Key%`n
      }

      GetKeyState,stateL,RWin
      GetKeyState,stateP,RWin, P
      if (stateL <> stateP)
      {
         Send,{RWin Up}
         ProbSolvMessage = %ProbSolvMessage%%lng_Right% %lng_KbWin%-%lng_Key%`n
      }

      GetKeyState,stateL,LAlt
      GetKeyState,stateP,LAlt, P
      if (stateL <> stateP)
      {
         Send,{LAlt Up}
         ProbSolvMessage = %ProbSolvMessage%%lng_Left% %lng_KbAlt%-%lng_Key%`n
      }

      GetKeyState,stateL,RAlt
      GetKeyState,stateP,RAlt, P
      if (stateL <> stateP)
      {
         Send,{RAlt Up}
         ProbSolvMessage = %ProbSolvMessage%%lng_Right% %lng_KbAlt%-%lng_Key%`n
      }

      GetKeyState,stateL,LCtrl
      GetKeyState,stateP,LCtrl, P
      if (stateL <> stateP)
      {
         Send,{LCtrl Up}
         ProbSolvMessage = %ProbSolvMessage%%lng_Left% %lng_KbCtrl%-%lng_Key%`n
      }

      GetKeyState,stateL,RCtrl
      GetKeyState,stateP,RCtrl, P
      if (stateL <> stateP)
      {
         Send,{RCtrl Up}
         ProbSolvMessage = %ProbSolvMessage%%lng_Right% %lng_KbCtrl%-%lng_Key%`n
      }

      GetKeyState,stateL,LShift
      GetKeyState,stateP,LShift, P
      if (stateL <> stateP)
      {
         Send,{LShift Up}
         ProbSolvMessage = %ProbSolvMessage%%lng_Left% %lng_KbShift%-%lng_Key%`n
      }

      GetKeyState,stateL,RShift
      GetKeyState,stateP,RShift, P
      if (stateL <> stateP)
      {
         Send,{RShift Up}
         ProbSolvMessage = %ProbSolvMessage%%lng_Right% %lng_KbShift%-%lng_Key%`n
      }
   }
Return

; Nach Updates im Internet suchen
sub_getUpdates:
   If MainGUiVisible <>
   {
      Gosub, sub_EnableDisable_ApplyButton
      If (SettingsChanged > 0 AND OnlyChangedWorkingDir = "")
      {
         MsgBox, 48, %ScriptTitle%, %lng_PleaseApplySettings%
         SimulateUpdate = 0
         StringReplace, A_Args, A_Args, SimulateUpdate,
         Return
      }
   }

   Gosub, sub_temporarySuspend
   Sleep,100

   If ( AutoUpdate <> 1 AND _SilentUpdate <> 1 )
   {
      If MainGuiVisible <>
         Gui, %GuiID_activAid%:+OwnDialogs
      MsgBox, 36, %ScriptTitle% - %lng_update%, %lng_AskUpdate%
      IfMsgBox, No
      {
         Gosub, sub_temporarySuspend
         SimulateUpdate = 0
         StringReplace, A_Args, A_Args, SimulateUpdate,
         Return
      }
   }

   GuiControl, Disable, %lng_Update%
   If func_CheckIfOnline()
      URLDownloadToFile,%UpdateURL%?dl=%ScriptVersion%, versions.ini

   If ( ErrorLevel = 1 OR func_CheckIfOnline() = 0)
   {
      MsgBox, 16, %ScriptTitle% - %lng_update%, %lng_UpdateError%
      Gosub, sub_temporarySuspend
      GuiControl, Enable, %lng_Update%
      SimulateUpdate = 0
      StringReplace, A_Args, A_Args, SimulateUpdate,
      Return
   }

   IniRead, newScriptVersion, versions.ini, activAid, version

   If ExeDistribution = 1
   {
      IniRead, newScriptURL, versions.ini, activAid_NoUnzip, exeurl
      IniRead, newScriptSize, versions.ini, activAid_NoUnzip, exesize
      newAHKVersion = %A_AHKversion%
   }
   Else
   {
      IniRead, newScriptURL, versions.ini, activAid_NoUnzip, url
      IniRead, newScriptSize, versions.ini, activAid_NoUnzip, size
      IniRead, newAHKVersion, versions.ini, activAid, AHKversion, %A_AHKversion%
   }

   IniRead, newScriptExtension, versions.ini, activAid, Extensions
   IniRead, newScriptHideUpdate, versions.ini, activAid, hideupdate, 0
   FileDelete, versions.ini

   If newScriptVersion = ERROR
   {
      MsgBox, 16, %ScriptTitle% - %lng_Update%, %lng_UpdateError%
      Gosub, sub_temporarySuspend
      GuiControl, Enable, %lng_Update%
      SimulateUpdate = 0
      StringReplace, A_Args, A_Args, SimulateUpdate,
      Return
   }

   If ( (func_getNormalizedVersionNumber(newScriptVersion) > func_getNormalizedVersionNumber(ScriptVersion) OR SimulateUpdate = 1) AND newScriptHideUpdate = 0 )
   {
      Gosub, sub_NewVersion
   }
   Else
   {
      If newScriptHideUpdate = 1
         newScriptVersion = %ScriptVersion%

      MsgBox, 64, %ScriptTitle% - %lng_Update%, %lng_NeedNoUpdate% (Online: %newScriptVersion%)
      SimulateUpdate = 0
      StringReplace, A_Args, A_Args, SimulateUpdate,
   }
   GuiControl, Enable, %lng_Update%
   Gosub, sub_temporarySuspend
Return

func_getNormalizedVersionNumber(ScriptVersion)
{
   ScriptVersion4 = 9999999
   ScriptVersionTmp = %ScriptVersion%
   StringReplace, ScriptVersionTmp, ScriptVersionTmp, %A_Space%Beta, .
   StringReplace, ScriptVersionTmp, ScriptVersionTmp, %A_Space%Alpha, .
   StringSplit, ScriptVersion, ScriptVersionTmp, .
   StringReplace, ScriptVersion3, ScriptVersion3, e,
   StringReplace, ScriptVersion4, ScriptVersion4, e,
   StringReplace, ScriptVersion5, ScriptVersion5, e,

   ScriptVersion3 := "0000000000" ScriptVersion3
   StringRight, ScriptVersion3,ScriptVersion3, 10
   ScriptVersion4 := "0000000000" ScriptVersion4
   StringRight, ScriptVersion4, ScriptVersion4, 10
   ScriptVersion5 := "0000000000" ScriptVersion5
   StringRight, ScriptVersion5, ScriptVersion5, 10
   ScriptVersionCon = %ScriptVersion1%.%ScriptVersion2%.%ScriptVersion3%.%ScriptVersion4%.%ScriptVersion5%
   Return %ScriptVersionCon%
}

sub_getManualUpdates:
   Gui, %GuiID_activAid%:+Disabled
   GuiDefault("ManualUpdate", "+Owner" GuiID_activAid)
   Gui, Add, Text, Wrap w380, %lng_ManualUpdateText%
   Gui, Font, C000066 Underline
   If Betatester = 1
      Gui, Add, Text, y+3 gsub_OpenDownloadBetaURL, http://activaid.rumborak.de/
   Else
      Gui, Add, Text, y+3 gsub_OpenDownloadURL, http://www.heise.de/ct/activaid
   Gui, Font
   Gui, Font, S%FontSize%
   Gui, Add, Button, -Wrap X55 Y+10 W210 Default gsub_ManualUpdate, %lng_OpenURLAndExit%

   Gui, Add, Button, -Wrap X+5 W80 vMainGuiCancel gManualUpdateGuiClose, %lng_Close%
   Gui, Show, w400, %ScriptTitle% %lng_ManualUpdate%
Return

sub_OpenDownloadAhk:
   Run, http://www.autohotkey.com/download/AutoHotkeyInstall.exe
Return
sub_OpenDownloadAhkUSB:
   Run, http://www.autohotkey.com/download/AutoHotkey.zip
Return
sub_OpenDownloadURL:
   Run, http://www.heise.de/ct/activaid/
Return
sub_OpenDownloadBetaURL:
   Run, http://activaid.rumborak.de/
Return

ManualUpdateGuiEscape:
ManualUpdateGuiClose:
   Gui,%GuiID_activAid%:-Disabled
   Gui,%GuiID_ManualUpdate%:Destroy
Return

sub_ManualUpdate:
   If Betatester = 1
      Gosub, sub_OpenDownloadBetaURL
   Else
      Gosub, sub_OpenDownloadURL
   ExitApp
Return

sub_ShowBackupDir:
   IfExist, %BackupDir%
      Run, %FileBrowserSelect% %BackupDir%
Return

tim_AutoUpdate:
   Gosub, sub_AutoUpdate
Return

sub_SimulateUpdate:
   IfExist, %A_ScriptDir%\ac'tivAid_AHK-Checker.ahk
   {
      SimulateUpdate = 1
      A_Args = %A_Args% SimulateUpdate
      Gosub, sub_getUpdates
   }
   Else
      MsgBox, %ScriptTitle%, Simulate Update not possible:`n%A_ScriptDir%\ac'tivAid_AHK-Checker.ahk is missing.
Return

sub_AutoUpdate:
   NetworkTickCount := A_TickCount
   URLDownloadToFile,%UpdateURL%?dl=%ScriptVersion%, versions.ini
   NetworkTickCount := A_TickCount - NetworkTickCount
   If ErrorLevel = 0
   {
      IniRead, newScriptVersion, versions.ini, activAid, version

      If ExeDistribution = 1
      {
         IniRead, newScriptURL, versions.ini, activAid_NoUnzip, exeurl
         IniRead, newScriptSize, versions.ini, activAid_NoUnzip, exesize
         newAHKVersion = %A_AHKversion%
      }
      Else
      {
         IniRead, newScriptURL, versions.ini, activAid_NoUnzip, url
         IniRead, newScriptSize, versions.ini, activAid_NoUnzip, size
         IniRead, newAHKVersion, versions.ini, activAid, AHKversion, %A_AHKversion%
      }
      IniRead, newScriptExtension, versions.ini, activAid, Extensions
      IniRead, newScriptHideUpdate, versions.ini, activAid, hideupdate, 0
      FileDelete, versions.ini

      if newScriptHideUpdate <> 1
      {
         If newScriptVersion <> ERROR
         {
            If ( func_getNormalizedVersionNumber(newScriptVersion) > func_getNormalizedVersionNumber(ScriptVersion) OR SimulateUpdate = 1)
            {
               SetTimer, tim_Loading, Off
               SplashImage, 2:Off
               Gosub, sub_NewVersion
            }
            IniWrite, % A_YYYY A_YDay, %ConfigFile%, %ScriptName%, LastUpdate
         }
      }
   }
   If (NetworkTickCount > NetworkTimeout*1000 AND DisableAutoUpdateOnSlowNetwork = 1)
   {
      If LoadingFinished <> 1
      {
         SetTimer, tim_Loading, Off
         SplashImage, Off
         SplashImage, 2:Off
         Critical
      }
      MsgBox,131092, %ScriptTitle%, %lng_SlowNetwork%
      If LoadingFinished <> 1
      {
         Critical, Off
         IfNotInstring, A_Args, nosplash
            SetTimer, tim_Loading, On
      }
      IfMsgBox, Yes
      {
         AutoUpdate = 0
         IniWrite, 0, %ConfigFile%, %ScriptName%, AutoUpdate
      }
      Else
      {
         DisableAutoUpdateOnSlowNetwork = 0
         IniWrite, %DisableAutoUpdateOnSlowNetwork%, %ConfigFile%, %ScriptName%, DisableAutoUpdateOnSlowNetwork
      }
   }
Return

sub_NewVersion:
   SetTimer, sub_NewVersionThread, -20
Return

sub_NewVersionThread:
   Gui %GuiID_activAid%:+OwnDialogs
   If newAHKVersion > %A_AHKversion%
      newScriptSize := newScriptSize + 1710
   msgbox = yes
   If ( UpdateImmediatly <> 1 AND _SilentUpdate <> 1 )
   {
      If MainGUiVisible =
         Gui, %GuiID_activAid%:Show, x-30000 y-30000, %ScriptTitle% - %lng_Update%
      func_AddMessage( 0x53, "sub_ShowExternalChangeLog" )
      SetTimer, tim_RenameViewChangelog, 1
      If SimulateUpdate = 1
         MsgBox, 16420, %test% %ScriptTitle% - %lng_Update%, %lng_NeedUpdate% %newScriptVersion% (ca. %newScriptSize% Kb)`n`nSIMULATE UPDATE!
      Else
         MsgBox, 16420, %test% %ScriptTitle% - %lng_Update%, %lng_NeedUpdate% %newScriptVersion% (ca. %newScriptSize% Kb)
      func_RemoveMessage( 0x53, "sub_ShowExternalChangeLog" )
      If MainGUiVisible =
      {
         Gui, %GuiID_activAid%:Destroy
         mainGuiID =
      }

      IfMsgBox, Yes
         msgbox = yes
      Else
         msgbox = no
   }

   If MsgBox = yes
   {
      If (A_IsCompiled = 1 AND ExeDistribution <> 1)
      {
         MsgBox, 16, %ScriptTitle% - %lng_Update%, %lng_NoUpdate%
         SimulateUpdate = 0
         StringReplace, A_Args, A_Args, SimulateUpdate,
         Return
      }

      NewWorkingDir := A_WorkingDir

      If ( MainDirNotWriteable > 0 )
      {
         IniWrite, 1, %ConfigFile%, %ScriptName%, CheckForUpdates
         Gosub, sub_RunAsAdmin
         Return
      }
      WorkingDir = %A_WorkingDir%
      SetWorkingDir, %A_ScriptDir%
      Settimer, tim_UPDATEDSCRIPT, Off
      IniWrite, %newScriptExtension%, %ConfigFile%, activAid, newext
      IniWrite, %newScriptVersion%, %ConfigFile%, activAid, newver

      IfNotExist, settings
         FileCreateDir, settings

      SoundPlay, Nonexistent.wav, wait

      If newAHKVersion > %A_AHKversion%
      {
         StringReplace, AHKVersion_DL, newAHKversion, ., , A
         If AHKonUSB = 1
         {
            If Betatester = 1
               URL2 = http://activaid.rumborak.de/update_autohotkey.exe
            Else
               URL2 = http://www.heise.de/ct/activaid/download/update_autohotkey_v%AHKVersion_DL%.exe
            File2 = update_autohotkey.exe
         }
         Else
         {
            URL2 = http://www.autohotkey.net/programs/AutoHotkey%AHKVersion_DL%_Install.exe
            File2 = AutoHotkeyInstall.exe
         }
      }

      Gosub, sub_UpdateProgress

      If BackupOnUpdate = 1
      {
         FileRemoveDir, %BackupDir%, 1
         FileCopyDir, %A_ScriptDir%, %BackupDir%, 1
      }

      FileRemoveDir, %A_Temp%\activAidUpdateBackup.tmp, 1
      FileCopyDir, %A_ScriptDir%, %A_Temp%\activAidUpdateBackup.tmp, 1

      Errors := func_Download( newScriptURL, "update.exe", lng_downloadingActivAid , ScriptNameFull " Update", newScriptSize, URL2, File2, URL3, File3)

      If Errors = 0
      {
         If A_IsSuspended = 1
            Gosub, sub_MenuSuspend
         Gosub, sub_MenuSuspend
         If A_IsCompiled = 1
         {
            If MaintainStats = 1
            {
               statUpdateCount ++
               IniWrite, %statUpdateCount%, %ConfigFile%, Statistics, UpdateCount
            }
            FileAppend, %ScriptNameFull%.exe kill`n, update.cmd
            FileAppend, update.exe`n, update.cmd
            FileAppend, %ScriptNameFull%-updater.exe`n, update.cmd
            SoundPlay, Nonexistent.avi, wait
            RunWait, update.cmd,%A_ScriptDir%, Hide UseErrorLevel
            ExitApp
         }
         SoundPlay, Nonexistent.wav, wait
         Sleep, 300
         If SimulateUpdate = 1
         {
            FileMove, %A_ScriptDir%\ac'tivAid.ahk, %A_ScriptDir%\ac'tivAid_main.ahk
            FileCopy, %A_ScriptDir%\ac'tivAid_AHK-Checker.ahk, %A_ScriptDir%\ac'tivAid.ahk
         }
         Else
            RunWait, update.exe %A_Args%, %A_ScriptDir%, Hide UseErrorLevel
         Sleep, 300
      }

      If (ErrorLevel = 0 OR Errors > 0)
      {
         SetTimer, tim_Loading, Off
         SplashImage, 2:Off
         SimulateUpdate = 0
         StringReplace, A_Args, A_Args, SimulateUpdate,
         If _SilentUpdate <> 1
            MsgBox, 64, %ScriptTitle% - %lng_Update%, %lng_UpdateFinished%, 10
         If (A_IsAdmin = 1 AND tempAdminMode = 1)
            A_Args = LeaveAdmin %A_Args%
         LeaveAdmin =
      }
      Else
      {
         SetTimer, tim_Loading, Off
         SplashImage, 2:Off
         MsgBox, 16, %ScriptTitle% - %lng_Update%, %lng_UpdateFailed%
         FileDelete, update.exe
         FileDelete, update.cmd
         SetWorkingDir, %WorkingDir%

         FileCopyDir, %A_Temp%\activAidUpdateBackup.tmp, %A_ScriptDir%, 1
         FileRemoveDir, %A_Temp%\activAidUpdateBackup.tmp, 1

         Return
      }
      If MaintainStats = 1
         statUpdateCount ++

      FileRemoveDir, %A_Temp%\activAidUpdateBackup.tmp, 1

      SetWorkingDir, %WorkingDir%
      Debug("RELOAD",A_LineNumber,A_LineFile,A_ThisFunc A_ThisLabel)
      Gosub, Reload
   }
Return

tim_RenameViewChangelog:
   ControlSetText, Button3, &%lng_ViewChangelog%, %ScriptTitle% - %lng_Update%,, ahk_id %activAidID%
   If ErrorLevel = 0
      SetTimer, tim_RenameViewChangelog, Off
Return

sub_ShowExternalChangeLog:
   If UpdateURL = %UpdateURLbeta%
      Run, http://activaid.rumborak.de/beta/aenderungen.htm
   Else
      Run, http://www.heise.de/ct/activaid/htm/changelog.htm
Return

; Skript bei nderung automatisch neu laden
tim_UPDATEDSCRIPT:
;   Critical
   WinGetActiveTitle, act_Title
   IfNotInstring, act_Title, .ahk
      Return

   Loop, %A_ScriptDir%\*.ahk, 0, 1
   {
      If (func_StrLeft(A_LoopFileName,1) = "_" OR func_StrLeft(A_LoopFileName,1) = ".")
         continue
      If A_LoopFileAttrib contains A
      {
         IfNotInString, act_Title, %A_LoopFileName%
            continue

         Suspend, On

         FileSetAttrib,-A,%A_LoopFileFullpath%
         Debug("RELOAD",A_LineNumber,A_LineFile,"Script has been modified")
         Gosub, Reload
      }
   }
Return

tim_BalloonTipTimeout:
   SetTimer, tim_BalloonTipTimeout, Off
   TrayTip
Return

; ac'tivAid im Autostart-Ordner eintragen
sub_MenuAutostart:
   If AutoStart = -1
      AutoStartNoSplash = nosplash
   Else
      AutoStartNoSplash =

   If UsingUserDir = 1
      FileCreateShortcut,%A_ScriptFullPath%, %activAidData%\%ScriptNameFull%.lnk,%activAidData%,,,%ScriptIcon%

   If AutoStart = 0
      FileDelete, %A_Startup%\%ScriptNameFull%.lnk
   Else If AHKonUSB <> 1
   {
      If A_Iscompiled = 1
         FileCreateShortcut,%A_ScriptFullPath%,%A_Startup%\%ScriptNameFull%.lnk,%A_WorkingDir%,%AutoStartNoSplash%,,%A_ScriptFullPath%
      Else
      {
         If UsingUserDir = 1
            FileCreateShortcut,%A_ScriptFullPath%,%A_Startup%\%ScriptNameFull%.lnk,%activAidData%,%AutoStartNoSplash%,,%ScriptOnIcon%
         Else
            FileCreateShortcut,%A_ScriptFullPath%,%A_Startup%\%ScriptNameFull%.lnk,%A_WorkingDir%,%AutoStartNoSplash%,,%ScriptOnIcon%
      }
   }
   Else If AHKonlyPortable = 1
   {
      If A_Iscompiled = 1
         FileCreateShortcut,%A_ScriptDir%\Portable_ac'tivAid.exe,%A_Startup%\%ScriptNameFull%.lnk,%A_WorkingDir%,%AutoStartNoSplash%,,%A_ScriptFullPath%
      Else
      {
         If UsingUserDir = 1
            FileCreateShortcut,%A_ScriptDir%\Portable_ac'tivAid.exe,%A_Startup%\%ScriptNameFull%.lnk,%activAidData%,%AutoStartNoSplash%,,%ScriptOnIcon%
         Else
            FileCreateShortcut,%A_ScriptDir%\Portable_ac'tivAid.exe,%A_Startup%\%ScriptNameFull%.lnk,%A_WorkingDir%,%AutoStartNoSplash%,,%ScriptOnIcon%
      }
   }
   If ErrorLevel
      Error++

   If (CreateUninstaller = 2 AND AHKonUSB <> 1)
   {
      FileCreateDir, %A_Programs%\ac'tivAid
      SplitPath, ReadmeFile, ProgramsReadme
      If UsingUserDir = 1
         FileCreateShortcut,%A_ScriptFullPath%, %activAidData%\%ScriptNameFull%.lnk,%activAidData%,,,%ScriptIcon%
      If A_Iscompiled = 1
      {
         FileCreateShortcut,%A_ScriptFullPath%,%A_Programs%\ac'tivAid\%ScriptNameFull%.lnk,%A_ScriptDir%,,,%A_ScriptFullPath%
         FileCreateShortcut,%A_ScriptDir%\%ProgramsReadme%,%A_Programs%\ac'tivAid\%ProgramsReadme%.lnk,%A_ScriptDir%,,,%A_ScriptDir%\%ProgramsReadme%
      }
      Else
      {
         If UsingUserDir = 1
         {
            FileCreateShortcut,%activAidData%\%ScriptNameFull%.lnk, %A_Programs%\ac'tivAid\%ScriptNameFull%.lnk,%activAidData%,,,%ScriptOnIcon%
         }
         Else
         {
            FileCreateShortcut,%A_ScriptFullPath%,%A_Programs%\ac'tivAid\%ScriptNameFull%.lnk,%A_ScriptDir%,,,%ScriptOnIcon%
         }
         FileCreateShortcut,%A_ScriptDir%\%ProgramsReadme%,%A_Programs%\ac'tivAid\%ProgramsReadme%.lnk,%A_ScriptDir%,,,%A_ScriptDir%\%ProgramsReadme%
      }
      If ErrorLevel
         Error++
   }
Return

sub_MenuContextHelp:
   Context:= GuiTabs[%ListBox_selected%]
;   StringReplace, Context, A_ThisMenuItem, % lng_ContextHelp " ",
   Gosub, sub_ContextHelpMain
Return

sub_EMContextHelp:
sub_ContextHelp:
   IfInString, A_GuiControl, CH_
      StringReplace, Context, A_GuiControl, CH_,
   If Context =
      Return
   Gosub, sub_ContextHelpMain
Return

sub_ContextHelpMain:
   ContextBegin   = 0
   ContextContent =
   GuiDefault("HelpWindow")

   Context := func_StrTrimChars(Context, "", "1234567890" )

   Loop, Parse, ReadMe, `n, `r
   {
      If ContextBegin = 1
      {
         If ( InStr(A_LoopField, ". " Context) > 2 AND InStr(A_LoopField, ". " Context) < 8)
         {
            ContextBegin++
         }
         Continue
      }
      If ContextBegin = 2
      {
         ContextBegin++
         Continue
      }
      If ContextBegin = 3
      {
         If A_LoopField contains _________________________
            break
         ContextContent = %ContextContent%%A_LoopField%`n
      }

      If A_LoopField contains ________________________
      {
         ContextBegin++
         Continue
      }


   }
   Prefix := ExtensionPrefix[%Context%]
   If %Prefix%_Help <>
      ContextContent := %Prefix%_Help
   Gui, Destroy
   GuiDefault("HelpWindow", "-Maximize -Minimize +ToolWindow +AlwaysOnTop")
   Gui, Font, S%FontSize14% bold, Arial
   Gui, Add, Text,, %Context%
   Gosub, GuiDefaultFont
   If ExtensionVersion[%Context%] =
      Gui, Add, Text,x+5 yp+7, % " "
   Else
      Gui, Add, Text,x+5 yp+7, % "v" ExtensionVersion[%Context%] " " lng_by " " %Prefix%_Author

   Gui, Add, Text, X377 YP-2 W80 Right, %lng_Search%:
   Gui, Add, Edit, x+5 yp-4 w100 vsearchTermContextHelp gsub_ReadmeSearch
   Gui, Add, Button, -Wrap x+3 gsub_ReadmeSearch vsearchButtonContextHelp H21 W15, >

   Gui, Font, , Courier New
   Gui, Font, , Lucida Console
   Gui, Add, Edit,Readonly 0x100 -WantReturn x10 Y+5 T100 H330 W570 vContextHelp, %ContextContent%
   Gosub, GuiDefaultFont
   Gui, Add, Button, -Wrap w50 X270 gHelpWindowGuiClose, %lng_OK%
   Gui, Show, , %ScriptTitle% - %Context%
   Send,^{Home}
Return

HelpWindowGuiClose:
HelpWindowGuiEscape:
   Gui, %GuiID_HelpWindow%:Destroy
Return

sub_OnExit:
   Critical
   Debug("STATUS", A_LineNumber, A_LineFile, "ExitReason: " A_ExitReason )
   If IsLabel("cd_sub_RestoreTempDeskWindows")
      Gosub, cd_sub_RestoreTempDeskWindows%A_EmptyVar%
   If IsLabel("cd_sub_RestoreHiddenWindows")
      Gosub, cd_sub_RestoreHiddenWindows%A_EmptyVar%
   Loop
   {
      If Extension[%A_Index%] =
         break
      Function := Extension[%A_Index%]
      If ( IsLabel("OnExitAndReload_" Function) )
      {
         Debug("STATUS", A_LineNumber, A_LineFile, "OnExitAndReload_" Function "...")
         Gosub, OnExitAndReload_%Function%
      }
   }

   If HotkeyList <>
   {
      Gui, %GuiID_HotkeyList%:+LastFoundExist
      IfWinExist
         WinGetPos, ShowHotkeyListX , ShowHotkeyListY , ShowHotkeyListW, ShowHotkeyListH
      If ShowHotkeyListH <>
      {
         WinGet, MinMax, MinMax
         If MinMax <> -1
         {
            IniWrite, %ShowHotkeyListX%, %ConfigFile%, %ScriptName%, ShowHotkeyListX
            IniWrite, %ShowHotkeyListY%, %ConfigFile%, %ScriptName%, ShowHotkeyListY
            IniWrite, %ShowHotkeyListH%, %ConfigFile%, %ScriptName%, ShowHotkeyListH
            IniWrite, %ShowHotkeyListW%, %ConfigFile%, %ScriptName%, ShowHotkeyListW
         }
      }
   }

   If GuiID_VarDump <>
   {
      Gui, %GuiID_VarDump%:+LastFoundExist
      IfWinExist
      {
         IniWrite, 1, %ConfigFile%, %ScriptName%, ShowVarDump
         Gosub, VarDumpGuiOK
      }
   }

   If A_ExitReason <> Reload
   {
      IniDelete, %ConfigFile%, %ScriptName%, ShowGUI
      IniDelete, %ConfigFile%, %ScriptName%, LastExitReason
      If MaintainStats = 1
         IniWrite, %statLastLaunched%, %ConfigFile%, Statistics, LastLaunched

      If (tempAdminMode = 1 AND A_ExitReason = "Exit")
      {
         tempAdminMode = 0
         DetectHiddenWindows, On
         If A_IsCompiled = 1
            SendMessage, 0x1ccc, 33, 33,,%A_ScriptDir%\extensions\RunWithAdminRights.exe
         Else
            SendMessage, 0x1ccc, 33, 33,,%A_ScriptDir%\extensions\RunWithAdminRights.ahk - AutoHotkey v%A_Ahkversion%
      }
   }
   Else
   {
      IniWrite, Reload, %ConfigFile%, %ScriptName%, LastExitReason
      statReloadCount++
   }

   If A_ExitReason not in Reload,Single,Error,Logoff,Shutdown,Close
      statExitCount++

   CallHook( "On" A_ExitReason )

   If MaintainStats = 1
   {
      statTime = %A_Now%
      IniWrite, %statFirstLaunch%, %ConfigFile%, Statistics, FirstLaunch
      IniWrite, %statLaunchCount%, %ConfigFile%, Statistics, LaunchCount
      IniWrite, %statReloadCount%, %ConfigFile%, Statistics, ReloadCount
      IniWrite, %statUpdateCount%, %ConfigFile%, Statistics, UpdateCount
      IniWrite, %statExitCount%, %ConfigFile%, Statistics, ExitCount
      EnvSub, statTime, statTimeLaunched, Minutes
      statTotalTime := statTotalTime+statTime
      IniWrite, %statTotalTime%, %ConfigFile%, Statistics, TotalTime
      If statTime > %statLongestSession%
         IniWrite, %statTime%, %ConfigFile%, Statistics, LongestSession
   }
   IfWinExist, ahk_id %MainGuiID%
   {
      If MainGuiX <> Reset
      {
         WinGet, MinMax, MinMax, ahk_id %MainGuiID%
         If MinMax <> -1
         {
            WinGetPos, MainGuiX, MainGuiY, , , ahk_id %MainGuiID%
            IniWrite, %MainGuiX%, %ConfigFile%, %ScriptName%, MainGuiX
            IniWrite, %MainGuiY%, %ConfigFile%, %ScriptName%, MainGuiY
         }
      }
   }
   ExitApp
Return

sub_Statistics:
   Gui, %GuiID_Statistics%:+LastFoundExist
   IfWinExist
   {
      Gui, %GuiID_Statistics%:Show
      Return
   }

   GuiDefault("Statistics", "-Resize +LastFoundExist")

   statIndent = 150

   statTime = %A_Now%
   EnvSub, statTime, statTimeLaunched, Minutes
   statTotalTimeTmp := statTotalTime+statTime
   If statTime > %statLongestSession%
      statLongestSession = %statTime%

   Gui, Font, b s13
   Gui, Add, Text, x10, %lng_Statistics%
   Gosub, GuiDefaultFont

   If A_IsCompiled = 1
      statAdd = %statAdd%%lng_StatCompiled%
   Gui, Add, Text, x10 y+3 w%statIndent%, %lng_StatVersion%:
   Gui, Add, Text, x+5, %ScriptTitle%%statAdd%
   statAdd =

   If MainDirNotWriteable = 1
      statAdd = %statAdd%%lng_StatWriteLocked%
   Gui, Add, Text, y+0, %A_ScriptFullPath% %statAdd%
   statAdd =

   Gui, Add, Text, x10 y+3 w%statIndent%, %lng_StatMode%:
   If AHKonUSB = 1
      Gui, Add, Text, x+5, %UserMode% (%A_AutoHotkeyDriveType%)
   Else
      Gui, Add, Text, x+5, %UserMode%

   Gui, Add, Text, x10 y+3 w%statIndent%, %lng_StatAHKVersion%:
   Gui, Add, Text, x+5, %A_AHKversion%
   Gui, Add, Text, y+0, %A_AHKPath%
   Gui, Add, Text, x10 y+3 w%statIndent%, %lng_StatOS%:
   Gui, Add, Text, x+5, %A_OSversion% (%A_OStype%) `t Real: %A_RealOSversion% %A_OSWordSize%-Bit
   Gui, Add, Text, x10 y+3 w%statIndent%, %lng_StatUser%:
   If main_IsAdmin = 1
      statAdd = (Admin)
   Gui, Add, Text, x+5, %A_Username% %statAdd%
   statAdd =
   Gui, Add, Text, x10 y+3 w%statIndent%, %lng_StatComputer%:
   Gui, Add, Text, x+5, %A_Computername%
   Gui, Add, Text, x10 y+3 w%statIndent%, %lng_StatIP%:
   Gui, Add, Text, x+5, %A_Ipaddress1%
   Gui, Add, Text, x10 y+3 w%statIndent%, %lng_StatSettingsDir%:
   Gui, Add, Text, x+5, %WorkingDir%\%SettingsDir%

   Gui, Add, Text, x10 y+15 w%statIndent%, %lng_StatFirstLaunch%:
   Gui, Add, Text, x+5, % func_FormatTime(statFirstLaunch)
   Gui, Add, Text, x10 y+3 w%statIndent%, %lng_StatLastLaunched%:
   Gui, Add, Text, x+5, % func_FormatTime(statLastLaunched)
   Gui, Add, Text, x10 y+3 w%statIndent%, %lng_StatLaunchCount%:
   Gui, Add, Text, x+5, % statLaunchCount
   Gui, Add, Text, x10 y+3 w%statIndent%, %lng_StatExitCount%:
   Gui, Add, Text, x+5, % statExitCount
   Gui, Add, Text, x10 y+3 w%statIndent%, %lng_StatReloadCount%:
   Gui, Add, Text, x+5, % statReloadCount
   Gui, Add, Text, x10 y+3 w%statIndent%, %lng_StatUpdateCount%:
   Gui, Add, Text, x+5, % statUpdateCount
   Gui, Add, Text, x10 y+3 w%statIndent%, %lng_StatTotalTime%:
   Gui, Add, Text, x+5 vstatTotalTime, % func_FormatTime(statTotalTimeTmp, "duration")
   Gui, Add, Text, x10 y+3 w%statIndent%, %lng_StatSessionTime%:
   Gui, Add, Text, x+5 vstatSessionTime, % func_FormatTime(statTime, "duration")
   Gui, Add, Text, x10 y+3 w%statIndent%, %lng_StatLongestSession%:
   Gui, Add, Text, x+5 vstatLongestSession, % func_FormatTime(statLongestSession, "duration")
   Gui, Add, Text, x10 y+3 w%statIndent%, %lng_StatLoadingTime%:
   Gui, Add, Text, x+5 , % func_FormatTime(LoadingTime/1000, "duration precise seconds")
   Gui, Add, Text, x10 y+3 w%statIndent%, %lng_StatMainGuiBuildTime%:
   Gui, Add, Text, x+5 , % func_FormatTime(MainGuiBuildTime/1000, "duration precise seconds")

   Gui, Add, Text, x10 y+15 w%statIndent%, %lng_StatNumOfExtensions%:
   Gui, Add, Text, x+5 , %NumOfExtensions%
   Gui, Add, Text, x10 y+3 w%statIndent%, %lng_StatExtendRButton%:
   Gui, Add, Text, x+5 , % func_StrReplace( Hook_RButton, "|", ", ", "A" )
   Gui, Add, Text, x10 y+3 w%statIndent%, %lng_StatExtendMButton%:
   Gui, Add, Text, x+5 , % func_StrReplace( Hook_MButton, "|", ", ", "A" )

   Gui, Add, Button, -Wrap -Default gStatisticsToClipboard, %lng_StatisticsToClipboard%

   Gui, Show,, %lng_Statistics%

   SetTimer, tim_RefreshStats, 60000
Return

StatisticsGuiClose:
StatisticsGuiEscape:
   SetTimer, tim_RefreshStats, Off
   Gui, %GuiID_Statistics%:Destroy
Return

StatisticsToClipboard:
   WinGetText, AllStatistics, A
   ExtendedStatistics := "Statistics:`r`n---------------------------------------------------------------------"
   Loop, Parse, AllStatistics, `n, `r
   {
      If (A_Index = 1 OR A_LoopField = lng_StatisticsToClipboard)
         continue
      If (func_StrRight(A_LoopField,1) = ":")
         ExtendedStatistics .= "`r`n" A_LoopField
      Else
         ExtendedStatistics .= "`t" A_LoopField
   }
   ExtendedStatistics .= "`r`n---------------------------------------------------------------------`r`n"
   ExtendedStatistics .= "`r`nScreenareas:`r`n---------------------------------------------------------------------"

   ExtendedStatistics .= "`r`nMonitor:`t" MonitorLeft ", " MonitorTop ", " MonitorRight ", " MonitorBottom " = " MonitorWidth " x " MonitorHeight
   ExtendedStatistics .= "`r`nMonitorArea:`t" MonitorAreaLeft ", " MonitorAreaTop ", " MonitorAreaRight ", " MonitorAreaBottom " = " MonitorAreaWidth " x " MonitorAreaHeight
   ExtendedStatistics .= "`r`nWorkArea:`t" WorkAreaLeft ", " WorkAreaTop ", " WorkAreaRight ", " WorkAreaBottom " = " WorkAreaWidth " x " WorkAreaHeight

   Loop, %NumOfMonitors%
   {
      ExtendedStatistics .= "`r`n`r`nMonitor" A_Index ":`t" Monitor%A_Index%Left ", " Monitor%A_Index%Top ", " Monitor%A_Index%Right ", " Monitor%A_Index%Bottom " = " Monitor%A_Index%Width " x " Monitor%A_Index%Height
      ExtendedStatistics .= "`r`nWorkArea" A_Index ":`t" WorkArea%A_Index%Left ", " WorkArea%A_Index%Top ", " WorkArea%A_Index%Right ", " WorkArea%A_Index%Bottom " = " WorkArea%A_Index%Width " x " WorkArea%A_Index%Height
   }

   ExtendedStatistics .= "`r`n`r`nBorderHeight:`t" BorderHeight
   ExtendedStatistics .= "`r`nBorderHeightToolWindow:`t" BorderHeightToolWindow
   ExtendedStatistics .= "`r`nCaptionHeight:`t" CaptionHeight
   ExtendedStatistics .= "`r`nSmallCaptionHeight:`t" SmallCaptionHeight
   ExtendedStatistics .= "`r`nMenuBarHeight:`t" MenuBarHeight
   ExtendedStatistics .= "`r`nScrollBarHWeight:`t" ScrollBarHWeight
   ExtendedStatistics .= "`r`nScrollBarVWeight:`t" ScrollBarVWeight

   Loop
   {
      actExtension := Extension[%A_Index%]
      If actExtension =
         Break

      ExtendedStatistics .= "`r`n---------------------------------------------------------------------`r`n"
      ExtendedStatistics .= "`r`n" actExtension ":`r`n---------------------------------------------------------------------"
      ExtendedStatistics .= "`r`nEnable_" actExtension ":`t" Enable_%actExtension%
      ExtendedStatistics .= "`r`nExtensionVersion:`t" ExtensionVersion[%actExtension%]
      ExtendedStatistics .= "`r`nExtensionPrefix:`t" ExtensionPrefix[%actExtension%]
      ExtendedStatistics .= "`r`nExtensionMenuName:`t" ExtensionMenuName[%actExtension%]
      ExtendedStatistics .= "`r`nExtensionHideSettings:`t" ExtensionHideSettings[%actExtension%]
      ExtendedStatistics .= "`r`nExtension:`t" Extension[%actExtension%]
      ExtendedStatistics .= "`r`nExtensionLoadingTime:`t" ExtensionLoadingTime[%actExtension%] " ms"
      ExtendedStatistics .= "`r`nExtensionGuiTime:`t" ExtensionGuiTime[%actExtension%] " ms"
      ExtendedStatistics .= "`r`nEnableTray_" actExtension ":`t" EnableTray_%actExtension%
      ExtendedStatistics .= "`r`n"

      If (IsLabel( "Statistics_" actExtension ))
         Gosub, Statistics_%actExtension%
   }

   Clipboard = %ExtendedStatistics%
   AllStatistics =
   Gosub, StatisticsGuiClose
Return

tim_RefreshStats:
   statTime = %A_Now%
   EnvSub, statTime, statTimeLaunched, Minutes
   statTotalTimeTmp := statTotalTime+statTime
   If statTime > %statLongestSession%
      statLongestSession = %statTime%
   Gui, %GuiID_Statistics%:Default
   GuiControl, , statTotalTime, % func_FormatTime(statTotalTimeTmp, "duration")
   GuiControl, , statSessionTime, % func_FormatTime(statTime, "duration")
   GuiControl, , statLongestSession, % func_FormatTime(statLongestSession, "duration")
Return

OnClipboardChange:
   Critical
   If (LoadingFinished = "" OR Hook_OnClipboardChange = "" OR NoOnClipboardChange = 1)
      Return
   Sleep, 400
   ThisClipboard = %Clipboard%
   If (A_EventInfo = 1 AND ThisClipboard = LastClipboard)
      Return
   CallHook("OnClipboardChange")
   LastClipboard = %ThisClipboard%
Return

; -----------------------------------------------------------------------------
; === Hotkeys =================================================================
; -----------------------------------------------------------------------------

#IfWinactive

#MaxThreadsperhotkey 1

~#ESC::
   Sleep, 300
   Suspend, Toggle
   Suspend, Toggle
   niftyWindows = on
Return

$MButton::
;   Critical
   MButton_DownTick = %A_TickCount%
   StringReplace, MButton_LastHotkey, A_ThisHotkey, $,

   MButton_down =
   MButton_send =

   CallHook( "MButton" )

   If (MButton_send = "" OR MButton_send = "yes")
   {
      If (MButton_UpTick <> MButton_DownTick)
      {
         Click down middle
         MButton_down = yes
      }
      Else
         Click up middle
   }

   MButton_send =
Return

$MButton Up::
;   Critical
   MButton_UpTick = %MButton_DownTick%
   CallHook("MButton","Up")

   If MButton_down = yes
   {
      Click up middle
      MButton_down =
   }
Return

DoEnable_MButton:
   Hotkey, IfWinActive
   Enable_MButton = 0
   Loop, Parse, Hook_MButton, |
   {
      If A_LoopField =
         continue
      If (Enable_%A_LoopField% = 1 AND EnableMButton_%A_LoopField% <> 0)
         Enable_MButton = 1
   }
   If Enable_MButton = 1
   {
      Hotkey, $MButton, On
      Hotkey, $MButton Up, On
   }
   Else
   {
      Hotkey, $MButton, Off
      Hotkey, $MButton Up, Off
   }
Return

DoDisable_MButton:
   Hotkey, IfWinActive
   Enable_MButton = 0
   Loop, Parse, Hook_MButton, |
   {
      If A_LoopField =
         continue
      If (Enable_%A_LoopField% = 1 AND EnableMButton_%A_LoopField% <> 0)
         Enable_MButton = 1
   }
   If Enable_MButton = 1
   {
      Hotkey, $MButton, Off
      Hotkey, $MButton Up, Off
   }
Return

#IfWinNotActive, ac'tivAid v ahk_class AutoHotkeyGUI
$RButton::
   DetectHiddenWindows, On
   IfWinExist, StrokeIt
      StrokeIt = 1
   Else
      StrokeIt = 0

   RButton_down =
   RButton_send =

   If (GetKeyState("LButton","P") = 0)
      Hotkey, $LButton, On

   CallHook("RButton")

   RButton_DownTick = %A_TickCount%
   If (RButton_send = "" OR RButton_send = "yes")
   {
      If (RButton_UpTick <> RButton_DownTick OR StrokeIt = 1)
      {
         Click down right
         RButton_down = yes
      }
      Else
      {
         Click up right
      }
   }

   WinGetClass, tmpClass, A
   If tmpClass = AutoHotkeyGUI
      KeyWait, RButton, L
   Else
      KeyWait, RButton

   CallHook("RButton","Up")

   RButton_UpTick = %RButton_DownTick%
   If (RButton_down = "yes")
   {
      Click up right
      RButton_down =
   }
   RButton_send =

   RLButton_send =
   Hotkey, $LButton, Off
   SendMode, %A_SendMode%
Return
#IfWinNotActive

$LButton::
   Critical
   If (GetKeyState("RButton","P"))
   {
      RLButton_send = 1
      Click down right
   }
   Click left
   If (GetKeyState("RButton","P"))
      Click up right
   Sleep, 0
Return

DoEnable_RButton:
   Hotkey, IfWinNotActive, ac'tivAid v ahk_class AutoHotkeyGUI
   Enable_RButton = 0
   Loop, Parse, Hook_RButton, |
   {
      If A_LoopField =
         continue
      If (Enable_%A_LoopField% = 1 AND EnableRButton_%A_LoopField% <> 0)
         Enable_RButton = 1
   }

   If Enable_RButton = 1
   {
      Hotkey, $RButton, On
;      Hotkey, $RButton Up, On
   }
   Else
   {
      Hotkey, $RButton, Off
;      Hotkey, $RButton Up, Off
   }
   Hotkey, IfWinNotActive
Return

DoDisable_RButton:
   Hotkey, IfWinNotActive, ac'tivAid v ahk_class AutoHotkeyGUI
   Enable_RButton = 0
   Loop, Parse, Hook_RButton, |
   {
      If A_LoopField =
         continue
      If (Enable_%A_LoopField% = 1 AND EnableRButton_%A_LoopField% <> 0)
         Enable_RButton = 1
   }
   If Enable_RButton = 1
   {
      Hotkey, $RButton, Off
;      Hotkey, $RButton Up, Off
   }
   Hotkey, IfWinNotActive
Return

tim_WM_DISPLAYCHANGE:
   ; Anzahl der Monitore und Arbeitsflche ermitteln
   SysGet, NumOfMonitors, 80
   SysGet, WorkArea, MonitorWorkArea

   ; Mae vom Standardmonitor
   SysGet, Monitor, Monitor
   MonitorHeight := MonitorBottom-MonitorTop
   MonitorWidth := MonitorRight-MonitorLeft

   SysGet, WorkAreaPrimary, MonitorWorkArea
   WorkAreaPrimaryWidth := WorkAreaPrimaryRight - WorkAreaPrimaryLeft
   WorkAreaPrimaryHeight := WorkAreaPrimaryBottom - WorkAreaPrimaryTop

   If NumOfMonitors < 1
      NumOfMonitors = 1

   Loop, %NumOfMonitors%
   {
      SysGet, tempArea, MonitorWorkArea, %A_Index%
      SysGet, WorkArea%A_Index%, MonitorWorkArea, %A_Index%
      SysGet, Monitor%A_Index%, Monitor, %A_Index%
      WorkArea%A_Index%Width := WorkArea%A_Index%Right - WorkArea%A_Index%Left
      WorkArea%A_Index%Height := WorkArea%A_Index%Bottom - WorkArea%A_Index%Top
      Monitor%A_Index%Width := Monitor%A_Index%Right - Monitor%A_Index%Left
      Monitor%A_Index%Height := Monitor%A_Index%Bottom - Monitor%A_Index%Top

      If tempAreaLeft < %WorkAreaLeft%
         WorkAreaLeft := tempAreaLeft
      If tempAreaRight > %WorkAreaRight%
         WorkAreaRight := tempAreaRight
      If tempAreaTop < %WorkAreaTop%
         WorkAreaTop := tempAreaTop
      If tempAreaBottom > %WorkAreaBottom%
         WorkAreaBottom := tempAreaBottom

   }

   WorkAreaWidth  := WorkAreaRight-WorkAreaLeft
   WorkAreaHeight := WorkAreaBottom-WorkAreaTop
   SysGet, MonitorAreaWidth, 78
   SysGet, MonitorAreaHeight, 79
   SysGet, MonitorAreaLeft, 76
   SysGet, MonitorAreaTop, 77
   If MonitorAreaWidth = 0 ; Win95/NT
   {
      MonitorAreaWidth := MonitorWidth
      MonitorAreaHeight := MonitorHeight
      MonitorAreaLeft := MonitorLeft
      MonitorAreaTop := MonitorTop
   }
   MonitorAreaBottom := MonitorAreaTop+MonitorAreaHeight
   MonitorAreaRight := MonitorAreaLeft+MonitorAreaWidth

   SysGet, BorderHeight, 32 ;7
   SysGet, SM_CXBORDER, 5
   BorderHeightToolWindow := BorderHeight-SM_CXBORDER
   SysGet, CaptionHeight, 4
   SysGet, MenuBarHeight, 15
   SysGet, SmallCaptionHeight, 51
   SysGet, ScrollBarVWeight, 9
   SysGet, ScrollBarHWeight, 10

   If ((WorkAreaWidth <> LastWorkAreaWidth OR WorkAreaHeight <> LastWorkAreaHeight) AND LastWorkAreaHeight <> "")
   {
      Debug("STATUS", A_LineNumber, A_LineFile, "Display settings changed ...")
      Loop
      {
         If Extension[%A_Index%] =
            break
         Function := Extension[%A_Index%]
         If ( IsLabel("DisplayChange_" Function) )
            Gosub, DisplayChange_%Function%
      }
   }

   LastWorkAreaWidth = %WorkAreaWidth%
   LastWorkAreaHeight = %WorkAreaHeight%
   LastMonitorAreaWidth = %MonitorAreaWidth%
   LastMonitorAreaHeight = %MonitorAreaHeight%

   ; ac'tivAid automatisch deaktiveren, wenn der Installer sichtbar ist.
   DetectHiddenWindows, On
   If (WinActive("License - ac'tivAid v") OR WinActive("Lizenzbestimmungen - ac'tivAid v") OR WinActive("ac'tivAid v","Installationsfortschritt") OR WinActive("ac'tivAid v","Installation progress") OR WinExist("##### NEXTBUILD.ahk"))
   {
      DetectHiddenWindows, Off
      If A_IsSuspended = 0
      {
         Gosub, sub_MenuSuspend
         InstallerVisible = 1
      }
   }
   Else If InstallerVisible = 1
   {
      DetectHiddenWindows, Off
      InstallerVisible =
      Gosub, sub_MenuSuspend
   }
Return

sub_ExtendEdit1Controls:
   edit1_Key = %#wParam%

   GuiControlGet, edit1_Focus, focus
   If (func_StrLeft(edit1_Focus,4) <> "Edit")
      Return

   GuiControlGet, edit1_Focus, focusV

   GetKeyState, edit1_CtrlState, Ctrl
   If edit1_CtrlState = D
      edit1_Key := edit1_Key + 1000
   GetKeyState, edit1_ShiftState, Shift
   If edit1_ShiftState = D
      edit1_Key := edit1_Key + 2000
   GetKeyState, edit1_AltState, Alt
   If edit1_AltState = D
      edit1_Key := edit1_Key + 4000

;      tooltip %edit1_Key% %edit1_Focus% %edit1_searchTermTargetHwnd%

   If (edit1_Key = 1008) ; Strg+Lschen
   {
      If edit1_Focus in Readme,ChangeLog,HotkeyList,ContextHelp
         GuiControl, Focus, searchTerm%edit1_Focus%
      SetKeyDelay,0
      Send,^+{Left}{Del}
      #Return = 0
   }
Return

#MaxThreadsperhotkey

; -----------------------------------------------------------------------------
; === Functions ===============================================================
; -----------------------------------------------------------------------------

; Falls BalloonTips deaktiviert sind, normale Meldung ausgeben
BalloonTip( Title, Text, Symbol="", OnlyOnce=0, AlwaysMessageBox=0, TimeOut="" ) {
   Global

   If (OnlyOnce = 1 AND LoadingFinished = 1)
   {
      OnceVar =
      OnceVar := "OnceVar" func_StrLeft(func_Hex(Title),16) func_StrRight(func_Hex(Title) func_Hex(Text),16)
      If %OnceVar% = 1
         Return
   }

   If OnlyOnce = Reset
   {
      OnceVar =
      OnceVar := "OnceVar" func_StrLeft(func_Hex(Title),16) func_StrRight(func_Hex(Title) func_Hex(Text),16)
      %OnceVar% =
      Return
   }

   If (OnlyOnce <> "" AND OnlyOnce <> 1 AND OnlyOnce <> "Reset")
   {
      OnceVar =
      OnceVar := "OnceVar" func_StrLeft(func_Hex(OnlyOnce),16) func_StrRight(func_Hex(OnlyOnce),16)
      If %OnceVar% = 1
         Return
   }

   If (EnableBalloonTips = 0 OR AlwaysMessageBox = 1 OR _MessageBoxTips = 1 OR NoTrayIcon = 1)
   {
      If AlwaysMessageBox <> -1
      {
         Gui %GuiID_activAid%:+OwnDialogs
         If Symbol = Info
            MsgBox,64, %Title%, %Text%, %TimeOut%
         If Symbol = Warning
            MsgBox,48, %Title%, %Text%, %TimeOut%
         If Symbol = Error
            MsgBox,16, %Title%, %Text%, %TimeOut%
      }
   }
   Else
   {
      If Symbol = Info
         Symbol = 1
      If Symbol = Warning
         Symbol = 2
      If Symbol = Error
         Symbol = 3
      TrayTip, %Title%, %Text%,, %Symbol%
      If TimeOut <>
      {
         TimeOut := TimeOut * 1000
         SetTimer, tim_BalloonTipTimeout, %TimeOut%
      }
   }
   If (OnlyOnce <> "" AND OnlyOnce <> 0 AND LoadingFinished = 1)
      %OnceVar% = 1
}

InfoScreen(heading,text,transperency=255,timeout=0,color="$1",fontcolor="000000",fontsize="", width=350, height="",refresh=1000,SplashOptions="")
{
   global

   InfoScreenHeading = %heading%
   InfoScreenText = %text%

   If IsLabel(InfoScreenHeading)
   {
      Gosub %InfoScreenHeading%
      heading = %#Return%
      SetTimer, tim_InfoScreenRefresh, %refresh%, 2
   }
   If IsLabel(InfoScreenText)
   {
      Gosub %InfoScreenText%
      text = %#Return%
      SetTimer, tim_InfoScreenRefresh, %refresh%, 2
   }
   if(transperency>-1) {
      if(color = "$1")
         color := "aaccff"
      if(color = "$2")
         color := "ccffaa"
      if(color = "$3")
         color := "ffccaa"

      If width <>
         width = W%width%
      If height <>
         height = H%height%
      If fontsize <>
         fontsize = FM%fontsize%

      if(transperency<256 AND transperency>0)
         SplashImage, 9: ,C01 Hide CW%color% CT%fontcolor% b1 FS9 ZY6 %width% %height% %fontsize% %SplashOptions%, %text%, %heading%, InfoScreenSplashImage
      Else
         SplashImage, 9: ,C01 Hide CW%color% CT%fontcolor% b FS9 ZY6 %width% %height% %fontsize% %SplashOptions%, %text%, %heading%, InfoScreenSplashImage

      DetectHiddenWindows, On
      WinWait, InfoScreenSplashImage

      WinGetPos,,,Width,Height,InfoScreenSplashImage

      Monitor := func_GetMonitorNumber()
      InfoX := Round(Monitor%Monitor%Left+(Monitor%Monitor%Width-width)/2)
      InfoY := Round(Monitor%Monitor%Top+(Monitor%Monitor%Height-height)/2)
      WinMove, InfoScreenSplashImage,,%InfoX%, %InfoY%
      If InfoX <>
         InfoX = x%InfoX%
      If InfoY <>
         InfoY = y%InfoY%

      If(transperency<255 AND transperency>0)
      {
         WinSet, Transparent, %transperency%, InfoScreenSplashImage
         WinSet, ExStyle, +0x20, InfoScreenSplashImage ; ClickThrough
      }
      Else if(transperency>255 OR transperency<1)
      {
         WinSet, TransColor, %color%, InfoScreenSplashImage
         WinSet, ExStyle, +0x20, InfoScreenSplashImage ; ClickThrough
      }

      SplashImage, 9:Show, ,,,InfoScreenSplashImage
      Sleep,0 ; is required for always displaying the text!!

      if (timeout > 0)
      {
         timeout := timeout * 1000
         SetTimer,tim_InfoScreenOff,%timeout%,2
      }
      else
         SetTimer,tim_InfoScreenOff,10000,2
   }
   else
      GoSub,tim_InfoScreenOff
}

tim_InfoScreenOff:
   SetTimer,tim_InfoScreenOff,Off
   SetTimer,tim_InfoScreenRefresh,Off
   SplashImage, 9:Off
Return

tim_InfoScreenRefresh:
   If IsLabel(InfoScreenHeading)
   {
      Gosub %InfoScreenHeading%
      heading = %#Return%
   }
   If IsLabel(InfoScreenText)
   {
      Gosub %InfoScreenText%
      text = %#Return%
   }
   SplashImage, 9: , , %text%, %heading%, InfoScreenSplashImage
Return

; S-1-1-0 = Everyone
; S-1-5-32-545 = Users
func_SetFileAccessRights( Path, GroupSID="", Rights="" ) {
   If GroupSID =
      GroupSID = S-1-1-0
   Group := Ansi2Oem(LookupAccountSid( GroupSID ))

   If Rights =
      RunWait, CACLS "%Path%" /T /E /C /R %Group%,,Hide
   Else
      RunWait, CACLS "%Path%" /T /E /C /G %Group%:%Rights%,,Hide
   Return ErrorLevel
}

/*
CP_ACP   = 0
CP_OEMCP = 1
CP_MACCP = 2
CP_UTF7  = 65000
CP_UTF8  = 65001
*/

Ansi2Oem( sString ) {
   Ansi2Unicode(sString, wString, 0)
   Unicode2Ansi(wString, zString, 1)
   Return zString
}

Oem2Ansi( zString ) {
   Ansi2Unicode(zString, wString, 1)
   Unicode2Ansi(wString, sString, 0)
   Return sString
}

Ansi2UTF8( sString ) {
   Ansi2Unicode(sString, wString, 0)
   Unicode2Ansi(wString, zString, 65001)
   Return zString
}

UTF82Ansi( zString ) {
   Ansi2Unicode(zString, wString, 65001)
   Unicode2Ansi(wString, sString, 0)
   Return sString
}

Ansi2Unicode( ByRef sString, ByRef wString, CP = 0 ) {
     nSize := DllCall("MultiByteToWideChar"
      , "Uint", CP
      , "Uint", 0
      , "Uint", &sString
      , "int",  -1
      , "Uint", 0
      , "int",  0)

   VarSetCapacity(wString, nSize * 2)

   DllCall("MultiByteToWideChar"
      , "Uint", CP
      , "Uint", 0
      , "Uint", &sString
      , "int",  -1
      , "Uint", &wString
      , "int",  nSize)
}

Unicode2Ansi( ByRef wString, ByRef sString, CP = 0 ) {
     nSize := DllCall("WideCharToMultiByte"
      , "Uint", CP
      , "Uint", 0
      , "Uint", &wString
      , "int",  -1
      , "Uint", 0
      , "int",  0
      , "Uint", 0
      , "Uint", 0)

   VarSetCapacity(sString, nSize)

   DllCall("WideCharToMultiByte"
      , "Uint", CP
      , "Uint", 0
      , "Uint", &wString
      , "int",  -1
      , "str",  sString
      , "int",  nSize
      , "Uint", 0
      , "Uint", 0)
}

LookupAccountName( sName, sSystem = "" ) {
   DllCall("advapi32\LookupAccountNameA", "str", sSystem, "str", sName, "Uint", 0, "UintP", nSizeSID, "Uint", 0, "UintP", nSizeRDN, "UintP", eUser)
   VarSetCapacity(SID, nSizeSID, 0)
   VarSetCapacity(RDN, nSizeRDN, 0)
   DllCall("advapi32\LookupAccountNameA", "str", sSystem, "str", sName, "str", SID, "UintP", nSizeSID, "str", RDN, "UintP", nSizeRDN, "UintP", eUser)

   DllCall("advapi32\ConvertSidToStringSidA", "str", SID, "UintP", pString)
   VarSetCapacity(sSid, DllCall("lstrlen", "Uint", pString))
   DllCall("lstrcpy", "str", sSid, "Uint", pString)
   DllCall("LocalFree", "Uint", pString)
   Return sSid
}

LookupAccountSid( sSid, sSystem = "" ) {
   DllCall("advapi32\ConvertStringSidToSidA", "str", sSid, "UintP", pSid)

   DllCall("advapi32\LookupAccountSidA", "str", sSystem, "Uint", pSid, "Uint", 0, "UintP", nSizeNM, "Uint", 0, "UintP", nSizeRD, "UintP", eUser)
   VarSetCapacity(sName, nSizeNM, 0)
   VarSetCapacity(sRDmn, nSizeRD, 0)
   DllCall("advapi32\LookupAccountSidA", "str", sSystem, "Uint", pSid, "str", sName, "UintP", nSizeNM, "str", sRDmn, "UintP", nSizeRD, "UintP", eUser)

   DllCall("LocalFree", "Uint", pSid)
   Return sName
}

func_FormatTime( DateTime, Format="" ) {
   global lng_Day,lng_Days,lng_Hour,lng_Hours,lng_Minute,lng_Minutes,lng_Year,lng_Years,lng_Month,lng_Months,lng_Second,lng_Seconds
   If Format contains duration
   {
      If Format contains seconds
         WantSeconds = 60
      Else
         WantSeconds = 1
      AutoTrim, Off
;      Years := Floor( DateTime/(WantSeconds*60*24*365) )
;      Days := Floor( (DateTime-(Years*365))/(WantSeconds*60*24) )
;      Hours := Floor( (DateTime-(Years*365+Days*24*60*WantSeconds))/60 )
;      Minutes := Floor( DateTime-(Years*365+Days*24*60*WantSeconds+Hours*60*WantSeconds) )
;      Seconds := Floor( DateTime-(Years*365+Days*24*60*WantSeconds+Hours*60*WantSeconds+Minutes*60) )

      Years    := Floor( DateTime/WantSeconds/60/24/12/365 )
      Months   := Floor( DateTime/WantSeconds/60/24/12-(Years*365) )
      Days     := Floor( DateTime/WantSeconds/60/24-(Years*365*12+Months*12) )
      Hours   := Floor( DateTime/WantSeconds/60-(Years*365*12*24+Months*12*24+Days*24) )
      Minutes := Floor( DateTime/WantSeconds-(Years*365*12*24*60+Months*12*24*60+Days*24*60+Hours*60) )
      Seconds := Floor( DateTime-(Years*365*12*24*60*60+Months*12*24*60*60+Days*24*60*60+Hours*60*60+Minutes*60) )
      If (Seconds = 0 OR InStr(Format, "precise"))
         Seconds := Round( DateTime-(Years*365*12*24*60*60+Months*12*24*60*60+Days*24*60*60+Hours*60*60+Minutes*60),3 )


      If Years = 0
         Years =
      Else If Years = 1
         Years = 1 %lng_Year%,%A_Space%
      Else
         Years = %Years% %lng_Years%,%A_Space%

      If (Months = 0 AND Years = "")
         Months =
      Else If Months = 1
         Months = 1 %lng_Month%,%A_Space%
      Else
         Months = %Months% %lng_Months%,%A_Space%

      If (Days = 0 AND Months = "" AND Years = "")
         Days =
      Else If Days = 1
         Days = 1 %lng_Day%,%A_Space%
      Else
         Days = %Days% %lng_Days%,%A_Space%

      If (Hours = 0 AND Days = "" AND Months = "" AND Years = "")
         Hours =
      Else If Hours = 1
         Hours = 1 %lng_Hour%,%A_Space%
      Else
         Hours = %Hours% %lng_Hours%,%A_Space%

      If (Minutes = 0 AND Hours = "" AND Days = "" AND Months = "" AND Years = "" AND WantSeconds = 60)
         Minutes =
      Else If Minutes = 1
         Minutes = 1 %lng_Minute%
      Else
         Minutes = %Minutes% %lng_Minutes%

      If Seconds = 1
         Seconds = 1 %lng_Second%
      Else
         Seconds = %Seconds% %lng_Seconds%

      If WantSeconds = 60
      {
         If Minutes <>
            Minutes = %Minutes%,%A_Space%
         DateTime = %Years%%Months%%Days%%Hours%%Minutes%%Seconds%
      }
      Else
         DateTime = %Years%%Months%%Days%%Hours%%Minutes%
   }
   Else
   {
      FormatTime, DateTime, %DateTime% R, %Format%

   }
   Return %DateTime%
}

func_GetDateFromSeconds( Seconds )
{
   Year    := func_StrRight("0000" Floor( Seconds/60/60/24/12/365 ), 4)
   Month   := func_StrRight("00"   Floor( Seconds/60/60/24/12-(Year*365) ), 2)
   Day     := func_StrRight("00"   Floor( Seconds/60/60/24-(Year*365*12+Month*12) ), 2)
   Hours   := func_StrRight("00"   Floor( Seconds/60/60-(Year*365*12*24+Month*12*24+Day*24) ), 2)
   Minutes := func_StrRight("00"   Floor( Seconds/60-(Year*365*12*24*60+Month*12*24*60+Day*24*60+Hours*60) ), 2)
   Seconds := func_StrRight("00"   Floor( Seconds-(Year*365*12*24*60*60+Month*12*24*60*60+Day*24*60*60+Hours*60*60+Minutes*60) ), 2)
   Year    := func_StrRight("0000" Year+1753, 4)
   Month   := func_StrRight("00" Month+1, 2)
   Day     := func_StrRight("00" Day+1, 2)
   Result = %Year%%Month%%Day%%Hours%%Minutes%%Seconds%
   Return %Result%
}

func_GetSecondsFromDate( Date )
{
   Date2 = 17530101000000
   EnvSub, Date, %Date2%, Seconds
   Return %Date%
}
func_HotkeyAddGuiControl( Text, Variable, Options, SingleKey="", ButtonOptions="", Hidden="" ) {
   global

   IfNotInString, ButtonOptions, h
      ButtonOptions = %ButtonOptions% H20
   IfNotInString, ButtonOptions, w
      ButtonOptions = %ButtonOptions% W300
   IfNotInString, ButtonOptions, x
      ButtonOptions = %ButtonOptions% X+5
   IfNotInString, ButtonOptions, y
      ButtonOptions = %ButtonOptions% YP-3

   gsub_Hotkey =
   IfNotInstring, Options, sub_
      gsub_Hotkey = gsub_HotkeyButton

   If SingleKey <>
      SingleHotkey_%Variable% = 1
   Else
      SingleHotkey_%Variable% =
   If SingleKey = 2
      SingleHotkey_%Variable% = 2

   If Text =
   {
      If Hidden =
         Gui, Add, Button, -Wrap +0x100 +0x8000 H20 %Options% vHotkey_%Variable% %gsub_Hotkey%, % "  " func_HotkeyDecompose(Hotkey_%Variable%, 0 )
      func_CreateListOfHotkeys( Hotkey_%Variable%, Function " (" Variable ")", Function, Hotkey_%Variable%_sub )
   }
   Else
   {
      If Hidden =
      {
         Gui, Add, Text, %Options% vHotkeyText_%Variable%, %Text%:
         Gui, Add, Button, -Wrap +0x100 +0x8000 %ButtonOptions% vHotkey_%Variable% %gsub_Hotkey%, % "  " func_HotkeyDecompose(Hotkey_%Variable%, 0 )
      }
      Hotkey_ExtensionText[%Variable%] := Text
      func_CreateListOfHotkeys( Hotkey_%Variable%, Text, Function, Hotkey_%Variable%_sub )
   }
   Debug("GUI", A_LineNumber, A_LineFile, "Hotkey control added: " Text ", " Variable ", " Options ", " SingleKey ", " ButtonOptions )
}

func_CreateListOfHotkeys( Hotkey, Text, Extension, SubRoutine="", SubCategory="" ) {
   Global
   CreateListOfHotkeys_Hotkey := Hotkey
   CreateListOfHotkeys_Text:= Text
   CreateListOfHotkeys_Extension  := Extension
   CreateListOfHotkeys_Subroutine := Subroutine
   CreateListOfHotkeys_SubCategory := SubCategory

   PlainHotkey = %Hotkey%

   IfInString, Hotkey, HOTSTRING`:
   {
      StringTrimLeft, Hotkey, Hotkey, 10
      StringSplit, Hotkey, Hotkey, :
      Hotkey = %Hotkey3%
      HotkeyIndent := func_StrLeft( " " Hotkey A_SpaceLine, 40 )
   }
   Else
      HotkeyIndent := func_StrLeft( " " func_HotkeyDecompose(Hotkey) A_SpaceLine, 40 )

   If (Readme_Hotkeys_LastExt <> Extension AND CreateHotKeyList = 1)
   {
      Readme_Hotkeys := Readme_Hotkeys "`r`n_______________________________________________________________________________________________________________________________`r`n " Extension "`r`n"
      Readme_Hotkeys_LastExt := Extension
      Menu, SubContextMenu%Extension%#, Add
      Menu, SubContextMenu%Extension%#, DeleteAll
   }
   If Text = %lng_Hotkey%
   {
      Text := ExtensionMenuName[%Extension%]
      StringSplit, Text, Text, %A_Tab%
      Text := Text1
   }
   StringReplace, Text, Text, `n, %A_Space%, A

   Hotkey = %Hotkey%
   SubCategoryVar := func_StrClean(SubCategory,"",0,"_")
   MenuHotkey%Extension%#%SubCategoryVar%++
   MenuHotkey := MenuHotkey%Extension%#%SubCategoryVar%
   MenuHotkey%Extension%%MenuHotkey%#%SubCategoryVar% := PlainHotkey
   IfInString, PlainHotkey, HOTSTRING`:
      MenuSub%Extension%%MenuHotkey%#%SubCategoryVar% = %Text%
   Else
      MenuSub%Extension%%MenuHotkey%#%SubCategoryVar% = %SubRoutine%

   StringReplace, Text, Text, __NewLine__, % "  ", A
   MenuText := func_StrLeft(Text,60)

   If (MenuSub%Extension%%MenuHotkey%#%SubCategoryVar% <> "" AND MenuText <> "")
   {
      If MenuSub%Extension%%MenuHotkey%#%SubCategoryVar% = <SEPARATOR>
      {
         Menu, SubContextMenu%Extension%#%SubCategoryVar%, Add
         If CreateHotKeyList = 1
            Readme_Hotkeys := Readme_Hotkeys "`r`n"
      }
      Else
         Menu, SubContextMenu%Extension%#%SubCategoryVar%, Add, % MenuText "`t" Hotkey, sub_MainContextMenu

      IfNotInString, Readme_Hotkeys_LastSubMenu, #%SubCategoryVar%#
      {
         If SubCategory <>
         {
            Menu, SubContextMenu%Extension%#, Add, %SubCategory%, :SubContextMenu%Extension%#%SubCategoryVar%
            MenuHotkey%Extension%#++
         }
      }
      If (Readme_Hotkeys_PrevLastExt <> Extension AND Extension <> "")
         Menu, MainContextMenu, Add, %Extension%, :SubContextMenu%Extension%#
   }
   Else
   {
      MenuHotkey%Extension%#%SubCategoryVar%--
      MenuHotkey := MenuHotkey%Extension%#%SubCategoryVar%
   }

   If SubCategory <>
      Text = {%SubCategory%}: %Text%
   If Hotkey  <>
   {
      If (StrLen(Text) > 84)
         Text := func_StrLeft(Text,42) "..." func_StrRight(Text,42)
      If CreateHotKeyList = 1
         Readme_Hotkeys := Readme_Hotkeys "`r`n" HotkeyIndent Text
   }

   If MenuSub%Extension%%MenuHotkey%#%SubCategoryVar% <>
   {
      Readme_Hotkeys_LastExt = %Extension%
      Readme_Hotkeys_PrevLastExt = %Extension%
      StringReplace, Readme_Hotkeys_LastSubMenu, Readme_Hotkeys_LastSubMenu, #%SubCategoryVar%#
      Readme_Hotkeys_LastSubMenu = %Readme_Hotkeys_LastSubMenu%#%SubCategoryVar%#
   }

   ; Duplikate
   Hotkey_OldDupMessage := Extension "`t" func_HotkeyDecompose(PlainHotkey,1) "`t" SubRoutine "`n"
   Hotkey_NewDupMessage := Extension "`t" func_HotkeyDecompose(PlainHotkey,1) "`t" MenuText "`n"
   StringReplace, HotKey_AllDuplicates, HotKey_AllDuplicates, %Hotkey_OldDupMessage%, %Hotkey_NewDupMessage%`n
   Hotkey_OldDupMessage := Extension "`t*" func_HotkeyDecompose(PlainHotkey,1) "`t" SubRoutine "`n"
   Hotkey_NewDupMessage := Extension "`t*" func_HotkeyDecompose(PlainHotkey,1) "`t" MenuText "`n"
   StringReplace, HotKey_AllDuplicates, HotKey_AllDuplicates, %Hotkey_OldDupMessage%, %Hotkey_NewDupMessage%`n

   CallHook("CreateListOfHotkeys")
   CreateListOfHotkeys_Hotkey =
   CreateListOfHotkeys_SubCategory =

   Debug("GUI", A_LineNumber, A_LineFile, "added to Hotkeylist: " Hotkey ", " Text ", " Extension ", " SubRoutine ", " SubCategory )
}

sub_MainContextMenu:
   StringReplace, Extension, A_ThisMenu, SubContextMenu,
   StringSplit, Extension, Extension, #
   Extension = %Extension1%
   SubCategory = %Extension2%
   WinWaitActive, ahk_id %WinIDbeforeContextMenu%,, 1
   If ErrorLevel
      WinActivate, ahk_id %WinIDbeforeContextMenu%
   Sleep,50

;   msgbox, % A_ThisMenu "`n" A_ThisMenuItemPos ":" A_ThisMenuItem "`n" MenuHotkey%Extension%%A_ThisMenuItemPos%#%SubCategory%  "`n" MenuSub%Extension%%A_ThisMenuItemPos%#%SubCategory%
   activAid_ThisHotkey := MenuHotkey%Extension%%A_ThisMenuItemPos%#%SubCategory%
   IfInString, MenuHotkey%Extension%%A_ThisMenuItemPos%#%SubCategory%, HOTSTRING`:
   {
      StringReplace, activAid_ThisHotkey,activAid_ThisHotkey,HOTSTRING`:,
      IfInString, MenuSub%Extension%%A_ThisMenuItemPos%#%SubCategory%, __NewLine__
         Gosub, %activAid_ThisHotkey%
      Else
      {
         StringSplit, HotStringOptions, activAid_ThisHotkey, :
         IfInString, HotStringOptions2, R
            SendRaw, % MenuSub%Extension%%A_ThisMenuItemPos%#%SubCategory%
         Else
         {
            StringReplace, HotStringText, MenuSub%Extension%%A_ThisMenuItemPos%#%SubCategory%, ``r, `r, All
            StringReplace, HotstringText, HotstringText, ``n, `n, All
            StringReplace, HotstringText, HotstringText, ``t, %A_Tab%, All
            StringReplace, HotstringText, HotstringText, ```;, `;, All
            StringReplace, HotstringText, HotstringText, ```:, `:, All
            Send, %HotStringText%
         }
      }

   }
   Else
   {
      CalledFrom = %A_ThisLabel%
      Gosub, % MenuSub%Extension%%A_ThisMenuItemPos%#%SubCategory%
      CalledFrom =
   }
   activAid_ThisHotkey =
Return

func_HotkeyRead( OutputVar, Filename, Section, Key, SubRoutine, DefaultValue, Prefix="", Classes="", Options="" ) {
   global
   If Classes =
      Classes = ,

   If (func_StrLeft(Classes,7)="Hotkey_")
   {
      If %Classes% =
         Classes = ,
   }

   IniRead, Hotkey_%OutputVar%, %Filename%, %Section%, %Key%

   If (func_StrLeft(Hotkey_%OutputVar%,1) = "$")
      StringTrimLeft, Hotkey_%OutputVar%,Hotkey_%OutputVar%, 1

   if Hotkey_%OutputVar% = ERROR
      Hotkey_%OutputVar% = %DefaultValue%

   Hotkey_%OutputVar% := func_SortHotkeyModifiers( Hotkey_%OutputVar% )

   HotkeyClasses_%OutputVar% = %Classes%

   IfInString, Hotkey_%OutputVar%, % " & "
   {
      StringReplace, Prefix, Prefix, $,,
      StringReplace, Prefix, Prefix, ~,,
      IfNotInstring, Hotkey_%OutputVar%, ~
         Prefix = %Prefix%~
   }

   HotkeyPrefix_%OutputVar% = %Prefix%

   If SubRoutine in AltTab,ShiftAltTab,AltTabAndMenu,AltTabMenuDismiss
   {
      If (!InStr(Hotkey_%OutputVar%,"<") AND !InStr(Hotkey_%OutputVar%,">") )
      {
         StringReplace, Hotkey_%OutputVar%, Hotkey_%OutputVar%, !, <!
         StringReplace, Hotkey_%OutputVar%, Hotkey_%OutputVar%, ^, <^
         StringReplace, Hotkey_%OutputVar%, Hotkey_%OutputVar%, #, <#
         StringReplace, Hotkey_%OutputVar%, Hotkey_%OutputVar%, +, <+
      }
   }

   If Hotkey_%OutputVar% <>
   {
      Loop, Parse, HotkeyClasses_%OutputVar%, `,
      {
         LoopField = %A_LoopField%
         If (func_StrLeft(LoopField,7)="Hotkey_")
         {
            If %LoopField% =
               LoopField =
         }
         Else If (!InStr(LoopField, "ahk_") AND LoopField <> "")
            LoopField = ahk_class %LoopField%

         HotkeyDup = 0
         If (InStr(Hotkey_AllHotkeys, "<" Hotkey_%OutputVar% " " LoopField ">"))
            HotkeyDup=1

         If HotkeyDup = 1
         {
            Loop, Parse, Hotkey_Extensions, |
            {
               FunctionTmp := A_LoopField
               If (Hotkey_Extension[%FunctionTmp%] = Hotkey_%OutputVar%)
                  break
               FunctionTmp =
               FunctionTmp1 =
               FunctionTmp2 =
            }
            StringSplit, FunctionTmp, FunctionTmp, $

            Hotkey_DupMessage := FunctionTmp1 "`t" func_HotkeyDecompose(Hotkey_%OutputVar%,1) "`t" FunctionTmp2
            IfNotInString, HotKey_AllDuplicates, %Hotkey_DupMessage%`n
               HotKey_AllDuplicates := HotKey_AllDuplicates Hotkey_DupMessage "`n"
            Hotkey_DupMessage := Section "`t*" func_HotkeyDecompose(Hotkey_%OutputVar%,1) "`t" Subroutine
            IfNotInString, HotKey_AllDuplicates, %Hotkey_DupMessage%`n
               HotKey_AllDuplicates := HotKey_AllDuplicates Hotkey_DupMessage "`n"
            Hotkey_DupMessage =

            HotkeyOutputVar := Hotkey_%OutputVar%
            Hotkey_AllHotkeys := Hotkey_AllHotkeys "<" HotkeyOutputVar " " LoopField ">"
            Hotkey_Extension[%Section%$%OutputVar%] := Hotkey_%OutputVar%
            Hotkey_Extensions := Hotkey_Extensions Section "$" OutputVar "|"
            Hotkey_%OutputVar%_new := Hotkey_%OutputVar%
         }
         Else
         {
            Hotkey, IfWinActive, %LoopField%
            Hotkey, % HotkeyPrefix_%OutputVar% Hotkey_%OutputVar%, %SubRoutine%, Off UseErrorLevel

            If ErrorLevel = 0
            {
               HotkeyOutputVar := Hotkey_%OutputVar%
               Hotkey_AllHotkeys := Hotkey_AllHotkeys "<" HotkeyOutputVar " " LoopField ">"
               Hotkey_Extension[%Section%$%OutputVar%] := Hotkey_%OutputVar%
               Hotkey_Extensions := Hotkey_Extensions Section "$" OutputVar "|"
               Hotkey_%OutputVar%_new := Hotkey_%OutputVar%
            }
            Else
               Hotkey_%OutputVar% =
         }

         If HotkeyClasses_%OutputVar% = ,
            Break
      }
      Hotkey, IfWinActive
   }

   Hotkey_%OutputVar%_Sub := SubRoutine
   Hotkey_%OutputVar%_old := Hotkey_%OutputVar%

   Debug("Settings", A_LineNumber, A_LineFile, "func_HotkeyRead: " Hotkey_%OutputVar% " -> " OutputVar ", " Filename ", " Section ", " Key ", " SubRoutine ", " DefaultValue ", " Prefix ", " Classes ", " Options )
}

func_HotkeyWrite( OutputVar, Filename, Section, Key, SubRoutine="", Prefix="", Classes="" ) {
   global

   If Prefix <>
      HotkeyPrefix_%OutputVar% = %Prefix%

   IfInString, Hotkey_%OutputVar%, % " & "
   {
      StringReplace, Prefix, Prefix, $,,
      StringReplace, Prefix, Prefix, ~,,
      IfNotInstring, Hotkey_%OutputVar%, ~
         Prefix = %Prefix%~
   }

   If SubRoutine in AltTab,ShiftAltTab,AltTabAndMenu,AltTabMenuDismiss
   {
      If (!InStr(Hotkey_%OutputVar%,"<") AND !InStr(Hotkey_%OutputVar%,">") )
      {
         StringReplace, Hotkey_%OutputVar%, Hotkey_%OutputVar%, !, <!
         StringReplace, Hotkey_%OutputVar%, Hotkey_%OutputVar%, ^, <^
         StringReplace, Hotkey_%OutputVar%, Hotkey_%OutputVar%, #, <#
         StringReplace, Hotkey_%OutputVar%, Hotkey_%OutputVar%, +, <+
      }
   }

   If Classes <>
   {
      If (func_StrLeft(Classes,7)="Hotkey_")
      {
         If %Classes% =
            Classes = ,
      }
      HotkeyClasses_%OutputVar% = %Classes%
   }

   Loop, Parse, HotkeyClasses_%OutputVar%, `,
   {
      LoopField = %A_LoopField%
      If (func_StrLeft(LoopField,7)="Hotkey_")
      {
         If %LoopField% =
            LoopField =
      }
      Else If (!InStr(LoopField, "ahk_") AND LoopField <> "")
         LoopField = ahk_class %LoopField%
      Hotkey, IfWinActive, %LoopField%

      If Hotkey_%OutputVar%_old <>
      {
         Hotkey, % HotkeyPrefix_%OutputVar% Hotkey_%OutputVar%_old, Off, UseErrorLevel
      }

      If ( Hotkey_%OutputVar%_new <> Hotkey_%OutputVar% OR Hotkey_%OutputVar%_del = 1)
      {
         If Hotkey_%OutputVar%_del = 1
            Hotkey_%OutputVar% =
         Else
            Hotkey_%OutputVar% := Hotkey_%OutputVar%_new
         Hotkey_%OutputVar%_del =
         HotkeyOutputVarOld := Hotkey_%OutputVar%_old
         StringReplace, Hotkey_AllHotkeys, Hotkey_AllHotkeys, % "<" HotkeyOutputVarOld " " LoopField ">", , A
         Hotkey_Extension[%Section%$%OutputVar%] := Hotkey_%OutputVar%
         StringReplace, Hotkey_Extensions, Hotkey_Extensions, % Section "$" OutputVar "|", , A
      }

      Hotkey_%OutputVar% := func_SortHotkeyModifiers( Hotkey_%OutputVar% )

      IniWrite, % Hotkey_%OutputVar%, %Filename%, %Section%, %Key%

      if Hotkey_%OutputVar% <>
      {
         If SubRoutine <>
            Hotkey_%OutputVar%_Sub = %SubRoutine%
         Hotkey, % HotkeyPrefix_%OutputVar% Hotkey_%OutputVar%, % Hotkey_%OutputVar%_Sub, UseErrorLevel
         HotkeyOutputVarOld := Hotkey_%OutputVar%_old
         HotkeyOutputVar := Hotkey_%OutputVar%
         StringReplace, Hotkey_AllHotkeys, Hotkey_AllHotkeys, % "<" HotkeyOutputVarOld " " A_LoopField ">", , A
         Hotkey_AllHotkeys := Hotkey_AllHotkeys "<" HotkeyOutputVar " " LoopField ">"
         Hotkey_Extension[%Section%$%OutputVar%] := Hotkey_%OutputVar%
         Hotkey_Extensions := Hotkey_Extensions Section "$" OutputVar "|"
      }

      Hotkey_%OutputVar%_old := Hotkey_%OutputVar%
   }
   Hotkey, IfWinActive
}

func_HotkeyEnable( Variable ) {
   global

   If Hotkey_%Variable% <>
   {
      Loop, Parse, HotkeyClasses_%Variable%, `,
      {
         LoopField = %A_LoopField%
         If (func_StrLeft(LoopField,7)="Hotkey_")
         {
            If %LoopField% =
               LoopField =
         }
         Else If (!InStr(LoopField, "ahk_") AND LoopField <> "")
            LoopField = ahk_class %LoopField%
         Hotkey, IfWinActive, %LoopField%
         Hotkey, % HotkeyPrefix_%Variable% Hotkey_%Variable%, On, UseErrorLevel
      }
      Hotkey, IfWinActive
   }
}

func_HotkeyDisable( Variable ) {
   global

   If Hotkey_%Variable% <>
   {
      Loop, Parse, HotkeyClasses_%Variable%, `,
      {
         LoopField = %A_LoopField%
         If (func_StrLeft(LoopField,7)="Hotkey_")
         {
            If %LoopField% =
               LoopField =
         }
         Else If (!InStr(LoopField, "ahk_") AND LoopField <> "")
            LoopField = ahk_class %LoopField%
         Hotkey, IfWinActive, %LoopField%
         Hotkey, % HotkeyPrefix_%Variable% Hotkey_%Variable%, Off, UseErrorLevel
      }
      Hotkey, IfWinActive
   }
}

func_HotkeyGetNumber( Array, Amount, Prefix="", Hotkey="" ) {
   global

   IfInString, Hotkey, % " & "
   {
      StringReplace, Prefix, Prefix, $,,
      StringReplace, Prefix, Prefix, ~,,
      IfNotInstring, Hotkey, ~
         Prefix = %Prefix%~
   }

   StringLen, PrefixLen, Prefix
   If Hotkey =
      StringTrimLeft, ThisHotkey, A_ThisHotkey, %PrefixLen%
   Else
      ThisHotkey = %Hotkey%

   Loop, %Amount%
   {
      If ( Hotkey_%Array%%A_Index% = ThisHotkey )
         Return %A_Index%
   }
}

func_HotkeyGetVar( HotkeyArray, Amount, GetArray, CustomHotkey="",PrefixArray="" ) {
   global

   Loop, %Amount%
   {
      Prefix = %PrefixArray%
      IfInString, Hotkey_%HotkeyArray%%A_Index%, % " & "
      {
         StringReplace, Prefix, Prefix, $,,
         StringReplace, Prefix, Prefix, ~,,
         IfNotInstring, Hotkey_%HotkeyArray%%A_Index%, ~
            Prefix = %Prefix%~
      }

      StringLen, PrefixLen, Prefix
      StringTrimLeft, ThisHotkey, A_ThisHotkey, %PrefixLen%

      If ( Hotkey_%HotkeyArray%%A_Index% = ThisHotkey AND CustomHotkey = "")
         Return % %GetArray%%A_Index%
      Else If ( Hotkey_%HotkeyArray%%A_Index% = CustomHotkey AND CustomHotkey <> "")
         Return % %GetArray%%A_Index%
   }
}

sub_HotkeyButton:
;   Critical
   Getkeystate,InputMode,Alt
   If InputMode = U
      Getkeystate,InputMode,Shift
   If InputMode = U
      Getkeystate,InputMode,Ctrl

   Gosub, sub_temporarySuspend

   If (PreWinStateD <> 2)
   {
      StringReplace, VarHK, A_GuiControl, Button,

      StringReplace, VarHKCL, A_GuiControl, Button,CapsLock
      StringReplace, VarHKW, A_GuiControl, Button,Win
      Gui,%GuiID_activAid%:+Disabled

      If A_OSversion = WIN_NT4
         StringReplace, Hotkey_DupMessage, Hotkey_DupMessage, , --, All

      WinGetPos, MainGuiX, MainGuiY, MainGuiW, , ahk_id %MainGuiID%

      GuiSplashX := MainGuiX+(MainGuiW-400)/2-BorderHeight*2
      GuiSplashY := MainGuiY+225

      If InputMode = D
            SplashImage,,b1 x%GuiSplashX% y%GuiSplashY% cwFFFF80 FS9 WS700 w400, %Hotkey_DupMessage%%lng_GetInputDevice%
      Else
      {
         If Single%VarHK% = 1
            SplashImage,,b1 x%GuiSplashX% y%GuiSplashY% cwFFFF80 FS9 WS700 w400, % Hotkey_DupMessage lng_GetSingleKey lng_GetKeySuspendStatus%A_IsSuspended%
         Else If Single%VarHK% = 2
            SplashImage,,b1 x%GuiSplashX% y%GuiSplashY% cwFFFF80 FS9 WS700 w400, % Hotkey_DupMessage lng_GetSingleKey
         Else
            SplashImage,,b1 x%GuiSplashX% y%GuiSplashY% cwFFFF80 FS9 WS700 w400, % Hotkey_DupMessage lng_GetKey lng_GetKeySuspendStatus%A_IsSuspended%
      }
   }
   Hotkey_DupMessage =
   DeviceInput =
   GetKey =

   If InputMode = D
   {
      Loop
      {
         DeviceStates =
         Loop, Parse, InputFromDevices, {, }
         {
            If A_LoopField =
               continue
            GetKeyState, GetInput, %A_LoopField%
            DeviceStates = %DeviceStates%%GetInput%
            If (GetInput <> "U" AND GetInput <> "")
            {
               IfNotInString, DeviceInput, %A_LoopField%
               {
                  If DeviceInput =
                     DeviceInput = %DeviceInput%%A_LoopField%
                  Else
                     DeviceInput = %DeviceInput% & %A_LoopField%
               }
            }
            GetKeyState, GetInputESC, ESC
            GetKeyState, GetInputDel, Delete
            GetKeyState, GetInputBsp, Backspace
            GetKeyState, GetInputUp, Up
            GetKeyState, GetInputDown, Down
            If (GetInputUp = "D")
            {
               IfNotInString, DeviceInput, WheelUp
               {
                  If DeviceInput =
                     DeviceInput = %DeviceInput%WheelUp
                  Else
                     DeviceInput = %DeviceInput% & WheelUp
               }
            }
            If (GetInputDown = "D")
            {
               IfNotInString, DeviceInput, WheelDown
               {
                  If DeviceInput =
                     DeviceInput = %DeviceInput%WheelDown
                  Else
                     DeviceInput = %DeviceInput% & WheelDown
               }
            }
            If (GetInputDel = "D" OR GetInputBsp = "D")
            {
               DeviceInput =
               GetKey = Delete
               Break
            }
            If GetInputESC = D
            {
               DeviceInput =
               GetKey = Escape
               Break
            }
        }
        If (GetKey <> "" OR (DeviceInput <> "" AND !InStr(DeviceStates,"D")))
           Break
      }
   }
   Else
   {
      SetTimer, tim_HotkeyWaitToggleSuspend, 10
      If Single%VarHK% = 2
         Input,GetKey, L1 * M, %InputEscapeKeys%{LCtrl}{RCtrl}{LShift}{RShift}{CapsLock}
      Else
         Input,GetKey, L1 * M, %InputEscapeKeys%
      SetTimer, tim_HotkeyWaitToggleSuspend, Off
   }
   SplashImage, Off
   Gui -Disabled

   Getkeystate,GetKeyCtrl,Ctrl
   Getkeystate,GetKeyAlt,Alt
   Getkeystate,GetKeyShift,Shift
   Getkeystate,GetKeyLWin,LWin,
   Getkeystate,GetKeyRWin,RWin,
   Getkeystate,GetKeyCapsLock,CapsLock
   Getkeystate,GetKeyLCtrl,LCtrl
   Getkeystate,GetKeyRAlt,RAlt

   tmpGetKey := GetKey
   tmpErrorLevel := ErrorLevel
   If A_IsSuspended = 1
      Gosub, sub_temporarySuspend
   Critical, Off
   GetKey := tmpGetKey
   ErrorLevel := tmpErrorLevel

   If Asc(GetKey) < 32
      GetKey := Chr(Asc(GetKey)+96)

   If ErrorLevel contains Endkey:
      StringReplace, GetKey, ErrorLevel, Endkey:,

   If (GetKey = Chr(34) And Lng = 07)
      GetKey = 2
   If (GetKey = "AKUT" OR GetKey = "ACUTE" OR GetKey = "ACCENT")
      GetKey = 
   If (GetKey = "ZIRKUMFLEX" OR GetKey = "ZIRCUMFLEX" OR GetKey = "CIRCUMFLEX" OR GetKey = "CIRCUMFLEX ACCENT" OR)
      GetKey = ^

   If Lng=07
      GetKey := func_StrTranslate(Getkey,"!$%&/()=?*':;","134567890+#.,")

   If GetKey in NumpadDel,NumpadIns,NumpadClear,NumpadUp,NumpadDown,NumpadLeft,NumpadRight,NumpadHome,NumpadEnd,NumpadPgUp,NumpadPgDn
      GetKeyShift = U

   If (InputMode = D AND InStr(Getkey,"Joy"))
   {
      GetKeyCtrl = U
      GetKeyLCtrl = U
      GetKeyShift = U
   }

   If (DeviceInput <> "" AND InputMode = "D")
   {
      StringTrimRight, GetKey, GetKey, 1
      GetKey = %GetKey%%DeviceInput%
   }

   InputMode =

   If Single%VarHK% <> 1
   {
      If GetKeyShift = D
         GetKey = +%GetKey%
      If (GetKeyLCtrl = "D" AND GetKeyRAlt = "D")
         GetKey = <^>!%GetKey%
      Else
      {
         If GetKeyAlt = D
            GetKey = !%GetKey%
         If GetKeyCtrl = D
            GetKey = ^%GetKey%
      }
      If (GetKeyLWin = "D" OR PreWinState = "D")
         GetKey = #%GetKey%
      If (GetKeyRWin = "D")
         GetKey = >#%GetKey%
      If GetKeyCapsLock = D
         GetKey = ~CapsLock & %GetKey%
   }

   If (PreWinStateD >= 1 AND GetKey = "#" Hotkey_rmp_SimWin)
   {
      PreWinStateD = 2
      goto, sub_HotkeyButton
   }

   If GetKey = LButton
      GetKey = Escape


   If (((GetKey = "#" Hotkey_rmp_SimWin AND Hotkey_rmp_SimWin <> "") OR GetKey = Hotkey_rmp_SimWin ) AND Enable_RemapKeys = 1)
   {
      PreWinState = D
      PreWinStateD = 1
      Hotkey_DupMessage = %lng_rmp_HotkeyButtonMsg%`n`n
      goto, sub_HotkeyButton
   }
   Gosub, sub_HotkeyParseGetKey
Return

; Parameter: VarHK, Getkey
sub_HotkeyParseGetKey:
   PreWinState =
   PreWinStateD =

   If (GetKey = "Escape" OR GetKey = "Enter")
   {
      SplashImage, Off
      Gui,-Disabled
      Return
   }

   If (Getkey = "Backspace" OR Getkey = "Delete")
   {
      Getkey =
      %VarHK%_del = 1
   }
;   msgbox, %Hotkey_AllNewHotkeys%
   Hotkey_AllHotkeys_tmp := Hotkey_AllNewHotkeys ; Hotkey_AllHotkeys
   StringReplace, Hotkey_AllHotkeys_tmp, Hotkey_AllHotkeys_tmp, <%Hotkey_TempSuspend% >,
   StringReplace, OutputVar, VarHK, Hotkey_
   HotkeyDup = 0
;   msgbox, % HotkeyClasses_%OutputVar%

   GetKey := func_SortHotkeyModifiers(GetKey)

   If (InStr(Hotkey_WindowsHotkeys, "<" Getkey " "))
      HotkeyDup = 2

   Loop, Parse, HotkeyClasses_%OutputVar%, `,
   {
      LoopField = %A_LoopField%
      If (func_StrLeft(LoopField,7)="Hotkey_")
      {
         If %LoopField% =
            LoopField =
      }
      Else If (!InStr(LoopField, "ahk_") AND LoopField <> "")
         LoopField = ahk_class %LoopField%
      IfInstring, Hotkey_AllHotkeys_tmp , % "<" GetKey " " LoopField ">"
         HotkeyDup = 1
   }

   If HotkeyDup > 0
   {
      Loop, Parse, Hotkey_Extensions, |
      {
         FunctionTmp := A_LoopField
         If Hotkey_Extension[%FunctionTmp%] = %GetKey%
            break
         FunctionTmp =
         FunctionTmp1 =
         FunctionTmp2 =
      }
      StringSplit, FunctionTmp, FunctionTmp, $

      If HotkeyDup = 2
      {
         StringGetPos, Hotkey_WinkeyPos1, Hotkey_WindowsHotkeys, % "<" GetKey " "
         StringGetPos, Hotkey_WinkeyPos2, Hotkey_WindowsHotkeys, >, , %Hotkey_WinkeyPos1%
         FunctionTmp3 := SubStr(Hotkey_WindowsHotkeys, Hotkey_WinkeyPos1+StrLen(GetKey)+4, Hotkey_WinkeyPos2-(Hotkey_WinkeyPos1+StrLen(GetKey)+3))
         If lng_winHK_%FunctionTmp3% =
            FunctionTmp3 := RegExReplace(FunctionTmp3,"(.)([A-Z])","$1 $2")
         Else
            FunctionTmp3 := lng_winHK_%FunctionTmp3%
         StringReplace,FunctionTmp4, A_RealOSVersion, WIN_, % "Windows "
      }

      If %VarHK%_new <> %GetKey%
      {
         If HotkeyDup = 2
            Hotkey_DupMessage := #(lng_DuplicateWinHotkey, func_HotkeyDecompose(Getkey,1), FunctionTmp4) " " FunctionTmp3 "`n`n" lng_OverwriteWinHotkey
         Else If FunctionTmp1 =
            Hotkey_DupMessage := #(lng_DuplicateTempHotkey, func_HotkeyDecompose(Getkey,1)) "`n`n" lng_OverwriteDupHotkey
         Else
         {
            FunctionTmp := Function
            ExtensionIndexTmp := ExtensionIndex
            PrefixTmp := Prefix

            Function := FunctionTmp1

            ExtensionIndex := ExtensionIndex[%Function%]
            Prefix := ExtensionPrefix[%ExtensionIndex%]

            GetKeyTmp := GetKey
            If ExtensionGuiDrawn[%Function%] = 0
               Gosub, sub_CreateExtensionConfigGui
            GetKey := GetKeyTmp

            Function := FunctionTmp
            ExtensionIndex := ExtensionIndexTmp
            Prefix := PrefixTmp
            Hotkey_DupMessage := #(lng_DuplicateHotkey, func_HotkeyDecompose(Getkey,1)) "`n" FunctionTmp1 ": " Hotkey_ExtensionText[%FunctionTmp2%] "`n`n" lng_OverwriteDupHotkey
         }
         Gui +OwnDialogs
         SplashImage, Off
         msgbox, 52, %ScriptTitle%, %Hotkey_DupMessage%
         Gui -Disabled
         Hotkey_DupMessage =
         IfMsgBox, Yes
         {
            HotkeyFunctionTmp2new := Hotkey_%FunctionTmp2%_new
            Loop, Parse, HotkeyClasses_%OutputVar%, `,
            {
               LoopField = %A_LoopField%
               If (func_StrLeft(LoopField,7)="Hotkey_")
               {
                  If %LoopField% =
                     LoopField =
               }
               Else If (!InStr(LoopField, "ahk_") AND LoopField <> "")
                  LoopField = ahk_class %LoopField%
               StringReplace, Hotkey_AllNewHotkeys, Hotkey_AllNewHotkeys, % "<" HotkeyFunctionTmp2new " " LoopField ">" , , A
            }
            Hotkey_%FunctionTmp2%_new =
            Hotkey_%FunctionTmp2%_del = 1
            Hotkey_DupDuplicates++
            GuiControl,,Hotkey_%FunctionTmp2%,% "  " func_HotkeyDecompose("", 0)
            func_SettingsChanged(FunctionTmp1)
            If (IsLabel("SettingsChanged_" FunctionTmp1))
               Gosub, SettingsChanged_%FunctionTmp1%
         }
         Else
         {
            HotkeyDup =
            Return
         }
      }
   }
   Else
   {
      SplashImage, Off
      Gui -Disabled
   }

   GuiControlGet, activeTab,,DlgTabs

   If activeTab = %lng_Hotkeys%
      activeTab = activAid

   Hotkey_Extensions_tmp := Hotkey_Extensions_tmp activeTab "$" VarHK "|"
   Hotkey_Extension_tmp[%activeTab%$%VarHK%] = %GetKey%

   VarHKNew := %VarHK%_new
   Loop, Parse, HotkeyClasses_%OutputVar%, `,
   {
      LoopField = %A_LoopField%
      If (func_StrLeft(LoopField,7)="Hotkey_")
      {
         If %LoopField% =
            LoopField =
      }
      Else If (!InStr(LoopField, "ahk_") AND LoopField <> "")
         LoopField = ahk_class %LoopField%
      StringReplace, Hotkey_AllNewHotkeys, Hotkey_AllNewHotkeys, % "<" VarHKNew " " LoopField ">" , , A
   }
   %VarHK%_new = %GetKey%
   GuiControl,,%VarHK%,% "  " func_HotkeyDecompose(GetKey, 0)

   Loop, Parse, HotkeyClasses_%OutputVar%, `,
   {
      LoopField = %A_LoopField%
      If (func_StrLeft(LoopField,7)="Hotkey_")
      {
         If %LoopField% =
            LoopField =
      }
      Else If (!InStr(LoopField, "ahk_") AND LoopField <> "")
         LoopField = ahk_class %LoopField%
      If %VarHK%_del <> 1
         Hotkey_AllNewHotkeys := Hotkey_AllNewHotkeys "<" GetKey " " LoopField ">"
   }

   Debug("GUI", A_LineNumber, A_LineFile, "sub_HotkeyButton: " activeTab " : " ChangedSettings[%activeTab%] "---" %A_Guicontrol% "-" GetKey )

   If MainGuiVisible <> 2
      Return

   StringReplace, ChangedSettings[%activeTab%], ChangedSettings[%activeTab%], %A_GuiControl%|,,A
   If %A_GuiControl% <> %GetKey%
   {
      ChangedSettings[%activeTab%] := ChangedSettings[%activeTab%] A_GuiControl "|"
      Gosub, sub_EnableDisable_ApplyButton
      If Hotkey_AllDuplicates
      {
         Loop, Parse, Hotkey_AllDuplicates, `n
         {
            If (InStr("`n" A_LoopField, "`n" activeTab "`t" func_HotkeyDecompose(%A_GuiControl%,1) "`t") OR InStr("`n" A_LoopField, "`n" activeTab "`t*" func_HotkeyDecompose(%A_GuiControl%,1) "`t"))
            {
               StringReplace, Hotkey_AllDuplicates, Hotkey_AllDuplicates, %A_LoopField%`n
               Gosub, sub_ShowDuplicates
               Break
            }
         }
         RemainingDuplicates = 0
         StringReplace, tmpDup, Hotkey_AllDuplicates, % "`t" func_HotkeyDecompose(%A_GuiControl%,1) "`t",, A UseErrorLevel
         RemainingDuplicates := RemainingDuplicates + ErrorLevel
         StringReplace, tmpDup, Hotkey_AllDuplicates, % "`t*" func_HotkeyDecompose(%A_GuiControl%,1) "`t",, A UseErrorLevel
         RemainingDuplicates := RemainingDuplicates + ErrorLevel
         If RemainingDuplicates = 1
         {
            Loop, Parse, Hotkey_AllDuplicates, `n
            {
               If (InStr(A_LoopField, "`t" func_HotkeyDecompose(%A_GuiControl%,1) "`t") OR InStr(A_LoopField, "`t*" func_HotkeyDecompose(%A_GuiControl%,1) "`t"))
               {
                  StringReplace, Hotkey_AllDuplicates, Hotkey_AllDuplicates, %A_LoopField%`n
                  Gosub, sub_ShowDuplicates
                  Break
               }
            }
         }
      }
   }
Return

tim_HotkeyWaitToggleSuspend:
   If (GetKeyState("LCtrl") AND GetKeyState("RCtrl"))
   {
      Gosub, sub_temporarySuspend
      If Single%VarHK% = 1
         SplashImage,,b1 cwFFFF80 FS9 WS700 w400, % Hotkey_DupMessage lng_GetSingleKey lng_GetKeySuspendStatus%A_IsSuspended%
      Else
         SplashImage,,b1 cwFFFF80 FS9 WS700 w400, % Hotkey_DupMessage lng_GetKey lng_GetKeySuspendStatus%A_IsSuspended%
      Loop
      {
         If (GetKeyState("LCtrl") AND GetKeyState("RCtrl"))
            Continue
         Break
      }
      SetTimer, tim_HotkeyWaitToggleSuspend, 10
   }
Return

RegisterAdditionalSetting( Prefix, Name, DefaultValue=0, Parameters="" ) {
   Global
   Local Index,SeparateMenu,Type
   SeparateMenu =
   Type =
   #IncludeAgain %A_ScriptDir%\library\#ParseFunctionParameters.ahk

   %Prefix%_AdditionalSettings++
   Index := %Prefix%_AdditionalSettings
   %Prefix%_AdditionalSettings[%Index%] = %Name%
   %Prefix%_AdditionalSettingsType[%Index%] = %Type%
   %Prefix%_AdditionalSettingsParameters[%Index%] = %Parameters%
   %Prefix%_AdditionalSettingsSeparateMenu[%Index%] = %SeparateMenu%
   %Prefix%_AdditionalSettingsReloadOnChange[%Index%] = %ReloadOnChange%
   %Prefix%_%SeparateMenu%_AdditionalMenu = 1
   If Type <> SubRoutine
   {
      IniRead, %Prefix%_%Name%, %ConfigFile%, % %Prefix%_ScriptName, %Name%, %DefaultValue%
      %Prefix%_%Name%_tmp := %Prefix%_%Name%
   }
   Debug("Settings", A_LineNumber, A_LineFile, "RegisterAdditionalSetting: " Prefix ", " Name ", " DefaultValue ", " Type )
}

SaveAdditionalSettings( Prefix ) {
   Global
   local Index,Name
   Index := %Prefix%_AdditionalSettings
   Loop, %Index%
   {
      Name := %Prefix%_AdditionalSettings[%A_Index%]
      If (%Prefix%_AdditionalSettingsType[%A_Index%] <> "SubRoutine")
      {
         %Prefix%_%Name% := %Prefix%_%Name%_tmp
         IniWrite, % %Prefix%_%Name%, %ConfigFile%, % %Prefix%_ScriptName, %Name%
      }
   }
   Debug("Settings", A_LineNumber, A_LineFile, "SaveAdditionalSettings: " Prefix )
}

RestoreAdditionalTmpSettings( Prefix ) {
   Global
   local Index,Name
   Index := %Prefix%_AdditionalSettings
   Loop, %Index%
   {
      Name := %Prefix%_AdditionalSettings[%A_Index%]
      If (%Prefix%_AdditionalSettingsType[%A_Index%] <> "SubRoutine")
         %Prefix%_%Name%_tmp := %Prefix%_%Name%
   }
   Debug("Settings", A_LineNumber, A_LineFile, "RestoreAdditionalTmpSettings: " Prefix )
}

SeparateAdditionalSettingsButton(SeparateMenu,Options="X+5")
{
   Global
   StringSplit, Prefix, SeparateMenu, _
   Prefix = %Prefix1%
   SeparateMenu = %Prefix2%
   Gui, Add, Button, -Wrap w50 h21 %Options% gsub_AdditionalSettingsMenu vta_AdditionalSettingsMenu_%SeparateMenu%, %lng_More% ...
   SeparateMenuName = %Prefix%_%SeparateMenu%
   Gosub, sub_CreateAdditionalSettingsMenu
}

sub_CreateAdditionalSettingsMenu:
   If tmpPrefix =
      tmpPrefix = %Prefix%

   LastAdditionalSettingsPrefix = %tmpPrefix%

   LastAdditionalSettings := tmpPrefix %tmpPrefix%_AdditionalSettingsMenuExternal

   tmpIndex := %tmpPrefix%_AdditionalSettings

   Menu, AdditionalSettingsMenu%SeparateMenuName%, UseErrorLevel
   Menu, AdditionalSettingsMenu%SeparateMenuName%, Delete

   If %tmpPrefix%_AdditionalSettingsMenuExternal =
   {
      If(  SeparateMenuName = "" OR lng_%SeparateMenuName% = "")
      {
         Menu, AdditionalSettingsMenu%SeparateMenuName%, Add, % %tmpPrefix%_ScriptName, sub_AdditionalSettingsMenuCall
         Menu, AdditionalSettingsMenu%SeparateMenuName%, Disable, % %tmpPrefix%_ScriptName
      }
      Else
      {
         Menu, AdditionalSettingsMenu%SeparateMenuName%, Add, % lng_%SeparateMenuName%, sub_AdditionalSettingsMenuCall
         Menu, AdditionalSettingsMenu%SeparateMenuName%, Disable, % lng_%SeparateMenuName%
      }

      Menu, AdditionalSettingsMenu%SeparateMenuName%, Add
   }
   tmpLastType = null
   lastOptionGroup =
   Index = 0
   Loop, %tmpIndex%
   {
      If (%tmpPrefix%_AdditionalSettingsSeparateMenu[%A_Index%] <> SeparateMenuName)
         Continue
      Index++
      tmpName := %tmpPrefix%_AdditionalSettings[%A_Index%]
      StringRight, tmpOptionGroup, tmpName, 1
      tmpOptionGroup := tmpOptionGroup + 0 ; Wenn keine Zahl, dann leer

      If ((%tmpPrefix%_AdditionalSettingsType[%A_Index%] <> tmpLastType AND tmpLastType <> "null") OR tmpOptionGroup < lastOptionGroup OR (lastOptionGroup = "" AND tmpOptionGroup <> "" AND A_Index > 1) OR (lastOptionGroup <> "" AND tmpOptionGroup = "" AND A_Index > 1 ))
      {
         Menu, AdditionalSettingsMenu%SeparateMenuName%, Add
         tmpSeparators++
         Index++
      }
      %tmpPrefix%_AdditionalSettingsSeparators[%SeparateMenuName%_%Index%] := Index-A_Index

      lastOptionGroup := tmpOptionGroup

      If lng_%tmpPrefix%_%tmpName% =
      {
         If lng_%tmpName% =
         {
            If %tmpPrefix%_AdditionalSettingsType[%A_Index%] = SubRoutine
            {
               Menu, AdditionalSettingsMenu%SeparateMenuName%, Add, %tmpName% ..., %tmpPrefix%_%tmpName%
               IfInString, %tmpPrefix%_AdditionalSettingsParameters[%A_Index%], Disabled
                  Menu, AdditionalSettingsMenu%SeparateMenuName%, Disable, %tmpName% ...
            }
            Else
            {
               Menu, AdditionalSettingsMenu%SeparateMenuName%, Add, %tmpName%, sub_AdditionalSettingsMenuCall
               If %tmpPrefix%_%tmpName%_tmp = 1
                  Menu, AdditionalSettingsMenu%SeparateMenuName%, Check, %tmpName%
               IfInString, %tmpPrefix%_AdditionalSettingsParameters[%A_Index%], Disabled
                  Menu, AdditionalSettingsMenu%SeparateMenuName%, Disable, %tmpName%
            }
         }
         Else
         {
            If %tmpPrefix%_AdditionalSettingsType[%A_Index%] = SubRoutine
            {
               Menu, AdditionalSettingsMenu%SeparateMenuName%, Add, % lng_%tmpName% " ...", %tmpPrefix%_%tmpName%
               IfInString, %tmpPrefix%_AdditionalSettingsParameters[%A_Index%], Disabled
                  Menu, AdditionalSettingsMenu%SeparateMenuName%, Disable, % lng_%tmpName% " ..."
            }
            Else
            {
               Menu, AdditionalSettingsMenu%SeparateMenuName%, Add, % lng_%tmpName%, sub_AdditionalSettingsMenuCall
               If %tmpPrefix%_%tmpName%_tmp = 1
                  Menu, AdditionalSettingsMenu%SeparateMenuName%, Check, % lng_%tmpName%
               IfInString, %tmpPrefix%_AdditionalSettingsParameters[%A_Index%], Disabled
                  Menu, AdditionalSettingsMenu%SeparateMenuName%, Disable, % lng_%tmpName%

            }
         }
      }
      Else
      {
         If %tmpPrefix%_AdditionalSettingsType[%A_Index%] = SubRoutine
         {
            Menu, AdditionalSettingsMenu%SeparateMenuName%, Add, % lng_%tmpPrefix%_%tmpName% " ...", %tmpPrefix%_%tmpName%
            IfInString, %tmpPrefix%_AdditionalSettingsParameters[%A_Index%], Disabled
               Menu, AdditionalSettingsMenu%SeparateMenuName%, Disable, % lng_%tmpPrefix%_%tmpName% " ..."
         }
         Else
         {
            Menu, AdditionalSettingsMenu%SeparateMenuName%, Add, % lng_%tmpPrefix%_%tmpName%, sub_AdditionalSettingsMenuCall
            If %tmpPrefix%_%tmpName%_tmp = 1
               Menu, AdditionalSettingsMenu%SeparateMenuName%, Check, % lng_%tmpPrefix%_%tmpName%
            IfInString, %tmpPrefix%_AdditionalSettingsParameters[%A_Index%], Disabled
               Menu, AdditionalSettingsMenu%SeparateMenuName%, Disable, % lng_%tmpPrefix%_%tmpName%
         }
      }
      tmpLastType := %tmpPrefix%_AdditionalSettingsType[%A_Index%]
   }
   tmpPrefix =
Return

sub_AdditionalSettingsMenu:
   ;StringReplace,Prefix, A_GuiControl, _AdditionalSettingsMenu
   Prefix3 =
   SeparateMenuName =
   If (InStr(A_GuiControl, "_"))
   {
      StringSplit, Prefix, A_GuiControl, _
      If %Prefix1%__AdditionalMenu = 1
      {
         Prefix = %Prefix1%
         If (Prefix3 <> "" AND %Prefix1%_%Prefix1%_%Prefix3%_AdditionalMenu = 1)
            SeparateMenuName = %Prefix1%_%Prefix3%
      }
   }

   If (LastAdditionalSettings <> Prefix %Prefix%_AdditionalSettingsMenuExternal)
      Gosub, sub_CreateAdditionalSettingsMenu
   Menu, AdditionalSettingsMenu%SeparateMenuName%, Show
Return

sub_AdditionalSettingsMenuCall:
   tmpPrefix := LastAdditionalSettingsPrefix
   If %tmpPrefix%_AdditionalSettingsMenuExternal =
      ThisMenuItemPos := A_ThisMenuItemPos-2
   Else
      ThisMenuItemPos := A_ThisMenuItemPos
   ThisMenuItemPos := ThisMenuItemPos-%tmpPrefix%_AdditionalSettingsSeparators[%SeparateMenuName%_%ThisMenuItemPos%]
   tmpName := %tmpPrefix%_AdditionalSettings[%ThisMenuItemPos%]

   If %Prefix%_AdditionalSettingsReloadOnChange[%ThisMenuItemPos%] = 1
      Reload = 1
   StringRight, tmpOptionGroup, tmpName, 1
   tmpOptionGroup := tmpOptionGroup + 0 ; Wenn keine Zahl, dann leer
   %tmpPrefix%_%tmpName%_tmp := Not(%tmpPrefix%_%tmpName%_tmp)
   If lng_%tmpPrefix%_%tmpName% =
   {
      If lng_%tmpName% =
         Menu, AdditionalSettingsMenu%SeparateMenuName%, ToggleCheck, %tmpName%
      Else
         Menu, AdditionalSettingsMenu%SeparateMenuName%, ToggleCheck, % lng_%tmpName%
   }
   Else
      Menu, AdditionalSettingsMenu%SeparateMenuName%, ToggleCheck, % lng_%tmpPrefix%_%tmpName%

   If %tmpPrefix%_AdditionalSettingsMenuExternal = 1
   {
      %tmpPrefix%_%tmpName% := %tmpPrefix%_%tmpName%_tmp
      IniWrite, % %tmpPrefix%_%tmpName%, %ConfigFile%, % %tmpPrefix%_ScriptName, %tmpName%
   }
   Else
      func_SettingsChanged( %tmpPrefix%_ScriptName )

   If (tmpOptionGroup > 0 AND tmpOptionGroup < 10 AND %tmpPrefix%_%tmpName%_tmp = 1)
   {
      StringTrimRight, tmpOptionGroupName, tmpName, 1
      Loop, 9
      {
         tmpName = %tmpOptionGroupName%%A_Index%
         If A_Index = %tmpOptionGroup%
            continue
         If (lng_%tmpPrefix%_%tmpName% = "" AND lng_%tmpName% = "")
            Break

         If lng_%tmpPrefix%_%tmpName% =
         {
            If lng_%tmpName% =
               Menu, AdditionalSettingsMenu%SeparateMenuName%, UnCheck, %tmpName%
            Else
               Menu, AdditionalSettingsMenu%SeparateMenuName%, UnCheck, % lng_%tmpName%
         }
         Else
            Menu, AdditionalSettingsMenu%SeparateMenuName%, UnCheck, % lng_%tmpPrefix%_%tmpName%

         %tmpPrefix%_%tmpName%_tmp := 0
         If %tmpPrefix%_AdditionalSettingsMenuExternal = 1
         {
            %tmpPrefix%_%tmpName% := %tmpPrefix%_%tmpName%_tmp
            IniWrite, % %tmpPrefix%_%tmpName%, %ConfigFile%, % %tmpPrefix%_ScriptName, %tmpName%
         }
      }
   }
Return

func_HotkeyDecompose( Hotkey, ShortName=0, MenusAndButtons=1 ) {
   global
   AutoTrim, Off

   Hotkey := func_SortHotkeyModifiers( Hotkey )

   StringUpper, Hotkey, Hotkey

   StringReplace, Hotkey, Hotkey, NumpadAdd, NumpadPlus
   StringReplace, Hotkey, Hotkey, NumpadDiv, Numpad
   StringReplace, Hotkey, Hotkey, NumpadSub, NumpadMinus
   StringReplace, Hotkey, Hotkey, NumpadMult, Numpad*
   StringReplace, Hotkey, Hotkey, NumpadDel, NumpadDel (sShiftNumDot)
   StringReplace, Hotkey, Hotkey, NumpadIns, NumpadIns (sShiftNum0)
   StringReplace, Hotkey, Hotkey, NumpadClear, NumpadClear (sShiftNum5)
   StringReplace, Hotkey, Hotkey, NumpadUp, NumpadUp (sShiftNum8)
   StringReplace, Hotkey, Hotkey, NumpadDown, NumpadDown (sShiftNum2)
   StringReplace, Hotkey, Hotkey, NumpadLeft, NumpadLeft (sShiftNum4)
   StringReplace, Hotkey, Hotkey, NumpadRight, NumpadRight (sShiftNum6)
   StringReplace, Hotkey, Hotkey, NumpadHome, NumpadHome (sShiftNum7)
   StringReplace, Hotkey, Hotkey, NumpadEnd, NumpadEnd (sShiftNum1)
   StringReplace, Hotkey, Hotkey, NumpadPgUp, NumpadPgUp (sShiftNum9)
   StringReplace, Hotkey, Hotkey, NumpadPgDn, NumpadPgDn (sShiftNum3)
   If (InStr(Hotkey,"*") AND func_StrRight(Hotkey,1) <> "*")
      StringReplace, Hotkey, Hotkey, *

   If ShortName > 0
   {
      StringReplace, Hotkey, Hotkey, Numpad, %lng_KbNumpadShort%
      StringReplace, Hotkey, Hotkey, Num, %lng_KbNumpadShort%
      Hotkey_Sep := "+"
      If MenusAndButtons = 1
         Hotkey_Sep2 := "&&"
      Else
         Hotkey_Sep2 := "&"
      Hotkey_Win = Win
      If ( func_StrLeft(Hotkey,1) = ">" OR func_StrLeft(Hotkey,2) = "$>" OR func_StrLeft(Hotkey,2) = "~>" OR func_StrLeft(Hotkey,3) = "$~>" )
      {
         StringReplace, Hotkey, Hotkey, >
         Hotkey_Win = RWin
      }
   }
   Else
   {
      StringReplace, Hotkey, Hotkey, Numpad, %lng_KbNumpad%
      StringReplace, Hotkey, Hotkey, Num, %lng_KbNumpadShort%
      Hotkey_Sep := " + "
      If MenusAndButtons = 1
         Hotkey_Sep2 := " && "
      Else
         Hotkey_Sep2 := " & "
      Hotkey_Win = %lng_KbWin%
      If ( func_StrLeft(Hotkey,1) = ">" OR func_StrLeft(Hotkey,2) = "$>" OR func_StrLeft(Hotkey,2) = "~>" OR func_StrLeft(Hotkey,3) = "$~>" )
      {
         StringReplace, Hotkey, Hotkey, >
         Hotkey_Win = %lng_Right% %lng_KbWin%
      }
   }

   If Hotkey contains <!,<+,<^,<#
      StringReplace, Hotkey, Hotkey, <, L

   If Hotkey contains >!,>+,>^,>#
      StringReplace, Hotkey, Hotkey, >, R

   StringReplace, Hotkey, Hotkey, End, %lng_KbEnd%
   StringReplace, Hotkey, Hotkey, DOT, %lng_KbDot%

   StringReplace, Hotkey, Hotkey, Help              , %lng_KbHelp%
   StringReplace, Hotkey, Hotkey, Sleep             , %lng_KbSleep%
   StringReplace, Hotkey, Hotkey, Browser_Back      , %lng_KbBrowser_Back%
   StringReplace, Hotkey, Hotkey, Browser_Forward   , %lng_KbBrowser_Forward%
   StringReplace, Hotkey, Hotkey, Browser_Refresh   , %lng_KbBrowser_Refresh%
   StringReplace, Hotkey, Hotkey, Browser_Stop      , %lng_KbBrowser_Stop%
   StringReplace, Hotkey, Hotkey, Browser_Search    , %lng_KbBrowser_Search%
   StringReplace, Hotkey, Hotkey, Browser_Favorites , %lng_KbBrowser_Favorites%
   StringReplace, Hotkey, Hotkey, Browser_Home      , %lng_KbBrowser_Home%
   StringReplace, Hotkey, Hotkey, Volume_Mute       , %lng_KbVolume_Mute%
   StringReplace, Hotkey, Hotkey, Volume_Down       , %lng_KbVolume_Down%
   StringReplace, Hotkey, Hotkey, Volume_Up         , %lng_KbVolume_Up%
   StringReplace, Hotkey, Hotkey, Media_Next        , %lng_KbMedia_Next%
   StringReplace, Hotkey, Hotkey, Media_Prev        , %lng_KbMedia_Prev%
   StringReplace, Hotkey, Hotkey, Media_Stop        , %lng_KbMedia_Stop%
   StringReplace, Hotkey, Hotkey, Media_Play_Pause  , %lng_KbMedia_Play_Pause%
   StringReplace, Hotkey, Hotkey, Launch_Mail       , %lng_KbLaunch_Mail%
   StringReplace, Hotkey, Hotkey, Launch_Media      , %lng_KbLaunch_Media%
   StringReplace, Hotkey, Hotkey, Launch_App1       , %lng_KbLaunch_App1%
   StringReplace, Hotkey, Hotkey, Launch_App2       , %lng_KbLaunch_App2%

   StringReplace, Hotkey, Hotkey, ScrollLock, %lng_KbScrollLock%
   StringReplace, Hotkey, Hotkey, PgUp, %lng_KbPgUp%
   StringReplace, Hotkey, Hotkey, PgDn, %lng_KbPgDn%
   StringReplace, Hotkey, Hotkey, Delete, %lng_KbDel%
   StringReplace, Hotkey, Hotkey, Del, %lng_KbDel%
   StringReplace, Hotkey, Hotkey, Home, %lng_KbHome%
   StringReplace, Hotkey, Hotkey, Insert, %lng_KbIns%
   StringReplace, Hotkey, Hotkey, PrintScreen, %lng_KbPrintScreen%
   StringReplace, Hotkey, Hotkey, Backspace, %lng_KbBackspace%
   StringReplace, Hotkey, Hotkey, Space, %lng_KbSpace%
   StringReplace, Hotkey, Hotkey, ENTER, %lng_KbEnter%
   StringReplace, Hotkey, Hotkey, Clear, %lng_KbClear%
   StringReplace, Hotkey, Hotkey, ESCAPE, ESC
   StringReplace, Hotkey, Hotkey, Tab, %lng_KbTab%
   StringReplace, Hotkey, Hotkey, Pause, %lng_KbPause%
   StringReplace, Hotkey, Hotkey, CtrlBreak, %lng_KbCtrlBreak%
   StringReplace, Hotkey, Hotkey, Left, %lng_KbCurLeft%
   StringReplace, Hotkey, Hotkey, Right, %lng_KbCurRight%
   StringReplace, Hotkey, Hotkey, %A_Space%Up, %A_Space%%lng_kbRelease%
   StringReplace, Hotkey, Hotkey, WheelUp, %lng_KbWheelUp%
   If ErrorLevel = 1
      StringReplace, Hotkey, Hotkey, Up, %lng_KbCurUp%
   StringReplace, Hotkey, Hotkey, WheelDown, %lng_KbWheelDown%
   If ErrorLevel = 1
      StringReplace, Hotkey, Hotkey, Down, %lng_KbCurDown%
   StringReplace, Hotkey, Hotkey, LButton, %lng_KbLButton%
   StringReplace, Hotkey, Hotkey, RButton, %lng_KbRButton%
   StringReplace, Hotkey, Hotkey, MButton, %lng_KbMButton%
   StringReplace, Hotkey, Hotkey, % "~CapsLock & ", %A_Space%
   StringReplace, Hotkey, Hotkey, NUMLOCK, NumLock
   StringReplace, Hotkey, Hotkey, AppsKey, %lng_KbAppsKey%
   StringReplace, Hotkey, Hotkey, % " & ", %Hotkey_Sep2%, A
   If Hotkey in CapsLock,AppsKey
   {
      StringReplace, Hotkey, Hotkey, CapsLock, %lng_kbCapsLock%
      StringReplace, Hotkey, Hotkey, AppsKey, %lng_kbAppsKey%
   }

   StringReplace, Hotkey, Hotkey, LShift, %lng_Left% %lng_kbShift%
   StringReplace, Hotkey, Hotkey, RShift, %lng_Right% %lng_kbShift%
   StringReplace, Hotkey, Hotkey, LAlt, %lng_Left% %lng_kbAlt%
   StringReplace, Hotkey, Hotkey, RAlt, %lng_Right% %lng_kbAlt%
   StringReplace, Hotkey, Hotkey, LWin, %lng_Left% %lng_kbWin%
   StringReplace, Hotkey, Hotkey, RWin, %lng_Right% %lng_kbWin%
   StringReplace, Hotkey, Hotkey, LControl, %lng_Left% %lng_kbCtrl%
   StringReplace, Hotkey, Hotkey, RControl, %lng_Right% %lng_kbCtrl%


   ReGexMatch(Hotkey,"i)(SC[0-9a-f]{3})$",HotkeySC)
   If HotkeySC1 <>
      StringReplace, Hotkey, Hotkey, %HotkeySC1%, % lng_Kb%HotkeySC1%, A

   If (func_StrLeft(Hotkey,2) = "$~" OR func_StrLeft(Hotkey,2) = "~$")
      StringTrimLeft, Hotkey, Hotkey, 2
   Else If (func_StrLeft(Hotkey,1) = "~" OR func_StrLeft(Hotkey,1) = "$")
      StringTrimLeft, Hotkey, Hotkey, 1

   If (func_StrRight(Hotkey,1) = "+")
      Hotkey := func_StrLeft( Hotkey, StrLen(Hotkey)-1 ) "Plus"
   If (func_StrRight(Hotkey,1) = "-")
      Hotkey := func_StrLeft( Hotkey, StrLen(Hotkey)-1 ) "Minus"

   Len := StrLen(Hotkey)
   HotkeyDecomposed =

   IfInString, Hotkey, <^>!
      StringReplace, Hotkey, Hotkey, <^>!, <<>>

   Loop, Parse, Hotkey
   {
      HotkeyDecomp =
      If (A_Index < Len)
      {
         If A_LoopField = #
            HotkeyDecomp := Hotkey_Win Hotkey_Sep
         If A_LoopField = ^
            HotkeyDecomp := lng_KbCtrl Hotkey_Sep
         If A_LoopField = !
            HotkeyDecomp := lng_KbAlt Hotkey_Sep
         If A_LoopField = +
            HotkeyDecomp := ((ShortName=2) ? lng_KbShiftShort : lng_KbShift) Hotkey_Sep
         If (A_LoopField = " " AND A_Index = 1)
            HotkeyDecomp := lng_KbCapsLock Hotkey_Sep
      }
      If HotkeyDecomp =
         HotkeyDecomp = %A_LoopField%
      HotkeyDecomposed = %HotkeyDecomposed%%HotkeyDecomp%
   }
   StringReplace, HotkeyDecomposed, HotkeyDecomposed, <<>>, AltGr%Hotkey_Sep%
   StringReplace, HotkeyDecomposed, HotkeyDecomposed, sShift, %lng_KbShiftShort%+

   Return %HotkeyDecomposed%
}

sub_ListBox_addApp:
   StringReplace, VarApp, A_GuiControl, Add_,
   WinSet,Bottom,, %ScriptTitle%
   SplashImage,,b1 cwFFFF80 FS9 WS700, %lng_AddApps%
   Gui,%GuiID_activAid%:+Disabled
   Input,GetKey,,{Enter}{ESC}
   StringReplace,GetKey,ErrorLevel,Endkey:
   SplashImage, Off
   Gui,%GuiID_activAid%:-Disabled
   WinGet, GetProcName, ProcessName, A
   If Getkey = Enter
   {
      IfNotInstring, %VarApp%, %GetProcName%
      {
         GuiControl,,%VarApp%_tmp,%GetProcName%
         %VarApp% := %VarApp% "|" GetProcName
         StringReplace,%VarApp%,%VarApp%,||,|,a
      }
   }
   Gui,%GuiID_activAid%:Show
   WinSet, Top, , %ScriptTitle%

   If (MainGuiVisible <> 2 OR GetKey = "ESCAPE")
      Return

   StringReplace, VarAppOrg, VarApp, _Box,
   If ( func_StrLeft(%VarApp%,1) = "|" )
   {
      StringTrimLeft, %VarApp%, %VarApp%, 1
   }
   If ( func_StrRight(%VarApp%,1) = "|" )
   {
      StringTrimRight, %VarApp%, %VarApp%, 1
   }
   GuiControlGet, activeTab,,DlgTabs
   StringReplace, ChangedSettings[%activeTab%], ChangedSettings[%activeTab%], %VarApp%|,,A
   If (%VarApp% <> ChangedSettings[%activeTab%])
      ChangedSettings[%activeTab%] := ChangedSettings[%activeTab%] %VarApp% "|"
   Gosub, sub_EnableDisable_ApplyButton
;   Tooltip, % activeTab " : " ChangedSettings[%activeTab%]
Return

sub_ListBox_addFolder:
   Gui %GuiID_activAid%:+OwnDialogs
   StringReplace, VarApp, A_GuiControl, Add_,
   FileSelectFolder,GetFolder, *%GetFolder%
   If GetFolder =
      Return
   If ListBox_addFolder_VariableDriveLetter = 1
   {
      GetFolder := func_ReplaceWithCommonPathVariables(GetFolder)
   }
   IfNotInstring, %VarApp%, %GetFolder%
   {
      If %VarApp%_DontAllowSubfolders = 1
      {
         Loop, Parse, %VarApp%, |
         {
            If A_LoopField =
               continue
            If ( func_StrLeft( GetFolder, StrLen(A_LoopField) ) = A_LoopField)
            {
               MsgBox, 16,%qc_ScriptName%, %lng_IsSubfolder% %A_LoopField%
               return
            }
         }
      }

      GuiControl,,%VarApp%_tmp,%GetFolder%
      %VarApp% := %VarApp% "|" GetFolder
      StringReplace,%VarApp%,%VarApp%,||,|,a
   }
   Else
   {
      If %VarApp%_DontAllowSubfolders = 1
         MsgBox, 16,%qc_ScriptName%, %lng_HasSubfolder%
      Else
         MsgBox, 16,%qc_ScriptName%, %lng_IsInList%
      return
   }

   If MainGuiVisible <> 2
      Return

   StringReplace, VarAppOrg, VarApp, _Box,
   If ( func_StrLeft(%VarApp%,1) = "|" )
   {
      StringTrimLeft, %VarApp%, %VarApp%, 1
   }
   If ( func_StrRight(%VarApp%,1) = "|" )
   {
      StringTrimRight, %VarApp%, %VarApp%, 1
   }
   GuiControlGet, activeTab,,DlgTabs
   StringReplace, ChangedSettings[%activeTab%], ChangedSettings[%activeTab%], %VarApp%|,,A

   If (%VarApp% <> ChangedSettings[%activeTab%])
      ChangedSettings[%activeTab%] := ChangedSettings[%activeTab%] %VarApp% "|"
   Gosub, sub_EnableDisable_ApplyButton
;   Tooltip, % activeTab " : " ChangedSettings[%activeTab%]
Return

sub_ListBox_remove:
   StringReplace, VarApp, A_GuiControl, Remove_,
   GuiControlGet, App_selected, , %VarApp%_tmp
   %VarApp% := "|" %VarApp% "|"
   StringReplace,%VarApp%,%VarApp%,|%App_selected%|,|,a
   StringReplace,%VarApp%,%VarApp%,||,|,a
   StringReplace,%VarApp%,%VarApp%,||,|,a
   GuiControl,,%VarApp%_tmp,% %VarApp%

   If MainGuiVisible <> 2
      Return

   StringReplace, VarAppOrg, VarApp, _Box,
   If ( func_StrLeft(%VarApp%,1) = "|" )
   {
      StringTrimLeft, %VarApp%, %VarApp%, 1
      StringTrimRight, %VarApp%, %VarApp%, 1
   }
   GuiControlGet, activeTab,,DlgTabs
   StringReplace, ChangedSettings[%activeTab%], ChangedSettings[%activeTab%], %VarApp%|,,A
   If (%VarAppOrg% <> %VarApp%)
      ChangedSettings[%activeTab%] := ChangedSettings[%activeTab%] VarApp "|"
   Gosub, sub_EnableDisable_ApplyButton
;   Tooltip, % activeTab " : " ChangedSettings[%activeTab%] "`n" %VarAppOrg%  "<>" %VarApp%
Return

func_StrLeft(String,Len)
{
   StringLeft, Output, String, %Len%
   Return Output
}

func_StrRight( String, Len )
{
   StringRight, Output, String, %Len%
   Return Output
}

func_StrMid( String, Left, Len )
{
   StringMid, Output, String, %Left%, %Len%
   Return Output
}

func_StrTranslate( String, TransFrom, TransTo )
{
   Loop, Parse, TransFrom
   {
      StringMid, TransToChar, TransTo, %A_Index%, 1
      StringReplace, String, String, %A_LoopField%, %TransToChar%, All
   }
   Return String
}

func_StrClean( String,AllowedChars="",OnlyOnce=0,ReplaceChar="" )
{
   ReturnString =
   If AllowedChars =
      AllowedChars = abcdefghijklmnopqrstuvwxyz1234567890#_@$?[]
   If OnlyOnce = 0
   {
      Loop, Parse, String
      {
         IfInString, AllowedChars, %A_LoopField%
            ReturnString := ReturnString A_LoopField
         Else If ReplaceChar <>
            ReturnString := ReturnString ReplaceChar
      }
   }
   Else
   {
      Loop, Parse, String
      {
         IfInString, AllowedChars, %A_LoopField%
         {
            IfNotInString, ReturnString, %A_LoopField%
               ReturnString := ReturnString A_LoopField
            Else If ReplaceChar <>
               ReturnString := ReturnString ReplaceChar
         }
         Else If ReplaceChar <>
            ReturnString := ReturnString ReplaceChar
      }
   }
   Return ReturnString
}

func_StrTrimChars(String,Left="",Right="")
{
   If Left =
      Left := " `t"
   If Right =
      Right := Left

   LeftPos =
   RightPos =
   Loop, Parse, String
   {
      StringMid, StrLeft, String, %A_Index%, 1
      StringMid, StrRight, String, % StrLen(String)-A_Index+1, 1

      If LeftPos =
         IfNotInString, Left, %StrLeft%
            LeftPos := A_Index-1
         Else If (A_Index = StrLen(String) AND RightPos = "")
            LeftPos := A_Index
      If RightPos =
         IfNotInString, Right, %StrRight%
            RightPos := A_Index-1
      If (RightPos > 0 AND LeftPos > 0)
         break
   }

   StringTrimLeft, String, String, %LeftPos%
   StringTrimRight, String, String, %RightPos%
   Return %String%
}

func_LimitValue( Variable, Range="-1-1", Default="" )
{
   StringSplit, Range, Range, -, %A_Space%
   If Range1 =
      From = -%Range2%
   Else
      From = %Range1%

   If Range2 =
      To = -%Range3%
   Else If From <>
      To = %Range2%

   If (Range3 = "" AND Range1="")
      To = -%Range4%
   Else If (To = Range2 AND Range3 <> "")
      To = %Range3%

   If Variable > %To%
      If Default =
         Variable = %To%
      Else
         Variable = %Default%
   If Variable < %From%
      If Default =
         Variable = %From%
      Else
         Variable = %Default%
   Return Variable
}

func_StrReplace( String,SearchText,ReplaceText="",Options="" )
{
   StringReplace, Options, Options, TrimRight, , All UseErrorLevel
   If ErrorLevel > 0
      String := func_StrTrimChars( String, "", SearchText )
   StringReplace, Options, Options, TrimLeft, , All UseErrorLevel
   If ErrorLevel > 0
      String := func_StrTrimChars( String, SearchText, "" )
   StringReplace, String, String, %SearchText%, %ReplaceText%, %Options%
   Return %String%
}

func_ChangeDir( retPath,NewWindow=0,FolderTree=0 )
{
   Global lng_ChangeDirFailed, ScriptTitle, lng_FolderDoesNotExist, ChangeDirClasses, FileBrowser, FileBrowserSelect, FileBrowserWithTree
   SetKeyDelay,20,20

   If retPath = control
      retPath = ::{20D04FE0-3AEA-1069-A2D8-08002B30309D}\::{21EC2020-3AEA-1069-A2DD-08002B30309D}

   WinGet     , activeWinID, ID, A             ; ID es aktiven Fensters
   WinGetClass, activeClass, ahk_id %activeWinID%  ; Fensterklasse ermitteln
   WinGetText, activeWinText, ahk_id %activeWinID%

   Edit1Pos =

   ; Prfen ob Fensterklasse untersttzt wird
   If activeClass contains %ChangeDirClasses%
   {
      ; Ermitteln ob ein Edit1-Control vorhanden ist (Eingabezeile)
      IfInString, activeWinText, MSNTB_Window ; MSN-Toolbar oder Visual Studio?
      {
         EditClass = Edit2
      }
      Else IfInString, activeClass, bosa_sdm_Mso96 ; VisualStudio
      {
         EditClass = Edit2
      }
      Else
      {
         EditClass = Edit1
      }


      ControlGetPos, Edit1Pos,,,, %EditClass% , ahk_id %activeWinID%
   }

   If Edit1Pos =  ; Wenn kein Edit1-Control gefunden ...
   {
      ; Ermitteln ob ein RichEdit-Control vorhanden ist (MS-Office)
      EditClass = RichEdit20W2
      ControlGetPos, Edit1Pos,,,, %EditClass% , ahk_id %activeWinID%
   }

   If activeClass = AfxMDIFrame80su
   {
      EditClass = ComboBox3
      ControlGetPos, Edit1Pos,,,, %EditClass% , ahk_id %activeWinID%
   }

   FileGetAttrib, isFolder, %retPath%
   If (func_StrLeft(retPath,3) = "`:`:{")
      isFolder = D

   If NewWindow < 1 ; Verzeichnis im aktuellen Fenster wechseln
   {
      IfNotInString, isFolder, D
         Return

      ; Verzeichnis in Dateidialogen wechseln
      If activeClass contains #32770,bosa_sdm,bosa_sdm_Mso96
      {
         If Edit1Pos <>
         {
            WinActivate ahk_id %activeWinID%
            ControlGetText, text, %EditClass%, ahk_id %activeWinID%
            ControlFocus, %EditClass%, ahk_id %activeWinID%
            ControlSetText, %EditClass%, %retPath%, ahk_id %activeWinID%
            WinGet,Process, ProcessName, ahk_id %activeWinID%
            func_AddToRecentDir(retPath)
            If Process in WinRar.exe
               Return
            if Process in Acad.exe
            {
               ControlSend   , %EditClass%, {SPACE}{BS} , ahk_id %activeWinID%
               Sleep, 200
            }
            If activeClass = bosa_sdm
               ControlSend   , %EditClass%, {Tab} , ahk_id %activeWinID%
            Else
               ControlSend   , %EditClass%, {Enter} , ahk_id %activeWinID%
            Sleep, 100
            ControlSetText, %EditClass%, %text%, ahk_id %activeWinID%
            Return
         }
      }
      ; Verzeichnis in Explorer-Fenstern wechseln
      Else If activeClass in ExploreWClass,CabinetWClass,WinRarWindow,dopus.lister
      {
         If Edit1Pos <>
         {
            ControlSetText, %EditClass%, %retPath%      , ahk_id %activeWinID%
            ControlSend   , %EditClass%, {Right}{Enter}, ahk_id %activeWinID%
            Sleep,200
            Send, +{Tab}
            func_AddToRecentDir(retPath)
            Return
         }
      }
      ; Verzeichnis im CubicExplorer wechseln
      Else If activeClass in TMainForm
      {
         ControlGetPos, Edit1Pos,,,, TComboEdit.UnicodeClass2 , ahk_id %activeWinID%
         If Edit1Pos <>
         {
            ControlSetText, TComboEdit.UnicodeClass2, %retPath%, ahk_id %activeWinID%
            ControlSend   , TComboEdit.UnicodeClass2, {Enter}{Tab} , ahk_id %activeWinID%
            func_AddToRecentDir(retPath)
            Return
         }
      }
      ; UltraExplorer
      Else If activeClass in TTntFormUltraExplorer.UnicodeClass
      {
         ControlGetPos, Edit1Pos,,,, TComboEdit.UnicodeClass1 , ahk_id %activeWinID%
         If Edit1Pos <>
         {
            ControlGetFocus, activeControl, ahk_id %activeWinID%
            ControlSetText, TComboEdit.UnicodeClass1, %retPath%, ahk_id %activeWinID%
            ControlSend   , TComboEdit.UnicodeClass1, {Enter} , ahk_id %activeWinID%
            ControlFocus, %activeClass%, ahk_id %activeWinID%
            func_AddToRecentDir(retPath)
            Return
         }
      }
      ; Verzeichnis in AcdSee, Filezilla, SpeedCommander wechseln
      Else If activeClass in Afx:400000:0,FileZilla Main Window,SC10MainFrame,SC11MainFrame,SC12MainFrame
      {
         If Edit1Pos <>
         {
            ControlSetText, %EditClass%, %retPath%, ahk_id %activeWinID%
            ControlSend   , %EditClass%, {Enter} , ahk_id %activeWinID%
            func_AddToRecentDir(retPath)
            Return
         }
      }
      ; Total Commander
      Else If activeClass = TTOTAL_CMD
      {
         PostMessage 1075, 2912,,, ahk_id %activeWinID% ; added by MayorA for TotalCommander (send cm_EditPath)
         Sleep,50
         ControlGetFocus, activeControl, ahk_id %activeWinID%
         ControlSetText, %activeControl%, %retPath%, ahk_id %activeWinID%
         ControlSend   , %activeControl%, {Left}{Right}{Enter} , ahk_id %activeWinID%
         func_AddToRecentDir(retPath)
         Return
      }
      ; xplorer
      Else If activeClass = ATL:ExplorerFrame
      {
         If Edit1Pos <>
         {
            ControlSetText, %EditClass%, %retPath%, ahk_id %activeWinID%
            ControlFocus  , %EditClass%, ahk_id %activeWinID%
            ControlSend   , %EditClass%, {Enter} , ahk_id %activeWinID%
            func_AddToRecentDir(retPath)
            Return
         }
      }
      ; Verzeichnis in der Eingabeaufforderung wechseln
      Else If activeClass = ConsoleWindowClass
      {
         WinGetActiveTitle, wTitle

         If wTitle contains cmd.exe,4NT
         {
            WinActivate, ahk_id %activeWinID%
            SetKeyDelay, 0

            IfInString, retPath, :
            {
               StringLeft, path_Drive, retPath, 1
               Send {ESC}%path_Drive%:{Enter}
            }

            Send, {ESC}
            SendRaw, cd "%retPath%"
            Send, {Enter}
            func_AddToRecentDir(retPath)
            Return
         }
         ; Verzeichnis in Powershell.exe wechseln
         Else If wTitle contains powershell.exe
         {
            WinActivate, ahk_id %activeWinID%
            SetKeyDelay, 0

            Send, {ESC}
            SendRaw, Set-Location "%retPath%"
            Send, {Enter}
            func_AddToRecentDir(retPath)
            Return
         }
      }
   }
   If NewWindow <> 0
   {
      ; Explorer-Fenster ffnen (fhrt auch Programme aus)
      If (FileExist(retPath) OR func_StrLeft(retPath,3) = "::{" OR func_StrLeft(retPath,7) = "control")
      {
         retPath = "%retPath%"

         If ( isFolder contains "D" AND FolderTree = "1")
            Run, %FileBrowserWithTree% %retPath%,,UseErrorLevel
         Else
            Run, %FileBrowser% %retPath%,,UseErrorLevel
         If ErrorLevel = ERROR
            func_GetErrorMessage( A_LastError, ScriptTitle, A_Quote retPath A_Quote "`n`n" )
         Else
            func_AddToRecentDir(retPath)
      }
      Else
         BalloonTip(ScriptTitle, lng_FolderDoesNotExist "`n" retPath, "Info")
   }
   Else
      BalloonTip(ScriptTitle, lng_ChangeDirFailed, "Info", 1)
}

func_AddToRecentDir( retPath )
{
   global RecentPath
   SplitPath, retPath, Name, parentDir,,,Drive
   If Name =
      StringReplace, Name, Drive, :, ,
   FileDelete, %RecentPath%\%Name%
   FileCreateShortcut, %retPath%, %RecentPath%\%Name%.lnk
}

func_GetDir( WindowID, Message="", Repeat="", AddToTitle="", NoDelay=0 )
{
   global Enable_Freespace,lng_fs_FreeSpace,lng_fs_FreeSpaceShort, lng_CheckYourFolderOptions, ScriptTitle, USERPROFILE

   WinGetTitle, activeWinTitle, ahk_id %WindowID%
   WinGetText, activeWinText, ahk_id %WindowID%
   WinGetClass, activeWinClass, ahk_id %WindowID%

   IfInString, activeWinText, MSNTB_Window ; MSN-Toolbar?
      EditClass = Edit2
   Else
      EditClass = Edit1

   ControlGetText, retPath, %EditClass%, ahk_id %WindowID%
   retPathErrorLevel = %ErrorLevel%

   If activeWinTitle contains - Microsoft Internet Explorer
      Return

   If Repeat = Once
      Repeat = 1
   Else If Repeat <> Never
      Repeat =
   If AddToTitle <>
      AddToTitle := " - " AddToTitle

   If A_OSversion = WIN_NT4
   {
      RegRead, FullPath, HKCU,Software\Microsoft\Windows\CurrentVersion\Explorer\CabinetState,Settings
      StringMid, FullPath, FullPath,10,1
      If FullPath = B
         FullPath = 1
      Else
         FullPath = 0
   }
   Else
   {
      RegRead, FullPath, HKCU,Software\Microsoft\Windows\CurrentVersion\Explorer\CabinetState,FullPath
      RegRead, FullPathAddress, HKCU,Software\Microsoft\Windows\CurrentVersion\Explorer\CabinetState,FullPathAddress
      If FullPath =
         FullPath = 0
      If FullPathAddress =
         FullPathAddress = 1
   }

   RegRead, RegDesktop, HKEY_CURRENT_USER,Software\Microsoft\Windows\CurrentVersion\Explorer\User Shell Folders,Desktop
   StringReplace, RegDesktop, RegDesktop, `%USERPROFILE`%\

   RegRead, RegPersonal, HKEY_CURRENT_USER,Software\Microsoft\Windows\CurrentVersion\Explorer\User Shell Folders,Personal
   RegRead, MyDocs, HKEY_CURRENT_USER,Software\Microsoft\Office\11.0\Common\General,MyDocuments
   StringReplace, RegPersonal, RegPersonal, `%USERPROFILE`%, %USERPROFILE%
   StringReplace, RegPersonal, RegPersonal, `%USERNAME`%, %A_Username%
   SplitPath, RegPersonal, RegDir

   If (retPathErrorLevel = 1 AND WinExist("ahk_id " WindowID) AND WinActive("ahk_id " WindowID) AND NoDelay = 0)
   {
     WinWaitClose, ahk_id %WindowID%,,1
   }

   If activeWinClass in CabinetWClass,ExploreWClass
   {
      If (( (FullPath = 0 AND FullPathAddress = 0 ) OR (FullPathAddress = 1 AND retPathErrorLevel = 1) ) AND (WinExist("ahk_id " WindowID) AND WinActive("ahk_id " WindowID)) )
      {
         If Message = ShowBalloonTip
         {
            If Repeat = 1
               BalloonTip( ScriptTitle AddToTitle, lng_CheckYourFolderOptions,"Info",WindowID,0)
            Else If Repeat <> Never
               BalloonTip( ScriptTitle AddToTitle, lng_CheckYourFolderOptions,"Info",0,0)
         }
         Else If Message = ShowMessage
         {
            If Repeat = 1
               BalloonTip( ScriptTitle AddToTitle, lng_CheckYourFolderOptions,"Info",WindowID,1)
            Else If Repeat <> Never
               BalloonTip( ScriptTitle AddToTitle, lng_CheckYourFolderOptions,"Info",0,1)
         }
         Return
      }

      ; Aktuellen Pfad anhand der Adress- oder Titelleiste ermitteln
      If FullPathAddress = 1
      {
         If retPathErrorLevel = 1
            return
      }
      Else If FullPath = 1
      {
         WinGetTitle, retPath, ahk_id %WindowID%
         If A_OSversion = WIN_NT4
            StringReplace, retPath, retPath, % "Explorer - "
         If Enable_FreeSpace = 1
         {
            IfInString, retPath, % " (" lng_fs_FreeSpace " "
            {
               StringGetPos, FSpos, retPath, % " (" lng_fs_FreeSpace " "
               StringLeft, retPath, retPath, %FSpos%
            }
            StringRight, retPathR, retPath, % StrLen(lng_fs_FreeSpaceShort)+2
            IfInString, retPathR, % " " lng_fs_FreeSpaceShort ")"
            {
               StringGetPos, FSpos, retPath, % " (", R1
               StringLeft, retPath, retPath, %FSpos%
            }
         }
      }

      ; Prfe, ob 'Desktop' im Explorer ausgewhlt wurde
      If RegDesktop = %retPath%
         retPath = %A_Desktop%

      ; Prfe, ob 'Eigene Dateien' im Explorer ausgewhlt wurde
      If retPath in Eigene Dateien,My Documents,mijn documenten,%MyDocs%,%RegDir%
         retPath = %RegPersonal%

      Loop
      {
         If SpecialFolder%A_Index% =
            break
         RegRead, SpecialFolder, HKCR, % "CLSID\{" SpecialFolder%A_Index% "}"
         If retPath = %SpecialFolder%
            retPath := SpecialFolderRun%A_Index%
      }

      If (retPathErrorLevel=1 And WinActive("ahk_id " WindowID) )
      {
         If Message = ShowBalloonTip
         {
            If Repeat = 1
               BalloonTip(ScriptTitle AddToTitle, lng_CheckYourFolderOptions,"Info",1,0)
            Else If Repeat <> Never
               BalloonTip(ScriptTitle AddToTitle, lng_CheckYourFolderOptions,"Info",0,0)
         }
         Else If Message = ShowMessage
         {
            If Repeat = 1
               BalloonTip(ScriptTitle AddToTitle, lng_CheckYourFolderOptions,"Info",1,1)
            Else If Repeat <> Never
               BalloonTip(ScriptTitle AddToTitle, lng_CheckYourFolderOptions,"Info",0,1)
         }
      }

      If (InStr(FileExist(retPath),"R"))
      {
         FileGetShortcut, %retPath%, retPathNew
         If retPathNew <>
            retPath := retPathNew
      }

      If (!FileExist(retPath) AND !InStr(retPath,"::{"))
         retPath =

      Return %retPath%
   }
   Else If activeWinClass in Progman,WorkerW
   {
      retPath = %A_Desktop%
      Return %retPath%
   }
}

func_CheckIfOnline()
{
   Return 1
}

func_AddMessage( Message, SubRoutine )
{
   Global
   StringReplace, Messages%Message%, Messages%Message%, %SubRoutine%|
   Messages%Message% := Messages%Message% SubRoutine "|"
   OnMessage( Message, "func_CallMessages" )
}

func_RemoveMessage( Message, SubRoutine )
{
   Global
   StringReplace, Messages%Message%, Messages%Message%, %SubRoutine%|
   If Messages%Message% =
      OnMessage( Message, "" )
   Else
      OnMessage( Message, "func_CallMessages" )
}

func_CallMessages( wParam,lParam, msg, hwnd )
{
   Global
   Loop, Parse, Messages%msg%, |
   {
      If A_LoopField =
         continue
      #wParam = %wParam%
      #lParam = %lParam%
      #msg    = %msg%
      #hwnd   = %hwnd%
      #Return =
      Gosub,%A_LoopField%
      If #Return <>
      {
         Return %#Return%
      }
   }
}

; Konvertiert Stings in Hex-Werte
func_Hex( String, Unicode = 0 )
{
   OldFormat = %A_FormatInteger%
   SetFormat, Integer, hex

   Loop, Parse, String
   {
      TransForm, Asc, Asc, %A_LoopField%
      Asc += 0
      StringTrimLeft, Hex, Asc, 2
      If Unicode = 0
         Result = %Result%%Hex%
      Else
         Result = %Result%%Hex%00
   }
   SetFormat, Integer, %OldFormat%
   StringUpper, Result, Result

   SetFormat, integer, d

   Return Result
}

/*
BinaryEncodingDecoding.ahk

Routines to encode and decode binary data to and from Ascii/Ansi data (source code).

// by Philippe Lhoste <PhiLho(a)GMX.net> http://Phi.Lho.free.fr
// File/Project history:
 1.02.000 -- 2007/01/03 (PL) -- Code rewritten for speed, using new AHK expression features and regexes.
 1.01.000 -- 2006/07/04 (PL) -- Finally, I put Pebwa in its own file, it has less generic use.
 1.00.000 -- 2006/03/29 (PL) -- Creation, taking Bin2Hex and Hex2Bin
          (and Bin2Pebwa & Pebwa2Bin) from DllCallStruct.

Bin2Hex & Hex2Bin derivated from Laszlo's code.
*/
/* Copyright notice: See the PhiLhoSoftLicence.txt file for details.
This file is distributed under the zlib/libpng license.
Copyright (c) 2006-2007 Philippe Lhoste / PhiLhoSoft
*/

FormatHexNumber(_value, _digitNb)
{
   local hex, intFormat

   ; Save original integer format
   intFormat := A_FormatInteger
   ; For converting bytes to hex
   SetFormat Integer, Hex

   hex := _value + (1 << 4 * _digitNb)
   StringRight hex, hex, _digitNb
   ; I prefer my hex numbers to be in upper case
   StringUpper hex, hex

   ; Restore original integer format
   SetFormat Integer, %intFormat%

   SetFormat, integer, d

   Return hex
}

/*
// Convert raw bytes stored in a variable to a string of hexa digit pairs.
// Convert either _byteNb bytes or, if null, the whole content of the variable.
//
// Return the number of converted bytes, or -1 if error (memory allocation)
*/
Bin2Hex(ByRef @hexString, ByRef @bin, _byteNb=0)
{
   local dataSize, dataAddress, granted, f

   ; Get size of data
   dataSize := _byteNb < 1 ? VarSetCapacity(@bin) : _byteNb
   dataAddress := &@bin
   ; Make enough room (faster)
   granted := VarSetCapacity(@hexString, dataSize * 5)
   if (granted < dataSize * 5)
   {
      ; Cannot allocate enough memory
      ErrorLevel = Mem=%granted%
      Return -1
   }
   f := A_FormatInteger
   SetFormat Integer, H
   Loop %dataSize%
   {
      @hexString .= *(dataAddress++) + 256
   }
   StringReplace @hexString, @hexString, 0x1, , All
   StringUpper @hexString, @hexString
   SetFormat Integer, %f%

   Return dataSize
}

/*
// Convert a string of hexa digit pairs to raw bytes stored in a variable.
// Convert either _byteNb bytes or, if null, the whole content of the variable.
//
// Return the number of converted bytes, or -1 if error (memory allocation)
*/
Hex2Bin(ByRef @bin, ByRef @hex, _byteNb=0)
{
   local l, data, granted, dataAddress

   If (_byteNb < 1 or _byteNb > dataSize)
   {
      ; Get size of data
      l := StrLen(@hex)
      _byteNb := l // 2
      if (l = 0 or _byteNb * 2 != l)
      {
         ; Invalid string, empty or odd number of digits
         ErrorLevel = Param
         Return -1
      }
   }
   ; Make enough room
   granted := VarSetCapacity(@bin, _byteNb, 0)
   if (granted < _byteNb)
   {
      ; Cannot allocate enough memory
      ErrorLevel = Mem=%granted%
      Return -1
   }
   data := RegExReplace(@hex, "..", "0x$0!")
   StringLeft data, data, _byteNb * 5
   dataAddress := &@bin

   Loop Parse, data, !
   {
      ; Store integer in memory
      DllCall("RtlFillMemory"
            , "UInt", dataAddress++
            , "UInt", 1
            , "UChar", A_LoopField)
   }

   Return _byteNb
}

func_StrLower( String )
{
   StringLower, String, String
   Return String
}

func_Download( URL, File, Splashtext, Title="", Size=0, URL2="", File2="", URL3="", File3="" )
{
   Suspend, On
   SetTimer, tim_Loading, Off
   ToolTip
   SetTimer, tim_UPDATEDSCRIPT, Off

   Setbatchlines, 15
   global DownloadProgressSplashtext,DownloadProgressFile,DownloadProgressFileSize,DownloadProgressTotalSize,DownloadProgressAddSize,DownloadProgressTitle
   DownloadProgressTotalSize = %Size%

   DownloadProgressAddSize = 0
   DownloadProgressSplashtext = %Splashtext%
   DownloadProgressTitle = %Title%
   DownloadProgressFile = %File%
   If Size > 5
      Progress, T M2 FM10 FS10 WM400 WS400 P0 w400, %File%, %DownloadProgressSplashtext%, %Title%
   Else
      SplashImage,, T M2 FS9 W400, %DownloadProgressSplashtext%
   SetTimer, tim_DownloadProgress, 10
   URLDownloadToFile, %URL%?dl=%ScriptVersion%, %File%
   ReturnVal = %ErrorLevel%
   FileRead, test, *m2048 %File%
   If (InStr(test,"<html>") AND InStr(test,"404"))
      ReturnVal++

   If (URL2 <> "" AND File2 <> "")
   {
      If Size > 5
      {
         Progress, T M2 P%DownloadProgressPercentage% FM10 FS10 WM400 WS400 w400, %File2%, %DownloadProgressSplashtext%, %Title%
      }
      DownloadProgressFile = %File2%
      DownloadProgressAddSize = %DownloadProgressFileSize%
      URLDownloadToFile, %URL2%?dl=%ScriptVersion%, %File2%
      ReturnVal := ReturnVal + ErrorLevel
      FileRead, test, *m2048 %File2%
      If (InStr(test,"<html>") AND InStr(test,"404"))
         ReturnVal++
   }
   If (URL3 <> "" AND File3 <> "")
   {
      If Size > 5
      {
         ;Progress, Off
         Progress, T M2 P%DownloadProgressPercentage% FM10 FS10 WM400 WS400 w400, %File3%, %DownloadProgressSplashtext%, %Title%
      }
      DownloadProgressFile = %File3%
      DownloadProgressAddSize = %DownloadProgressFileSize%
      URLDownloadToFile, %URL3%?dl=%ScriptVersion%, %File3%
      ReturnVal := ReturnVal + ErrorLevel
      FileRead, test, *m2048 %File3%
      If (InStr(test,"<html>") AND InStr(test,"404"))
         ReturnVal++
   }
   Sleep,50
   SetTimer, tim_DownloadProgress, off
   SplashImage, Off
   Progress, Off
   Return %ReturnVal%
}

tim_DownloadProgress:
;   Critical
   FileGetSize, DownloadProgressFileSize, %DownloadProgressFile%, K
   DownloadProgressFileSize := DownloadProgressAddSize + DownloadProgressFileSize
   If DownloadProgressFileSize = %DownloadProgressFileSizeLast%
      return
   If DownloadProgressTotalSize > 5
   {
      DownloadProgressPercentage := Round(DownloadProgressFileSize / DownloadProgressTotalSize * 100,0)
      Progress, %DownloadProgressPercentage%
   }
   Else
   {
      SplashImage,,T M2 FS9 W400, %DownloadProgressSplashtext% (%DownloadProgressFileSize% Kb)
   }
   DownloadProgressFileSizeLast = %DownloadProgressFileSize%
Return

sub_UpdateProgress:
   SplashImage, 2:%SplashIcon%,b2 FS5 C c00 ZY2 ZX2 w36, %A_Space%,,, Terminal
   SetTimer, tim_Loading, 50
Return

func_BeautifyIniFile( IniFile )
{
   Critical
   FileDelete, %IniFile%.tmp
   IniFileNewContent =
   FileRead, IniFileContent, %IniFile%
   Loop, Parse, IniFileContent, `n, `r
   {
      If A_LoopField =
         continue

      If A_LoopField = `;____________________________________________________________________________
         continue

      If A_LoopField = `;
         continue

      If ( func_StrLeft(A_LoopField,1) = "[" )
      {
         IniFileNewContent = %IniFileNewContent%`r`n`;____________________________________________________________________________`r`n
         IniFileNewContent = %IniFileNewContent%%A_LoopField%`r`n
         IniFileNewContent = %IniFileNewContent%`;`r`n
         continue
      }

      StringGetPos, ReadLinePos, A_LoopField, =
      ReadLinePos := 32-ReadLinePos
      StringRight, ReadLineIndent, A_SpaceLine, %ReadLinePos%
      StringReplace, ReadLine, A_LoopField, =, % "" ReadLineIndent "="
      IniFileNewContent = %IniFileNewContent%%ReadLine%`r`n
   }
   FileAppend, %IniFileNewContent%, %IniFile%.tmp
   Sleep, 200
   If ErrorLevel = 0
   {
      FileDelete, %IniFile%
      Sleep, 200
      FileCopy, %IniFile%.tmp, %IniFile%, 1
      Sleep, 200
   }
   FileDelete, %IniFile%.tmp
}

func_GetMonitorNumber( Mode="" )
{
   global

   If Mode = Mouse
   {
      CoordMode, Mouse, Screen
      MouseGetPos, MouseX, MouseY

      Loop, %NumOfMonitors%
      {
         If (MouseX >= Monitor%A_Index%Left AND MouseX <= Monitor%A_Index%Right AND MouseY >= Monitor%A_Index%Top AND MouseY <= Monitor%A_Index%Bottom)
            Return %A_Index%
      }
   }
   Else
   {
      If (Mode = "" OR Mode = "ActiveWindow")
         Mode = A
      WinGetPos, WinX, WinY, WinW, WinH, %Mode%
      WinCenX := WinX + WinW/2
      WinCenY := WinY + WinH/2

      Loop, %NumOfMonitors%
      {
         If (WinCenX >= Monitor%A_Index%Left AND WinCenX <= Monitor%A_Index%Right AND WinCenY >= Monitor%A_Index%Top AND WinCenY <= Monitor%A_Index%Bottom)
            Return %A_Index%
      }

   }
   Return 1
}

func_CenterCoordsOnActiveMonitor(ByRef WinX, ByRef WinY, WinW=0, WinH=0, GuiShow=2,Mon="")
{
   Global BorderHeight, CaptionHeight, BorderHeightToolWindow, MenuBarHeight
   If Mon =
      Mon := func_GetMonitorNumber("Mouse")
   If GuiShow > 0
   {
      WinW := WinW + BorderHeight*2-2
      WinH := WinH + BorderHeight*2-2 + CaptionHeight
      If GuiShow = 2
         WinH := WinH + MenuBarHeight
   }
   WinX := Monitor%Mon%Left+Floor((Monitor%Mon%Width-WinW)/2)
   WinY := Monitor%Mon%Top+Floor((Monitor%Mon%Height-WinH)/2)
   If GuiShow > 0
   {
      WinX = x%WinX%
      WinY = y%WinY%
   }
}

func_CheckIfCoordsCentered(WinX, WinY, WinW=0, WinH=0)
{
   Global NumOfMonitors
   Loop %NumOfMonitors%
   {
      WinXtest := WinX
      WinYtest := WinY
      func_CenterCoordsOnActiveMonitor(WinXtest, WinYtest, WinW, WinH,0,A_Index)
      If (WinXtest = WinX AND WinYtest = WinY)
         Return true
   }
   Return false
}

func_MoveCoordsIntoViewArea(ByRef WinX, ByRef WinY, WinW=0, WinH=0, GuiShow=2,Mon="Area")
{
   Global BorderHeight, CaptionHeight, BorderHeightToolWindow, MenuBarHeight
   If Mon = Mouse
      Mon := func_GetMonitorNumber("Mouse")
   If GuiShow > 0
   {
      WinW := WinW + BorderHeight*2-2
      WinH := WinH + BorderHeight*2-2 + CaptionHeight
      If GuiShow = 2
         WinH := WinH + MenuBarHeight
   }
   If (WinX+WinW > Monitor%Mon%Right)
      WinX := Monitor%Mon%Right-WinW
   If (WinY+WinH > Monitor%Mon%Bottom)
      WinY := Monitor%Mon%Bottom-WinH
   If (WinX+WinW < Monitor%Mon%Left)
      WinX := Monitor%Mon%Left
   If (WinY+WinH < Monitor%Mon%Top)
      WinY := Monitor%Mon%Top
   If GuiShow > 0
   {
      WinX = x%WinX%
      WinY = y%WinY%
   }
}


func_WildcardMatch( Haystack, Needle, Case=0 )
{
   If (!InStr(Needle,"*"))
   {
      If (InStr(Haystack,Needle,Case))
         Return true
      Else
         Return false
   }
   If Case = 1
      StringCaseSense, On
   Else
      StringCaseSense, Off

   StringReplace, ext_temp, Needle, *, *, A UseErrorLevel
   NumOfParts := ErrorLevel+1

   notFound = 0
   Loop, Parse, Needle, *
   {
      If A_LoopField =
         continue

      StringLen, PartLen, A_LoopField

      If A_Index = 1
      {
         StringLeft, CompareString, Haystack, %PartLen%
         StringTrimLeft, Haystack, Haystack, %PartLen%
         StringTrimLeft, Needle, Needle, % PartLen+1
         If A_LoopField != %CompareString%
            notFound++
      }
      Else If A_Index = %NumOfParts%
      {
         StringRight, CompareString, Haystack, %PartLen%
         StringTrimRight, Haystack, Haystack, %PartLen%
         StringTrimRight, Needle, Needle, % PartLen+1
         If A_LoopField != %CompareString%
            notFound++
      }
   }
   If NumOfParts > 2
   {
      Loop, Parse, Needle, *
      {
         IfNotInstring, Haystack, %A_LoopField%
            notFound++
      }
   }
   If notFound > 0
      return false
   Else
      return true
}

func_GetSelection( copyAsText=1, copyOnly=0, clipWaitTime=0.5 )
{
   global Selection, SavedClipboard, NoOnClipboardChange
   NoOnClipboardChange = 1

   SavedClipboard := ClipboardAll
   Clipboard =
   Sleep,0

   WinGetClass, Class, A

   ;Send, {Blind}%resetModifiers%^c%restoreModifiers%
   IfWinActive, Adobe
   {
      SetKeyDelay, 20, 20
      SendEvent, {Ctrl down}^c{Ctrl up}
   }
   Else If Class in PuTTY,ConsoleWindowClass,ytWindow
      Send, {ENTER}
   Else
      Send, {Ctrl down}^c{Ctrl up}

   IfWinActive, Adobe
   {
      Gui, 99:+ToolWindow
      Gui, 99:Show, x-1000 y-1000 w10 h10
   }

   If clipWaitTime <>
   {
      If copyAsText = 0
         ClipWait, %clipWaitTime%, 1
      Else
         ClipWait, %clipWaitTime%
   }
   Sleep,0

   IfWinActive, Adobe
   {
      Sleep,10
      Gui, 99:Destroy
   }

   If copyAsText = 1
      Selection := Clipboard
   Else If copyAsText in Unicode,UTF8,UTF-8
   {
      Transform, Selection, Unicode
      ;msgbox, % Ansi2UTF8(UTF82Ansi(Selection)) "`n" Selection
      If (Ansi2UTF8(UTF82Ansi(Selection)) = Selection)
         Selection := Clipboard
   }
   Else
      Selection := ClipboardAll

   If copyOnly = 0
   {
      Sleep, 20
      Clipboard := SavedClipboard
   }
   Sleep,0

   NoOnClipboardChange =

   If copyAsText = 1
      Return Selection
}

func_UnpackSplash( file )
{
   global UnpackSplashStyle
   SplashImage,,%UnpackSplashStyle%, Dateien werden ausgepackt ... / Unpacking files ...`n%file%
   UnpackSplashStyle =
}

func_prepareHotkeyForSend( Hotkey,State="",Blind=1 ) {
   If State <>
      State := " " State

   If Blind = 1
      Prefix = {Blind}
   Else
      Prefix =

   StringLower, Hotkey, Hotkey
   If Hotkey not in $,*,~
   {
      StringReplace Hotkey,Hotkey,$
      StringReplace Hotkey,Hotkey,*
      StringReplace Hotkey,Hotkey,~
   }
   StringReplace Hotkey2,Hotkey,!
   StringReplace Hotkey2,Hotkey2,#
   StringReplace Hotkey2,Hotkey2,^
   StringReplace Hotkey2,Hotkey2,+
   StringLeft, Hotkey, Hotkey, StrLen(Hotkey)-StrLen(Hotkey2)

   If Hotkey2 =
   {
;      If (StrLen(Hotkey . State) = 1)
;         Return Prefix Hotkey State
;      Else
         Return Prefix "{" Hotkey State "}"
   }
   Else
   {
;      If (StrLen(Hotkey2 . State) = 1)
;         Return Prefix Hotkey . Hotkey2 . State
;      Else
         Return Prefix Hotkey "{" Hotkey2 State "}"
   }
}

sub_GetAllEnv:
   tmp_blockAddr := DllCall("GetEnvironmentStrings")
   tmp_pointer := tmp_blockAddr
   tmp_bGetVar := true
   Loop
   {
      tmp_lstrlen := DllCall("lstrlen", UInt, tmp_pointer)
      ; Skip first value
      If (A_Index = 1)
      {
         tmp_pointer += tmp_lstrlen + 1
         Continue   ; Strange value...: "=::=::\"
      }
      VarSetCapacity(tmp_buffer, tmp_lstrlen+1, 0)
      DllCall("lstrcpy", "Str", tmp_buffer, "UInt", tmp_pointer)
      ; Here, we have in buffer something like "var=value"
      StringSplit, tmp_EnvVar, tmp_buffer, =
      tmp_EnvVar1 := func_StrClean(tmp_EnvVar1,"",0,"_")
      ; Avoid an error because these variables exist and are read-only
      If tmp_EnvVar1 <>
         If tmp_EnvVar1 not in ComSpec,ProgramFiles
            %tmp_EnvVar1% = %tmp_EnvVar2%%tmp_EnvVar3%%tmp_EnvVar4%%tmp_EnvVar5%%tmp_EnvVar6%%tmp_EnvVar7%%tmp_EnvVar8%%tmp_EnvVar9%
      Loop, 9
         tmp_EnvVar%A_Index% =
      tmp_pointer += tmp_lstrlen + 1
      If (*tmp_pointer = 0)
         Break
   }

   DllCall("FreeEnvironmentStrings", "UInt", tmp_blockAddr)
   FormatTime, DATE,,ShortDate
   FormatTime, Time,,Time
Return

CreateGuiID( VariableName )
{
   global
   LastGuiID++
   GuiID_%VariableName% = %LastGuiID%
   GuiID%LastGuiID% := %Prefix%_ScriptName " " VariableName
   Return %LastGuiID%
}

GuiDefault( VariableName, Options="" )
{
   global
   If GuiID_%VariableName% =
      Return
   Gui, % GuiID_%VariableName% ":Default"
   Gui, +Label%VariableName%Gui %Options%
   Gui, +LastFound
   Gosub, GuiDefaultFont
   WinGet, GuiID, ID
   Return GuiID
}

func_SortHotkeyModifiers( Hotkey )
{
   global WinModifierFirst
   If StrLen(Hotkey) > 2
   {
      Hotkey := RegExReplace(Hotkey, "^([^ ]*)\+\^([^+\^]*)$", "$1^+$2")
      Hotkey := RegExReplace(Hotkey, "^([^ ]*)!#([^!#]+)$", "$1#!$2")
      Hotkey := RegExReplace(Hotkey, "^([^ ]*)\+#([^+#]+)$", "$1#+$2")
      If WinModifierFirst = 1
         Hotkey := RegExReplace(Hotkey, "^([^ ]*)\^#([^#^]+)$", "$1#^$2")
      Else
         Hotkey := RegExReplace(Hotkey, "^([^ ]*)#\^([^#^]+)$", "$1^#$2")
      Hotkey := RegExReplace(Hotkey, "^([^ ]*)!\^([^!^]+)$", "$1^!$2")
      Hotkey := RegExReplace(Hotkey, "^([^ ]*)\+!([^!+]+)$", "$1!+$2")
   }
   StringReplace, Hotkey, Hotkey, ^Pause, ^CtrlBreak

   Return %Hotkey%
}

func_isFullscreen( Window="A" )
{
   global FullScreenApps
   WinGetClass, tmpWinClass, %Window%
   If tmpWinClass contains %FullScreenApps%
      Return true
   WinGetTitle, tmpWinTitle, %Window%
   If tmpWinTitle contains %FullScreenApps%
      Return true

   Return false
}

func_SearchInControl( SearchTerm, Control, Window="", Backwards=0 )
{
   global SearchTermLast
   If Window = ""
      Window = "A"
   ControlGetFocus, ControlTmp, %Window%
   ControlFocus, %Control%, %Window%
   ControlGetText, searchEditText, %Control%, %Window%
   StringReplace, searchEditText, searchEditText, `r`n, `n, %Window%
   StringReplace, searchEditText, searchEditText, `n, `r`n, %Window%
   ControlGet, searchCol, CurrentCol,,%Control%, %Window%
   ControlGet, searchLine, CurrentLine,,%Control%, %Window%
   searchCol--
   searchLine--
   If SearchTerm <> %SearchTermLast%
      searchCol := searchCol-StrLen(SearchTerm)
   SendMessage, 0xBB, searchLine, 0 , %Control%, %Window%  ; EM_LINEINDEX
   searchEditIndex := Errorlevel + searchCol

   If Backwards = 1
   {
      StringLeft, searchEditTmp, searchEditText, %searchEditIndex%
      StringReplace, searchEditTmp, searchEditTmp, %SearchTerm%,,A UseErrorLevel
      searchBackPos := ErrorLevel
      StringGetPos, searchSearchPos, searchEditText, %SearchTerm%, L%searchBackPos%
   }
   Else
      StringGetPos, searchSearchPos, searchEditText, %SearchTerm%, L, % searchEditIndex+1

   If searchSearchPos = -1
   {
      If _NoSoundBeepInSearch = 0
         SoundBeep, 500, 20
      If Backwards = 1
      {
         searchSearchPos = -1
         Loop, 300
         {
            lastSearchPos = %searchSearchPos%
            StringGetPos, searchSearchPos, searchEditText, %SearchTerm%, L, % searchSearchPos+1
            If searchSearchPos = -1
            {
               searchSearchPos = %lastSearchPos%
               break
            }
         }
      }
      Else
      {
         searchEditIndex = 0
         SendMessage, 0x115, 6 , , %Control% ; WM_VSCROLL (top)
         StringGetPos, searchSearchPos, searchEditText, %SearchTerm%, L, % searchEditIndex+1
      }
   }

   If searchSearchPos <> -1
   {
      ControlGetPos,,,, ScrollHalfHeight, %Control%, %Window%
      ScrollHalfHeight := ScrollHalfHeight/24
      ;SendMessage, 0x115, 6 , , %Control% ; WM_VSCROLL (top)
      SendMessage, 0xB1, searchSearchPos, searchSearchPos+StrLen(SearchTerm), %Control%, %Window% ; EM_SETSEL
      SendMessage, 0xB7, , , %Control%, %Window% ; EM_SCROLLCARET
      If Backwards = 1
         ControlSend, %Control%, {Up %ScrollHalfHeight%}{Down %ScrollHalfHeight%}, %Window%
      Else
         ControlSend, %Control%, {Down %ScrollHalfHeight%}{Up %ScrollHalfHeight%}, %Window%
      SendMessage, 0xB1, searchSearchPos, searchSearchPos+StrLen(SearchTerm), %Control%, %Window% ; EM_SETSEL
      ;SendMessage, 0xB6, , %ScrollHalfHeight%, %Control% ; EM_LINESCROLL
      SendMessage, 0x114, 6 , , %Control% ; WM_VSCROLL (htop)
   }
   Else
      If _NoSoundBeepInSearch = 0
         SoundBeep, 500, 20

   SearchTermLast = %SearchTerm%
   ControlFocus, %ControlTmp%, %Window%
}


RegisterHook( fhook_Hookname, fhook_ExtensionName, fhook_First=0 )
{
   Global
   fhook_Function = hook_%fhook_Hookname%
   %fhook_Function% := "|" %fhook_Function% "|"
   StringReplace, %fhook_Function%, %fhook_Function%, |%fhook_ExtensionName%|, |, All
   If fhook_First
      %fhook_Function% := fhook_ExtensionName "|" %fhook_Function%
   Else
      %fhook_Function% := %fhook_Function% "|" fhook_ExtensionName
   StringReplace, %fhook_Function%, %fhook_Function%, |||, |, All
   StringReplace, %fhook_Function%, %fhook_Function%, ||, |, All
   %fhook_Function% := func_StrTrimChars( %fhook_Function%, "|" )
   If %fhook_Function% = |
      %fhook_Function% =
   Debug("HOOK", A_LineNumber, A_LineFile, "RegisterHook: " fhook_Hookname "->" fhook_ExtensionName " (" fhook_Function ")")
}

UnRegisterHook( fhook_Hookname, fhook_ExtensionName )
{
   Global
   fhook_Function = hook_%fhook_Hookname%
   %fhook_Function% := "|" %fhook_Function% "|"
   StringReplace, %fhook_Function%, %fhook_Function%, |%fhook_ExtensionName%|, |, All
   StringReplace, %fhook_Function%, %fhook_Function%, |||, |, All
   StringReplace, %fhook_Function%, %fhook_Function%, ||, |, All
   %fhook_Function% := func_StrTrimChars( %fhook_Function%, "|" )
   If %fhook_Function% = |
      %fhook_Function% =
   Debug("HOOK", A_LineNumber, A_LineFile, "UnRegisterHook: " fhook_Hookname "->" fhook_ExtensionName " (" fhook_Function ")")
}

CallHook( fhook_Hookname, fhook_Section="" )
{
   Global
   fhook_Function = hook_%fhook_Hookname%
   Loop, Parse, %fhook_Function%, |
   {
      If A_LoopField =
         continue
      If (IsLabel(fhook_Hookname fhook_Section "_" A_LoopField) AND Enable_%A_LoopField% = 1 AND Enable%fhook_Hookname%_%A_LoopField% <> 0)
      {
         Gosub, %fhook_Hookname%%fhook_Section%_%A_LoopField%
         Debug("HOOK", A_LineNumber, A_LineFile, "CallHook: " fhook_Hookname fhook_Section "_" A_LoopField "... (" fhook_Function ")")
      }
   }
}


; Ermittelt die Hhe einer Zeile in der ListView des Windows Explorers.
;
; Fr den Code vielen Dank an shimanov im englischen Forum unter:
; http://www.autohotkey.com/forum/viewtopic.php?p=53882
func_GetLVRowHeight( Window="", Class="" )
{
   If Window =
      Window = A
   WinGet, pid_target, PID, %Window%

   hp_explorer := DllCall( "OpenProcess"
                        , "uint", 0x18                           ; PROCESS_VM_OPERATION|PROCESS_VM_READ
                        , "int", false
                        , "uint", pid_target )

   remote_buffer := DllCall( "VirtualAllocEx"
                        , "uint", hp_explorer
                        , "uint", 0
                        , "uint", 0x1000
                        , "uint", 0x1000                        ; MEM_COMMIT
                        , "uint", 0x4 )                           ; PAGE_READWRITE

   ; LVM_GETITEMRECT
   ;   LVIR_BOUNDS
   SendMessage, 0x1000+14, 0, remote_buffer, %Class%, %Window%

   VarSetCapacity( rect, 16, 0 )
   result := DllCall( "ReadProcessMemory"
                  , "uint", hp_explorer
                  , "uint", remote_buffer
                  , "uint", &rect
                  , "uint", 16
                  , "uint", 0 )

   result := DllCall( "VirtualFreeEx"
                     , "uint", hp_explorer
                     , "uint", remote_buffer
                     , "uint", 0
                     , "uint", 0x8000 )                           ; MEM_RELEASE

   result := DllCall( "CloseHandle", "uint", hp_explorer )

   y1 := 0
   y2 := 0
   loop, 4
   {
      y1 += *( &rect+3+A_Index )
      y2 += *( &rect+11+A_Index )
   }
   rowHeight := y2-y1

   Return rowHeight
}

func_GetErrorMessage( Error,MessageHeader="",MessageBody="" )
{
   bufferSize = 1024 ; Arbitrary, should be large enough for most uses
   VarSetCapacity(buffer, bufferSize)
   FORMAT_MESSAGE_FROM_SYSTEM = 0x1000
   LANG_SYSTEM_DEFAULT = 0x10000
   LANG_USER_DEFAULT = 0x20000
   DllCall("FormatMessage"
      , "UInt", FORMAT_MESSAGE_FROM_SYSTEM
      , "UInt", 0
      , "UInt", Error
      , "UInt", LANG_USER_DEFAULT
      , "Str", buffer
      , "UInt", bufferSize
      , "UInt", 0)

   If MessageHeader <>
      BalloonTip( MessageHeader, MessageBody Buffer, "Error" , 0, 0, 10)

   Debug("ERROR",A_LineNumber,A_LineFile, MessageHeader " " MessageBody " " Buffer )

   Return %buffer%
}

func_ReplaceExtension( OldExt, NewExt )
{
   global

   IfNotExist, extensions\ac'tivAid_%OldExt%.ahk
      Return

   FileDelete, extensions\ac'tivAid_%OldExt%.ahk

   FileRead, ExtMain, settings\extensions_main.ini
   StringReplace, ExtMain, ExtMain, _%OldExt%.ahk, _%NewExt%.ahk, A
   StringReplace, ExtMain, ExtMain, `;%OldExt%, `;%NewExt%, A
   FileDelete, settings\extensions_main.ini
   FileAppend, %ExtMain%, settings\extensions_main.ini

   FileRead, ExtHeader, settings\extensions_header.ini
   StringReplace, ExtHeader, ExtHeader, = %OldExt%, = %NewExt%, A
   FileDelete, settings\extensions_header.ini
   FileAppend, %ExtHeader%, settings\extensions_header.ini

   FileRead, ExtSettings, %ConfigFile%
   StringReplace, ExtSettings, ExtSettings, [%OldExt%], [%NewExt%], A
   StringReplace, ExtSettings, ExtSettings, _%OldExt%, _%NewExt%, A
   StringReplace, ExtSettings, ExtSettings, %OldExt%_, %NewExt%_, A
   FileDelete, %ConfigFile%
   FileAppend, %ExtSettings%, %ConfigFile%
}

func_RemoveExtension(ExtName)
{
   FileRead, ExtMain, settings\extensions_main.ini
   Loop, Parse, ExtMain, `n, `r
   {
      IfNotInString, A_LoopField, _%ExtName%.ahk
         NewExtMain = %NewExtMain%%A_LoopField%`n
   }

   FileDelete, settings\extensions_main.ini
   FileAppend, %NewExtMain%, settings\extensions_main.ini

   FileRead, ExtHeader, settings\extensions_header.ini
   NewExtHeaderNumber = 1
   Loop, Parse, ExtHeader, `n, `r
   {
      IfInString, A_LoopField, = %ExtName%
         continue
      NewExtHeader = % NewExtHeader RegExReplace(A_LoopField,"\[\d+\] *=","[" NewExtHeaderNumber "] =") "`n"
      IfInString, A_LoopField, Extension[
         NewExtHeaderNumber++
   }
   FileDelete, settings\extensions_header.ini
   FileAppend, %NewExtHeader%, settings\extensions_header.ini
}

func_AddExtension(ExtName)
{
   FileRead, NewExtMain, settings\extensions_main.ini
   IfNotInString, NewExtMain, extensions\ac'tivAid_%ExtName%.ahk
      NewExtMain = %NewExtMain%#Include *i `%A_ScriptDir`%\extensions\ac'tivAid_%ExtName%.ahk `;%ExtName%`n
   FileDelete, settings\extensions_main.ini
   FileAppend, %NewExtMain%, settings\extensions_main.ini

   FileRead, ExtHeader, settings\extensions_header.ini
   NewExtHeaderNumber = 1
   Loop, Parse, ExtHeader, `n, `r
   {
      NewExtHeader = % NewExtHeader RegExReplace(A_LoopField,"\[\d+\] *=","[" NewExtHeaderNumber "] =") "`n"
      IfInString, A_LoopField, Extension[
         NewExtHeaderNumber++
   }
   NewExtHeader = %NewExtHeader%Extension[%NewExtHeaderNumber%] = %ExtName%`n
   FileDelete, settings\extensions_header.ini
   FileAppend, %NewExtHeader%, settings\extensions_header.ini
}

func_SelectInExplorer( FileName, Window="", Index="" )
{
   global Break
   If Window =
      Window = A

   RegRead, HideFileExt, HKEY_CURRENT_USER,Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced, HideFileExt

   If HideFileExt = 1
      SplitPath, FileName, , , , FileName

   ControlFocus, SysListView321, %Window%

   Send, %FileName%

   Sleep, 40

   ControlGet, List, List, Col1, SysListView321, %Window%
   ControlGet, Focused, List, Focused Col1, SysListView321, %Window%

   If Focused = %FileName%
      Return

   StartIndex =
   Loop, Parse, List, `n, `r
   {
      If A_LoopField = %Focused%
      {
         StartIndex = %A_Index%
         Break
      }
   }

   If StartIndex =
   {
      StartIndex = 1
      ControlSend, SysListView321, {Home}, %Window%
   }

   If Index =
   {
      Loop, Parse, List, `n, `r
      {
         If A_LoopField = %FileName%
         {
            Index = %A_Index%
            Break
         }
         Index =
      }
   }

   If (Index = StartIndex OR Index = "")
      Return

   If (Index > StartIndex)
   {
      Move := Index - StartIndex
      If Move > 0
      {
         If Move > 1
         {
            Move --
            Send, {Ctrl down}{Down %Move%}{Ctrl up}{Down}
         }
         Else
            Send, {Down}
         Send, %FileName%
      }
   }
   Else
   {
      Move := StartIndex - Index
      If Move > 0
      {
         If Move > 1
         {
            Send, {Ctrl down}{Up %Move%}{Ctrl up}{Up}
         }
         Else
            Send, {Up}
         Send, %FileName%
      }
   }
}

func_EscapeForSend( String, WithEscape=1 )
{
   StringReplace, String, String, {, {#aad#{, a
   StringReplace, String, String, }, {}}, a
   StringReplace, String, String, {#aad#{, {{}, a
   StringReplace, String, String, ^, {ASC 094}, a
   StringReplace, String, String, !, {!}, a
   StringReplace, String, String, +, {+}, a
   StringReplace, String, String, #, {#}, a
   If WithEscape = 1
      StringReplace, String, String, ``, ````, a

   StringReplace, String, String, ``, {ASC 096}, a
   StringReplace, String, String, , {ASC 0180}, a

   Return %String%
}


func_EscapeForRegEx( String )
{
   String := RegExReplace(String,"([\\\.\*\?\+\[\{\|\(\)\^\$\}\]])","\$1")
   Return %String%
}

func_Swap(ByRef Var1, ByRef Var2)
{
   Var3 := Var1
   Var1 := Var2
   Var2 := Var3
}

func_FormatNumber( number, lngID="" )
{
   Global RegionFormatID
   SetFormat, Integer, Hex
   If lngID =
   {
      lngID := DllCall("GetKeyboardLayout", "uint",GetThreadOfWindow(), "uint")
      lngID := lngID & 0xFFFF
   }
   RegionFormatID = %lngID%
   SetFormat, Integer, Dec

   fmtSize = 100 ; Generous... I can also call GetNumberFormat to get needed size
   granted := VarSetCapacity(formatted, fmtSize, 0)

   If (granted < fmtSize)
   {
      ; Cannot allocate enough memory
      ErrorLevel = Error: Memory (%granted%/%fmtSize%)
      Return
   }

   result := DllCall("GetNumberFormat"
         , "UInt", lngID      ; Locale
         , "UInt", 0      ; dwFlags (user format)
         , "Str", number   ; lpValue
         , "UInt", 0      ; lpFormat (NULL)
         , "Str", formatted      ; lpNumberStr
         , "UInt", fmtSize)   ; cchNumber
   If (result == 0 or ErrorLevel != 0)
   {
      ErrorLevel = Error - API %ErrorLevel%
      Return
   }
   Return formatted
}

; RC4 by Laszlo/Rajat (http://www.autohotkey.com./forum/topic6804.html)
RC4txt2hex( Data, Pass )
{
   Format := A_FormatInteger
   SetFormat Integer, Hex
   b := 0
   j := 0
   VarSetCapacity(Result,StrLen(Data)*2)
   Loop 256
   {
      a := A_Index - 1
      c := SubStr(Pass, Mod(a,StrLen(Pass))+1, 1)
      Key%a% := Asc(c)
      sBox%a% := a
   }
   Loop 256
   {
      a := A_Index - 1
      b := b + sBox%a% + Key%a%  & 255
      T := sBox%a%
      sBox%a% := sBox%b%
      sBox%b% := T
   }
   Loop Parse, Data
   {
      i := A_Index & 255
      j := sBox%i% + j  & 255
      k := sBox%i% + sBox%j%  & 255
      Result .= SubStr(Asc(A_LoopField)^sBox%k%, -1, 2)
   }
   StringReplace Result, Result, x, 0, All
   SetFormat Integer, %Format%
   Return Result
}

RC4hex2txt( Data,Pass )
{
   b := 0
   j := 0
   x := "0x"
   VarSetCapacity(Result,StrLen(Data)//2)
   Loop 256
   {
      a := A_Index - 1
      c := SubStr(Pass, Mod(a,StrLen(Pass))+1, 1)
      Key%a% := Asc(c)
      sBox%a% := a
   }
   Loop 256
   {
      a := A_Index - 1
      b := b + sBox%a% + Key%a%  & 255
      T := sBox%a%
      sBox%a% := sBox%b%
      sBox%b% := T
   }
   Loop % StrLen(Data)//2
   {
      i := A_Index & 255
      j := sBox%i% + j  & 255
      k := sBox%i% + sBox%j%  & 255
      Result .= Chr((x . SubStr(Data,2*A_Index-1,2)) ^ sBox%k%)
   }
   Return Result
}

; ******************************************************************
; CMDret-AHK functions
; version 1.10 beta
;
; Updated: Dec 5, 2006
; by: corrupt
; Code modifications and/or contributions made by:
; Laszlo, shimanov, toralf, Wdb
; ******************************************************************
; Usage:
; CMDin - command to execute
; WorkingDir - full path to working directory (Optional)
; ******************************************************************
; Known Issues:
; - If using dir be sure to specify a path (example: cmd /c dir c:\)
; or specify a working directory
; - Running 16 bit console applications may not produce output. Use
; a 32 bit application to start the 16 bit process to receive output
; ******************************************************************
; Additional requirements:
; - none
; ******************************************************************
; Code Start
; ******************************************************************

CMDret_RunReturn( CMDin, WorkingDir=0 )
{
  Global cmdretPID
  tcWrk := WorkingDir=0 ? "Int" : "Str"
  idltm := A_TickCount + 20
  CMsize = 1
  VarSetCapacity(CMDout, 1, 32)
  VarSetCapacity(sui,68, 0)
  VarSetCapacity(pi, 16, 0)
  VarSetCapacity(pa, 12, 0)
  Loop, 4 {
    DllCall("RtlFillMemory", UInt,&pa+A_Index-1, UInt,1, UChar,12 >> 8*A_Index-8)
    DllCall("RtlFillMemory", UInt,&pa+8+A_Index-1, UInt,1, UChar,1 >> 8*A_Index-8)
  }
  IF (DllCall("CreatePipe", "UInt*",hRead, "UInt*",hWrite, "UInt",&pa, "Int",0) <> 0) {
    Loop, 4
      DllCall("RtlFillMemory", UInt,&sui+A_Index-1, UInt,1, UChar,68 >> 8*A_Index-8)
    DllCall("GetStartupInfo", "UInt", &sui)
    Loop, 4 {
      DllCall("RtlFillMemory", UInt,&sui+44+A_Index-1, UInt,1, UChar,257 >> 8*A_Index-8)
      DllCall("RtlFillMemory", UInt,&sui+60+A_Index-1, UInt,1, UChar,hWrite >> 8*A_Index-8)
      DllCall("RtlFillMemory", UInt,&sui+64+A_Index-1, UInt,1, UChar,hWrite >> 8*A_Index-8)
      DllCall("RtlFillMemory", UInt,&sui+48+A_Index-1, UInt,1, UChar,0 >> 8*A_Index-8)
    }
    IF (DllCall("CreateProcess", Int,0, Str,CMDin, Int,0, Int,0, Int,1, "UInt",0, Int,0, tcWrk, WorkingDir, UInt,&sui, UInt,&pi) <> 0) {
      Loop, 4
        cmdretPID += *(&pi+8+A_Index-1) << 8*A_Index-8
      Loop {
        idltm2 := A_TickCount - idltm
        If (idltm2 < 10) {
          DllCall("Sleep", Int, 10)
          Continue
        }
        IF (DllCall("PeekNamedPipe", "uint", hRead, "uint", 0, "uint", 0, "uint", 0, "uint*", bSize, "uint", 0 ) <> 0 ) {
          Process, Exist, %cmdretPID%
          IF (ErrorLevel OR bSize > 0) {
            IF (bSize > 0) {
              VarSetCapacity(lpBuffer, bSize+1)
              IF (DllCall("ReadFile", "UInt",hRead, "Str", lpBuffer, "Int",bSize, "UInt*",bRead, "Int",0) > 0) {
                IF (bRead > 0) {
                  TRead += bRead
                  VarSetCapacity(CMcpy, (bRead+CMsize+1), 0)
                  CMcpy = a
                  DllCall("RtlMoveMemory", "UInt", &CMcpy, "UInt", &CMDout, "Int", CMsize)
                  DllCall("RtlMoveMemory", "UInt", &CMcpy+CMsize, "UInt", &lpBuffer, "Int", bRead)
                  CMsize += bRead
                  VarSetCapacity(CMDout, (CMsize + 1), 0)
                  CMDout=a
                  DllCall("RtlMoveMemory", "UInt", &CMDout, "UInt", &CMcpy, "Int", CMsize)
                  VarSetCapacity(CMDout, -1)   ; fix required by change in autohotkey v1.0.44.14
                }
              }
            }
          }
          ELSE
            break
        }
        ELSE
          break
        idltm := A_TickCount
      }
      cmdretPID=
      DllCall("CloseHandle", UInt, hWrite)
      DllCall("CloseHandle", UInt, hRead)
    }
  }
  IF (StrLen(CMDout) < TRead) {
    VarSetCapacity(CMcpy, TRead, 32)
    TRead2 = %TRead%
    Loop {
      DllCall("RtlZeroMemory", "UInt", &CMcpy, Int, TRead)
      NULLptr := StrLen(CMDout)
      cpsize := Tread - NULLptr
      DllCall("RtlMoveMemory", "UInt", &CMcpy, "UInt", (&CMDout + NULLptr + 2), "Int", (cpsize - 1))
      DllCall("RtlZeroMemory", "UInt", (&CMDout + NULLptr), Int, cpsize)
      DllCall("RtlMoveMemory", "UInt", (&CMDout + NULLptr), "UInt", &CMcpy, "Int", cpsize)
      TRead2 --
      IF (StrLen(CMDout) > TRead2)
        break
    }
  }
  StringTrimLeft, CMDout, CMDout, 1
  Return, CMDout
}

ExtractInteger( ByRef pSource, pOffset = 0, pIsSigned = false, pSize = 4 )
{
   ; pSource is a string (buffer) whose memory area contains a raw/binary integer at pOffset.
   ; The caller should pass true for pSigned to interpret the result as signed vs. unsigned.
   ; pSize is the size of PSource's integer in bytes (e.g. 4 bytes for a DWORD or Int).
   ; pSource must be ByRef to avoid corruption during the formal-to-actual copying process
   ; (since pSource might contain valid data beyond its first binary zero).
   Loop %pSize%  ; Build the integer by adding up its bytes.
      result += *(&pSource + pOffset + A_Index-1) << 8*(A_Index-1)
   if (!pIsSigned OR pSize > 4 OR result < 0x80000000)
      return result  ; Signed vs. unsigned doesn't matter in these cases.
   ; Otherwise, convert the value (now known to be 32-bit) to its signed counterpart:
   return -(0xFFFFFFFF - result + 1)
}

InsertInteger( pInteger, ByRef pDest, pOffset = 0, pSize = 4 )
{
   ; The caller must ensure that pDest has sufficient capacity.  To preserve any existing contents in pDest,
   ; only pSize number of bytes starting at pOffset are altered in it.
   Loop %pSize%  ; Copy each byte in the integer into the structure as raw binary data.
      DllCall("RtlFillMemory", "UInt", &pDest + pOffset + A_Index-1, "UInt", 1, "UChar", pInteger >> 8*(A_Index-1) & 0xFF)
}

sub_OnWakeUp:
   If #wparam not in 6,7,18
      Return
   If ReloadOnWakeUp = 1
   {
      Debug("RELOAD",A_LineNumber,A_LineFile,A_ThisFunc A_ThisLabel)
      Gosub, Reload
   }
Return

Debug( dbgClass,dbgLine,dbgFile,dbgMessage )
{
   Global

   dbgError =
   If ( ErrorLevel <> "" AND ErrorLevel <> 0 )
      dbgError := " {ErrorLevel:" ErrorLevel ", GetLastError:" A_LastError "}"

   AutoTrim, Off
   If (_DebugLevel = "" OR _DebugLevel = 0 OR _Debug = 0)
      Return
   If (!(_DebugLevel = "ALL" OR InStr(_DebugLevel, dbgClass)) AND dbgClass <> "INIT")
      Return

   SplitPath, dbgFile, dbgOutFileName
   dbgClass = [%dbgClass%]
   dbgLine := SubStr("      " dbgLine, -5)

   If dbgClass = [VAR]
   {
      dbgNewMessage =
      dbgIndentVar := SubStr(A_SpaceLine, 1, StrLen(dbgOutFileName " " dbgLine ": " dbgClass " "))
      Loop, Parse, dbgMessage, `,
      {
         dbgVar := %A_LoopField%
         If A_Index = 1
            dbgNewMessage := dbgNewMessage dbgNewLine dbgOutFileName " " dbgLine ": " dbgClass " " A_LoopField " = " dbgVar "`n"
         Else
            dbgNewMessage := dbgNewMessage dbgIndentVar A_LoopField " = " dbgVar "`n"

      }
      dbgMessage = %dbgNewMessage%

      If _DebugToFile <>
         FileAppend, %dbgMessage%, %_DebugToFile%
      Else
         OutputDebug, %dbgMessage%
   }
   Else
      If _DebugToFile <>
         FileAppend, %dbgNewLine%%dbgOutFileName% %dbgLine%: %dbgClass% %dbgMessage%%dbgError%, %_DebugToFile%
      Else
         OutputDebug, %dbgNewLine%%dbgOutFileName% %dbgLine%: %dbgClass% %dbgMessage%%dbgError%
}

func_DumpVars( dumpVarsVariables, Parameters="",LocalVar1="",LocalVar2="",LocalVar3="",LocalVar4="",LocalVar5="",LocalVar6="",LocalVar7="",LocalVar8="",LocalVar9="" )
{
   Global
   Local ShowVar:=true,Delimiter:="`n"
   #IncludeAgain %A_ScriptDir%\library\#ParseFunctionParameters.ahk

   AutoTrim, On
   dumpVarsResult =
   Loop, Parse, dumpVarsVariables, `,
   {
      dumpVarsVariable = %A_LoopField%
      dumpVarsVariable := %dumpVarsVariable%
      If (dumpVarsVariable = "" AND LocalVar%A_Index% <> "")
         dumpVarsVariable := LocalVar%A_Index%
      If ShowVar
         dumpVarsResult:= dumpVarsResult A_LoopField " = " dumpVarsVariable Delimiter
      Else
         dumpVarsResult:= dumpVarsResult dumpVarsVariable Delimiter
   }
   Return dumpVarsResult
}

func_Deref(Var,Debug="")
{
   If Debug <>
      OutputDebug, Deref: %A_ThisLabel% - %Debug%
   Transform, Var, Deref, %Var%
   Return %Var%
}

func_ReplaceWithCommonPathVariables(Var,AdditionalVariables="")
{
   Global Drive,A_AutoHotkeyPath
   Variables = %AdditionalVariables%A_Desktop,A_DesktopCommon,A_Programs,A_ProgramsCommon,A_Startup,A_StartupCommon,A_StartMenu,A_StartMenuCommon,A_ProgramFiles,A_WinDir,A_AppData,A_AppDataCommon,A_MyDocuments,A_Temp,Drive,A_AutoHotkeyPath,A_ScriptDir
   Loop, Parse, Variables, `,
   {
      LoopField := %A_LoopField%
      If Var = %LoopField%
         Var = `%%A_LoopField%`%
      Else
         StringReplace, Var, Var, %LoopField%\, `%%A_LoopField%`%\
   }
   Return %Var%
}

; MetaSoundex: Gibt einen phonetisch vereinfachten String zurck
func_MetaSoundex(String, Parameters="" )
{
   RemovePunctuation = space
   CaseSensitive := true

   #IncludeAgain %A_ScriptDir%\library\#ParseFunctionParameters.ahk

   StringCaseSense, Off
   ; Doppelbuchstaben und Sonderzeichen vereinfachen
   StringReplace, String, String, bb, b, A
   StringReplace, String, String, cc, c, A
   StringReplace, String, String, dd, d, A
   StringReplace, String, String, ff, f, A
   StringReplace, String, String, gg, g, A
   StringReplace, String, String, hh, h, A
   StringReplace, String, String, jj, j, A
   StringReplace, String, String, kk, k, A
   StringReplace, String, String, ll, l, A
   StringReplace, String, String, mm, m, A
   StringReplace, String, String, nn, n, A
   StringReplace, String, String, pp, p, A
   StringReplace, String, String, rr, r, A
   StringReplace, String, String, ss, s, A
   StringReplace, String, String, tt, t, A
   StringReplace, String, String, vv, v, A
   StringReplace, String, String, ww, w, A
   StringReplace, String, String, xx, x, A
   StringReplace, String, String, zz, z, A
   StringReplace, String, String, , u, A
   StringReplace, String, String, , u, A
   StringReplace, String, String, , u, A
   StringReplace, String, String, , u, A
   StringReplace, String, String, , a, A
   StringReplace, String, String, , a, A
   StringReplace, String, String, , a, A
   StringReplace, String, String, , a, A
   StringReplace, String, String, , a, A
   StringReplace, String, String, , a, A
   StringReplace, String, String, , a, A
   StringReplace, String, String, , e, A
   StringReplace, String, String, , e, A
   StringReplace, String, String, , e, A
   StringReplace, String, String, , e, A
   StringReplace, String, String, , o, A
   StringReplace, String, String, , o, A
   StringReplace, String, String, , o, A
   StringReplace, String, String, , o, A
   StringReplace, String, String, , o, A
   StringReplace, String, String, , o, A
   StringReplace, String, String, , y, A
   StringReplace, String, String, , i, A
   StringReplace, String, String, , i, A
   StringReplace, String, String, , i, A
   StringReplace, String, String, , i, A
   StringReplace, String, String, , c, A
   StringReplace, String, String, , y, A
   StringReplace, String, String, , n, A
   StringReplace, String, String, , d, A
   StringReplace, String, String, %A_Space%%A_Space%, %A_Space%, A

   If RemovePunctuation
   {
      If RemovePunctuation = space
         RemovePunctuation = %A_Space%
      If RemovePunctuation = 1
         RemovePunctuation =
      String := func_RemovePunctuation(String,RemovePunctuation)
   }

   ; Buchstabenkombinationen phonetish vereinfachen
   StringReplace, String, String, v, f, A
   StringReplace, String, String, w, f, A
   StringReplace, String, String, sch, s, A
   StringReplace, String, String, chs, s, A
   StringReplace, String, String, cks, s, A
   StringReplace, String, String, ch, k, A
   StringReplace, String, String, cz, s, A
   StringReplace, String, String, ks, s, A
   StringReplace, String, String, ts, s, A
   StringReplace, String, String, tz, s, A
   StringReplace, String, String, sz, s, A
   StringReplace, String, String, ck, k, A
   StringReplace, String, String, dt, t, A
   StringReplace, String, String, pf, f, A
   StringReplace, String, String, ph, f, A
   StringReplace, String, String, ch, o, A
   StringReplace, String, String, qu, kf, A
   StringReplace, String, String, ct, kt, A

   If CaseSensitive
   {
      ; Schrgstriche mit Leerzeichen umschlieen
      StringReplace, String, String, \, %A_Space%#\\\#%A_Space%, A
      StringReplace, String, String, /, %A_Space%#///#%A_Space%, A
      ; Anfangsbuchstaben der Wrter gro
      StringUpper, String, String, T
      ; Leerzeichen um Schrgstriche wieder entfernen
      StringReplace, String, String, %A_Space%#\\\#%A_Space%, \, A
      StringReplace, String, String, %A_Space%#///#%A_Space%, /, A
      ; Leerzeichen um * wieder entfernen
      StringCaseSense, On
   }

   ; Buchstaben phonetisch Zahlen zuordnen
   StringReplace, String, String, ie, 7, A
   StringReplace, String, String, ei, 7, A
   StringReplace, String, String, ai, 7, A
   StringReplace, String, String, ui, 7, A
   StringReplace, String, String, oi, 7, A
   StringReplace, String, String, a, , A
   StringReplace, String, String, e, , A
   StringReplace, String, String, i, , A
   StringReplace, String, String, o, , A
   StringReplace, String, String, u, , A
   StringReplace, String, String, h, , A
   StringReplace, String, String, w, , A
   StringReplace, String, String, y, , A
   StringReplace, String, String, b, 1, A
   StringReplace, String, String, f, 1, A
   StringReplace, String, String, p, 1, A
   StringReplace, String, String, v, 1, A
   StringReplace, String, String, c, 2, A
   StringReplace, String, String, g, 8, A
   StringReplace, String, String, j, 2, A
   StringReplace, String, String, k, 8, A
   StringReplace, String, String, q, 8, A
   StringReplace, String, String, , 2, A
   StringReplace, String, String, s, 2, A
   StringReplace, String, String, x, 2, A
   StringReplace, String, String, z, 2, A
   StringReplace, String, String, d, 3, A
   StringReplace, String, String, t, 3, A
   StringReplace, String, String, l, 4, A
   StringReplace, String, String, m, 5, A
   StringReplace, String, String, n, 5, A
   StringReplace, String, String, r, 6, A

   Return %String%
}

func_RemovePunctuation(String,RemovePunctuation="",DontRemoveWildcard=0)
{
   StringReplace, String, String, -, %RemovePunctuation% , A
   StringReplace, String, String, `,, %RemovePunctuation% , A
   StringReplace, String, String, ', %RemovePunctuation% , A
   StringReplace, String, String, ., %RemovePunctuation% , A
   StringReplace, String, String, `;, %RemovePunctuation% , A
   StringReplace, String, String, :, %RemovePunctuation% , A
   StringReplace, String, String, _, %RemovePunctuation% , A
   StringReplace, String, String, +, %RemovePunctuation% , A
   If DontRemoveWildcard = 0
      StringReplace, String, String, *, %RemovePunctuation% , A
   StringReplace, String, String, (, %RemovePunctuation% , A
   StringReplace, String, String, ), %RemovePunctuation% , A
   StringReplace, String, String, {, %RemovePunctuation% , A
   StringReplace, String, String, }, %RemovePunctuation% , A
   StringReplace, String, String, [, %RemovePunctuation% , A
   StringReplace, String, String, ], %RemovePunctuation% , A
   StringReplace, String, String, /, %RemovePunctuation% , A
   StringReplace, String, String, \, %RemovePunctuation% , A
   Return String
}

/*
CoHelper.ahk
*/

VTable(ppv, idx)
{
   Return CoDecodeInteger(CoDecodeInteger(ppv) + idx * 4)
}

CoDecodeInteger(ptr)
{
   Return *ptr | *++ptr << 8 | *++ptr << 16 | *++ptr << 24
}

CoEncodeInteger(ref, val)
{
   DllCall("ntdll\RtlFillMemoryUlong", "Uint", ref, "Uint", 4, "Uint", val)
}

CoAnsi2Unicode(ByRef sString, ByRef wString, nLen = 0)
{
   If !nLen
      nLen := DllCall("MultiByteToWideChar"
      , "Uint", 0
      , "Uint", 0
      , "Uint", &sString
      , "int",  -1
      , "Uint", 0
      , "int",  0)

   VarSetCapacity(wString, nLen * 2 + 1)

   DllCall("MultiByteToWideChar"
      , "Uint", 0
      , "Uint", 0
      , "Uint", &sString
      , "int",  -1
      , "Uint", &wString
      , "int",  nLen)
}

CoUnicode2Ansi(ByRef wString, ByRef sString, nLen = 0)
{
   pString := wString + 0 > 65535 ? wString : &wString

   If !nLen
      nLen := DllCall("WideCharToMultiByte"
      , "Uint", 0
      , "Uint", 0
      , "Uint", pString
      , "int",  -1
      , "Uint", 0
      , "int",  0
      , "Uint", 0
      , "Uint", 0)

   VarSetCapacity(sString, nLen)

   DllCall("WideCharToMultiByte"
      , "Uint", 0
      , "Uint", 0
      , "Uint", pString
      , "int",  -1
      , "str",  sString
      , "int",  nLen
      , "Uint", 0
      , "Uint", 0)
}

CLSID4ProgID(Byref CLSID, sProgID)
{
   VarSetCapacity(CLSID, 16)
   CoAnsi2Unicode(sProgID, wProgID)
   DllCall("ole32\CLSIDFromProgID", "str", wProgID, "str", CLSID)
}

GUID4String(Byref CLSID, sString)
{
   VarSetCapacity(CLSID, 16)
   CoAnsi2Unicode(sString, wString, 38)
   DllCall("ole32\CLSIDFromString", "str", wString, "str", CLSID)
}

String4GUID(Byref CLSID)
{
   VarSetCapacity(wString, 38 * 2 + 1)
   DllCall("ole32\StringFromGUID2", "str", CLSID, "str", wString, "int", 38 + 1)
   CoUnicode2Ansi(wString, sString, 38)
   Return sString
}

CreateObject(ByRef CLSID, ByRef IID, CLSCTX = 5)
{
   If   StrLen(CLSID)  =  38
   GUID4String(CLSID, CLSID)
   If   StrLen(IID) = 38
   GUID4String(IID, IID)
   DllCall("ole32\CoCreateInstance", "str", CLSID, "Uint", 0, "Uint", CLSCTX, "str", IID, "UintP", ppv)
   Return ppv
}

GetObject(Namespace)
{
   CoAnsi2Unicode(Namespace, wNamespace)
   GUID4String(IID_IDispatch, "{00020400-0000-0000-C000-000000000046}")
   DllCall("ole32\CoGetObject", "str", wNamespace, "Uint", 0, "str", IID_IDispatch, "UintP", pdisp)
   Return pdisp
}

GetActiveObject(ProgID)
{
   InStr(ProgID, ".") ? CLSID4ProgID(CLSID, ProgID) : GUID4String(CLSID, ProgID)
   DllCall("oleaut32\GetActiveObject", "str", CLSID, "Uint", 0, "UintP", punk)
   Return punk
}

SysAllocString(sString)
{
   CoAnsi2Unicode(sString, wString)
   Return DllCall("oleaut32\SysAllocString", "str", wString)
}

SysFreeString(pString)
{
   Return DllCall("oleaut32\SysFreeString", "Uint", pString)
}

OleInitialize()
{
   DllCall("ole32\OleInitialize", "Uint", 0)
}

OleUninitialize()
{
   DllCall("ole32\OleUninitialize")
}

CoInitialize()
{
   DllCall("ole32\CoInitialize", "Uint", 0)
}

CoUninitialize()
{
   DllCall("ole32\CoUninitialize")
}

QueryInterface(ppv, ByRef IID)
{
   If   StrLen(IID) = 38
   GUID4String(IID, IID)
   DllCall(CoDecodeInteger(CoDecodeInteger(ppv)), "Uint", ppv, "str", IID, "UintP", ppv)
   Return ppv
}

AddRef(ppv)
{
   Return DllCall(CoDecodeInteger(CoDecodeInteger(ppv) + 4), "Uint", ppv)
}

Release(ppv)
{
   Return DllCall(CoDecodeInteger(CoDecodeInteger(ppv) + 8), "Uint", ppv)
}

QueryService(ppv, ByRef SID, ByRef IID)
{
   If   StrLen(SID) = 38
   GUID4String(SID, SID)
   If   StrLen(IID) = 38
   GUID4String(IID, IID)
   GUID4String(IID_IServiceProvider, "{6D5140C1-7436-11CE-8034-00AA006009FA}")
   DllCall(CoDecodeInteger(CoDecodeInteger(ppv)), "Uint", ppv, "str", IID_IServiceProvider, "UintP", psp)
   DllCall(CoDecodeInteger(CoDecodeInteger(psp) + 12), "Uint", psp, "str", SID, "str", IID, "UintP", ppv)
   DllCall(CoDecodeInteger(CoDecodeInteger(psp) +  8), "Uint", psp)
   Return ppv
}

func_ChooseColorAddGuiControl( ColorVariable, GuiText="", GuiOptions="y+10 xs+10" )
{
   Global

   if(%ColorVariable% = "$1")
      %ColorVariable% := "aaccff"
   if(%ColorVariable% = "$2")
      %ColorVariable% := "ccffaa"
   if(%ColorVariable% = "$3")
      %ColorVariable% := "ffccaa"

   ChoosColorValue := %ColorVariable%

   GuiEditOptions = y+10 xs+10 w55
   If GuiText <>
   {
      Gui, Add, Text, %GuiOptions%, %GuiText%
      GuiEditOptions = yp-3 x+5 w55
   }
   Gui, Font,, Courier New
   Gui, Add, Edit, %GuiEditOptions% v%ColorVariable% Limit6 gChooseColorEdit, %ChoosColorValue%
   Gosub, GuiDefaultFont

   Gui Add, ListView, x+5 H20 W20 ReadOnly +0x4000 +Background%ChoosColorValue% v%ColorVariable%_Box lv0x800000 0x4 -TabStop gChooseColorButton AltSubmit
}

ChooseColorButton:
   If A_GuiEvent <> DoubleClick
      Return
   StringReplace, ChooseColorControl, A_GuiControl, _Box,
   GuiControlGet, ChooseColorCurrentCol,, %ChooseColorControl%
   ChooseColorNewColor := ChooseColor(ChooseColorCurrentCol, WinActive("A"))
   If (ChooseColorNewColor != -1)
   {
      ChooseColorCurColor := "0x" . ChooseColorNewColor
      GuiControl +Background%ChooseColorCurColor%, %ChooseColorControl%_Box
      GuiControl, , %ChooseColorControl%, % FormatHex(ChooseColorCurColor)
      func_SettingsChanged( "A_GuiControl" )
   }
Return

ChooseColorEdit:
   GuiControlGet, ChooseColorCurColor,, %A_GuiControl%
   GuiControl +Background%ChooseColorCurColor%, %A_GuiControl%Box
   func_SettingsChanged( "A_GuiControl" )
Return

ChooseColor( Color=0x0, hPar=0x0, ccFile="")  { ;Thanks Skan
   Color := SubStr(Color,1,2)="0x" ? Color : "0x" Color      ; Check & Prefix Color with "0x"
   VarSetCapacity(CHOOSECOLOR, 36, 0) , mainPtr := (&CHOOSECOLOR)     ; Create Main structure
   DllCall( "RtlFillMemory", UInt,mainPtr+0, Int,1, UChar,36 ) ; Insert size of the Structure

   hPar := WinExist(ahk_id %hPar%) ; Validate the passed Parent window ID
   ; Break Parent window ID into 4 bytes
   H1 := hPar>>0 & 255,   H2 := hPar>>8 & 255,   H3 := hPar>>16 & 255,   H4 := hPar>>24 & 255
   Loop 4                       ; Insert Parent window ID to CHOOSECOLOR structure @ Offset 4
     DllCall( "RtlFillMemory", UInt,mainPtr+3+A_Index, Int,1, UChar,H%A_Index% )

   ; Break Color into R,G and B values
   RGB1 := Color>>16 & 255,    RGB2 := Color>>8  & 255,    RGB3 := Color>>0  & 255
   Loop 3                      ; Insert R,G and B values to CHOOSECOLOR structure @ Offset 12
     DllCall( "RtlFillMemory", UInt,mainPtr+11+A_Index, Int,1, UChar,RGB%A_Index% )

   ; CustomColors ( CUS1 will be primary array and CUS2 will be a copy to detect any change )
   VarSetCapacity(CUS1, 64, 0),   aPtr := (&CUS1),   VarSetCapacity(CUS2, 64, 0)
   IfEqual,ccFile,, SetEnv,ccFile,%A_WinDir%\CUSTOMCOLOR.BIN ; Assign default save filename
   IfExist,%ccFile%,  FileRead,CUS1, *m64 %ccFile%           ; Array CUS1 will be overwritten
   Loop 64                                                   ; Copy data from CUS1 to CUS2
    oS:=A_Index-1, DllCall( "RtlFillMemory", UInt,&CUS2+oS, Int,1, UChar,*(&CUS1+oS) )
   A1 := aPtr>>0 & 255,   A2 := aPtr>>8 & 255,   A3 := aPtr>>16 & 255,   A4 := aPtr>>24 & 255
   Loop 4        ; Insert pointer to Custom colors array to CHOOSECOLOR structure @ Offset 16
      DllCall( "RtlFillMemory", UInt,mainPtr+15+A_Index, Int,1, UChar,A%A_Index% )

   ; Insert Integer 259 @ Offset 21 (259 is CC_RGBINIT + CC_FULLOPEN + CC_ANYCOLOR )
   DllCall( "RtlFillMemory", UInt,mainPtr+20, Int,1,UChar,3  ) ; CC_RGBINIT=1 + CC_FULLOPEN=2
   DllCall( "RtlFillMemory", UInt,mainPtr+21, Int,1,UChar,1  ) ; CC_ANYCOLOR=256

   If ! DllCall("comdlg32\ChooseColorA", str, CHOOSECOLOR) OR errorLevel   ; Call ChooseColor
        Return -1            ; and return -1 in case of an error or if no color was selected.

   Loop 64 ; Compare data CUS2 and CUS1, if custom color changed, then save array to BIN file
      If ( *(&CUS1+A_Index-1) != *(&CUS2+A_Index-1) )   {       ; Check byte by byte
          h := DllCall( "_lcreat", Str,ccFile, Int,0 )         ; Overwrite/create file
               DllCall( "_lwrite", UInt,h, Str,CUS1, Int,64 )  ; write the array,
               DllCall( "_lclose", UInt,h )                    ; close the file,
               Break                                           ; break the loop.
                                                       }
   Hex := "123456789ABCDEF0",   RGB := mainPtr+11
   Loop 3 ; Extract nibbles directly from main structure and convert it into Hex (initd. abv)
     HexColorCode .=  SubStr(Hex, (*++RGB >> 4), 1) . SubStr(Hex, (*RGB & 15), 1)
   Return HexColorCode ; finally ... phew!
}

FormatHex(MyHex)
{
   Global OptBGR
   MyHex := SubStr(MyHex, 3)
   If OptBGR
      MyHex := RegExReplace(MyHex, "(..)(..)(..)", "$3$2$1")
   Return MyHex
}

GetLocalizedFilename( FullPath )
{
   sfi_size = 352  ; Structure size of SHFILEINFO.
   VarSetCapacity(sfi, sfi_size)
   VarSetCapacity(path,256,0)
   path := FullPath
   DllCall("Shell32\SHGetFileInfoA", "str", path, "uint", 0, "str", sfi, "uint", sfi_size, "uint", 0x200)  ; 0x200 is SHGFI_DISPLAYNAME
   Return % StringGet(sfi,11,256)
}

StringGet( ByRef struct, Offset, Length=256)
{
   str =
   Loop, %Length%
   {
      char := NumGet(struct, A_Index + Offset, "UChar")
      If char = 0
         break
      str .= Chr(char) ; where 0 is your offset
   }
   Return str
}

GetScrollInfo(hwnd, nBar, ByRef nPos, ByRef nPage, ByRef nMin, ByRef nMax, ByRef nTrackPos)    ; Gets scroll bar position and things
{
   ;Win32 API:   BOOL GetScrollInfo( HWND hwnd, int fnBar, LPSCROLLINFO lpsi )

   VarSetCapacity(SCROLLBAR_INFO, 28, 0)   ;Allocate SCROLLBAR_INFO structure and zero it
   NumPut(28, &SCROLLBAR_INFO)         ;Initialize its count-bytes parameter
   NumPut(0x17, &SCROLLBAR_INFO + 4)      ;Initialize the mask for what properties to get or set, SIF_ALL = 0x17

   bSuccess := DllCall("GetScrollInfo", UInt, hwnd, Int, nBar, UInt, &SCROLLBAR_INFO)
   if (!bSuccess)
      return false

   nMin := NumGet(&SCROLLBAR_INFO, 8)
   nMax := NumGet(&SCROLLBAR_INFO, 12)
   nPage := NumGet(&SCROLLBAR_INFO, 16)
   nPos := NumGet(&SCROLLBAR_INFO, 20)
   nTrackPos := NumGet(&SCROLLBAR_INFO, 24)

   return true
}

SetScrollInfo(hwnd, nBar, nPos, nPage, nMin, nMax)  ; Guess this changes the scroll bar's position and what not
{
   ;Win32 API:   int SetScrollInfo( HWND hwnd, int fnBar, LPCSCROLLINFO lpsi, BOOL fRedraw )

   global SCROLLBAR_INFO
   If (nMin) NumPut(nMin, &SCROLLBAR_INFO + 8)      ;Min
   If (nMax) NumPut(nMax, &SCROLLBAR_INFO + 12)      ;Max
   If (nPage) NumPut(nPage, &SCROLLBAR_INFO + 16)      ;Page
   NumPut(nPos, &SCROLLBAR_INFO + 20)      ;Pos
   iReturnPos := DllCall("SetScrollInfo", UInt, hwnd, Int, 1, UInt, &SCROLLBAR_INFO, Int, true)   ;SB_VERT = 1

   return (iReturnPos == nPos)
}

SetScrollPos(hwnd, nBar, nPos)
{
   ; WM_HSCROLL or WM_VSCROLL must be sent for the window to update it's contents.
   msg := (nBar=0) ? 0x114 : 0x115
   wParam := 4 ; SB_THUMBPOSITION
       | ((nPos&0xFFFF)<<16)
   SendMessage, msg, wParam,,, ahk_id %hwnd%
}

; Platzhalter in Sprachvariable ersetzen
#( String, var1="", var2="", var3="", var4="", var5="", var6="", var7="", var8="", var9="")
{
   a = %String%
   Loop
   {
      If var%A_Index% =
         Break
      StringReplace, String, String, ##%A_Index%, % var%A_Index%, A
      StringReplace, String, String, ###, % var%A_Index%
   }
   Return %String%
}

EditWordBreakProc(lpch, ichCurrent, cch, code) {
   static exp = "\W" ; treat any non alphanumeric character as a delimiter with this regex
   Loop, % cch * 2 ; build the string:
      str .= Chr(*(lpch - 1 + A_Index))
   If code = 0 ; WB_LEFT
      Return, RegExMatch(SubStr(str, 1, ichCurrent = cch
         ? cch : ichCurrent - (ichCurrent > 1)), exp . "[^" . exp . "]*\Z")
   Else If code = 1 ; WB_RIGHT
      Return, ichCurrent = cch or !(z := RegExMatch(str, exp, "", ichCurrent + 1)) ? cch : z - 1
   Else If code = 2 ; WB_ISDELIMITER
      Return, RegExMatch(SubStr(str, ichCurrent + 1, 1), exp)
}

func_AutoVSplitMenu(MenuName)
{
   Global A_RealOSVersion, MenuBarHeight, WorkAreaHeight, _useTrayMenuIcons, hTM
   TrayMenuHandle := GetMenuHandle(MenuName)

   TrayMenuItemCount := DllCall("GetMenuItemCount","uint",TrayMenuHandle)

   If A_RealOSVersion = WIN_VISTA
      MenuItemHeight := MenuBarHeight+1
   Else
      MenuItemHeight := MenuBarHeight-2
   If MenuItemHeight*TrayMenuItemCount > WorkAreaHeight
   {
      if (_useTrayMenuIcons = 1 && A_OSVersion != "WIN_VISTA")
         MI_SetMenuStyle(hTM, 0x10000000)

      TrayMenuBreak := TrayMenuItemCount/2
      VarSetCapacity(mii,48,0)
      NumPut(48,mii)
      NumPut(0x10,mii,4) ; fMask = MIIM_TYPE
      NumPut(0x160,mii,8) ; fType = RGB_VERTICALBARBREAK
      mlp := DllCall("InsertMenuItem","uint",TrayMenuHandle,"uint",TrayMenuBreak,"uint",1,"uint",&mii)
   }
}

func_URLEncode( url ) {
   SetFormat, integer, hex
   StringReplace, url, url, `%, `%25, A
   StringReplace, url, url, %A_Space%, `%20, A
   StringReplace, url, url, `", `%22, A
   StringReplace, url, url, `&, `%26, A
   StringReplace, url, url, `?, `%3F, A
   Loop, 127
   {
      HexCode := A_Index+127
      Transform, HighChar, Chr, %HexCode%
      StringUpper, HexCode, HexCode
      StringReplace, HexCode, HexCode, 0x,`%
      StringReplace, url, url, %HighChar%, %HexCode%
   }
   SetFormat, integer, dec
   Return %url%
}


; Gets a menu handle from a menu name.
; Adapted from Shimanov's Menu_AssignBitmap()
;   http://www.autohotkey.com/forum/topic7526.html
GetMenuHandle(menu_name)
{
    static   h_menuDummy
    If h_menuDummy=
    {
        Menu, menuDummy, Add
        Menu, menuDummy, DeleteAll

        Gui, 99:Menu, menuDummy
        Gui, 99:Show, Hide, guiDummy

        old_DetectHiddenWindows := A_DetectHiddenWindows
        DetectHiddenWindows, on

        Process, Exist
        h_menuDummy := DllCall( "GetMenu", "uint", WinExist( "guiDummy ahk_class AutoHotkeyGUI ahk_pid " ErrorLevel ) )
        If ErrorLevel or h_menuDummy=0
            return 0

        DetectHiddenWindows, %old_DetectHiddenWindows%

        Gui, 99:Menu
        Gui, 99:Destroy
    }

    Menu, menuDummy, Add, :%menu_name%
    h_menu := DllCall( "GetSubMenu", "uint", h_menuDummy, "int", 0 )
    DllCall( "RemoveMenu", "uint", h_menuDummy, "uint", 0, "uint", 0x400 )
    Menu, menuDummy, Delete, :%menu_name%

    return h_menu
}


;returns first thread for the <processID>
;sets optional <List> to pipe | separated thread list for the <processID>
GetProcessThreadOrList( processID, byRef list="" )
{
   ;THREADENTRY32 {
   THREADENTRY32_dwSize=0 ; DWORD
   THREADENTRY32_cntUsage = 4   ;DWORD
   THREADENTRY32_th32ThreadID = 8   ;DWORD
   THREADENTRY32_th32OwnerProcessID = 12   ;DWORD
   THREADENTRY32_tpBasePri = 16   ;LONG
   THREADENTRY32_tpDeltaPri = 20   ;LONG
   THREADENTRY32_dwFlags = 24   ;DWORD
   THREADENTRY32_SIZEOF = 28

   TH32CS_SNAPTHREAD=4

   hProcessSnap := DllCall("CreateToolhelp32Snapshot","uint",TH32CS_SNAPTHREAD, "uint",0)
   ifEqual,hProcessSnap,-1, return

   VarSetCapacity( thE, THREADENTRY32_SIZEOF, 0 )
   NumPut( THREADENTRY32_SIZEOF, thE )

   ret=-1

   if( DllCall("Thread32First","uint",hProcessSnap, "uint",&thE ))
      loop
      {
         if( NumGet( thE ) >= THREADENTRY32_th32OwnerProcessID + 4)
            if( NumGet( thE, THREADENTRY32_th32OwnerProcessID ) = processID )
            {   th := NumGet( thE, THREADENTRY32_th32ThreadID )
               IfEqual,ret,-1
                  ret:=th
               list .=  th "|"
            }
         NumPut( THREADENTRY32_SIZEOF, thE )
         if( DllCall("Thread32Next","uint",hProcessSnap, "uint",&thE )=0)
            break
      }

   DllCall("CloseHandle","uint",hProcessSnap)
   StringTrimRight,list,list,1
   return ret
}

; Returns thread owning specified window handle
; default = Active window
GetThreadOfWindow( hWnd=0 )
{
   IfEqual,hWnd,0
      hWnd:=WinExist("A")
   DllCall("GetWindowThreadProcessId", "uint",hWnd, "uintp",id)
   GetProcessThreadOrList(  id, threads )
   IfEqual,threads,
      return 0
   CB:=RegisterCallback("GetThreadOfWindowCallBack","Fast")
   lRet=0
   lParam:=hWnd
   loop,parse,threads,|
   {   NumPut( hWnd, lParam )
      DllCall("EnumThreadWindows", "uint",A_LoopField, "uint",CB, "uint",&lParam)
      if( NumGet( lParam )=true )
      {   lRet:=A_LoopField
         break
      }
   }
   DllCall("GlobalFree", "uint", CB)
   return lRet
}

GetThreadOfWindowCallBack( hWnd, lParam )
{
   IfNotEqual,hWnd,% NumGet( 0+lParam )
      return true
   NumPut( true, 0+lParam )
   return 0
}

; -----------------------------------------------------------------------------
; === Action Handling =========================================================
; -----------------------------------------------------------------------------
performAction(name,para="")
{
   Global

   ActionParameter := para
   LastAction := name
   loop, parse, name, |
   {
      routine := Action%A_LoopField%

      if IsLabel(routine)
         gosub, %routine%
   }
}

performHoldAction(name,para="")
{
   Global

   HoldActionParameter := para
   LastHoldAction := name
   loop, parse, name, |
   {
      routine := HoldActionStart%A_LoopField%

      if IsLabel(routine)
         gosub, %routine%
   }
}

finishHoldAction(name)
{
   Global

   loop, parse, name, |
   {
      routine := HoldActionEnd%A_LoopField%

      if IsLabel(routine)
         gosub, %routine%
   }
}

registerHoldAction(name,desc,start,end,para="")
{
   Global

   If desc =
   {
      StringReplace, desc, name, sub_, lng_
      IfNotInString, desc, lng_
         desc = lng_%desc%
      desc := %desc%
      If desc =
         desc = %name%
   }

   StringSplit, registerHoldAction_prefix, start, _
   If (registerHoldAction_prefix0 > 0 AND registerHoldAction_prefix1 <> "sub" AND StrLen(registerHoldAction_prefix1) > 1 AND StrLen(registerHoldAction_prefix1) < 5)
   {
      StringUpper, registerHoldAction_prefix1, registerHoldAction_prefix1
      desc := registerHoldAction_prefix1 ": " desc
   }

   HoldActions = %HoldActions%%name%|
   HoldActionsDesc = %HoldActionsDesc%%desc%|
   HoldActionStart%name% := start
   HoldActionEnd%name% := end
   HoldActionDesc%name% := desc
   HoldActionPara%name% := para
   descArray := func_StrLeft(func_StrClean(desc),128)
   HoldActionNameByDesc%descArray% := name
}

registerAction(name,desc="",routine="",para="")
{
   Global

   If routine =
      routine = %name%

   If desc =
   {
      StringReplace, desc, name, sub_, lng_
      IfNotInString, desc, lng_
         desc = lng_%desc%
      desc := %desc%
      If desc =
         desc = %name%
   }

   StringSplit, registerAction_prefix, routine, _
   If (registerAction_prefix0 > 0 AND registerAction_prefix1 <> "sub" AND StrLen(registerAction_prefix1) > 1 AND StrLen(registerAction_prefix1) < 5)
   {
      StringUpper, registerAction_prefix1, registerAction_prefix1
      desc := registerAction_prefix1 ": " desc
   }

   Actions = %Actions%%name%|
   ActionsDesc = %ActionsDesc%%desc%|
   Action%name% := routine
   ActionDesc%name% := desc
   ActionPara%name% := para
   descArray := func_StrLeft(func_StrClean(desc),128)

   ActionNameByDesc%descArray% := name
}

unRegisterAction(name)
{
   Global

   StringReplace, Actions, Actions, %name%|,,A
   Action%name% =
   ActionDesc%name% =
   ActionPara%name% =
}

unRegisterHoldAction(name)
{
   Global

   StringReplace, HoldActions, HoldActions, %name%|,,A
   HoldActionStart%name% =
   HoldActionEnd%name% =
   HoldActionDesc%name% =
   HoldActionPara%name% =
}

descHoldActionsString(str)
{
   Loop, parse, str, |
   {
      thisDesc := HoldActionDesc%A_LoopField%
      outStr = %outStr%%thisDesc%|
   }

   If (Substr(outStr,0,1) = "|")
      StringTrimRight,outStr,outStr,1

   if OutStr =
      OutStr := str

   return outStr
}

descActionsString(str)
{
   Loop, parse, str, |
   {
      thisDesc := ActionDesc%A_LoopField%
      outStr = %outStr%%thisDesc%|
   }

   If (Substr(outStr,0,1) = "|")
      StringTrimRight,outStr,outStr,1

   if OutStr =
      OutStr := str

   return outStr
}

ReadIcon(name,defVal="",defPos="",defValOff="",defPosOff="")
{
   Global

   If defVal !=
      IniRead, TrayIcon[%name%], %A_ScriptDir%\Settings\icons.ini, MainIcons, %name%, %defVal%

   ;IniWrite,% TrayIcon[%name%], %A_ScriptDir%\Settings\icons.ini, MainIcons, %name%

   If defPos !=
      IniRead, TrayIconPos[%name%], %A_ScriptDir%\Settings\icons.ini, MainIcons, %name%_Pos, %defPos%

   ;IniWrite,% TrayIconPos[%name%], %A_ScriptDir%\Settings\icons.ini, MainIcons, %name%_Pos

   If defValOff !=
      IniRead, TrayIconOff[%name%], %A_ScriptDir%\Settings\icons.ini, MainIcons, %name%_Off, %defValOff%

   If defPosOff !=
      IniRead, TrayIconOffPos[%name%], %A_ScriptDir%\Settings\icons.ini, MainIcons, %name%_Off_Pos, %defPosOff%

   If TrayIconOff[%name%] =
      TrayIconOff[%name%] = %A_WinDir%\system32\shell32.dll
   If TrayIconOffPos[%name%] =
      TrayIconOffPos[%name%] = 110

   IfNotExist, % TrayIcon[%name%]
   {
      TrayIcon[%name%] =
      TrayIconPos[%name%] =
   }
   IfNotExist, % TrayIconOff[%name%]
   {
      TrayIconOff[%name%] =
      TrayIconOffPos[%name%] =
   }
}

ExtractIcon(Filename, IconNumber, IconSize=0)
{
    static SmallIconSize, LargeIconSize
    if (!SmallIconSize) {
        SysGet, SmallIconSize, 49  ; 49, 50  SM_CXSMICON, SM_CYSMICON
        SysGet, LargeIconSize, 11  ; 11, 12  SM_CXICON, SM_CYICON
    }


    VarSetCapacity(phicon, 4, 0)
    h_icon = 0

    ; If possible, use PrivateExtractIcons, which supports any size of icon.
    if A_OSVersion in WIN_VISTA,WIN_2003,WIN_XP,WIN_2000
    {
        VarSetCapacity(piconid, 4, 0)

        ; MSDN: "... this function is deprecated ..." (oh well)
        ret := DllCall("PrivateExtractIcons"
            , "str", Filename
            , "int", IconNumber-1   ; zero-based index of the first icon to extract
            , "int", IconSize
            , "int", IconSize
            , "str", phicon         ; pointer to an array of icon handles...
            , "str", piconid        ; piconid - won't be used
            , "uint", 1             ; nIcons - number of icons to extract
            , "uint", 0, "uint")    ; flags

        if (ret && ret != 0xFFFFFFFF)
            h_icon := NumGet(phicon)
    }
    else
    {   ; Use ExtractIconEx, which only returns 16x16 or 32x32 icons.
        VarSetCapacity(phiconSmall, 4, 0)

        ; Extract the icon from an executable, DLL or icon file.
        if DllCall("shell32.dll\ExtractIconExA"
            , "str", Filename
            , "int", IconNumber-1   ; zero-based index of the first icon to extract
            , "str", phicon         ; pointer to an array of icon handles...
            , "str", phiconSmall
            , "uint", 1)
        {
            ; Use the best-fit size; clean up the other.
            if (IconSize <= SmallIconSize) {
                DllCall("DestroyIcon", "uint", NumGet(phicon))
                h_icon := NumGet(phiconSmall)
            } else {
                DllCall("DestroyIcon", "uint", NumGet(phiconSmall))
                h_icon := NumGet(phicon)
            }
        }
    }

    return h_icon
}

func_IsWindowInIgnoreList?(Window="A")
{
   WinGetClass, Class, %Window%
   If Class in Shell_TrayWnd,Progman,WorkerW,BaseBar,aadScreenShots,DV2ControlHost,SideBar_AppBarWindow
      Return 1
   Else
      Return 0
}

MouseMove(x,y,speed=0,relative="")
{
   CoordMode, Mouse, Screen
   If (relative <> "" AND relative <> "0")
   {
      MouseGetPos, movetoX, movetoY
      movetoX := movetoX + X
      movetoY := movetoY + Y
   }
   Else
   {
      movetoX := X
      movetoY := Y
   }
   DllCall("SetCursorPos", int, movetoX, int, movetoY)
}

#IfWinActive ahk_class AutoHotkeyGUI

$WheelDown::
$WheelUp::
   If (Enable_MouseWheel = 1 AND IsLabel("mw_sub_WheelUp"))
      Gosub, mw_sub_WheelUp%A_EmptyVar%
   Else
   {
      StringReplace, ThisHotkey, A_ThisHotkey, $
      MouseGetPos,,,WheelWin, WheelControl
      WinGetClass, WheelClass, ahk_id %WheelWin%
      If WheelClass = AutoHotkeyGUI
      {
         RegRead, WheelScrollLines, HKEY_CURRENT_USER, Control Panel\Desktop, WheelScrollLines
         Loop, %WheelScrollLines%
            SendMessage, 0x115, % (ThisHotKey="WheelDown"), 0, %WheelControl%, ahk_id %WheelWin%
      }
      Else
      {
         Send, {%ThisHotkey%}
      }
   }
Return

#IfWinActive

